﻿local MAJOR_VERSION = "Boss 1.2"
local MINOR_VERSION = tonumber(string.sub("$Revision: 13069 $", 12, -3))

if BabbleLib and BabbleLib.versions[MAJOR_VERSION] and BabbleLib.versions[MAJOR_VERSION].minor >= MINOR_VERSION then
	return
end

local locale = GetLocale and GetLocale() or "enUS"

local totalBosses = {
	-- Raid bosses
	["Patchwerk"] = "Patchwerk",
	["Grobbulus"] = "Grobbulus",
    ["Gluth"] = "Gluth",
    ["Thaddius"] = "Thaddius",
	["Feugen"] = "Feugen",
	["Stalagg"] = "Stalagg",
    ["Anub'Rekhan"] = "Anub'Rekhan",
    ["Grand Widow Faerlina"] = "Grand Widow Faerlina",
    ["Maexxna"] = "Maexxna",
    ["Instructor Razuvious"] = "Instructor Razuvious",
    ["Gothik the Harvester"] = "Gothik the Harvester",
	["Highlord Mograine"] = "Highlord Mograine",
    ["Thane Korth'azz"] = "Thane Korth'azz",
    ["Lady Blaumeux"] = "Lady Blaumeux",
    ["Sir Zeliek"] = "Sir Zeliek ",
    ["Noth the Plaguebringer"] =" Noth the Plaguebringer",
    ["Heigan the Unclean"] = "Heigan the Unclean",
    ["Loatheb"] = "Loatheb",
    ["Sapphiron"] = "Sapphiron",
    ["Kel'Thuzad"] = "Kel'Thuzad",
	["Lord Victor Nefarius"] = "Lord Victor Nefarius",
	["Nefarian"] = "Nefarian",
	["Vaelastrasz the Corrupt"] = "Vaelastrasz the Corrupt",
	["Razorgore the Untamed"] = "Razorgore the Untamed",
	["Broodlord Lashlayer"] = "Broodlord Lashlayer",
	["Chromaggus"] = "Chromaggus",
	["Ebonroc"] = "Ebonroc",
	["Firemaw"] = "Firemaw",
	["Flamegor"] = "Flamegor",
	["Majordomo Executus"] = "Majordomo Executus",
	["Ragnaros"] = "Ragnaros",
	["Baron Geddon"] = "Baron Geddon",
	["Golemagg the Incinerator"] = "Golemagg the Incinerator",
	["Garr"] = "Garr",
	["Sulfuron Harbinger"] = "Sulfuron Harbinger",
	["Shazzrah"] = "Shazzrah",
	["Lucifron"] = "Lucifron",
	["Gehennas"] = "Gehennas",
	["Magmadar"] = "Magmadar",
	["Onyxia"] = "Onyxia",
	["Azuregos"] = "Azuregos",
	["Lord Kazzak"] = "Lord Kazzak",
	["Ysondre"] = "Ysondre",
	["Emeriss"] = "Emeriss",
	["Taerar"] = "Taerar",
	["Lethon"] = "Lethon",
	["High Priestess Jeklik"] = "High Priestess Jeklik",
	["High Priest Venoxis"] = "High Priest Venoxis",
	["High Priest Thekal"] = "High Priest Thekal",
	["High Priestess Arlokk"] = "High Priestess Arlokk",
	["High Priestess Mar'li"] = "High Priestess Mar'li",
	["Jin'do the Hexxer"] = "Jin'do the Hexxer",
	["Bloodlord Mandokir"] = "Bloodlord Mandokir",
	["Gahz'ranka"] = "Gahz'ranka",
	["Gri'lek"] = "Gri'lek",
	["Hazza'rah"] = "Hazza'rah",
	["Renataki"] = "Renataki",
	["Wushoolay"] = "Wushoolay",
	["Hakkar"] = "Hakkar",
	["Ayamiss the Hunter"] = "Ayamiss the Hunter",
	["Buru the Gorger"] = "Buru the Gorger",
	["General Rajaxx"] = "General Rajaxx",
	["Moam"] = "Moam",
	["Anubisath Guardian"] = "Anubisath Guardian",
	["Ossirian the Unscarred"] = "Ossirian the Unscarred",
	["Lord Kri"] = "Lord Kri",
	["Princess Yauj"] = "Princess Yauj",
	["Vem"] = "Vem",
	["Eye of C'Thun"] = "Eye of C'Thun",
	["C'Thun"] = "C'Thun",
	["Anubisath Defender"] = "Anubisath Defender",
	["Fankriss the Unyielding"] = "Fankriss the Unyielding",
	["Princess Huhuran"] = "Princess Huhuran",
	["Ouro"] = "Ouro",
	["Battleguard Sartura"] = "Battleguard Sartura",
	["The Prophet Skeram"] = "The Prophet Skeram",
	["Emperor Vek'lor"] = "Emperor Vek'lor",
	["Emperor Vek'nilash"] = "Emperor Vek'nilash",
	["Viscidus"] = "Viscidus",
	-- Regular bosses
	["Alzzin the Wildshaper"] = "Alzzin the Wildshaper",
	["Ambassador Flamelash"] = "Ambassador Flamelash",
	["Anger'rel"] = "Anger'rel",
	["Archivist Galford"] = "Archivist Galford",
	["Atal'alarion"] = "Atal'alarion",
	["Avatar of Hakkar"] = "Avatar of Hakkar",
	["Bael'Gar"] = "Bael'Gar",
	["Balnazzar"] = "Balnazzar",
	["Baroness Anastari"] = "Baroness Anastari",
	["Baron Rivendare"] = "Baron Rivendare",
	["Cannon Master Willey"] = "Cannon Master Willey",
	["Captain Kromcrush"] = "Captain Kromcrush",
	["Celebras the Cursed"] = "Celebras the Cursed",
	["Crystal Fang"] = "Crystal Fang",
	["Darkmaster Gandling"] = "Darkmaster Gandling",
	["Doctor Theolen Krastinov"] = "Doctor Theolen Krastinov",
	["Doom'rel"] = "Doom'rel",
	["Dope'rel"] = "Dope'rel",
	["Dreamscythe"] = "Dreamscythe",
	["Emperor Dagran Thaurissan"] = "Emperor Dagran Thaurissan",
	["Fineous Darkvire"] = "Fineous Darkvire",
	["Gasher"] = "Gasher",
	["General Angerforge"] = "General Angerforge",
	["General Drakkisath"] = "General Drakkisath",
	["Gloom'rel"] = "Gloom'rel",
	["Golem Lord Argelmach"] = "Golem Lord Argelmach",
	["Goraluk Anvilcrack"] = "Goraluk Anvilcrack",
	["Guard Fengus"] = "Guard Fengus",
	["Guard Mol'dar"] = "Guard Mol'dar",
	["Guard Slip'kik"] = "Guard Slip'kik",
	["Gyth"] = "Gyth",
	["Halycon"] = "Halycon",
	["Hate'rel"] = "Hate'rel",
	["Hazzas"] = "Hazzas",
	["Hearthsinger Forresten"] = "Hearthsinger Forresten",
	["High Interrogator Gerstahn"] = "High Interrogator Gerstahn",
	["Highlord Omokk"] = "Highlord Omokk",
	["Hukku"] = "Hukku",
	["Hurley Blackbreath"] = "Hurley Blackbreath",
	["Hydrospawn"] = "Hydrospawn",
	["Illyanna Ravenoak"] = "Illyanna Ravenoak",
	["Immol'thar"] = "Immol'thar",
	["Instructor Malicia"] = "Instructor Malicia",
	["Jammal'an the Prophet"] = "Jammal'an the Prophet",
	["Jandice Barov"] = "Jandice Barov",
	["King Gordok"] = "King Gordok",
	["Kirtonos the Herald"] = "Kirtonos the Herald",
	["Lady Illucia Barov"] = "Lady Illucia Barov",
	["Landslide"] = "Landslide",
	["Lethtendris"] = "Lethtendris",
	["Lord Alexei Barov"] = "Lord Alexei Barov",
	["Lord Incendius"] = "Lord Incendius",
	["Lord Vyletongue"] = "Lord Vyletongue",
	["Lorekeeper Polkelt"] = "Lorekeeper Polkelt",
	["Loro"] = "Loro",
	["Magister Kalendris"] = "Magister Kalendris",
	["Magistrate Barthilas"] = "Magistrate Barthilas",
	["Magmus"] = "Magmus",
	["Maleki the Pallid"] = "Maleki the Pallid",
	["Marduk Blackpool"] = "Marduk Blackpool",
	["Meshlok the Harvester"] = "Meshlok the Harvester",
	["Mijan"] = "Mijan",
	["Morphaz"] = "Morphaz",
	["Mother Smolderweb"] = "Mother Smolderweb",
	["Nerub'enkan"] = "Nerub'enkan",
	["Noxxion"] = "Noxxion",
	["Ogom the Wretched"] = "Ogom the Wretched",
	["Overlord Wyrmthalak"] = "Overlord Wyrmthalak",
	["Phalanx"] = "Phalanx",
	["Plugger Spazzring"] = "Plugger Spazzring",
	["Postmaster Malown"] = "Postmaster Malown",
	["Princess Moira Bronzebeard"] = "Princess Moira Bronzebeard",
	["Princess Theradras"] = "Princess Theradras",
	["Prince Tortheldrin"] = "Prince Tortheldrin",
	["Pusillin"] = "Pusillin",
	["Pyroguard Emberseer"] = "Pyroguard Emberseer",
	["Ramstein the Gorger"] = "Ramstein the Gorger",
	["Ras Frostwhisper"] = "Ras Frostwhisper",
	["Rattlegore"] = "Rattlegore",
	["Razorlash"] = "Razorlash",
	["Warchief Rend Blackhand"] = "Warchief Rend Blackhand",
	["Ribbly Screwspigot"] = "Ribbly Screwspigot",
	["Rotgrip"] = "Rotgrip",
	["Seeth'rel"] = "Seeth'rel",
	["Shade of Eranikus"] = "Shade of Eranikus",
	["Shadow Hunter Vosh'gajin"] = "Shadow Hunter Vosh'gajin",
	["Solakar Flamewreath"] = "Solakar Flamewreath",
	["Stomper Kreeg"] = "Stomper Kreeg",
	["Tendris Warpwood"] = "Tendris Warpwood",
	["The Beast"] = "The Beast",
	["The Ravenian"] = "The Ravenian",
	["Timmy the Cruel"] = "Timmy the Cruel",
	["Tinkerer Gizlock"] = "Tinkerer Gizlock",
	["Tsu'zee"] = "Tsu'zee",
	["Vectus"] = "Vectus",
	["Vile'rel"] = "Vile'rel",
	["War Master Voone"] = "War Master Voone",
	["Weaver"] = "Weaver",
	["Zevrim Thornhoof"] = "Zevrim Thornhoof",
	["Zolo"] = "Zolo",
	["Zul'Lor"] = "Zul'Lor",
}

local englishToLocal

if locale == "deDE" then
	englishToLocal = {
		-- Raid Bosses
		["Patchwerk"] = "Flickwerk", 
		["Grobbulus"] = "Grobbulus",
		["Gluth"] = "Gluth",
		["Thaddius"] = "Thaddius",
--		["Feugen"] = "Feugen", -- CHECK
--		["Stalagg"] = "Stalagg", -- CHECK
		["Anub'Rekhan"] = "Anub'Rekhan",
		["Grand Widow Faerlina"] = "Gro\195\159witwe Faerlina",
		["Maexxna"] = "Maexxna",
		["Instructor Razuvious"] = "Instrukteur Razuvious",
	    	["Gothik the Harvester"] = "Gothik der Seelenj\195\164ger",
		["Highlord Mograine"] = "Hochlord Mograine",
		["Thane Korth'azz"] = "Thane Korth'azz",
		["Lady Blaumeux"] = "Lady Blaumeux",
	  	["Sir Zeliek"] = "Sire Zeliek",
		["Noth the Plaguebringer"] = "Noth der Seuchenf\195\188rst",
    		["Heigan the Unclean"] = "Heigan der Unreine",
		["Loatheb"] = "Loatheb",
		["Sapphiron"] = "Sapphiron",
		["Kel'Thuzad"] = "Kel'Thuzad",
		["Lord Victor Nefarius"] = "Lord Victor Nefarius",
		["Nefarian"] = "Nefarian",
		["Vaelastrasz the Corrupt"] = "Vaelastrasz der Verdorbene",
		["Razorgore the Untamed"] = "Razorgore der Ungez\195\164hmte",
		["Broodlord Lashlayer"] = "Brutw\195\164chter Dreschbringer",
		["Chromaggus"] = "Chromaggus",
		["Ebonroc"] = "Schattenschwinge",
		["Firemaw"] = "Feuerschwinge",
		["Flamegor"] = "Flammenmaul",
		["Majordomo Executus"] = "Majordomus Executus",
		["Ragnaros"] = "Ragnaros",
		["Baron Geddon"] = "Baron Geddon",
		["Golemagg the Incinerator"] = "Golemagg der Verbrenner",
		["Garr"] = "Garr",
		["Sulfuron Harbinger"] = "Sulfuronherold",
		["Shazzrah"] = "Shazzrah",
		["Lucifron"] = "Lucifron",
		["Gehennas"] = "Gehennas",
		["Magmadar"] = "Magmadar",
		["Onyxia"] = "Onyxia",
		["Azuregos"] = "Azuregos",
		["Emeriss"] = "Emeriss",
		["Taerar"] = "Taerar",
		["Lethon"] = "Lethon",
		["Jin'do the Hexxer"] = "Jin'do der Verhexer",
		["Bloodlord Mandokir"] = "Blutf\195\188rst Mandokir",
		["Hakkar"] = "Hakkar",
		["Lord Kazzak"] = "Lord Kazzak",
		["Ysondre"] = "Ysondre",
		["High Priestess Jeklik"] = "Hohepriesterin Jeklik",
		["High Priest Venoxis"] = "Hohepriester Venoxis",
		["High Priest Thekal"] = "Hohepriester Thekal",
		["High Priestess Arlokk"] = "Hohepriesterin Arlokk",
		["High Priestess Mar'li"] = "Hohepriesterin Mar'li",
		["Gahz'ranka"] = "Gahz'ranka",
		["Gri'lek"] = "Gri'lek",
		["Hazza'rah"] = "Hazza'rah",
		["Renataki"] = "Renataki",
		["Wushoolay"] = "Wushoolay",
		["Ayamiss the Hunter"] = "Ayamiss der J\195\164ger",
		["Buru the Gorger"] = "Buru der Verschlinger",
		["General Rajaxx"] = "General Rajaxx",
		["Moam"] = "Moam",
		["Anubisath Guardian"] = "Besch\195\188tzer des Anubisath",
		["Ossirian the Unscarred"] = "Ossirian der Narbenlose",
		["Kurinnaxx"] = "Kurinnaxx",
		["Lord Kri"] = "Lord Kri",
		["Princess Yauj"] = "Prinzessin Yauj",
		["Vem"] = "Vem",
		["Eye of C'Thun"] = "Auge von C'Thun",
		["C'Thun"] = "C'Thun",
		["Anubisath Defender"] = "Verteidiger des Anubisath",
		["Fankriss the Unyielding"] = "Fankriss der Unnachgiebige",
		["Princess Huhuran"] = "Prinzessin Huhuran",
		["Ouro"] = "Ouro",
		["Battleguard Sartura"] = "Schlachtwache Sartura",
		["The Prophet Skeram"] = "Der Prophet Skeram",
		["Emperor Vek'lor"] = "Imperator Vek'lor",
		["Emperor Vek'nilash"] = "Imperator Vek'nilash",
		["Viscidus"] = "Viscidus",
		-- Regular Bosses
		["Alzzin the Wildshaper"] = "Alzzin der Wildformer",
		["Ambassador Flamelash"] = "Botschafter Flamelash",
		["Anger'rel"] = "Zorn'rel",
		["Archivist Galford"] = "Archivar Galford",
		["Atal'alarion"] = "Atal'alarion",
		["Avatar of Hakkar"] = "Avatar von Hakkar",
		["Bael'Gar"] = "Bael'Gar",
		["Balnazzar"] = "Balnazzar",
		["Baroness Anastari"] = "Baroness Anastari",
		["Baron Rivendare"] = "Baron Rivendare",
		["Captain Kromcrush"] = "Captain Kromcrush",
		["Celebras the Cursed"] = "Celebras der Verfluchte",
		["Crystal Fang"] = "Kristallfangzahn",
		["Darkmaster Gandling"] = "Dunkelmeister Gandling",
		["Doctor Theolen Krastinov"] = "Doktor Theolen Krastinov",
		["Doom'rel"] = "Un'rel",
		["Dope'rel"] = "Trott'rel",
		["Dreamscythe"] = "Traumsense",
		["Fineous Darkvire"] = "Fineous Darkvire",
		["Gasher"] = "Gasher",
		["General Angerforge"] = "General Zornesschmied",
		["General Drakkisath"] = "General Drakkisath",
		["Gloom'rel"] = "Dunk'rel",
		["Golem Lord Argelmach"] = "Golemlord Argelmach",
		["Goraluk Anvilcrack"] = "Goraluk Hammerbruch",
		["Gyth"] = "Gyth",
		["Halycon"] = "Halycon",
		["Hate'rel"] = "Hass'rel",
		["Hazzas"] = "Hazzas",
		["Hearthsinger Forresten"] = "Herdsinger Forresten",
		["Highlord Omokk"] = "Hochlord Omokk",
		["Hukku"] = "Hukku",
		["Hurley Blackbreath"] = "Hurley Blackbreath",
		["Hydrospawn"] = "Hydrobrut",
		["Illyanna Ravenoak"] = "Illyanna Ravenoak",
		["Immol'thar"] = "Immol'thar",
		["Instructor Malicia"] = "Instrukteurin Malicia",
		["Jammal'an the Prophet"] = "Jammal'an der Prophet",
		["Jandice Barov"] = "Jandice Barov",
		["Kirtonos the Herald"] = "Kirtonos der Herold",
		["Lady Illucia Barov"] = "Lady Illucia Barov",
		["Landslide"] = "Erdrutsch",
		["Lethtendris"] = "Lethtendris",
		["Lorekeeper Polkelt"] = "H\195\188ter des Wissens Polkelt",
		["Loro"] = "Loro",
		["Magister Kalendris"] = "Magister Kalendris",
		["Magistrate Barthilas"] = "Magistrat Barthilas",
		["Magmus"] = "Magmus",
		["Maleki the Pallid"] = "Maleki der Leichenblasse",
		["Marduk Blackpool"] = "Marduk Blackpool",
		["Meshlok the Harvester"] = "Meshlok der Ernter",
		["Mijan"] = "Mijan",
		["Morphaz"] = "Morphaz",
		["Mother Smolderweb"] = "Mutter Glimmernetz",
		["Nerub'enkan"] = "Nerub'enkan",
		["Noxxion"] = "Noxxion",
		["Ogom the Wretched"] = "Ogom der Elende",
		["Overlord Wyrmthalak"] = "Oberanf\195\188hrer Wyrmthalak",
		["Phalanx"] = "Phalanx",
		["Plugger Spazzring"] = "Plugger Spazzring",
		["Postmaster Malown"] = "Postmeister Malown",
		["Princess Moira Bronzebeard"] = "Prinzessin Moira Bronzebeard",
		["Princess Theradras"] = "Prinzessin Theradras",
		["Prince Tortheldrin"] = "Prinz Tortheldrin",
		["Pusillin"] = "Pusillin",
		["Pyroguard Emberseer"] = "Feuerwache Glutseher",
		["Ramstein the Gorger"] = "Ramstein der Verschlinger",
		["Rattlegore"] = "Blutrippe",
		["Razorlash"] = "Schlingwurzler",
		["Ribbly Screwspigot"] = "Ribbly Screwspigot",
		["Rotgrip"] = "Faulschnapper",
		["Seeth'rel"] = "Wut'rel",
		["Shade of Eranikus"] = "Eranikus' Schemen",
		["Solakar Flamewreath"] = "Solakar Feuerkrone",
		["Stomper Kreeg"] = "Stampfer Kreeg",
		["Tendris Warpwood"] = "Tendris Wucherborke",
		["Timmy the Cruel"] = "Timmy der Grausame",
		["Tinkerer Gizlock"] = "T\195\188ftler Gizlock",
		["Tsu'zee"] = "Tsu'zee",
		["Vectus"] = "Vectus",
		["Vile'rel"] = "B\195\182s'rel",
		["Weaver"] = "Wirker",
		["Zevrim Thornhoof"] = "Zevrim Thornhoof",
		["Zolo"] = "Zolo",
		["Zul'Lor"] = "Zul'Lor",
		["Cannon Master Willey"] = "Kanonenmeister Willey",
		["Emperor Dagran Thaurissan"] = "Imperator Dagran Thaurissan",
		["Guard Fengus"] = "Wache Fengus",
		["Guard Mol'dar"] = "Wache Mol'dar",
		["Guard Slip'kik"] = "Wache Slip'kik",
		["High Interrogator Gerstahn"] = "Verh\195\182rmeisterin Gerstahn",
		["King Gordok"] = "K\195\182nig Gordok",
		["Lord Alexei Barov"] = "Lord Alexei Barov",
		["Lord Incendius"] = "Lord Incendius",
		["Lord Vyletongue"] = "Lord Schlangenzunge",
		["Ras Frostwhisper"] = "Ras Frostraunen",
		["Warchief Rend Blackhand"] = "Kriegsh\195\164uptling Rend Blackhand",
		["Shadow Hunter Vosh'gajin"] = "Schattenj\195\164gerin Vosh'gajin",
		["The Beast"] = "Die Bestie",
		["The Ravenian"] = "Der Ravenier",
		["War Master Voone"] = "Kriegsmeister Voone",
	}
elseif locale == "frFR" then
	englishToLocal = {
		-- Raid Bosses
--		["Patchwerk"] = "Patchwerk", -- CHECK
--		["Grobbulus"] = "Grobbulus", -- CHECK
--	    ["Gluth"] = "Gluth", -- CHECK
--	    ["Thaddius"] = "Thaddius", -- CHECK
--		["Feugen"] = "Feugen", -- CHECK
--		["Stalagg"] = "Stalagg", -- CHECK
--	    ["Anub'Rekhan"] = "Anub'Rekhan", -- CHECK
--	    ["Grand Widow Faerlina"] = "Grand Widow Faerlina", -- CHECK
--	    ["Maexxna"] = "Maexxna", -- CHECK
--	    ["Instructor Razuvious"] = "Instructor Razuvious", -- CHECK
--	    ["Gothik the Harvester"] = "Gothik the Harvester", -- CHECK
--		["Highlord Mograine"] = "Highlord Mograine", -- CHECK
--	    ["Thane Korth'azz"] = "Thane Korth'azz", -- CHECK
--	    ["Lady Blaumeux"] = "Lady Blaumeux", -- CHECK
--	    ["Sir Zeliek"] = "Sir Zeliek ", -- CHECK
--	    ["Noth the Plaguebringer"] =" Noth the Plaguebringer", -- CHECK
--	    ["Heigan the Unclean"] = "Heigan the Unclean", -- CHECK
--		["Loatheb"] = "Loatheb", -- CHECK
--	    ["Sapphiron"] = "Sapphiron", -- CHECK
--	    ["Kel'Thuzad"] = "Kel'Thuzad", -- CHECK
--		["Lord Victor Nefarius"] = "Lord Victor Nefarius", -- CHECK
		["Nefarian"] = "Nefarian",
		["Vaelastrasz the Corrupt"] = "Vaelastrasz le Corrompu",
		["Razorgore the Untamed"] = "Razorgore l'Indompt\195\169",
		["Broodlord Lashlayer"] = "Seigneur des couv\195\169es Lashslayer",
		["Chromaggus"] = "Chromaggus",
		["Ebonroc"] = "Ebonroc",
		["Firemaw"] = "Gueule-de-feu",
		["Flamegor"] = "Flamegor",
		["Majordomo Executus"] = "Majordome Executus",
		["Ragnaros"] = "Ragnaros",
		["Baron Geddon"] = "Baron Geddon",
		["Golemagg the Incinerator"] = "Golemagg l'Incin\195\169rateur",
		["Garr"] = "Garr",
		["Sulfuron Harbinger"] = "Messager de Sulfuron",
		["Shazzrah"] = "Shazzrah",
		["Lucifron"] = "Lucifron",
		["Gehennas"] = "Gehennas",
		["Magmadar"] = "Magmadar",
		["Onyxia"] = "Onyxia",
		["Azuregos"] = "Azuregos",
		["Emeriss"] = "Emeriss",
		["Taerar"] = "Taerar",
		["Lethon"] = "L\195\169thon",
		["Jin'do the Hexxer"] = "Jin'do le Mal\195\169ficieur",
		["Bloodlord Mandokir"] = "Seigneur sanglant Mandokir",
		["Hakkar"] = "Hakkar",
		["Lord Kazzak"] = "Seigneur Kazzak",
		["Ysondre"] = "Ysondre",
		["High Priestess Jeklik"] = "Grande pr\195\170tresse Jeklik",
		["High Priest Venoxis"] = "Grand-pr\195\170tre Venoxis",
		["High Priest Thekal"] = "Grand pr\195\170tre Thekal",
		["High Priestess Arlokk"] = "Grande pr\195\170tresse Arlokk",
		["High Priestess Mar'li"] = "Grande pr\195\170tresse Mar'li",
		["Gahz'ranka"] = "Gahz'ranka",
		["Gri'lek"] = "Gri'lek",
		["Hazza'rah"] = "Hazza'rah",
		["Renataki"] = "Renataki",
		["Wushoolay"] = "Wushoolay",
		["Ayamiss the Hunter"] = "Ayamiss le Chasseur",
		["Buru the Gorger"] = "Buru Grandgosier",
		["General Rajaxx"] = "Général Rajaxx",
--		["Moam"] = "Moam", --Check		
--		["Anubisath Guardian"] = "Anubisath Guardian", -- CHECK
--		["Ossirian the Unscarred"] = "Ossirian the Unscarred", -- CHECK
--		["Lord Kri"] = "Lord Kri", -- CHECK
--		["Princess Yauj"] = "Princess Yauj", -- CHECK
--		["Vem"] = "Vem", -- CHECK
--		["Eye of C'Thun"] = "Eye of C'Thun", -- CHECK
--		["C'Thun"] = "C'Thun", -- CHECK
--		["Anubisath Defender"] = "Anubisath Defender", -- CHECK
--		["Fankriss the Unyielding"] = "Fankriss the Unyielding", -- CHECK
--		["Princess Huhuran"] = "Princess Huhuran", -- CHECK
--		["Ouro"] = "Ouro", -- CHECK
--		["Battleguard Sartura"] = "Battleguard Sartura", -- CHECK
		["The Prophet Skeram"] = "Le Prophète Skeram",
--		["Emperor Vek'lor"] = "Emperor Vek'lor", -- CHECK
--		["Emperor Vek'nilash"] = "Emperor Vek'nilash", -- CHECK
--		["Viscidus"] = "Viscidus", -- CHECK
		-- Regular Bosses
		["Alzzin the Wildshaper"] = "Alzzin le Modeleur",
		["Ambassador Flamelash"] = "Ambassadeur Flamelash",
		["Anger'rel"] = "Anger'rel",
		["Archivist Galford"] = "Archiviste Galford",
		["Atal'alarion"] = "Atal'alarion",
		["Avatar of Hakkar"] = "Avatar d'Hakkar",
		["Bael'Gar"] = "Bael'Gar",
		["Balnazzar"] = "Balnazzar",
		["Baroness Anastari"] = "Baronne Anastari",
		["Baron Rivendare"] = "Baron Rivendare",
		["Captain Kromcrush"] = "Capitaine Kromcrush",
		["Celebras the Cursed"] = "Celebras le Maudit",
		["Crystal Fang"] = "Croc cristallin",
		["Darkmaster Gandling"] = "Sombre Ma\195\174tre Gandling",
		["Doctor Theolen Krastinov"] = "Docteur Theolen Krastinov",
		["Doom'rel"] = "Doom'rel",
		["Dope'rel"] = "Dope'rel",
		["Dreamscythe"] = "Fauche-r\195\170ve",
		["Fineous Darkvire"] = "Fineous Darkvire",
		["Gasher"] = "Gasher",
		["General Angerforge"] = "G\195\169n\195\169ral Angerforge",
		["General Drakkisath"] = "G\195\169n\195\169ral Drakkisath",
		["Gloom'rel"] = "Gloom'rel",
		["Golem Lord Argelmach"] = "Seigneur golem Argelmach",
		["Goraluk Anvilcrack"] = "Goraluk Anvilcrack",
		["Gyth"] = "Gyth",
		["Halycon"] = "Halycon",
		["Hate'rel"] = "Hate'rel",
		["Hazzas"] = "Hazzas",
		["Hearthsinger Forresten"] = "Hearthsinger Forresten",
		["Highlord Omokk"] = "G\195\169n\195\169ralissime Omokk",
		["Hukku"] = "Hukku",
		["Hurley Blackbreath"] = "Hurley Blackbreath",
		["Hydrospawn"] = "Hydrospawn",
		["Illyanna Ravenoak"] = "Illyanna Ravenoak",
		["Immol'thar"] = "Immol'thar",
		["Instructor Malicia"] = "Instructeur Malicia",
		["Jammal'an the Prophet"] = "Jammal'an le proph\195\168te",
		["Jandice Barov"] = "Jandice Barov",
		["Kirtonos the Herald"] = "Kirtonos le H\195\169raut",
		["Lady Illucia Barov"] = "Dame Illucia Barov",
		["Landslide"] = "Glissement de terrain",
		["Lethtendris"] = "Lethtendris",
		["Lorekeeper Polkelt"] = "Gardien du savoir Polkelt",
		["Loro"] = "Loro",
		["Magister Kalendris"] = "Magist\195\168re Kalendris",
		["Magistrate Barthilas"] = "Magistrat Barthilas",
		["Magmus"] = "Magmus",
		["Maleki the Pallid"] = "Maleki le Blafard",
		["Marduk Blackpool"] = "Marduk Blackpool",
		["Meshlok the Harvester"] = "Meshlok le Collecteur",
		["Mijan"] = "Mijan",
		["Morphaz"] = "Morphaz",
		["Mother Smolderweb"] = "Matriarche Couveuse",
		["Nerub'enkan"] = "Nerub'enkan",
		["Noxxion"] = "Noxxion",
		["Ogom the Wretched"] = "Ogom le Corrompu",
		["Overlord Wyrmthalak"] = "Seigneur Wyrmthalak",
		["Phalanx"] = "Phalange",
		["Plugger Spazzring"] = "Plugger Spazzring",
		["Postmaster Malown"] = "Postier Malown",
		["Princess Moira Bronzebeard"] = "Princesse Moira Bronzebeard",
		["Princess Theradras"] = "Princesse Theradras",
		["Prince Tortheldrin"] = "Prince Tortheldrin",
		["Pusillin"] = "Pusillin",
		["Pyroguard Emberseer"] = "Pyrogarde Proph\195\168te ardent",
		["Ramstein the Gorger"] = "Ramstein Grandgosier",
		["Rattlegore"] = "Rattlegore",
		["Razorlash"] = "Razorlash",
		["Ribbly Screwspigot"] = "Ribbly Screwspigot",
		["Rotgrip"] = "Grippe-charogne",
		["Seeth'rel"] = "Seeth'rel",
		["Shade of Eranikus"] = "Ombre d'Eranikus",
		["Solakar Flamewreath"] = "Solakar Flamewreath",
		["Stomper Kreeg"] = "Kreeg le Marteleur",
		["Tendris Warpwood"] = "Tendris Crochebois",
		["Timmy the Cruel"] = "Timmy le Cruel",
		["Tinkerer Gizlock"] = "Artisan Gizlock",
		["Tsu'zee"] = "Tsu'zee",
		["Vectus"] = "Vectus",
		["Vile'rel"] = "Vile'rel",
		["Weaver"] = "Tisserand",
		["Zevrim Thornhoof"] = "Zevrim Thornhoof",
		["Zolo"] = "Zolo",
		["Zul'Lor"] = "Zul'Lor",
		["Cannon Master Willey"] = "Ma\195\174tre canonnier Willey",
		["Emperor Dagran Thaurissan"] = "Empereur Dagran Thaurissan",
		["Guard Fengus"] = "Garde Fengus",
		["Guard Mol'dar"] = "Garde Mol'dar",
		["Guard Slip'kik"] = "Garde Slip'kik",
		["High Interrogator Gerstahn"] = "Grand Interrogateur Gerstahn",
		["King Gordok"] = "Roi Gordok",
		["Lord Alexei Barov"] = "Seigneur Alexei Barov",
		["Lord Incendius"] = "Seigneur Incendius",
		["Lord Vyletongue"] = "Seigneur Vyletongue",
		["Ras Frostwhisper"] = "Ras Frostwhisper",
		["Warchief Rend Blackhand"] = "Chef de guerre Rend Blackhand",
		["Shadow Hunter Vosh'gajin"] = "Chasseur des ombres Vosh'gajin",
		["The Beast"] = "La B\195\170te",
		["The Ravenian"] = "Le Voracien",
		["War Master Voone"] = "Ma\195\174tre de guerre Voone",
	}
elseif locale == "zhCN" then
	englishToLocal = {
		-- Raid bosses
		["Patchwerk"] = "帕奇维克", 
		["Grobbulus"] = "格罗布鲁斯",
	    ["Gluth"] = "格拉斯",
	    ["Thaddius"] = "塔迪乌斯", 
		["Feugen"] = "费尔根",
		["Stalagg"] = "斯塔拉格",
	    ["Anub'Rekhan"] = "阿鲁布雷坎", 
	    ["Grand Widow Faerlina"] = "黑女巫法琳娜", 
	    ["Maexxna"] = "迈克斯纳", 
	    ["Instructor Razuvious"] = "教官拉苏维奥斯",
	    ["Gothik the Harvester"] = "收割者戈提克", 
		["Highlord Mograine"] = "大领主莫格莱尼",
	    ["Thane Korth'azz"] = "库尔塔兹领主",
	    ["Lady Blaumeux"] = "女公爵布劳缪克丝",
	    ["Sir Zeliek"] = "瑟里耶克爵士",
	    ["Noth the Plaguebringer"] ="瘟疫使者诺斯",
	    ["Heigan the Unclean"] = "肮脏的希尔盖", 
		["Loatheb"] = "洛欧塞布",
	    ["Sapphiron"] = "萨菲隆", 
	    ["Kel'Thuzad"] = "克尔苏加德",
		["Lord Victor Nefarius"] = "维克多·奈法里奥斯",
		["Nefarian"] = "\229\165\136\230\179\149\229\136\169\229\174\137",
		["Vaelastrasz the Corrupt"] = "\229\160\149\232\144\189\231\154\132\231\147\166\230\139\137\230\150\175\229\161\148\229\133\185",
		["Razorgore the Untamed"] = "\231\139\130\233\135\142\231\154\132\230\139\137\228\189\144\230\160\188\229\176\148",
		["Broodlord Lashlayer"] = "\229\139\146\228\187\128\233\155\183\229\176\148",
		["Chromaggus"] = "\229\133\139\230\180\155\231\142\155\229\143\164\230\150\175",
		["Ebonroc"] = "\229\159\131\229\141\154\232\175\186\229\133\139",
		["Firemaw"] = "\232\180\185\229\176\148\233\187\152",
		["Flamegor"] = "\229\188\151\232\142\177\230\160\188\229\176\148",
		["Majordomo Executus"] = "\231\174\161\231\144\134\232\128\133\229\159\131\229\133\139\231\180\162\229\155\190\230\150\175",
		["Ragnaros"] = "\230\139\137\230\160\188\231\186\179\231\189\151\230\150\175",
		["Baron Geddon"] = "\232\191\166\233\161\191\231\148\183\231\136\181",
		["Golemagg the Incinerator"] = "\231\132\154\229\140\150\232\128\133\229\143\164\233\155\183\230\155\188\230\160\188",
		["Garr"] = "\229\138\160\229\176\148",
		["Sulfuron Harbinger"] = "\232\144\168\229\188\151\233\154\134\229\133\136\233\169\177\232\128\133",
		["Shazzrah"] = "\230\178\153\230\150\175\230\139\137\229\176\148",
		["Lucifron"] = "\233\178\129\232\165\191\229\188\151\233\154\134",
		["Gehennas"] = "\229\159\186\232\181\171\231\186\179\230\150\175",
		["Magmadar"] = "\231\142\155\230\160\188\230\155\188\232\190\190",
		["Onyxia"] = "\229\165\165\229\166\174\229\133\139\229\184\140\228\186\154",
		["Azuregos"] = "\232\137\190\231\180\162\233\155\183\232\145\155\230\150\175",
		["Lord Kazzak"] = "\229\141\161\230\137\142\229\133\139",
		["Ysondre"] = "\228\188\138\230\163\174\229\190\183\233\155\183",
		["Emeriss"] = "\232\137\190\232\142\171\232\142\137\228\184\157",
		["Taerar"] = "\230\179\176\230\139\137\229\176\148",
		["Lethon"] = "\232\142\177\231\180\162\230\129\169",
		["High Priestess Jeklik"] = "\233\171\152\233\152\182\231\165\173\229\143\184\232\128\182\229\133\139\233\135\140\229\133\139",
		["High Priest Venoxis"] = "\233\171\152\233\152\182\231\165\173\229\143\184\230\184\169\232\175\186\229\184\140\230\150\175",
		["High Priest Thekal"] = "\233\171\152\233\152\182\231\165\173\229\143\184\229\161\158\229\141\161\229\176\148",
		["High Priestess Arlokk"] = "\233\171\152\233\152\182\231\165\173\229\143\184\229\168\133\229\176\148\231\189\151",
		["High Priestess Mar'li"] = "\233\171\152\233\152\182\231\165\173\229\143\184\231\142\155\229\176\148\233\135\140",
		["Jin'do the Hexxer"] = "\229\166\150\230\156\175\229\184\136\233\135\145\229\186\166",
		["Bloodlord Mandokir"] = "\232\161\128\233\162\134\228\184\187\230\155\188\229\164\154\229\159\186\229\176\148",
		["Gahz'ranka"] = "\229\138\160\229\133\185\229\133\176\229\141\161",
		["Gri'lek"] = "\230\160\188\233\135\140\233\155\183\229\133\139",
		["Hazza'rah"] = "\229\147\136\230\137\142\230\139\137\229\176\148",
		["Renataki"] = "\233\155\183\231\186\179\229\161\148\229\159\186",
		["Wushoolay"] = "\228\185\140\232\139\143\233\155\183",
		["Hakkar"] = "\229\147\136\229\141\161",
		["Ayamiss the Hunter"] = "狩猎者阿亚米斯",
		["Buru the Gorger"] = "吞咽者布鲁",
		["General Rajaxx"] = "拉贾克斯将军",
		["Moam"] = "莫阿姆",
		["Anubisath Guardian"] = "阿努比萨斯守卫者",
		["Ossirian the Unscarred"] = "无疤者奥斯里安",
		["Lord Kri"] = "克里勋爵",
		["Princess Yauj"] = "亚尔基公主",
		["Vem"] = "维姆", 
		["Eye of C'Thun"] = "克苏恩之眼", 
		["Anubisath Defender"] = "阿努比萨斯防御者",
		["Fankriss the Unyielding"] = "顽强的范克瑞斯",
		["Princess Huhuran"] = "哈霍兰公主", 
		["Ouro"] = "奥罗", 
		["Battleguard Sartura"] = "沙尔图拉",
		["The Prophet Skeram"] = "预言者斯克拉姆", 
		["Emperor Vek'lor"] = "维克洛尔大帝", 
		["Emperor Vek'nilash"] = "维克尼拉斯大帝", 
		["Viscidus"] = "维希度斯",
		-- Regular bosses
		["Alzzin the Wildshaper"] = "\229\165\165\229\133\185\230\129\169",
		["Ambassador Flamelash"] = "\229\188\151\232\142\177\230\139\137\230\150\175\229\164\167\228\189\191",
		["Anger'rel"] = "\229\174\137\230\160\188\233\155\183\229\176\148",
		["Archivist Galford"] = "\230\161\136\231\174\161\231\144\134\229\145\152\229\138\160\229\176\148\231\166\143\231\137\185",
		["Atal'alarion"] = "\233\152\191\229\161\148\230\139\137\229\136\169\2 30\129\169",
		["Avatar of Hakkar"] = "\229\147\136\229\141\161\231\154\132\229\140\150\2 32\186\171",
		["Bael'Gar"] = "\232\180\157\229\176\148\229\138\160",
		["Balnazzar"] = "\229\183\180\231\186\179\230\137\142\229\176\148",
		["Baroness Anastari"] = "\229\174\137\229\168\156\228\184\157\229\161\148\228\184\189\231\148\183\231\136\181\229\164\171\228\186\186",
		["Baron Rivendare"] = "\231\145\158\230\150\135\230\136\180\229\176\148\231\148\183\231\136\181",
		["Cannon Master Willey"] = "\231\130\174\230\137\139\229\168\129\229\136\169",
		["Captain Kromcrush"] = "\229\133\139\231\189\151\229\141\161\230\150\175",
		["Celebras the Cursed"] = "\232\162\171\232\175\133\229\146\146\231\154\132\229\161\158\233\155\183\229\184\131\230\139\137\230\150\175",
		["Crystal Fang"] = "\230\176\180\230\153\182\228\185\139\231\137\153",
		["Darkmaster Gandling"] = "\233\187\145\230\154\151\233\153\162\233\149\191\229\138\160\228\184\129",
		["Doctor Theolen Krastinov"] = "\231\145\159\229\176\148\230\158\151\224\130\183\229\141\161\230\150\175\232\191\170\232\175\186\229\164\171\230\149\153\230\142\136",
		["Doom'rel"] = "\230\157\156\229\167\134\233\155\183\229\176\148",
		["Dope'rel"] = "\229\164\154\230\153\174\233\155\183\229\176\148",
		["Dreamscythe"] = "\229\190\183\229\167\134\229\161\158\229\141\161\2 29\176\148",
		["Emperor Dagran Thaurissan"] = "\232\190\190\230\160\188\229\133\176\224\130\183\231\180\162\231\145\158\230\163\174\229\164\167\229\184\157",
		["Fineous Darkvire"] = "\229\188\151\232\175\186\230\150\175\224\130\183\232\190\190\229\133\139\231\187\180\229\176\148",
		["Gasher"] = "\229\138\160\228\187\128\229\176\148",
		["General Angerforge"] = "\229\174\137\230\160\188\229\188\151\229\176\134\229\134\155",
		["General Drakkisath"] = "\232\190\190\229\159\186\232\144\168\230\150\175\229\176\134\229\134\155",
		["Gloom'rel"] = "\230\160\188\233\178\129\233\155\183\229\176\148",
		["Golem Lord Argelmach"] = "\229\130\128\229\132\161\231\187\159\229\184\133\233\152\191\230\160\188\230\155\188\229\165\135",
		["Goraluk Anvilcrack"] = "\229\143\164\230\139\137\233\178\129\229\133\139",
		["Guard Fengus"] = "\229\141\171\229\133\181\232\138\172\229\143\164\230\150\175",
		["Guard Mol'dar"] = "\229\141\171\229\133\181\230\145\169\229\176\148\232\190\190",
		["Guard Slip'kik"] = "\229\141\171\229\133\181\230\150\175\233\135\140\229\159\186\229\133\139",
		["Gyth"] = "\231\155\150\230\150\175",
		["Halycon"] = "\229\147\136\233\155\183\232\130\175",
		["Hate'rel"] = "\233\187\145\231\137\185\233\155\183\229\176\148",
		["Hazzas"] = "\229\147\136\230\137\142\230\150\175",
		["Hearthsinger Forresten"] = "\229\188\151\233\155\183\230\150\175\231\137\185\230\129\169",
		["High Interrogator Gerstahn"] = "\229\174\161\232\174\175\229\174\152\230\160\188\230\150\175\229\161\148\230\129\169",
		["Highlord Omokk"] = "\230\172\167\232\142\171\229\133\139\229\164\167\231\142\139",
		["Hukku"] = "\232\131\161\229\186\147",
		["Hurley Blackbreath"] = "\233\156\141\229\176\148\233\155\183\224\130\183\233\187\145\233\161\187",
		["Hydrospawn"] = "\230\181\183\229\164\154\230\150\175\229\141\154\230\129\169",
		["Illyanna Ravenoak"] = "\228\188\138\231\144\179\229\168\156\224\130\183\230\154\151\230\156\168",
		["Immol'thar"] = "\228\188\138\232\142\171\229\161\148\229\176\148",
		["Instructor Malicia"] = "\232\174\178\229\184\136\231\142\155\228\184\189\229\184\140\228\186\154",
		["Jammal'an the Prophet"] = "\233\162\132\232\168\128\232\128\133\232\191\166\2 31\142\155\229\133\176",
		["Jandice Barov"] = "\232\169\185\232\191\170\230\150\175\224\130\183\229\183\180\231\189\151\229\164\171",
		["King Gordok"] = "\230\136\136\229\164\154\229\133\139\229\164\167\231\142\139",
		["Kirtonos the Herald"] = "\228\188\160\228\187\164\229\174\152\229\159\186\229\176\148\229\155\190\232\175\186\230\150\175",
		["Lady Illucia Barov"] = "\228\188\138\233\156\178\229\184\140\228\186\154\224\130\183\229\183\180\231\189\151\229\164\171",
		["Landslide"] = "\229\133\176\230\150\175\229\136\169\229\190\183",
		["Lethtendris"] = "\232\149\190\231\145\159\229\161\148\232\146\130\228\184\157",
		["Lord Alexei Barov"] = "\233\152\191\233\155\183\229\133\139\230\150\175\224\130\183\229\183\180\231\189\151\229\164\171",
		["Lord Incendius"] = "\228\188\138\230\163\174\232\191\170\229\165\165\230\150\175",
		["Lord Vyletongue"] = "\231\187\180\229\136\169\229\161\148\230\129\169",
		["Lorekeeper Polkelt"] = "\229\141\154\229\173\166\232\128\133\230\153\174\229\133\139\229\176\148\231\137\185",
		["Loro"] = "\230\180\155\232\139\165\229\176\148",
		["Magister Kalendris"] = "\229\141\161\233\155\183\232\191\170\230\150\175\233\149\135\233\149\191",
		["Magistrate Barthilas"] = "\229\183\180\231\145\159\230\139\137\230\150\175\233\149\135\233\149\191",
		["Magmus"] = "\231\142\155\230\160\188\229\167\134\230\150\175",
		["Maleki the Pallid"] = "\232\139\141\231\153\189\231\154\132\231\142\155\229\139\146\229\159\186",
		["Marduk Blackpool"] = "\233\169\172\230\157\156\229\133\139\224\130\183\229\184\131\232\142\177\229\133\139\230\179\162\229\176\148",
		["Meshlok the Harvester"] = "\230\148\182\229\137\178\232\128\133\233\186\166\228\187\128\230\180\155\229\133\139",
		["Mijan"] = "\231\177\179\230\157\137",
		["Morphaz"] = "\230\145\169\229\188\151\230\139\137\230\150\175",
		["Mother Smolderweb"] = "\231\131\159\231\189\145\232\155\155\229\144\142",
		["Nerub'enkan"] = "\229\165\136\233\178\129\229\184\131\230\129\169\229\157\142",
		["Noxxion"] = "\232\175\186\229\133\139\232\181\155\230\129\169",
		["Ogom the Wretched"] = "\229\143\175\230\130\178\231\154\132\229\165\165\2 30\136\136\229\167\134",
		["Overlord Wyrmthalak"] = "\231\187\180\229\167\134\232\144\168\230\139\137\229\133\139",
		["Phalanx"] = "\230\179\149\230\139\137\229\133\139\230\150\175",
		["Plugger Spazzring"] = "\230\153\174\230\139\137\230\160\188",
		["Postmaster Malown"] = "\233\130\174\229\183\174\233\169\172\233\190\153",
		["Princess Moira Bronzebeard"] = "\233\147\129\231\130\137\229\160\161\229\133\172\228\184\187\232\140\137\232\137\190\230\139\137\224\130\183\233\147\156\233\161\187",
		["Princess Theradras"] = "\231\145\159\232\142\177\229\190\183\228\184\157\229\133\172\228\184\187",
		["Prince Tortheldrin"] = "\230\137\152\229\161\158\229\190\183\230\158\151\231\142\139\229\173\144",
		["Pusillin"] = "\230\153\174\229\184\140\230\158\151",
		["Pyroguard Emberseer"] = "\231\131\136\231\132\176\229\141\171\229\163\171\232\137\190\229\141\154\229\184\140\229\176\148",
		["Ramstein the Gorger"] = "\229\144\158\229\146\189\232\128\133\230\139\137\229\167\134\230\150\175\231\153\187",
		["Ras Frostwhisper"] = "\232\142\177\230\150\175\224\130\183\233\156\156\232\175\173",
		["Rattlegore"] = "\232\161\128\233\170\168\229\130\128\229\132\161",
		["Razorlash"] = "\233\148\144\229\136\186\233\158\173\231\172\158\232\128\133",
		["Warchief Rend Blackhand"] = "\233\155\183\229\190\183\224\130\183\233\187\145\230\137\139",
		["Ribbly Screwspigot"] = "\233\155\183\229\184\131\233\135\140\224\130\183\230\150\175\229\186\147\230\175\148\230\160\188\231\137\185",
		["Rotgrip"] = "\230\180\155\231\137\185\230\160\188\233\135\140\230\153\174",
		["Seeth'rel"] = "\232\165\191\230\150\175\233\155\183\229\176\148",
		["Shade of Eranikus"] = "\228\188\138\229\133\176\229\176\188\229\186\147\2 30\150\175\231\154\132\233\152\180\229\189\177",
		["Shadow Hunter Vosh'gajin"] = "\230\154\151\229\189\177\231\140\142\230\137\139\230\178\131\228\187\128\229\138\160\230\150\175",
		["Solakar Flamewreath"] = "Solakar Flamewreath",
		["Stomper Kreeg"] = "\232\183\181\232\184\143\232\128\133\229\133\139\2 33\155\183\230\160\188",
		["Tendris Warpwood"] = "\231\137\185\232\191\170\230\150\175\224\130\183\230\137\173\230\156\168",
		["The Beast"] = "\230\175\148\230\150\175\229\183\168\229\133\189",
		["The Ravenian"] = "\230\139\137\230\150\135\229\176\188\228\186\154",
		["Timmy the Cruel"] = "\230\130\178\230\131\168\231\154\132\230\143\144\2 31\177\179 --Timmy!!!",
		["Tinkerer Gizlock"] = "\229\183\165\229\140\160\229\144\137\229\133\185\230\180\155\229\133\139",
		["Tsu'zee"] = "\232\139\143\230\150\175",
		["Vectus"] = "\231\187\180\229\133\139\229\155\190\230\150\175",
		["Vile'rel"] = "\231\147\166\229\139\146\233\155\183\229\176\148",
		["War Master Voone"] = "\230\140\135\230\140\165\229\174\152\230\178\131\2 30\129\169",
		["Weaver"] = "\229\190\183\230\139\137\231\187\180\230\178\131\2 29\176\148",
		["Zevrim Thornhoof"] = "\229\161\148\231\189\151\224\130\183\229\136\186\232\185\132",
		["Zolo"] = "\231\165\150\231\189\151",
		["Zul'Lor"] = "\231\165\150\231\189\151\229\176\148",
	}
elseif locale == "koKR" then
	englishToLocal = {
		-- Raid bosses
		["Patchwerk"] = "패치워크",
		["Grobbulus"] = "그라불루스",
		["Gluth"] = "글루스",
		["Thaddius"] = "타디우스",
		["Feugen"] = "페이건", -- 확인 요
		["Stalagg"] = "스탈랙", -- CHECK
		["Anub'Rekhan"] = "아눕레칸",
		["Grand Widow Faerlina"] = "귀부인 팰리나",
		["Maexxna"] = "맥스나",
		["Instructor Razuvious"] = "훈련교관 라주비어스",
		["Gothik the Harvester"] = "영혼의 착취자 고딕",
		["Highlord Mograine"] = "대군주 모그레인",
		["Thane Korth'azz"] = "호족 코르타즈",
		["Lady Blaumeux"] = "귀부인 블로뮤",
		["Sir Zeliek"] = "젤리엑 경",
		["Noth the Plaguebringer"] ="역병술사 노스",
		["Heigan the Unclean"] = "부정의 헤이건",
		["Loatheb"] = "로아텝",
		["Sapphiron"] = "사피론",
		["Kel'Thuzad"] = "켈투자드",
		["Lord Victor Nefarius"] = "군주 빅터 네파리우스", 
		["Nefarian"] = "네파리안",
		["Vaelastrasz the Corrupt"] = "타락한 밸라스트라즈", -- 확인 요... 타락의 ??
		["Razorgore the Untamed"] = "폭군 서슬송곳니", 
		["Broodlord Lashlayer"] = "용기대장 래쉬레이어", 
		["Chromaggus"] = "크로마구스",
		["Ebonroc"] = "에본로크",
		["Firemaw"] = "화염아귀",
		["Flamegor"] = "플레임고르",
		
		["Majordomo Executus"] = "청지기 이그젝큐투스",
		["Ragnaros"] = "라그나로스",
		["Baron Geddon"] = "남작 게돈",
		["Golemagg the Incinerator"] = "초열의 골레마그", 
		["Garr"] = "가르", 
		["Sulfuron Harbinger"] = "설퍼론 사자", 
		["Shazzrah"] = "샤즈라",
		["Lucifron"] = "루시프론",
		["Gehennas"] = "게헨나스",
		["Magmadar"] = "마그마다르",
		
		["Onyxia"] = "오닉시아",
		["Azuregos"] = "아주어고스", 
		["Lord Kazzak"] = "군주 카자크", 
		["Ysondre"] = "이손드레", 
		["Emeriss"] = "에메리스",
		["Taerar"] = "타에라",
		["Lethon"] = "레손", 
		
		["High Priestess Jeklik"] = "대여사제 제클릭",
		["High Priest Venoxis"] = "대사제 베녹시스",
		["High Priest Thekal"] = "대사제 데칼", 
		["High Priestess Arlokk"] = "대여사제 알로크", 
		["High Priestess Mar'li"] = "대여사제 말리",
		["Jin'do the Hexxer"] = "주술사 진도", 
		["Bloodlord Mandokir"] = "혈군주 만도키르",
		["Gahz'ranka"] = "가즈란카", 
		["Gri'lek"] = "그리렉", -- 확인요
		["Hazza'rah"] = "하자라", -- 확인요
		["Renataki"] = "레나타키", -- 확인요
		["Wushoolay"] = "우슬레이", -- 확인요
		["Hakkar"] = "학카르",
		
		["Ayamiss the Hunter"] = "사냥꾼 아야미스",
		["Buru the Gorger"] = "먹보 부루",
		["General Rajaxx"] = "장군 라작스",
		["Moam"] = "모암", 
		["Anubisath Guardian"] = "아누비사스 감시자",
		["Ossirian the Unscarred"] = "무적의 오시리안",
		
		["Lord Kri"] = "군주 크리",
		["Princess Yauj"] = "공주 야우즈",
		["Vem"] = "벰",
		["Eye of C'Thun"] = "쑨의 눈",
		["Anubisath Defender"] = "아누비사스 문지기",
		["Fankriss the Unyielding"] = "불굴의 판크리스",
		["Princess Huhuran"] = "공주 후후란",
		["Ouro"] = "아우로",
		["Battleguard Sartura"] = "전투감시병 살투라",
		["The Prophet Skeram"] = "예언자 스케람",
		["Emperor Vek'lor"] = "제왕 베클로어",
		["Emperor Vek'nilash"] = "제왕 베크닐라쉬",
		["Viscidus"] = "비시디우스",
		-- Regular bosses
		["Alzzin the Wildshaper"] = "칼날바람 알진", 
		["Ambassador Flamelash"] = "사자 화염채찍", 
		["Anger'rel"] = "Anger'rel", 
		["Archivist Galford"] = "기록관 갈포드", 
		["Atal'alarion"] = "아탈알라리온", 
		["Avatar of Hakkar"] = "학카르의 화신", 
		["Bael'Gar"] = "벨가르", 
		["Balnazzar"] = "발나자르", 
		["Baroness Anastari"] = "남작부인 아나스타리", 
		["Baron Rivendare"] = "남작 리븐데어", 
		["Cannon Master Willey"] = "포병대장 윌리", 
		["Captain Kromcrush"] = "대장 크롬크러쉬", 
		["Celebras the Cursed"] = "저주받은 셀레브라스", 
		["Crystal Fang"] = "수정 맹독 거미", 
		["Darkmaster Gandling"] = "암흑스승 간틀링", 
		["Doctor Theolen Krastinov"] = "학자 테올린 크라스티노브", 
		["Doom'rel"] = "운명의 문지기", 
		["Dope'rel"] = "최면의 문지기", 
		["Dreamscythe"] = "드림사이드", 
		["Emperor Dagran Thaurissan"] = "제왕 다그란 타우릿산", 
		["Fineous Darkvire"] = "파이너스 다크바이어",  
		["Gasher"] = "게이셔",  
		["General Angerforge"] = "사령관 앵거포지",  
		["General Drakkisath"] = "사령관 드라키사스",  
		["Gloom'rel"] = "그늘의 문지기",  
		["Golem Lord Argelmach"] = "골렘군주 아젤마크",  
		["Goraluk Anvilcrack"] = "고랄루크 앤빌크랙",  
		["Guard Fengus"] = "경비병 펜구스",  
		["Guard Mol'dar"] = "경비병 몰다르",  
		["Guard Slip'kik"] = "경기병 슬립킥",  
		["Gyth"] = "기스",  
		["Halycon"] = "할리콘",  
		["Hate'rel"] = "증오의 문지기",  
		["Hazzas"] = "하자스",  
		["Hearthsinger Forresten"] = "하스싱어 포레스턴",  
		["High Interrogator Gerstahn"] = "대심문관 게르스탄",  
		["Highlord Omokk"] = "대군주 오모크",  
		["Hukku"] = "후쿠",  
		["Hurley Blackbreath"] = "헐레이 블랙브레스",  
		["Hydrospawn"] = "히드로스폰",  
		["Illyanna Ravenoak"] = "일샨나 레이븐호크",  
		["Immol'thar"] = "이몰타르",  
		["Instructor Malicia"] = "조교 말리시아",  
		["Jammal'an the Prophet"] = "예언자 잠말란",  
		["Jandice Barov"] = "잔다이스 바로브",  
		["King Gordok"] = "왕 고르독",  
		["Kirtonos the Herald"] = "사자 키르토노스",  
		["Lady Illucia Barov"] = "여군주 일루시아 바로브",  
		["Landslide"] = "산사태",  
		["Lethtendris"] = "레스텐드리스",  
		["Lord Alexei Barov"] = "군주 알렉세이 바로브",  
		["Lord Incendius"] = "군주 인센디우스",  
		["Lord Vyletongue"] = "군주 바일텅",  
		["Lorekeeper Polkelt"] = "현자 폴켈트",  
		["Loro"] = "로로",  
		["Magister Kalendris"] = "마법사 칼렌드리스",  
		["Magistrate Barthilas"] = "집정관 바실라스",  
		["Magmus"] = "마그무스",  
		["Maleki the Pallid"] = "냉혈한 말레키",  
		["Marduk Blackpool"] = "마르두크 블랙풀",  
		["Meshlok the Harvester"] = "정원사 메슬로크",  
		["Mijan"] = "마이잔",  
		["Morphaz"] = "몰파즈",  
		["Mother Smolderweb"] = "여왕 불그물거미",  
		["Nerub'enkan"] = "네룹엔칸",  
		["Noxxion"] = "녹시온",  
		["Ogom the Wretched"] = "비운의 오그옴",  
		["Overlord Wyrmthalak"] = "대군주 윔타라크",  
		["Phalanx"] = "팔란스",  
		["Plugger Spazzring"] = "플러거스파즈링",  
		["Postmaster Malown"] = "우체국장 말로운",  
		["Princess Moira Bronzebeard"] = "공주 모이라 브론즈비어드",  
		["Princess Theradras"] = "공주 테라드라스",  
		["Prince Tortheldrin"] = "왕자 토르텔드린",  
		["Pusillin"] = "푸실린",  
		["Pyroguard Emberseer"] = "불의 수호자 엠버시어",  
		["Ramstein the Gorger"] = "먹보 람스타인",  
		["Ras Frostwhisper"] = "라스 프로스트위스퍼",  
		["Rattlegore"] = "들창어금니",  
		["Razorlash"] = "칼날채찍",  
		["Warchief Rend Blackhand"] = "대족장 랜드 블랜핸드",  
		["Ribbly Screwspigot"] = "리블리 스크류스피곳",  
		["Rotgrip"] = "썩은 아귀",  
		["Seeth'rel"] = "불안의 문지기",  
		["Shade of Eranikus"] = "에라니쿠스의 사령",  
		["Shadow Hunter Vosh'gajin"] = "어둠사냥꾼 보쉬가진",  
		["Solakar Flamewreath"] = "화염고리 솔라카르",  
		["Stomper Kreeg"] = "천둥발 크리그",  
		["Tendris Warpwood"] = "굽이나무 텐드리스",  
		["The Beast"] = "괴수",  
		["The Ravenian"] = "라베니안",  
		["Timmy the Cruel"] = "잔혹한 티미",  
		["Tinkerer Gizlock"] = "땜장이 기즐록",  
		["Tsu'zee"] = "츄지",  
		["Vectus"] = "벡투스",  
		["Vile'rel"] = "타락의 문지기",  
		["War Master Voone"] = "대장군 부네",  
		["Weaver"] = "위버",  
		["Zevrim Thornhoof"] = "제브림 쏜후프",  
		["Zolo"] = "졸로",  
		["Zul'Lor"] = "줄로",  
	}
elseif locale ~= "enUS" then
	-- no translations
	englishToLocal = {
	}
end

if englishToLocal then
	for key in pairs(englishToLocal) do
		if not totalBosses[key] then
			error("Improper translation exists. %q is likely misspelled for locale %s.", key, locale)
			break
		end
	end
end

-------------IRIEL'S-STUB-CODE--------------
local stub = {};

-- Instance replacement method, replace contents of old with that of new
function stub:ReplaceInstance(old, new)
   for k,v in pairs(old) do old[k]=nil; end
   for k,v in pairs(new) do old[k]=v; end
end

-- Get a new copy of the stub
function stub:NewStub()
  local newStub = {};
  self:ReplaceInstance(newStub, self);
  newStub.lastVersion = '';
  newStub.versions = {};
  return newStub;
end

-- Get instance version
function stub:GetInstance(version)
   if (not version) then version = self.lastVersion; end
   local versionData = self.versions[version];
   if (not versionData) then
	  message("Cannot find library instance with version '" 
			  .. version .. "'");
	  return;
   end
   return versionData.instance;
end

-- Register new instance
function stub:Register(newInstance)
   local version,minor = newInstance:GetLibraryVersion();
   self.lastVersion = version;
   local versionData = self.versions[version];
   if (not versionData) then
	  -- This one is new!
	  versionData = { instance = newInstance,
		 minor = minor,
		 old = {} 
	  };
	  self.versions[version] = versionData;
	  newInstance:LibActivate(self);
	  return newInstance;
   end
   if (minor <= versionData.minor) then
	  -- This one is already obsolete
	  if (newInstance.LibDiscard) then
		 newInstance:LibDiscard();
	  end
	  return versionData.instance;
   end
   -- This is an update
   local oldInstance = versionData.instance;
   local oldList = versionData.old;
   versionData.instance = newInstance;
   versionData.minor = minor;
   local skipCopy = newInstance:LibActivate(self, oldInstance, oldList);
   table.insert(oldList, oldInstance);
   if (not skipCopy) then
	  for i, old in ipairs(oldList) do
		 self:ReplaceInstance(old, newInstance);
	  end
   end
   return newInstance;
end

-- Bind stub to global scope if it's not already there
if (not BabbleLib) then
   BabbleLib = stub:NewStub();
end

-- Nil stub for garbage collection
stub = nil;
-----------END-IRIEL'S-STUB-CODE------------

local function assert(condition, message)
	if not condition then
		local stack = debugstack()
		local first = string.gsub(stack, "\n.*", "")
		local file = string.gsub(first, "^(.*\\.*).lua:%d+: .*", "%1")
		file = string.gsub(file, "([%(%)%.%*%+%-%[%]%?%^%$%%])", "%%%1")
		if not message then
			local _,_,second = string.find(stack, "\n(.-)\n")
			message = "assertion failed! " .. second
		end
		message = "BabbleLib-Boss: " .. message
		local i = 1
		for s in string.gfind(stack, "\n([^\n]*)") do
			i = i + 1
			if not string.find(s, file .. "%.lua:%d+:") then
				error(message, i)
				return
			end
		end
		error(message, 2)
		return
	end
	return condition
end

local function argCheck(arg, num, kind, kind2, kind3, kind4)
	if tostring(type(arg)) ~= kind then
		if kind2 then
			if tostring(type(arg)) ~= kind2 then
				if kind3 then
					if tostring(type(arg)) ~= kind3 then
						if kind4 then
							if tostring(type(arg)) ~= kind4 then
								local _,_,func = string.find(debugstack(), "\n.-`(.-)'\n")
								assert(false, format("Bad argument #%d to `%s' (%s, %s, %s, or %s expected, got %s)", num, func, kind, kind2, kind3, kind4, type(arg)))
							end
						else
							local _,_,func = string.find(debugstack(), "\n.-`(.-)'\n")
							assert(false, format("Bad argument #%d to `%s' (%s, %s, or %s expected, got %s)", num, func, kind, kind2, kind3, type(arg)))
						end
					end
				else
					local _,_,func = string.find(debugstack(), "\n.-`(.-)'\n")
					assert(false, format("Bad argument #%d to `%s' (%s or %s expected, got %s)", num, func, kind, kind2, type(arg)))
				end
			end
		else
			local _,_,func = string.find(debugstack(), "\n.-`(.-)'\n")
			assert(false, format("Bad argument #%d to `%s' (%s expected, got %s)", num, func, kind, type(arg)))
		end
	end
end

local lib = {}
local localToEnglish

if locale == "enUS" then
	function lib:GetEnglish(boss)
		argCheck(boss, 2, "string")
		assert(totalBosses[boss], format("Boss %q does not exist", boss))
		return boss
	end
	
	function lib:GetLocalized(boss)
		argCheck(boss, 2, "string")
		assert(totalBosses[boss], format("Boss %q does not exist", boss))
		return boss
	end
	
	function lib:GetIterator()
		return pairs(totalBosses)
	end
	
	lib.GetReverseIterator = lib.GetIterator
	
	function lib:HasBoss(boss)
		argCheck(boss, 2, "string")
		return totalBosses[boss] and true or false
	end
else
	function lib:GetEnglish(boss)
		argCheck(boss, 2, "string")
		local t = localToEnglish[boss]
		assert(t, format("Boss %q does not exist or is not translated into %s", boss, locale))
		return t
	end
	
	function lib:GetLocalized(boss)
		argCheck(boss, 2, "string")
		assert(totalBosses[boss], format("Boss %q does not exist", boss))
		local t = englishToLocal[boss]
		assert(t, format("Boss %q is not translated into %s", boss, locale))
		return t
	end
	
	local improperTranslation = nil
	for boss in pairs(totalBosses) do
		if not englishToLocal[boss] then
			improperTranslation = boss
			break
		end
	end
	
	if improperTranslation then
		function lib:GetIterator()
			assert(false, "Boss %q not translated into %s", improperTranslation, locale)
		end
		
		lib.GetReverseIterator = lib.GetIterator
	else
		function lib:GetIterator()
			return pairs(englishToLocal)
		end
		
		function lib:GetReverseIterator()
			return pairs(localToEnglish)
		end
	end
	
	function lib:HasBoss(boss)
		argCheck(boss, 2, "string")
		return (totalBosses[boss] or localToEnglish[boss]) and true or false
	end
end

function lib:GetLibraryVersion()
	return MAJOR_VERSION, MINOR_VERSION
end

function lib:LibActivate(stub, oldLib, oldList)
	if locale ~= "enUS" then
		localToEnglish = {}
		for english, localized in pairs(englishToLocal) do
			localToEnglish[localized] = english
		end
	end
	
	local mt = getmetatable(self) or {}
	mt.__call = self.GetLocalized
	setmetatable(self, mt)
end

function lib:LibDeactivate()
	totalBosses, localToEnglish, englishToLocal = nil
end

BabbleLib:Register(lib)
lib = nil
