local MAJOR_VERSION = "Spell 1.2"
local MINOR_VERSION = tonumber(string.sub("$Revision: 8515 $", 12, -3))

if BabbleLib and BabbleLib.versions[MAJOR_VERSION] and BabbleLib.versions[MAJOR_VERSION].minor >= MINOR_VERSION then
	return
end

local locale = GetLocale and GetLocale() or "enUS"

-- these spells functions were auto-generated, thus the incredible lack of readibility
local totalSpells = {
    ["Abolish Disease"]="Abolish Disease",
    ["Abolish Poison Effect"]="Abolish Poison Effect",
    ["Abolish Poison"]="Abolish Poison",
    ["Activate MG Turret"]="Activate MG Turret",
    ["Adrenaline Rush"]="Adrenaline Rush",
    ["Aftermath"]="Aftermath",
    ["Aggression"]="Aggression",
    ["Aimed Shot"]="Aimed Shot",
    ["Alchemy"]="Alchemy",
    ["Ambush"]="Ambush",
    ["Amplify Curse"]="Amplify Curse",
    ["Amplify Magic"]="Amplify Magic",
    ["Ancestral Healing"]="Ancestral Healing",
    ["Ancestral Knowledge"]="Ancestral Knowledge",
    ["Ancestral Spirit"]="Ancestral Spirit",
    ["Anger Management"]="Anger Management",
    ["Anticipation"]="Anticipation",
    ["Aquatic Form"]="Aquatic Form",
    ["Arcane Brilliance"]="Arcane Brilliance",
    ["Arcane Concentration"]="Arcane Concentration",
    ["Arcane Explosion"]="Arcane Explosion",
    ["Arcane Focus"]="Arcane Focus",
    ["Arcane Instability"]="Arcane Instability",
    ["Arcane Intellect"]="Arcane Intellect",
    ["Arcane Meditation"]="Arcane Meditation",
    ["Arcane Mind"]="Arcane Mind",
    ["Arcane Missiles"]="Arcane Missiles",
    ["Arcane Power"]="Arcane Power",
    ["Arcane Resistance"]="Arcane Resistance",
    ["Arcane Shot"]="Arcane Shot",
    ["Arcane Subtlety"]="Arcane Subtlety",
    ["Arctic Reach"]="Arctic Reach",
    ["Armorsmith"]="Armorsmith",
    ["Aspect of the Beast"]="Aspect of the Beast",
    ["Aspect of the Cheetah"]="Aspect of the Cheetah",
    ["Aspect of the Hawk"]="Aspect of the Hawk",
    ["Aspect of the Monkey"]="Aspect of the Monkey",
    ["Aspect of the Pack"]="Aspect of the Pack",
    ["Aspect of the Wild"]="Aspect of the Wild",
    ["Astral Recall"]="Astral Recall",
    ["Attack"]="Attack",
    ["Attacking"]="Attacking",
    ["Auto Shot"]="Auto Shot",
    ["Axe Specialization"]="Axe Specialization",
    ["Backstab"]="Backstab",
    ["Bane"]="Bane",
    ["Banish"]="Banish",
    ["Barkskin Effect"]="Barkskin Effect",
    ["Barkskin"]="Barkskin",
    ["Barrage"]="Barrage",
    ["Bash"]="Bash",
    ["Basic Campfire"]="Basic Campfire",
    ["Battle Shout"]="Battle Shout",
    ["Battle Stance Passive"]="Battle Stance Passive",
    ["Battle Stance"]="Battle Stance",
    ["Bear Form"]="Bear Form",
    ["Beast Lore"]="Beast Lore",
    ["Beast Slaying"]="Beast Slaying",
    ["Beast Training"]="Beast Training",
    ["Benediction"]="Benediction",
    ["Berserker Rage"]="Berserker Rage",
    ["Berserker Stance Passive"]="Berserker Stance Passive",
    ["Berserker Stance"]="Berserker Stance",
    ["Berserking"]="Berserking",
    ["Bestial Discipline"]="Bestial Discipline",
    ["Bestial Swiftness"]="Bestial Swiftness",
    ["Bestial Wrath"]="Bestial Wrath",
    ["Bite"]="Bite",
    ["Black Arrow"]="Black Arrow",
    ["Blackout"]="Blackout",
    ["Blacksmithing"]="Blacksmithing",
    ["Blade Flurry"]="Blade Flurry",
    ["Blast Wave"]="Blast Wave",
    ["Blessed Recovery"]="Blessed Recovery",
    ["Blessing of Freedom"]="Blessing of Freedom",
    ["Blessing of Kings"]="Blessing of Kings",
    ["Blessing of Light"]="Blessing of Light",
    ["Blessing of Might"]="Blessing of Might",
    ["Blessing of Protection"]="Blessing of Protection",
    ["Blessing of Sacrifice"]="Blessing of Sacrifice",
    ["Blessing of Salvation"]="Blessing of Salvation",
    ["Blessing of Sanctuary"]="Blessing of Sanctuary",
    ["Blessing of Wisdom"]="Blessing of Wisdom",
    ["Blind"]="Blind",
    ["Blinding Powder"]="Blinding Powder",
    ["Blink"]="Blink",
    ["Blizzard"]="Blizzard",
    ["Block"]="Block",
    ["Blood Craze"]="Blood Craze",
    ["Blood Frenzy"]="Blood Frenzy",
    ["Blood Fury"]="Blood Fury",
    ["Blood Pact"]="Blood Pact",
    ["Bloodrage"]="Bloodrage",
    ["Bloodthirst"]="Bloodthirst",
    ["Booming Voice"]="Booming Voice",
    ["Bow Specialization"]="Bow Specialization",
    ["Bows"]="Bows",
    ["Bright Campfire"]="Bright Campfire",
    ["Brutal Impact"]="Brutal Impact",
    ["Burning Soul"]="Burning Soul",
    ["Call Pet"]="Call Pet",
    ["Call of Flame"]="Call of Flame",
    ["Call of Thunder"]="Call of Thunder",
    ["Camouflage"]="Camouflage",
    ["Cannibalize"]="Cannibalize",
    ["Cat Form"]="Cat Form",
    ["Cataclysm"]="Cataclysm",
    ["Chain Heal"]="Chain Heal",
    ["Chain Lightning"]="Chain Lightning",
    ["Challenging Roar"]="Challenging Roar",
    ["Challenging Shout"]="Challenging Shout",
    ["Charge Rage Bonus Effect"]="Charge Rage Bonus Effect",
    ["Charge"]="Charge",
    ["Cheap Shot"]="Cheap Shot",
    ["Chilled"]="Chilled",
    ["Claw"]="Claw",
    ["Cleanse"]="Cleanse",
    ["Clearcasting"]="Clearcasting",
    ["Cleave"]="Cleave",
    ["Clever Traps"]="Clever Traps",
    ["Closing"]="Closing",
    ["Cloth"]="Cloth",
    ["Cobra Reflexes"]="Cobra Reflexes",
    ["Cold Blood"]="Cold Blood",
    ["Cold Snap"]="Cold Snap",
    ["Combat Endurance"]="Combat Endurance",
    ["Combustion"]="Combustion",
    ["Command"]="Command",
    ["Concentration Aura"]="Concentration Aura",
    ["Concussion Blow"]="Concussion Blow",
    ["Concussion"]="Concussion",
    ["Concussive Shot"]="Concussive Shot",
    ["Cone of Cold"]="Cone of Cold",
    ["Conflagrate"]="Conflagrate",
    ["Conjure Food"]="Conjure Food",
    ["Conjure Mana Agate"]="Conjure Mana Agate",
    ["Conjure Mana Citrine"]="Conjure Mana Citrine",
    ["Conjure Mana Jade"]="Conjure Mana Jade",
    ["Conjure Mana Ruby"]="Conjure Mana Ruby",
    ["Conjure Water"]="Conjure Water",
    ["Consecration"]="Consecration",
    ["Consume Shadows"]="Consume Shadows",
    ["Convection"]="Convection",
    ["Conviction"]="Conviction",
    ["Cooking"]="Cooking",
    ["Corruption"]="Corruption",
    ["Counterattack"]="Counterattack",
    ["Counterspell"]="Counterspell",
    ["Cower"]="Cower",
    ["Create Firestone"]="Create Firestone",
    ["Create Healthstone"]="Create Healthstone",
    ["Create Soulstone"]="Create Soulstone",
    ["Create Spellstone"]="Create Spellstone",
    ["Crippling Poison II"]="Crippling Poison II",
    ["Crippling Poison"]="Crippling Poison",
    ["Critical Mass"]="Critical Mass",
    ["Crossbows"]="Crossbows",
    ["Cruelty"]="Cruelty",
    ["Cultivation"]="Cultivation",
    ["Cure Disease"]="Cure Disease",
    ["Cure Poison"]="Cure Poison",
    ["Curse of Agony"]="Curse of Agony",
    ["Curse of Doom Effect"]="Curse of Doom Effect",
    ["Curse of Doom"]="Curse of Doom",
    ["Curse of Exhaustion"]="Curse of Exhaustion",
    ["Curse of Idiocy"]="Curse of Idiocy",
    ["Curse of Recklessness"]="Curse of Recklessness",
    ["Curse of Shadow"]="Curse of Shadow",
    ["Curse of Tongues"]="Curse of Tongues",
    ["Curse of Weakness"]="Curse of Weakness",
    ["Curse of the Elements"]="Curse of the Elements",
    ["Dagger Specialization"]="Dagger Specialization",
    ["Daggers"]="Daggers",
    ["Dampen Magic"]="Dampen Magic",
    ["Dark Pact"]="Dark Pact",
    ["Darkness"]="Darkness",
    ["Dash"]="Dash",
    ["Deadly Poison II"]="Deadly Poison II",
    ["Deadly Poison III"]="Deadly Poison III",
    ["Deadly Poison IV"]="Deadly Poison IV",
    ["Deadly Poison V"]="Deadly Poison V",
    ["Deadly Poison"]="Deadly Poison",
    ["Death Coil"]="Death Coil",
    ["Death Wish"]="Death Wish",
    ["Deep Wounds"]="Deep Wounds",
    ["Defense"]="Defense",
    ["Defensive Stance Passive"]="Defensive Stance Passive",
    ["Defensive Stance"]="Defensive Stance",
    ["Defensive State 2"]="Defensive State 2",
    ["Defensive State"]="Defensive State",
    ["Defiance"]="Defiance",
    ["Deflection"]="Deflection",
    ["Demon Armor"]="Demon Armor",
    ["Demon Skin"]="Demon Skin",
    ["Demonic Embrace"]="Demonic Embrace",
    ["Demonic Sacrifice"]="Demonic Sacrifice",
    ["Demoralizing Roar"]="Demoralizing Roar",
    ["Demoralizing Shout"]="Demoralizing Shout",
    ["Desperate Prayer"]="Desperate Prayer",
    ["Destructive Reach"]="Destructive Reach",
    ["Detect Greater Invisibility"]="Detect Greater Invisibility",
    ["Detect Invisibility"]="Detect Invisibility",
    ["Detect Lesser Invisibility"]="Detect Lesser Invisibility",
    ["Detect Magic"]="Detect Magic",
    ["Detect Traps"]="Detect Traps",
    ["Detect"]="Detect",
    ["Deterrence"]="Deterrence",
    ["Devastation"]="Devastation",
    ["Devotion Aura"]="Devotion Aura",
    ["Devour Magic Effect"]="Devour Magic Effect",
    ["Devour Magic"]="Devour Magic",
    ["Devouring Plague"]="Devouring Plague",
    ["Diplomacy"]="Diplomacy",
    ["Dire Bear Form"]="Dire Bear Form",
    ["Disarm Trap"]="Disarm Trap",
    ["Disarm"]="Disarm",
    ["Disease Cleansing Totem"]="Disease Cleansing Totem",
    ["Disenchant"]="Disenchant",
    ["Disengage"]="Disengage",
    ["Dismiss Pet"]="Dismiss Pet",
    ["Dispel Magic"]="Dispel Magic",
    ["Distract"]="Distract",
    ["Distracting Shot"]="Distracting Shot",
    ["Dive"]="Dive",
    ["Divine Favor"]="Divine Favor",
    ["Divine Fury"]="Divine Fury",
    ["Divine Intellect"]="Divine Intellect",
    ["Divine Intervention"]="Divine Intervention",
    ["Divine Protection"]="Divine Protection",
    ["Divine Shield"]="Divine Shield",
    ["Divine Spirit"]="Divine Spirit",
    ["Divine Strength"]="Divine Strength",
    ["Dodge"]="Dodge",
    ["Dragonscale Leatherworking"]="Dragonscale Leatherworking",
    ["Drain Life"]="Drain Life",
    ["Drain Mana"]="Drain Mana",
    ["Drain Soul"]="Drain Soul",
    ["Drink"]="Drink",
    ["Dual Wield Specialization"]="Dual Wield Specialization",
    ["Dual Wield"]="Dual Wield",
    ["Duel"]="Duel",
    ["Eagle Eye"]="Eagle Eye",
    ["Earth Shock"]="Earth Shock",
    ["Earthbind Totem"]="Earthbind Totem",
    ["Efficiency"]="Efficiency",
    ["Elemental Focus"]="Elemental Focus",
    ["Elemental Fury"]="Elemental Fury",
    ["Elemental Leatherworking"]="Elemental Leatherworking",
    ["Elemental Mastery"]="Elemental Mastery",
    ["Elune's Grace"]="Elune's Grace",
    ["Elusiveness"]="Elusiveness",
    ["Emberstorm"]="Emberstorm",
    ["Enchanting"]="Enchanting",
    ["Endurance Training"]="Endurance Training",
    ["Endurance"]="Endurance",
    ["Engineering Specialization"]="Engineering Specialization",
    ["Engineering"]="Engineering",
    ["Enrage"]="Enrage",
    ["Enriched Manna Biscuit"]="Enriched Manna Biscuit",
    ["Enslave Demon"]="Enslave Demon",
    ["Entangling Roots"]="Entangling Roots",
    ["Entrapment"]="Entrapment",
    ["Escape Artist"]="Escape Artist",
    ["Evasion"]="Evasion",
    ["Eventide"]="Eventide",
    ["Eviscerate"]="Eviscerate",
    ["Evocation"]="Evocation",
    ["Execute"]="Execute",
    ["Exorcism"]="Exorcism",
    ["Expansive Mind"]="Expansive Mind",
    ["Explosive Trap Effect"]="Explosive Trap Effect",
    ["Explosive Trap"]="Explosive Trap",
    ["Expose Armor"]="Expose Armor",
    ["Eye for an Eye"]="Eye for an Eye",
    ["Eye of Kilrogg"]="Eye of Kilrogg",
    ["Eyes of the Beast"]="Eyes of the Beast",
    ["Fade"]="Fade",
    ["Faerie Fire"]="Faerie Fire",
    ["Far Sight"]="Far Sight",
    ["Fear Ward"]="Fear Ward",
    ["Fear"]="Fear",
    ["Feed Pet"]="Feed Pet",
    ["Feedback"]="Feedback",
    ["Feign Death"]="Feign Death",
    ["Feint"]="Feint",
    ["Fel Concentration"]="Fel Concentration",
    ["Fel Domination"]="Fel Domination",
    ["Fel Intellect"]="Fel Intellect",
    ["Fel Stamina"]="Fel Stamina",
    ["Felfire"]="Felfire",
    ["Feline Grace"]="Feline Grace",
    ["Feline Swiftness"]="Feline Swiftness",
    ["Feral Aggression"]="Feral Aggression",
    ["Feral Charge"]="Feral Charge",
    ["Feral Instinct"]="Feral Instinct",
    ["Ferocious Bite"]="Ferocious Bite",
    ["Ferocity"]="Ferocity",
    ["Fetish"]="Fetish",
    ["Find Herbs"]="Find Herbs",
    ["Find Minerals"]="Find Minerals",
    ["Find Treasure"]="Find Treasure",
    ["Fire Blast"]="Fire Blast",
    ["Fire Nova Totem"]="Fire Nova Totem",
    ["Fire Power"]="Fire Power",
    ["Fire Resistance Aura"]="Fire Resistance Aura",
    ["Fire Resistance Totem"]="Fire Resistance Totem",
    ["Fire Resistance"]="Fire Resistance",
    ["Fire Shield"]="Fire Shield",
    ["Fire Vulnerability"]="Fire Vulnerability",
    ["Fire Ward"]="Fire Ward",
    ["Fireball"]="Fireball",
    ["Firebolt"]="Firebolt",
    ["First Aid"]="First Aid",
    ["Fishing Poles"]="Fishing Poles",
    ["Fishing"]="Fishing",
    ["Fist Weapon Specialization"]="Fist Weapon Specialization",
    ["Fist Weapons"]="Fist Weapons",
    ["Flame Shock"]="Flame Shock",
    ["Flame Throwing"]="Flame Throwing",
    ["Flamestrike"]="Flamestrike",
    ["Flamethrower"]="Flamethrower",
    ["Flametongue Totem"]="Flametongue Totem",
    ["Flametongue Weapon"]="Flametongue Weapon",
    ["Flare"]="Flare",
    ["Flash Heal"]="Flash Heal",
    ["Flash of Light"]="Flash of Light",
    ["Flurry"]="Flurry",
    ["Focused Casting"]="Focused Casting",
    ["Food"]="Food",
    ["Force of Will"]="Force of Will",
    ["Freezing Trap Effect"]="Freezing Trap Effect",
    ["Freezing Trap"]="Freezing Trap",
    ["Frenzied Regeneration"]="Frenzied Regeneration",
    ["Frenzy"]="Frenzy",
    ["Frost Armor"]="Frost Armor",
    ["Frost Channeling"]="Frost Channeling",
    ["Frost Nova"]="Frost Nova",
    ["Frost Resistance Aura"]="Frost Resistance Aura",
    ["Frost Resistance Totem"]="Frost Resistance Totem",
    ["Frost Resistance"]="Frost Resistance",
    ["Frost Shock"]="Frost Shock",
    ["Frost Trap"]="Frost Trap",
    ["Frost Ward"]="Frost Ward",
    ["Frostbite"]="Frostbite",
    ["Frostbolt"]="Frostbolt",
    ["Frostbrand Weapon"]="Frostbrand Weapon",
    ["Furious Howl"]="Furious Howl",
    ["Furor"]="Furor",
    ["Garrote"]="Garrote",
    ["Generic"]="Generic",
    ["Ghost Wolf"]="Ghost Wolf",
    ["Ghostly Strike"]="Ghostly Strike",
    ["Gift of Nature"]="Gift of Nature",
    ["Gift of the Wild"]="Gift of the Wild",
    ["Gouge"]="Gouge",
    ["Grace of Air Totem"]="Grace of Air Totem",
    ["Great Stamina"]="Great Stamina",
    ["Greater Blessing of Kings"]="Greater Blessing of Kings",
    ["Greater Blessing of Light"]="Greater Blessing of Light",
    ["Greater Blessing of Might"]="Greater Blessing of Might",
    ["Greater Blessing of Salvation"]="Greater Blessing of Salvation",
    ["Greater Blessing of Sanctuary"]="Greater Blessing of Sanctuary",
    ["Greater Blessing of Wisdom"]="Greater Blessing of Wisdom",
    ["Greater Heal"]="Greater Heal",
    ["Grim Reach"]="Grim Reach",
    ["Grounding Totem"]="Grounding Totem",
    ["Grovel"]="Grovel",
    ["Growl"]="Growl",
    ["Guardian's Favor"]="Guardian's Favor",
    ["Gun Specialization"]="Gun Specialization",
    ["Guns"]="Guns",
    ["Hammer of Justice"]="Hammer of Justice",
    ["Hammer of Wrath"]="Hammer of Wrath",
    ["Hamstring"]="Hamstring",
    ["Harass"]="Harass",
    ["Hardiness"]="Hardiness",
    ["Hawk Eye"]="Hawk Eye",
    ["Heal"]="Heal",
    ["Healing Focus"]="Healing Focus",
    ["Healing Light"]="Healing Light",
    ["Healing Stream Totem"]="Healing Stream Totem",
    ["Healing Touch"]="Healing Touch",
    ["Healing Wave"]="Healing Wave",
    ["Health Funnel"]="Health Funnel",
    ["Heart of the Wild"]="Heart of the Wild",
    ["Hellfire Effect"]="Hellfire Effect",
    ["Hellfire"]="Hellfire",
    ["Hemorrhage"]="Hemorrhage",
    ["Herb Gathering"]="Herb Gathering",
    ["Herbalism"]="Herbalism",
    ["Heroic Strike"]="Heroic Strike",
    ["Hex of Weakness"]="Hex of Weakness",
    ["Hibernate"]="Hibernate",
    ["Holy Fire"]="Holy Fire",
    ["Holy Light"]="Holy Light",
    ["Holy Nova"]="Holy Nova",
    ["Holy Power"]="Holy Power",
    ["Holy Reach"]="Holy Reach",
    ["Holy Shield"]="Holy Shield",
    ["Holy Shock"]="Holy Shock",
    ["Holy Specialization"]="Holy Specialization",
    ["Holy Wrath"]="Holy Wrath",
    ["Honorless Target"]="Honorless Target",
    ["Horse Riding"]="Horse Riding",
    ["Howl of Terror"]="Howl of Terror",
    ["Humanoid Slaying"]="Humanoid Slaying",
    ["Hunter's Mark"]="Hunter's Mark",
    ["Hurricane"]="Hurricane",
    ["Ice Armor"]="Ice Armor",
    ["Ice Barrier"]="Ice Barrier",
    ["Ice Block"]="Ice Block",
    ["Ice Shards"]="Ice Shards",
    ["Ignite"]="Ignite",
    ["Illumination"]="Illumination",
    ["Immolate"]="Immolate",
    ["Immolation Trap Effect"]="Immolation Trap Effect",
    ["Immolation Trap"]="Immolation Trap",
    ["Impact"]="Impact",
    ["Impale"]="Impale",
    ["Improved Ambush"]="Improved Ambush",
    ["Improved Arcane Explosion"]="Improved Arcane Explosion",
    ["Improved Arcane Missiles"]="Improved Arcane Missiles",
    ["Improved Arcane Shot"]="Improved Arcane Shot",
    ["Improved Aspect of the Hawk"]="Improved Aspect of the Hawk",
    ["Improved Aspect of the Monkey"]="Improved Aspect of the Monkey",
    ["Improved Backstab"]="Improved Backstab",
    ["Improved Battle Shout"]="Improved Battle Shout",
    ["Improved Berserker Rage"]="Improved Berserker Rage",
    ["Improved Blessing of Might"]="Improved Blessing of Might",
    ["Improved Blessing of Wisdom"]="Improved Blessing of Wisdom",
    ["Improved Blizzard"]="Improved Blizzard",
    ["Improved Bloodrage"]="Improved Bloodrage",
    ["Improved Chain Heal"]="Improved Chain Heal",
    ["Improved Chain Lightning"]="Improved Chain Lightning",
    ["Improved Challenging Shout"]="Improved Challenging Shout",
    ["Improved Charge"]="Improved Charge",
    ["Improved Cheap Shot"]="Improved Cheap Shot",
    ["Improved Cleave"]="Improved Cleave",
    ["Improved Concentration Aura"]="Improved Concentration Aura",
    ["Improved Concussive Shot"]="Improved Concussive Shot",
    ["Improved Cone of Cold"]="Improved Cone of Cold",
    ["Improved Corruption"]="Improved Corruption",
    ["Improved Counterspell"]="Improved Counterspell",
    ["Improved Curse of Agony"]="Improved Curse of Agony",
    ["Improved Curse of Exhaustion"]="Improved Curse of Exhaustion",
    ["Improved Curse of Weakness"]="Improved Curse of Weakness",
    ["Improved Dampen Magic"]="Improved Dampen Magic",
    ["Improved Deadly Poison"]="Improved Deadly Poison",
    ["Improved Demoralizing Shout"]="Improved Demoralizing Shout",
    ["Improved Devotion Aura"]="Improved Devotion Aura",
    ["Improved Disarm"]="Improved Disarm",
    ["Improved Distract"]="Improved Distract",
    ["Improved Drain Life"]="Improved Drain Life",
    ["Improved Drain Mana"]="Improved Drain Mana",
    ["Improved Drain Soul"]="Improved Drain Soul",
    ["Improved Enrage"]="Improved Enrage",
    ["Improved Enslave Demon"]="Improved Enslave Demon",
    ["Improved Entangling Roots"]="Improved Entangling Roots",
    ["Improved Evasion"]="Improved Evasion",
    ["Improved Eviscerate"]="Improved Eviscerate",
    ["Improved Execute"]="Improved Execute",
    ["Improved Expose Armor"]="Improved Expose Armor",
    ["Improved Eyes of the Beast"]="Improved Eyes of the Beast",
    ["Improved Fade"]="Improved Fade",
    ["Improved Feign Death"]="Improved Feign Death",
    ["Improved Fire Blast"]="Improved Fire Blast",
    ["Improved Fire Nova Totem"]="Improved Fire Nova Totem",
    ["Improved Fire Ward"]="Improved Fire Ward",
    ["Improved Fireball"]="Improved Fireball",
    ["Improved Firebolt"]="Improved Firebolt",
    ["Improved Firestone"]="Improved Firestone",
    ["Improved Flamestrike"]="Improved Flamestrike",
    ["Improved Flametongue Weapon"]="Improved Flametongue Weapon",
    ["Improved Flash of Light"]="Improved Flash of Light",
    ["Improved Frost Nova"]="Improved Frost Nova",
    ["Improved Frost Ward"]="Improved Frost Ward",
    ["Improved Frostbolt"]="Improved Frostbolt",
    ["Improved Frostbrand Weapon"]="Improved Frostbrand Weapon",
    ["Improved Garrote"]="Improved Garrote",
    ["Improved Ghost Wolf"]="Improved Ghost Wolf",
    ["Improved Gouge"]="Improved Gouge",
    ["Improved Grace of Air Totem"]="Improved Grace of Air Totem",
    ["Improved Grounding Totem"]="Improved Grounding Totem",
    ["Improved Hammer of Justice"]="Improved Hammer of Justice",
    ["Improved Hamstring"]="Improved Hamstring",
    ["Improved Healing Stream Totem"]="Improved Healing Stream Totem",
    ["Improved Healing Touch"]="Improved Healing Touch",
    ["Improved Healing Wave"]="Improved Healing Wave",
    ["Improved Healing"]="Improved Healing",
    ["Improved Health Funnel"]="Improved Health Funnel",
    ["Improved Healthstone"]="Improved Healthstone",
    ["Improved Heroic Strike"]="Improved Heroic Strike",
    ["Improved Hunter's Mark"]="Improved Hunter's Mark",
    ["Improved Immolate"]="Improved Immolate",
    ["Improved Imp"]="Improved Imp",
    ["Improved Inner Fire"]="Improved Inner Fire",
    ["Improved Instant Poison"]="Improved Instant Poison",
    ["Improved Intercept"]="Improved Intercept",
    ["Improved Intimidating Shout"]="Improved Intimidating Shout",
    ["Improved Judgement"]="Improved Judgement",
    ["Improved Kick"]="Improved Kick",
    ["Improved Kidney Shot"]="Improved Kidney Shot",
    ["Improved Lash of Pain"]="Improved Lash of Pain",
    ["Improved Lay on Hands"]="Improved Lay on Hands",
    ["Improved Lesser Healing Wave"]="Improved Lesser Healing Wave",
    ["Improved Life Tap"]="Improved Life Tap",
    ["Improved Lightning Bolt"]="Improved Lightning Bolt",
    ["Improved Lightning Shield"]="Improved Lightning Shield",
    ["Improved Magma Totem"]="Improved Magma Totem",
    ["Improved Mana Burn"]="Improved Mana Burn",
    ["Improved Mana Shield"]="Improved Mana Shield",
    ["Improved Mana Spring Totem"]="Improved Mana Spring Totem",
    ["Improved Mark of the Wild"]="Improved Mark of the Wild",
    ["Improved Mend Pet"]="Improved Mend Pet",
    ["Improved Mind Blast"]="Improved Mind Blast",
    ["Improved Moonfire"]="Improved Moonfire",
    ["Improved Nature's Grasp"]="Improved Nature's Grasp",
    ["Improved Overpower"]="Improved Overpower",
    ["Improved Power Word: Fortitude"]="Improved Power Word: Fortitude",
    ["Improved Power Word: Shield"]="Improved Power Word: Shield",
    ["Improved Prayer of Healing"]="Improved Prayer of Healing",
    ["Improved Psychic Scream"]="Improved Psychic Scream",
    ["Improved Pummel"]="Improved Pummel",
    ["Improved Regrowth"]="Improved Regrowth",
    ["Improved Reincarnation"]="Improved Reincarnation",
    ["Improved Rejuvenation"]="Improved Rejuvenation",
    ["Improved Rend"]="Improved Rend",
    ["Improved Renew"]="Improved Renew",
    ["Improved Retribution Aura"]="Improved Retribution Aura",
    ["Improved Revenge"]="Improved Revenge",
    ["Improved Revive Pet"]="Improved Revive Pet",
    ["Improved Righteous Fury"]="Improved Righteous Fury",
    ["Improved Rockbiter Weapon"]="Improved Rockbiter Weapon",
    ["Improved Rupture"]="Improved Rupture",
    ["Improved Sap"]="Improved Sap",
    ["Improved Scorch"]="Improved Scorch",
    ["Improved Scorpid Sting"]="Improved Scorpid Sting",
    ["Improved Seal of Righteousness"]="Improved Seal of Righteousness",
    ["Improved Seal of the Crusader"]="Improved Seal of the Crusader",
    ["Improved Searing Pain"]="Improved Searing Pain",
    ["Improved Searing Totem"]="Improved Searing Totem",
    ["Improved Serpent Sting"]="Improved Serpent Sting",
    ["Improved Shadow Bolt"]="Improved Shadow Bolt",
    ["Improved Shadow Word: Pain"]="Improved Shadow Word: Pain",
    ["Improved Shield Bash"]="Improved Shield Bash",
    ["Improved Shield Block"]="Improved Shield Block",
    ["Improved Shield Wall"]="Improved Shield Wall",
    ["Improved Shred"]="Improved Shred",
    ["Improved Sinister Strike"]="Improved Sinister Strike",
    ["Improved Slam"]="Improved Slam",
    ["Improved Slice and Dice"]="Improved Slice and Dice",
    ["Improved Spellstone"]="Improved Spellstone",
    ["Improved Sprint"]="Improved Sprint",
    ["Improved Starfire"]="Improved Starfire",
    ["Improved Stoneclaw Totem"]="Improved Stoneclaw Totem",
    ["Improved Stoneskin Totem"]="Improved Stoneskin Totem",
    ["Improved Strength of Earth Totem"]="Improved Strength of Earth Totem",
    ["Improved Succubus"]="Improved Succubus",
    ["Improved Sunder Armor"]="Improved Sunder Armor",
    ["Improved Taunt"]="Improved Taunt",
    ["Improved Thorns"]="Improved Thorns",
    ["Improved Thunder Clap"]="Improved Thunder Clap",
    ["Improved Tranquility"]="Improved Tranquility",
    ["Improved Vampiric Embrace"]="Improved Vampiric Embrace",
    ["Improved Vanish"]="Improved Vanish",
    ["Improved Voidwalker"]="Improved Voidwalker",
    ["Improved Windfury Weapon"]="Improved Windfury Weapon",
    ["Improved Wing Clip"]="Improved Wing Clip",
    ["Improved Wrath"]="Improved Wrath",
    ["Incinerate"]="Incinerate",
    ["Inferno"]="Inferno",
    ["Initiative"]="Initiative",
    ["Inner Fire"]="Inner Fire",
    ["Inner Focus"]="Inner Focus",
    ["Innervate"]="Innervate",
    ["Insect Swarm"]="Insect Swarm",
    ["Inspiration"]="Inspiration",
    ["Instant Poison II"]="Instant Poison II",
    ["Instant Poison III"]="Instant Poison III",
    ["Instant Poison IV"]="Instant Poison IV",
    ["Instant Poison V"]="Instant Poison V",
    ["Instant Poison VI"]="Instant Poison VI",
    ["Instant Poison"]="Instant Poison",
    ["Intensity"]="Intensity",
    ["Intercept"]="Intercept",
    ["Intimidating Shout"]="Intimidating Shout",
    ["Intimidation"]="Intimidation",
    ["Iron Will"]="Iron Will",
    ["Judgement of Command"]="Judgement of Command",
    ["Judgement of Justice"]="Judgement of Justice",
    ["Judgement of Light"]="Judgement of Light",
    ["Judgement of Righteousness"]="Judgement of Righteousness",
    ["Judgement of Wisdom"]="Judgement of Wisdom",
    ["Judgement of the Crusader"]="Judgement of the Crusader",
    ["Judgement"]="Judgement",
    ["Kick"]="Kick",
    ["Kidney Shot"]="Kidney Shot",
    ["Killer Instinct"]="Killer Instinct",
    ["Kodo Riding"]="Kodo Riding",
    ["Lash of Pain"]="Lash of Pain",
    ["Last Stand"]="Last Stand",
    ["Lasting Judgement"]="Lasting Judgement",
    ["Lay on Hands"]="Lay on Hands",
    ["Leader of the Pack"]="Leader of the Pack",
    ["Leather"]="Leather",
    ["Leatherworking"]="Leatherworking",
    ["Lesser Heal"]="Lesser Heal",
    ["Lesser Healing Wave"]="Lesser Healing Wave",
    ["Lesser Invisibility"]="Lesser Invisibility",
    ["Lethal Shots"]="Lethal Shots",
    ["Lethality"]="Lethality",
    ["Levitate"]="Levitate",
    ["Libram"]="Libram",
    ["Life Tap"]="Life Tap",
    ["Lightning Bolt"]="Lightning Bolt",
    ["Lightning Breath"]="Lightning Breath",
    ["Lightning Mastery"]="Lightning Mastery",
    ["Lightning Reflexes"]="Lightning Reflexes",
    ["Lightning Shield"]="Lightning Shield",
    ["Lightwell Renew"]="Lightwell Renew",
    ["Lightwell"]="Lightwell",
    ["Lockpicking"]="Lockpicking",
    ["Long Daze"]="Long Daze",
    ["Mace Specialization"]="Mace Specialization",
    ["Mace Stun Effect"]="Mace Stun Effect",
    ["Mage Armor"]="Mage Armor",
    ["Magma Totem"]="Magma Totem",
    ["Mail"]="Mail",
    ["Malice"]="Malice",
    ["Mana Burn"]="Mana Burn",
    ["Mana Shield"]="Mana Shield",
    ["Mana Spring Totem"]="Mana Spring Totem",
    ["Mana Tide Totem"]="Mana Tide Totem",
    ["Mangle"]="Mangle",
    ["Mark of the Wild"]="Mark of the Wild",
    ["Martyrdom"]="Martyrdom",
    ["Master Demonologist"]="Master Demonologist",
    ["Master Summoner"]="Master Summoner",
    ["Master of Deception"]="Master of Deception",
    ["Maul"]="Maul",
    ["Mechanostrider Piloting"]="Mechanostrider Piloting",
    ["Meditation"]="Meditation",
    ["Melee Specialization"]="Melee Specialization",
    ["Mend Pet"]="Mend Pet",
    ["Mental Agility"]="Mental Agility",
    ["Mental Strength"]="Mental Strength",
    ["Mind Blast"]="Mind Blast",
    ["Mind Control"]="Mind Control",
    ["Mind Flay"]="Mind Flay",
    ["Mind Soothe"]="Mind Soothe",
    ["Mind Vision"]="Mind Vision",
    ["Mind-numbing Poison II"]="Mind-numbing Poison II",
    ["Mind-numbing Poison III"]="Mind-numbing Poison III",
    ["Mind-numbing Poison"]="Mind-numbing Poison",
    ["Mining"]="Mining",
    ["Mocking Blow"]="Mocking Blow",
    ["Mongoose Bite"]="Mongoose Bite",
    ["Monster Slaying"]="Monster Slaying",
    ["Moonfire"]="Moonfire",
    ["Moonfury"]="Moonfury",
    ["Moonglow"]="Moonglow",
    ["Moonkin Aura"]="Moonkin Aura",
    ["Moonkin Form"]="Moonkin Form",
    ["Mortal Shots"]="Mortal Shots",
    ["Mortal Strike"]="Mortal Strike",
    ["Multi-Shot"]="Multi-Shot",
    ["Murder"]="Murder",
    ["Natural Armor"]="Natural Armor",
    ["Natural Shapeshifter"]="Natural Shapeshifter",
    ["Natural Weapons"]="Natural Weapons",
    ["Nature Resistance Totem"]="Nature Resistance Totem",
    ["Nature Resistance"]="Nature Resistance",
    ["Nature's Focus"]="Nature's Focus",
    ["Nature's Grace"]="Nature's Grace",
    ["Nature's Grasp"]="Nature's Grasp",
    ["Nature's Reach"]="Nature's Reach",
    ["Nature's Swiftness"]="Nature's Swiftness",
    ["Nightfall"]="Nightfall",
    ["Omen of Clarity"]="Omen of Clarity",
    ["One-Handed Axes"]="One-Handed Axes",
    ["One-Handed Maces"]="One-Handed Maces",
    ["One-Handed Swords"]="One-Handed Swords",
    ["One-Handed Weapon Specialization"]="One-Handed Weapon Specialization",
    ["Opening - No Text"]="Opening - No Text",
    ["Opening"]="Opening",
    ["Opportunity"]="Opportunity",
    ["Overpower"]="Overpower",
    ["Paranoia"]="Paranoia",
    ["Parry"]="Parry",
    ["Pathfinding"]="Pathfinding",
    ["Perception"]="Perception",
    ["Permafrost"]="Permafrost",
    ["Pet Aggression"]="Pet Aggression",
    ["Pet Hardiness"]="Pet Hardiness",
    ["Pet Recovery"]="Pet Recovery",
    ["Pet Resistance"]="Pet Resistance",
    ["Phase Shift"]="Phase Shift",
    ["Pick Lock"]="Pick Lock",
    ["Pick Pocket"]="Pick Pocket",
    ["Piercing Howl"]="Piercing Howl",
    ["Piercing Ice"]="Piercing Ice",
    ["Plate Mail"]="Plate Mail",
    ["Poison Cleansing Totem"]="Poison Cleansing Totem",
    ["Poisons"]="Poisons",
    ["Polearm Specialization"]="Polearm Specialization",
    ["Polearms"]="Polearms",
    ["Polymorph"]="Polymorph",
    ["Portal: Darnassus"]="Portal: Darnassus",
    ["Portal: Ironforge"]="Portal: Ironforge",
    ["Portal: Orgrimmar"]="Portal: Orgrimmar",
    ["Portal: Stormwind"]="Portal: Stormwind",
    ["Portal: Thunder Bluff"]="Portal: Thunder Bluff",
    ["Portal: Undercity"]="Portal: Undercity",
    ["Pounce Bleed"]="Pounce Bleed",
    ["Pounce"]="Pounce",
    ["Power Infusion"]="Power Infusion",
    ["Power Word: Fortitude"]="Power Word: Fortitude",
    ["Power Word: Shield"]="Power Word: Shield",
    ["Prayer of Fortitude"]="Prayer of Fortitude",
    ["Prayer of Healing"]="Prayer of Healing",
    ["Prayer of Shadow Protection"]="Prayer of Shadow Protection",
    ["Prayer of Spirit"]="Prayer of Spirit",
    ["Precision"]="Precision",
    ["Predatory Strikes"]="Predatory Strikes",
    ["Premeditation"]="Premeditation",
    ["Preparation"]="Preparation",
    ["Presence of Mind"]="Presence of Mind",
    ["Primal Fury"]="Primal Fury",
    ["Prowl"]="Prowl",
    ["Psychic Scream"]="Psychic Scream",
    ["Pummel"]="Pummel",
    ["Purge"]="Purge",
    ["Purification"]="Purification",
    ["Purify"]="Purify",
    ["Pursuit of Justice"]="Pursuit of Justice",
    ["Pyroblast"]="Pyroblast",
    ["Pyroclasm"]="Pyroclasm",
    ["Quickness"]="Quickness",
    ["Rain of Fire"]="Rain of Fire",
    ["Rake"]="Rake",
    ["Ram Riding"]="Ram Riding",
    ["Ranged Weapon Specialization"]="Ranged Weapon Specialization",
    ["Rapid Concealment"]="Rapid Concealment",
    ["Rapid Fire"]="Rapid Fire",
    ["Raptor Riding"]="Raptor Riding",
    ["Raptor Strike"]="Raptor Strike",
    ["Ravage"]="Ravage",
    ["Readiness"]="Readiness",
    ["Rebirth"]="Rebirth",
    ["Reckless Charge"]="Reckless Charge",
    ["Recklessness"]="Recklessness",
    ["Reckoning"]="Reckoning",
    ["Redemption"]="Redemption",
    ["Redoubt"]="Redoubt",
    ["Reflection"]="Reflection",
    ["Regeneration"]="Regeneration",
    ["Regrowth"]="Regrowth",
    ["Reincarnation"]="Reincarnation",
    ["Rejuvenation"]="Rejuvenation",
    ["Relentless Strikes"]="Relentless Strikes",
    ["Remorseless Attacks"]="Remorseless Attacks",
    ["Remove Curse"]="Remove Curse",
    ["Remove Insignia"]="Remove Insignia",
    ["Remove Lesser Curse"]="Remove Lesser Curse",
    ["Rend"]="Rend",
    ["Renew"]="Renew",
    ["Repentance"]="Repentance",
    ["Resurrection"]="Resurrection",
    ["Retaliation"]="Retaliation",
    ["Retribution Aura"]="Retribution Aura",
    ["Revenge Stun"]="Revenge Stun",
    ["Revenge"]="Revenge",
    ["Reverberation"]="Reverberation",
    ["Revive Pet"]="Revive Pet",
    ["Righteous Fury"]="Righteous Fury",
    ["Rip"]="Rip",
    ["Riposte"]="Riposte",
    ["Ritual of Doom Effect"]="Ritual of Doom Effect",
    ["Ritual of Doom"]="Ritual of Doom",
    ["Ritual of Summoning"]="Ritual of Summoning",
    ["Rockbiter Weapon"]="Rockbiter Weapon",
    ["Rogue Passive"]="Rogue Passive",
    ["Ruin"]="Ruin",
    ["Rupture"]="Rupture",
    ["Ruthlessness"]="Ruthlessness",
    ["Sacrifice"]="Sacrifice",
    ["Safe Fall"]="Safe Fall",
    ["Sanctity Aura"]="Sanctity Aura",
    ["Sap"]="Sap",
    ["Savage Fury"]="Savage Fury",
    ["Savage Strikes"]="Savage Strikes",
    ["Scare Beast"]="Scare Beast",
    ["Scatter Shot"]="Scatter Shot",
    ["Scorch"]="Scorch",
    ["Scorpid Poison"]="Scorpid Poison",
    ["Scorpid Sting"]="Scorpid Sting",
    ["Screech"]="Screech",
    ["Seal Fate"]="Seal Fate",
    ["Seal of Command"]="Seal of Command",
    ["Seal of Justice"]="Seal of Justice",
    ["Seal of Light"]="Seal of Light",
    ["Seal of Righteousness"]="Seal of Righteousness",
    ["Seal of Wisdom"]="Seal of Wisdom",
    ["Seal of the Crusader"]="Seal of the Crusader",
    ["Searing Light"]="Searing Light",
    ["Searing Pain"]="Searing Pain",
    ["Searing Totem"]="Searing Totem",
    ["Seduction"]="Seduction",
    ["Sense Demons"]="Sense Demons",
    ["Sense Undead"]="Sense Undead",
    ["Sentry Totem"]="Sentry Totem",
    ["Serpent Sting"]="Serpent Sting",
    ["Setup"]="Setup",
    ["Shackle Undead"]="Shackle Undead",
    ["Shadow Affinity"]="Shadow Affinity",
    ["Shadow Bolt"]="Shadow Bolt",
    ["Shadow Focus"]="Shadow Focus",
    ["Shadow Mastery"]="Shadow Mastery",
    ["Shadow Protection"]="Shadow Protection",
    ["Shadow Reach"]="Shadow Reach",
    ["Shadow Resistance Aura"]="Shadow Resistance Aura",
    ["Shadow Resistance"]="Shadow Resistance",
    ["Shadow Ward"]="Shadow Ward",
    ["Shadow Weaving"]="Shadow Weaving",
    ["Shadow Word: Pain"]="Shadow Word: Pain",
    ["Shadowburn"]="Shadowburn",
    ["Shadowform"]="Shadowform",
    ["Shadowguard"]="Shadowguard",
    ["Shadowmeld Passive"]="Shadowmeld Passive",
    ["Shadowmeld"]="Shadowmeld",
    ["Sharpened Claws"]="Sharpened Claws",
    ["Shatter"]="Shatter",
    ["Sheep"]="Sheep",
    ["Shell Shield"]="Shell Shield",
    ["Shield Bash"]="Shield Bash",
    ["Shield Block"]="Shield Block",
    ["Shield Slam"]="Shield Slam",
    ["Shield Specialization"]="Shield Specialization",
    ["Shield Wall"]="Shield Wall",
    ["Shield"]="Shield",
    ["Shoot Bow"]="Shoot Bow",
    ["Shoot Crossbow"]="Shoot Crossbow",
    ["Shoot Gun"]="Shoot Gun",
    ["Shoot"]="Shoot",
    ["Shred"]="Shred",
    ["Silence"]="Silence",
    ["Silent Resolve"]="Silent Resolve",
    ["Sinister Strike"]="Sinister Strike",
    ["Siphon Life"]="Siphon Life",
    ["Skinning"]="Skinning",
    ["Slam"]="Slam",
    ["Sleep"]="Sleep",
    ["Slice and Dice"]="Slice and Dice",
    ["Slow Fall"]="Slow Fall",
    ["Smelting"]="Smelting",
    ["Smite"]="Smite",
    ["Soothe Animal"]="Soothe Animal",
    ["Soothing Kiss"]="Soothing Kiss",
    ["Soul Fire"]="Soul Fire",
    ["Soul Link"]="Soul Link",
    ["Soulstone Resurrection"]="Soulstone Resurrection",
    ["Spell Lock"]="Spell Lock",
    ["Spell Warding"]="Spell Warding",
    ["Spirit Bond"]="Spirit Bond",
    ["Spirit Tap"]="Spirit Tap",
    ["Spirit of Redemption"]="Spirit of Redemption",
    ["Spiritual Focus"]="Spiritual Focus",
    ["Spiritual Guidance"]="Spiritual Guidance",
    ["Spiritual Healing"]="Spiritual Healing",
    ["Sprint"]="Sprint",
    ["Starfire"]="Starfire",
    ["Starshards"]="Starshards",
    ["Staves"]="Staves",
    ["Stealth"]="Stealth",
    ["Stoneclaw Totem"]="Stoneclaw Totem",
    ["Stoneform"]="Stoneform",
    ["Stoneskin Totem"]="Stoneskin Totem",
    ["Stormstrike"]="Stormstrike",
    ["Strength of Earth Totem"]="Strength of Earth Totem",
    ["Stuck"]="Stuck",
    ["Subtlety"]="Subtlety",
    ["Suffering"]="Suffering",
    ["Summon Charger"]="Summon Charger",
    ["Summon Dreadsteed"]="Summon Dreadsteed",
    ["Summon Felhunter"]="Summon Felhunter",
    ["Summon Felsteed"]="Summon Felsteed",
    ["Summon Imp"]="Summon Imp",
    ["Summon Succubus"]="Summon Succubus",
    ["Summon Voidwalker"]="Summon Voidwalker",
    ["Summon Warhorse"]="Summon Warhorse",
    ["Sunder Armor"]="Sunder Armor",
    ["Suppression"]="Suppression",
    ["Surefooted"]="Surefooted",
    ["Survivalist"]="Survivalist",
    ["Sweeping Strikes"]="Sweeping Strikes",
    ["Swipe"]="Swipe",
    ["Sword Specialization"]="Sword Specialization",
    ["Tactical Mastery"]="Tactical Mastery",
    ["Tainted Blood"]="Tainted Blood",
    ["Tailoring"]="Tailoring",
    ["Tame Beast"]="Tame Beast",
    ["Tamed Pet Passive"]="Tamed Pet Passive",
    ["Taunt"]="Taunt",
    ["Teleport: Darnassus"]="Teleport: Darnassus",
    ["Teleport: Ironforge"]="Teleport: Ironforge",
    ["Teleport: Moonglade"]="Teleport: Moonglade",
    ["Teleport: Orgrimmar"]="Teleport: Orgrimmar",
    ["Teleport: Stormwind"]="Teleport: Stormwind",
    ["Teleport: Thunder Bluff"]="Teleport: Thunder Bluff",
    ["Teleport: Undercity"]="Teleport: Undercity",
    ["The Human Spirit"]="The Human Spirit",
    ["Thick Hide"]="Thick Hide",
    ["Thorns"]="Thorns",
    ["Throw"]="Throw",
    ["Throwing Specialization"]="Throwing Specialization",
    ["Throwing Weapon Specialization"]="Throwing Weapon Specialization",
    ["Thrown"]="Thrown",
    ["Thunder Clap"]="Thunder Clap",
    ["Thundering Strikes"]="Thundering Strikes",
    ["Thunderstomp"]="Thunderstomp",
    ["Tidal Focus"]="Tidal Focus",
    ["Tidal Mastery"]="Tidal Mastery",
    ["Tiger Riding"]="Tiger Riding",
    ["Tiger's Fury"]="Tiger's Fury",
    ["Torment"]="Torment",
    ["Totem"]="Totem",
    ["Totemic Focus"]="Totemic Focus",
    ["Touch of Weakness"]="Touch of Weakness",
    ["Toughness"]="Toughness",
    ["Track Beasts"]="Track Beasts",
    ["Track Demons"]="Track Demons",
    ["Track Dragonkin"]="Track Dragonkin",
    ["Track Elementals"]="Track Elementals",
    ["Track Giants"]="Track Giants",
    ["Track Hidden"]="Track Hidden",
    ["Track Humanoids"]="Track Humanoids",
    ["Track Undead"]="Track Undead",
    ["Tranquil Air Totem"]="Tranquil Air Totem",
    ["Tranquil Spirit"]="Tranquil Spirit",
    ["Tranquility"]="Tranquility",
    ["Tranquilizing Shot"]="Tranquilizing Shot",
    ["Trap Mastery"]="Trap Mastery",
    ["Travel Form"]="Travel Form",
    ["Tremor Totem"]="Tremor Totem",
    ["Tribal Leatherworking"]="Tribal Leatherworking",
    ["Trueshot Aura"]="Trueshot Aura",
    ["Turn Undead"]="Turn Undead",
    ["Two-Handed Axes and Maces"]="Two-Handed Axes and Maces",
    ["Two-Handed Axes"]="Two-Handed Axes",
    ["Two-Handed Maces"]="Two-Handed Maces",
    ["Two-Handed Swords"]="Two-Handed Swords",
    ["Two-Handed Weapon Specialization"]="Two-Handed Weapon Specialization",
    ["Unarmed"]="Unarmed",
    ["Unbreakable Will"]="Unbreakable Will",
    ["Unbridled Wrath Effect"]="Unbridled Wrath Effect",
    ["Unbridled Wrath"]="Unbridled Wrath",
    ["Undead Horsemanship"]="Undead Horsemanship",
    ["Underwater Breathing"]="Underwater Breathing",
    ["Unending Breath"]="Unending Breath",
    ["Unholy Power"]="Unholy Power",
    ["Unleashed Fury"]="Unleashed Fury",
    ["Unyielding Faith"]="Unyielding Faith",
    ["Vampiric Embrace"]="Vampiric Embrace",
    ["Vanish"]="Vanish",
    ["Vanished"]="Vanished",
    ["Vengeance"]="Vengeance",
    ["Vigor"]="Vigor",
    ["Vile Poisons"]="Vile Poisons",
    ["Vindication"]="Vindication",
    ["Viper Sting"]="Viper Sting",
    ["Volley"]="Volley",
    ["Wand Specialization"]="Wand Specialization",
    ["Wands"]="Wands",
    ["War Stomp"]="War Stomp",
    ["Water Breathing"]="Water Breathing",
    ["Water Walking"]="Water Walking",
    ["Weaponsmith"]="Weaponsmith",
    ["Whirlwind"]="Whirlwind",
    ["Will of the Forsaken"]="Will of the Forsaken",
    ["Windfury Totem"]="Windfury Totem",
    ["Windfury Weapon"]="Windfury Weapon",
    ["Windwall Totem"]="Windwall Totem",
    ["Wing Clip"]="Wing Clip",
    ["Winter's Chill"]="Winter's Chill",
    ["Wisp Spirit"]="Wisp Spirit",
    ["Wolf Riding"]="Wolf Riding",
    ["Wound Poison II"]="Wound Poison II",
    ["Wound Poison III"]="Wound Poison III",
    ["Wound Poison IV"]="Wound Poison IV",
    ["Wound Poison"]="Wound Poison",
    ["Wrath"]="Wrath",
    ["Wyvern Sting"]="Wyvern Sting"
}

local englishToLocal
if locale == "koKR" then 
	englishToLocal = {
	  ["Abolish Disease"] = "질병 해제",
    ["Abolish Poison Effect"] = "독 해제 효과",
    ["Abolish Poison"] = "독 해제",
    ["Activate MG Turret"] = "",    --확인 요망
    ["Adrenaline Rush"] = "아드레날린 촉진",
    ["Aftermath"] = "재앙의 여파",
    ["Aggression"] = "공격성",
    ["Aimed Shot"] = "조준 사격",
    ["Alchemy"] = "연금술",
    ["Ambush"] = "매복",
    ["Amplify Curse"] = "저주 증폭",
    ["Amplify Magic"] = "마법 증폭",
    ["Ancestral Healing"] = "선인의 치유력",
    ["Ancestral Knowledge"] = "선인의 지혜",
    ["Ancestral Spirit"] = "고대의 영혼",
    ["Anger Management"] = "분노 제어",
    ["Anticipation"] = "직감",
    ["Aquatic Form"] = "바다표범 변신",
    ["Arcane Brilliance"] = "신비한 총명함",
    ["Arcane Concentration"] = "신비한 정신집중",
    ["Arcane Explosion"] = "신비한 폭발",
    ["Arcane Focus"] = "신비한 집중",
    ["Arcane Instability"] = "신비한 불안정성",
    ["Arcane Intellect"] = "신비한 지능",
    ["Arcane Meditation"] = "신비한 명상",
    ["Arcane Mind"] = "신비한 정신",
    ["Arcane Missiles"] = "신비한 화살",
    ["Arcane Power"] = "신비의 마법 강화",
    ["Arcane Resistance"] = "비전 저항력",
    ["Arcane Shot"] = "신비한 사격",
    ["Arcane Subtlety"] = "신비한 미묘함",
    ["Arctic Reach"] = "혹한의 손길",
    ["Armorsmith"] = "방어구제작",
    ["Aspect of the Beast"] = "야수의 상",
    ["Aspect of the Cheetah"] = "치타의 상",
    ["Aspect of the Hawk"] = "매의 상",
    ["Aspect of the Monkey"] = "원숭이의 상",
    ["Aspect of the Pack"] = "치타 무리의 상",
    ["Aspect of the Wild"] = "야생의 상",
    ["Astral Recall"] = "영혼의 귀환",
    ["Attack"] = "공격",
    ["Attacking"] = "파괴 중",
    ["Auto Shot"] = "자동 사격",
    ["Axe Specialization"] = "도끼류 전문화",
    ["Backstab"] = "기습",
    ["Bane"] = "파멸",
    ["Banish"] = "추방",
    ["Barkskin Effect"] = "",    --확인 요망
    ["Barkskin"] = "나무 껍질",
    ["Barrage"] = "탄막",
    ["Bash"] = "강타",
    ["Basic Campfire"] = "작은 모닥불",
    ["Battle Shout"] = "전투의 외침",
    ["Battle Stance Passive"] = "전투 태세",
    ["Battle Stance"] = "전투 태세",
    ["Bear Form"] = "곰 변신",
    ["Beast Lore"] = "야수 연구",
    ["Beast Slaying"] = "야수 사냥 전문화",
    ["Beast Training"] = "야수 조련",
    ["Benediction"] = "축복의 기도",
    ["Berserker Rage"] = "광전사의 격노",
    ["Berserker Stance Passive"] = "광폭 태세 지속효과",
    ["Berserker Stance"] = "광폭 태세",
    ["Berserking"] = "광폭화",
    ["Bestial Discipline"] = "야수 훈련",
    ["Bestial Swiftness"] = "야수의 신속함",
    ["Bestial Wrath"] = "야수의 격노",
    ["Bite"] = "물기",
    ["Black Arrow"] = "검은 화살",
    ["Blackout"] = "의식 상실",
    ["Blacksmithing"] = "대장기술",
    ["Blade Flurry"] = "폭풍의 칼날",
    ["Blast Wave"] = "화염 폭풍",
    ["Blessed Recovery"] = "",    --확인 요망
    ["Blessing of Freedom"] = "자유의 축복",
    ["Blessing of Kings"] = "왕의 축복",
    ["Blessing of Light"] = "빛의 축복",
    ["Blessing of Might"] = "힘의 축복",
    ["Blessing of Protection"] = "보호의 축복",
    ["Blessing of Sacrifice"] = "희생의 축복",
    ["Blessing of Salvation"] = "구원의 축복",
    ["Blessing of Sanctuary"] = "성역의 축복",
    ["Blessing of Wisdom"] = "지혜의 축복",
    ["Blind"] = "실명",
    ["Blinding Powder"] = "실명 가루",
    ["Blink"] = "점멸",
    ["Blizzard"] = "눈보라",
    ["Block"] = "방어",
    ["Blood Craze"] = "피의 광기",
    ["Blood Frenzy"] = "피의 광기",
    ["Blood Fury"] = "피의 격노",
    ["Blood Pact"] = "피의 서약",
    ["Bloodrage"] = "피의 분노",
    ["Bloodthirst"] = "피의 갈증",
    ["Booming Voice"] = "우렁찬 음성",
    ["Bow Specialization"] = "활류 전문화",
    ["Bows"] = "활",
    ["Bright Campfire"] = "밝은 모닥불",
    ["Brutal Impact"] = "야수의 습격",
    ["Burning Soul"] = "불타는 영혼",
    ["Call Pet"] = "야수 부르기",
    ["Call of Flame"] = "불꽃의 부름",
    ["Call of Thunder"] = "천둥의 부름",
    ["Camouflage"] = "위장술",
    ["Cannibalize"] = "시체먹기",
    ["Cat Form"] = "표범 변신",
    ["Cataclysm"] = "재앙",
    ["Chain Heal"] = "연쇄 치유",
    ["Chain Lightning"] = "연쇄 번개",
    ["Challenging Roar"] = "도전의 포효",
    ["Challenging Shout"] = "도전의 외침",
    ["Charge Rage Bonus Effect"] = "보너스 분노 충전 효과",
    ["Charge"] = "돌진",
    ["Cheap Shot"] = "비열한 습격",
    ["Chilled"] = "빙결",
    ["Claw"] = "할퀴기",
    ["Cleanse"] = "정화",
    ["Clearcasting"] = "정신 집중",
    ["Cleave"] = "회전베기",
    ["Clever Traps"] = "덫 개량",
    ["Closing"] = "닫는 중",
    ["Cloth"] = "천",
    ["Cobra Reflexes"] = "",    --확인 요망
    ["Cold Blood"] = "냉혈",
    ["Cold Snap"] = "매서운 한파",
    ["Combat Endurance"] = "전투 지구력",
    ["Combustion"] = "발화",
    ["Command"] = "지배",
    ["Concentration Aura"] = "집중의 오라",
    ["Concussion Blow"] = "충격의 일격",
    ["Concussion"] = "촉발",
    ["Concussive Shot"] = "충격포",
    ["Cone of Cold"] = "냉기 돌풍",
    ["Conflagrate"] = "점화",
    ["Conjure Food"] = "음식 창조",
    ["Conjure Mana Agate"] = "마나 마노 창조",
    ["Conjure Mana Citrine"] = "마나 황수정 창조",
    ["Conjure Mana Jade"] = "마나 비취 창조",
    ["Conjure Mana Ruby"] = "마나 루비 창조",
    ["Conjure Water"] = "음료 창조",
    ["Consecration"] = "신성화",
    ["Consume Shadows"] = "어둠 흡수",
    ["Convection"] = "기의 흐름",
    ["Conviction"] = "자각",
    ["Cooking"] = "요리",
    ["Corruption"] = "부패",
    ["Counterattack"] = "역습",
    ["Counterspell"] = "마법 차단",
    ["Cower"] = "웅크리기",
    ["Create Firestone"] = "화염석 생성",
    ["Create Healthstone"] = "중급 생명석 창조",
    ["Create Soulstone"] = "영혼석 창조",
    ["Create Spellstone"] = "주문석 창조",
    ["Crippling Poison II"] = "신경 마비 독 II",
    ["Crippling Poison"] = "신경 마비 독",
    ["Critical Mass"] = "화염 결집",
    ["Crossbows"] = "석궁",
    ["Cruelty"] = "무자비함",
    ["Cultivation"] = "재배",
    ["Cure Disease"] = "질병 치료",
    ["Cure Poison"] = "해독",
    ["Curse of Agony"] = "고통의 저주",
    ["Curse of Doom Effect"] = "파멸의 저주 효과",
    ["Curse of Doom"] = "파멸의 저주",
    ["Curse of Exhaustion"] = "피로의 저주",
    ["Curse of Idiocy"] = "무지의 저주",
    ["Curse of Recklessness"] = "무모함의 저주",
    ["Curse of Shadow"] = "어둠의 저주",
    ["Curse of Tongues"] = "언어의 저주",
    ["Curse of Weakness"] = "무력화 저주",
    ["Curse of the Elements"] = "원소의 저주",
    ["Dagger Specialization"] = "단검류 전문화",
    ["Daggers"] = "단검",
    ["Dampen Magic"] = "마법 감쇠",
    ["Dark Pact"] = "암흑의 계약",
    ["Darkness"] = "어둠",
    ["Dash"] = "질주",
    ["Deadly Poison II"] = "맹독 II",
    ["Deadly Poison III"] = "맹독 III",
    ["Deadly Poison IV"] = "맹독 IV",
    ["Deadly Poison V"] = "",    --확인 요망
    ["Deadly Poison"] = "맹독",
    ["Death Coil"] = "죽음의 고리",
    ["Death Wish"] = "죽음의 소원",
    ["Deep Wounds"] = "치명상",
    ["Defense"] = "방어",
    ["Defensive Stance Passive"] = "방어 태세 지속효과",
    ["Defensive Stance"] = "방어 태세",
    ["Defensive State 2"] = "방어 상태 2",
    ["Defensive State"] = "방어 상태",
    ["Defiance"] = "도전",
    ["Deflection"] = "재빠른 손놀림",
    ["Demon Armor"] = "악마의 갑옷",
    ["Demon Skin"] = "악마의 피부",
    ["Demonic Embrace"] = "악마의 은총",
    ["Demonic Sacrifice"] = "악의 제물",
    ["Demoralizing Roar"] = "위협의 포효",
    ["Demoralizing Shout"] = "사기의 외침",
    ["Desperate Prayer"] = "구원의 기도",
    ["Destructive Reach"] = "파괴의 테두리",
    ["Detect Greater Invisibility"] = "상급 투명체 감지",
    ["Detect Invisibility"] = "투명체 감지",
    ["Detect Lesser Invisibility"] = "하급 투명체 감지",
    ["Detect Magic"] = "마법 감지",
    ["Detect Traps"] = "함정 감지",
    ["Detect"] = "감지",
    ["Deterrence"] = "공격 저지",
    ["Devastation"] = "황폐",
    ["Devotion Aura"] = "기원의 오라",
    ["Devour Magic Effect"] = "마법 삼키기 효과",
    ["Devour Magic"] = "마법 삼키기",
    ["Devouring Plague"] = "파멸의 역병",
    ["Diplomacy"] = "외교",
    ["Dire Bear Form"] = "광포한 곰 변신",
    ["Disarm Trap"] = "함정 해제",
    ["Disarm"] = "무장 해제",
    ["Disease Cleansing Totem"] = "질병 정화 토템",
    ["Disenchant"] = "마력 추출",
    ["Disengage"] = "철수",
    ["Dismiss Pet"] = "야수 소환해제",
    ["Dispel Magic"] = "마법 무효화",
    ["Distract"] = "혼란",
    ["Distracting Shot"] = "견제 사격",
    ["Dive"] = "급강하",
    ["Divine Favor"] = "신의 은총",
    ["Divine Fury"] = "신의 격노",
    ["Divine Intellect"] = "",    --확인 요망
    ["Divine Intervention"] = "성스러운 중재",
    ["Divine Protection"] = "신의 가호",
    ["Divine Shield"] = "천상의 보호막",
    ["Divine Spirit"] = "천상의 정신",
    ["Divine Strength"] = "천상의 힘",
    ["Dodge"] = "회피",
    ["Dragonscale Leatherworking"] = "용비늘 가죽세공",
    ["Drain Life"] = "생명력 흡수",
    ["Drain Mana"] = "마나 흡수",
    ["Drain Soul"] = "영혼 흡수",
    ["Drink"] = "음료",
    ["Dual Wield Specialization"] = "쌍수 무기 전문화",
    ["Dual Wield"] = "쌍수 무기",
    ["Duel"] = "주문 7266",
    ["Eagle Eye"] = "독수리의 눈",
    ["Earth Shock"] = "대지 충격",
    ["Earthbind Totem"] = "속박의 토템",
    ["Efficiency"] = "사격술",
    ["Elemental Focus"] = "정기의 집중",
    ["Elemental Fury"] = "자연의 격노",
    ["Elemental Leatherworking"] = "원소 가죽세공",
    ["Elemental Mastery"] = "정기의 깨달음",
    ["Elune's Grace"] = "엘룬의 은총",
    ["Elusiveness"] = "약삭빠름",
    ["Emberstorm"] = "불보라",
    ["Enchanting"] = "마법부여",
    ["Endurance Training"] = "지구력 훈련",
    ["Endurance"] = "인내력",
    ["Engineering Specialization"] = "기계공학 전문화",
    ["Engineering"] = "기계공학",
    ["Enrage"] = "격노",
    ["Enriched Manna Biscuit"] = "맛좋은 만나빵",
    ["Enslave Demon"] = "악마 지배",
    ["Entangling Roots"] = "휘감는 뿌리",
    ["Entrapment"] = "올가미",
    ["Escape Artist"] = "탈출의 명수",
    ["Evasion"] = "회피",
    ["Eventide"] = "자연의 가르침",
    ["Eviscerate"] = "절개",
    ["Evocation"] = "환기",
    ["Execute"] = "마무리 일격",
    ["Exorcism"] = "퇴마술",
    ["Expansive Mind"] = "영리함",
    ["Explosive Trap Effect"] = "폭발의 덫",
    ["Explosive Trap"] = "폭발의 덫",
    ["Expose Armor"] = "약점 노출",
    ["Eye for an Eye"] = "",    --확인 요망
    ["Eye of Kilrogg"] = "킬로그의 눈",
    ["Eyes of the Beast"] = "야수의 눈",
    ["Fade"] = "소실",
    ["Faerie Fire"] = "요정의 불꽃",
    ["Far Sight"] = "천리안",
    ["Fear Ward"] = "공포의 수호물",
    ["Fear"] = "공포",
    ["Feed Pet"] = "먹이주기",
    ["Feedback"] = "역순환",
    ["Feign Death"] = "죽은척하기",
    ["Feint"] = "교란",
    ["Fel Concentration"] = "마의 정신집중",
    ["Fel Domination"] = "마의 지배",
    ["Fel Intellect"] = "마의 지능",
    ["Fel Stamina"] = "마의 체력",
    ["Felfire"] = "지옥불",
    ["Feline Grace"] = "살쾡이의 우아함",
    ["Feline Swiftness"] = "살쾡이의 기민함",
    ["Feral Aggression"] = "야생의 공격성",
    ["Feral Charge"] = "야성의 돌진",
    ["Feral Instinct"] = "야생의 본능",
    ["Ferocious Bite"] = "흉포한 이빨",
    ["Ferocity"] = "미사용 주문",
    ["Fetish"] = "",    --확인 요망
    ["Find Herbs"] = "약초 찾기",
    ["Find Minerals"] = "광물 찾기",
    ["Find Treasure"] = "보물 찾기",
    ["Fire Blast"] = "화염 작열",
    ["Fire Nova Totem"] = "불꽃 회오리 토템",
    ["Fire Power"] = "화염 마법 강화",
    ["Fire Resistance Aura"] = "화염 저항의 오라",
    ["Fire Resistance Totem"] = "화염 저항 토템",
    ["Fire Resistance"] = "화염 마법 저항",
    ["Fire Shield"] = "화염 보호막",
    ["Fire Vulnerability"] = "화염 저항력 약화",
    ["Fire Ward"] = "화염계 수호",
    ["Fireball"] = "화염구",
    ["Firebolt"] = "불화살",
    ["First Aid"] = "응급 치료",
    ["Fishing Poles"] = "낚싯대",
    ["Fishing"] = "낚시",
    ["Fist Weapon Specialization"] = "장착 무기류 전문화",
    ["Fist Weapons"] = "장착 무기류",
    ["Flame Shock"] = "화염 충격",
    ["Flame Throwing"] = "화염 발사",
    ["Flamestrike"] = "불기둥",
    ["Flamethrower"] = "화염방사기",
    ["Flametongue Totem"] = "불꽃의 토템",
    ["Flametongue Weapon"] = "불꽃의 무기",
    ["Flare"] = "섬광",
    ["Flash Heal"] = "순간 치유",
    ["Flash of Light"] = "빛의 섬광",
    ["Flurry"] = "질풍",
    ["Focused Casting"] = "집중력",
    ["Food"] = "음식",
    ["Force of Will"] = "의지의 힘",
    ["Freezing Trap Effect"] = "얼음의 덫",
    ["Freezing Trap"] = "얼음의 덫",
    ["Frenzied Regeneration"] = "광포한 재생력",
    ["Frenzy"] = "광기",
    ["Frost Armor"] = "냉기 갑옷",
    ["Frost Channeling"] = "냉기계 정신집중",
    ["Frost Nova"] = "얼음 회오리",
    ["Frost Resistance Aura"] = "냉기 저항의 오라",
    ["Frost Resistance Totem"] = "냉기 저항 토템",
    ["Frost Resistance"] = "냉기 마법 저항",
    ["Frost Shock"] = "냉기 충격",
    ["Frost Trap"] = "냉기의 덫",
    ["Frost Ward"] = "냉기계 수호",
    ["Frostbite"] = "동상",
    ["Frostbolt"] = "얼음 화살",
    ["Frostbrand Weapon"] = "냉기의 무기",
    ["Furious Howl"] = "사나운 울음소리",
    ["Furor"] = "광란",
    ["Garrote"] = "목조르기",
    ["Generic"] = "주문 2382",
    ["Ghost Wolf"] = "늑대 정령",
    ["Ghostly Strike"] = "그림자 일격",
    ["Gift of Nature"] = "자연의 선물",
    ["Gift of the Wild"] = "야생의 선물",
    ["Gouge"] = "후려치기",
    ["Grace of Air Totem"] = "은총의 토템",
    ["Great Stamina"] = "강인한 체력",
    ["Greater Blessing of Kings"] = "",    --확인 요망
    ["Greater Blessing of Light"] = "",    --확인 요망
    ["Greater Blessing of Might"] = "",    --확인 요망
    ["Greater Blessing of Salvation"] = "",    --확인 요망
    ["Greater Blessing of Sanctuary"] = "",    --확인 요망
    ["Greater Blessing of Wisdom"] = "",    --확인 요망
    ["Greater Heal"] = "상급 치유",
    ["Grim Reach"] = "냉혹의 테두리",
    ["Grounding Totem"] = "마법정화 토템",
    ["Grovel"] = "주문 7267",
    ["Growl"] = "포효",
    ["Guardian's Favor"] = "",    --확인 요망
    ["Gun Specialization"] = "총기류 전문화",
    ["Guns"] = "총",
    ["Hammer of Justice"] = "심판의 망치",
    ["Hammer of Wrath"] = "일격",
    ["Hamstring"] = "무력화",
    ["Harass"] = "괴롭히기",
    ["Hardiness"] = "강인함",
    ["Hawk Eye"] = "매의 눈",
    ["Heal"] = "치유",
    ["Healing Focus"] = "",    --확인 요망
    ["Healing Light"] = "",    --확인 요망
    ["Healing Stream Totem"] = "치유의 토템",
    ["Healing Touch"] = "치유의 손길",
    ["Healing Wave"] = "치유의 물결",
    ["Health Funnel"] = "생명력 집중",
    ["Heart of the Wild"] = "야생의 정수",
    ["Hellfire Effect"] = "지옥의 불길 효과",
    ["Hellfire"] = "지옥의 불길",
    ["Hemorrhage"] = "과다출혈",
    ["Herb Gathering"] = "약초채집",
    ["Herbalism"] = "약초 채집",
    ["Heroic Strike"] = "영웅의 일격",
    ["Hex of Weakness"] = "무력의 주술",
    ["Hibernate"] = "겨울잠",
    ["Holy Fire"] = "신성한 불꽃",
    ["Holy Light"] = "성스러운 빛",
    ["Holy Nova"] = "신성한 폭발",
    ["Holy Power"] = "신성 마법 강화",
    ["Holy Reach"] = "",    --확인 요망
    ["Holy Shield"] = "신성 보호막",
    ["Holy Shock"] = "신성 충격",
    ["Holy Specialization"] = "신성 마법 전문화",
    ["Holy Wrath"] = "신의 격노",
    ["Honorless Target"] = "명예 점수 없음",
    ["Horse Riding"] = "말 타기",
    ["Howl of Terror"] = "공포의 울부짖음",
    ["Humanoid Slaying"] = "인간형 사냥술",
    ["Hunter's Mark"] = "사냥꾼의 징표",
    ["Hurricane"] = "허리케인",
    ["Ice Armor"] = "얼음 갑옷",
    ["Ice Barrier"] = "얼음 보호막",
    ["Ice Block"] = "얼음 방패",
    ["Ice Shards"] = "얼음 파편",
    ["Ignite"] = "작열",
    ["Illumination"] = "계시",
    ["Immolate"] = "제물",
    ["Immolation Trap Effect"] = "제물의 덫",
    ["Immolation Trap"] = "제물의 덫",
    ["Impact"] = "충돌",
    ["Impale"] = "꿰뚫기",
    ["Improved Ambush"] = "매복 연마",
    ["Improved Arcane Explosion"] = "신비한 폭발 연마",
    ["Improved Arcane Missiles"] = "신비한 화살 연마",
    ["Improved Arcane Shot"] = "신비한 사격 연마",
    ["Improved Aspect of the Hawk"] = "매의 상 연마",
    ["Improved Aspect of the Monkey"] = "원숭이의 상 연마",
    ["Improved Backstab"] = "기습 연마",
    ["Improved Battle Shout"] = "전투의 외침 연마",
    ["Improved Berserker Rage"] = "광전사의 격노 연마",
    ["Improved Blessing of Might"] = "힘의 축복 연마",
    ["Improved Blessing of Wisdom"] = "지혜의 축복 연마",
    ["Improved Blizzard"] = "눈보라 연마",
    ["Improved Bloodrage"] = "피의 분노 연마",
    ["Improved Chain Heal"] = "연쇄 치유 연마",
    ["Improved Chain Lightning"] = "연쇄 번개 연마",
    ["Improved Challenging Shout"] = "도전의 외침 연마",
    ["Improved Charge"] = "돌진 연마",
    ["Improved Cheap Shot"] = "비열한 습격 연마",
    ["Improved Cleave"] = "회전베기 연마",
    ["Improved Concentration Aura"] = "집중의 오라 연마",
    ["Improved Concussive Shot"] = "충격포 연마",
    ["Improved Cone of Cold"] = "냉기 돌풍 연마",
    ["Improved Corruption"] = "부패 연마",
    ["Improved Counterspell"] = "마법 차단 연마",
    ["Improved Curse of Agony"] = "고통의 저주 연마",
    ["Improved Curse of Exhaustion"] = "피로의 저주 연마",
    ["Improved Curse of Weakness"] = "무력화 저주 연마",
    ["Improved Dampen Magic"] = "마법의 조화",
    ["Improved Deadly Poison"] = "맹독 연구",
    ["Improved Demoralizing Shout"] = "사기의 외침 연마",
    ["Improved Devotion Aura"] = "기원의 오라 연마",
    ["Improved Disarm"] = "무장 해제 연마",
    ["Improved Distract"] = "혼란 연마",
    ["Improved Drain Life"] = "생명력 흡수 연마",
    ["Improved Drain Mana"] = "마나 흡수 연마",
    ["Improved Drain Soul"] = "영혼 흡수 연마",
    ["Improved Enrage"] = "분노 연마",
    ["Improved Enslave Demon"] = "악마 지배 연마",
    ["Improved Entangling Roots"] = "휘감는 뿌리 연마",
    ["Improved Evasion"] = "회피 연마",
    ["Improved Eviscerate"] = "절개 연마",
    ["Improved Execute"] = "마무리 일격 연마",
    ["Improved Expose Armor"] = "약점 노출 연마",
    ["Improved Eyes of the Beast"] = "야수의 눈 연마",
    ["Improved Fade"] = "소실 연마",
    ["Improved Feign Death"] = "죽은척하기 연마",
    ["Improved Fire Blast"] = "화염 작열 연마",
    ["Improved Fire Nova Totem"] = "불의 토템 연마",
    ["Improved Fire Ward"] = "화염계 수호 연마",
    ["Improved Fireball"] = "화염구 연마",
    ["Improved Firebolt"] = "불화살 연마",
    ["Improved Firestone"] = "화염석 연마",
    ["Improved Flamestrike"] = "불기둥 연마",
    ["Improved Flametongue Weapon"] = "불꽃의 무기 연마",
    ["Improved Flash of Light"] = "빛의 섬광 연마",
    ["Improved Frost Nova"] = "얼음 회오리 연마",
    ["Improved Frost Ward"] = "냉기의 수호",
    ["Improved Frostbolt"] = "얼음 화살 연마",
    ["Improved Frostbrand Weapon"] = "냉기의 무기 연마",
    ["Improved Garrote"] = "목 조르기 연마",
    ["Improved Ghost Wolf"] = "늑대 정령 연마",
    ["Improved Gouge"] = "후려치기 연마",
    ["Improved Grace of Air Totem"] = "은총의 토템 연마",
    ["Improved Grounding Totem"] = "마법정화 토템 연마",
    ["Improved Hammer of Justice"] = "심판의 망치 연마",
    ["Improved Hamstring"] = "무력화 연마",
    ["Improved Healing Stream Totem"] = "치유의 토템 연마",
    ["Improved Healing Touch"] = "치유의 손길 연마",
    ["Improved Healing Wave"] = "치유의 물결 연마",
    ["Improved Healing"] = "치유 연마",
    ["Improved Health Funnel"] = "생명력 집중 연마",
    ["Improved Healthstone"] = "생명석 연마",
    ["Improved Heroic Strike"] = "영웅의 일격 연마",
    ["Improved Hunter's Mark"] = "사냥꾼의 징표 연마",
    ["Improved Immolate"] = "제물 연마",
    ["Improved Imp"] = "임프 연마",
    ["Improved Inner Fire"] = "내면의 열정 연마",
    ["Improved Instant Poison"] = "순간 효과 독 연구",
    ["Improved Intercept"] = "봉쇄 연마",
    ["Improved Intimidating Shout"] = "위협의 외침 연마",
    ["Improved Judgement"] = "",    --확인 요망
    ["Improved Kick"] = "발차기 연마",
    ["Improved Kidney Shot"] = "급소 가격 연마",
    ["Improved Lash of Pain"] = "고통의 채찍 연마",
    ["Improved Lay on Hands"] = "신의 축복 연마",
    ["Improved Lesser Healing Wave"] = "치유의 집중",
    ["Improved Life Tap"] = "생명력 전환 연마",
    ["Improved Lightning Bolt"] = "번개 화살 연마",
    ["Improved Lightning Shield"] = "번개 보호막 연마",
    ["Improved Magma Totem"] = "용암 토템 연마",
    ["Improved Mana Burn"] = "마나 연소 연마",
    ["Improved Mana Shield"] = "마나 보호막 연마",
    ["Improved Mana Spring Totem"] = "회복의 토템",
    ["Improved Mark of the Wild"] = "야생의 징표 연마",
    ["Improved Mend Pet"] = "동물 치료 연마",
    ["Improved Mind Blast"] = "정신 분열 연마",
    ["Improved Moonfire"] = "달빛 섬광 연마",
    ["Improved Nature's Grasp"] = "자연의 손아귀 연마",
    ["Improved Overpower"] = "제압 연마",
    ["Improved Power Word: Fortitude"] = "신의 권능: 인내 연마",
    ["Improved Power Word: Shield"] = "신의 권능: 보호막 연마",
    ["Improved Prayer of Healing"] = "치유의 기원 연마",
    ["Improved Psychic Scream"] = "영혼의 절규 연마",
    ["Improved Pummel"] = "자루 공격 연마",
    ["Improved Regrowth"] = "재생 연마",
    ["Improved Reincarnation"] = "윤회 연마",
    ["Improved Rejuvenation"] = "회복 연마",
    ["Improved Rend"] = "분쇄 연마",
    ["Improved Renew"] = "소생 연마",
    ["Improved Retribution Aura"] = "응보의 오라 연마",
    ["Improved Revenge"] = "복수 연마",
    ["Improved Revive Pet"] = "야수 되살리기 연마",
    ["Improved Righteous Fury"] = "",    --확인 요망
    ["Improved Rockbiter Weapon"] = "대지의 무기 연마",
    ["Improved Rupture"] = "파열 연마",
    ["Improved Sap"] = "기절시키기 연마",
    ["Improved Scorch"] = "불태우기 연마",
    ["Improved Scorpid Sting"] = "전갈 쐐기 연마",
    ["Improved Seal of Righteousness"] = "정의의 문장 연마",
    ["Improved Seal of the Crusader"] = "성전사의 문장 연마",
    ["Improved Searing Pain"] = "불타는 고통 연마",
    ["Improved Searing Totem"] = "불타는 토템 연마",
    ["Improved Serpent Sting"] = "독사 쐐기 연마",
    ["Improved Shadow Bolt"] = "어둠의 화살 연마",
    ["Improved Shadow Word: Pain"] = "어둠의 권능: 고통 연마",
    ["Improved Shield Bash"] = "방패 가격 연마",
    ["Improved Shield Block"] = "방패 막기 연마",
    ["Improved Shield Wall"] = "방패의 벽 연마",
    ["Improved Shred"] = "칼날 발톱 연마",
    ["Improved Sinister Strike"] = "사악한 일격 연마",
    ["Improved Slam"] = "격돌 연마",
    ["Improved Slice and Dice"] = "난도질 연마",
    ["Improved Spellstone"] = "주문석 연마",
    ["Improved Sprint"] = "전력 질주 연마",
    ["Improved Starfire"] = "별빛 화살 연마",
    ["Improved Stoneclaw Totem"] = "대지의 올가미",
    ["Improved Stoneskin Totem"] = "수호의 토템",
    ["Improved Strength of Earth Totem"] = "강화의 토템",
    ["Improved Succubus"] = "서큐버스 연마",
    ["Improved Sunder Armor"] = "방어구 가르기 연마",
    ["Improved Taunt"] = "도발 연마",
    ["Improved Thorns"] = "가시 연마",
    ["Improved Thunder Clap"] = "천둥벼락 연마",
    ["Improved Tranquility"] = "평온 연마",
    ["Improved Vampiric Embrace"] = "",    --확인 요망
    ["Improved Vanish"] = "소멸 연마",
    ["Improved Voidwalker"] = "보이드워커 연마",
    ["Improved Windfury Weapon"] = "자연의 무기",
    ["Improved Wing Clip"] = "날개 절단 연마",
    ["Improved Wrath"] = "천벌 연마",
    ["Incinerate"] = "소각",
    ["Inferno"] = "불지옥",
    ["Initiative"] = "선제 공격",
    ["Inner Fire"] = "내면의 열정",
    ["Inner Focus"] = "내면의 집중력",
    ["Innervate"] = "신속한 치유",
    ["Insect Swarm"] = "곤충 떼",
    ["Inspiration"] = "신의 계시",
    ["Instant Poison II"] = "순간 효과 독 II",
    ["Instant Poison III"] = "순간 효과 독 III",
    ["Instant Poison IV"] = "순간 효과 독 IV",
    ["Instant Poison V"] = "순간 효과 독 V",
    ["Instant Poison VI"] = "순간 효과 독 VI",
    ["Instant Poison"] = "순간 효과 독",
    ["Intensity"] = "격렬",
    ["Intercept"] = "봉쇄",
    ["Intimidating Shout"] = "위협의 외침",
    ["Intimidation"] = "위협",
    ["Iron Will"] = "강건한 의지",
    ["Judgement of Command"] = "지휘의 심판",
    ["Judgement of Justice"] = "정의의 심판",
    ["Judgement of Light"] = "빛의 심판",
    ["Judgement of Righteousness"] = "",    --확인 요망
    ["Judgement of Wisdom"] = "지혜의 심판",
    ["Judgement of the Crusader"] = "성전사의 심판",
    ["Judgement"] = "심판",
    ["Kick"] = "발차기",
    ["Kidney Shot"] = "급소 가격",
    ["Killer Instinct"] = "살수의 본능",
    ["Kodo Riding"] = "코도 타기",
    ["Lash of Pain"] = "고통의 채찍",
    ["Last Stand"] = "최후의 저항",
    ["Lasting Judgement"] = "",    --확인 요망
    ["Lay on Hands"] = "신의 축복",
    ["Leader of the Pack"] = "무리의 우두머리",
    ["Leather"] = "가죽",
    ["Leatherworking"] = "가죽세공",
    ["Lesser Heal"] = "하급 치유",
    ["Lesser Healing Wave"] = "하급 치유의 물결",
    ["Lesser Invisibility"] = "하급 투명화",
    ["Lethal Shots"] = "정밀한 사격",
    ["Lethality"] = "치명상",
    ["Levitate"] = "공중 부양",
    ["Libram"] = "",    --확인 요망
    ["Life Tap"] = "생명력 전환",
    ["Lightning Bolt"] = "번개 화살",
    ["Lightning Breath"] = "번개 숨결",
    ["Lightning Mastery"] = "번개 전문화",
    ["Lightning Reflexes"] = "번개같은 반사 신경",
    ["Lightning Shield"] = "번개 보호막",
    ["Lightwell Renew"] = "",    --확인 요망
    ["Lightwell"] = "",    --확인 요망
    ["Lockpicking"] = "자물쇠 따기",
    ["Long Daze"] = "오랜 멍해짐",
    ["Mace Specialization"] = "둔기류 전문화",
    ["Mace Stun Effect"] = "철퇴 기절 효과",
    ["Mage Armor"] = "마법사 갑옷",
    ["Magma Totem"] = "용암 토템",
    ["Mail"] = "사슬",
    ["Malice"] = "원한",
    ["Mana Burn"] = "마나 연소",
    ["Mana Shield"] = "마나 보호막",
    ["Mana Spring Totem"] = "마나샘 토템",
    ["Mana Tide Totem"] = "마나 해일 토템",
    ["Mangle"] = "짓이기기",
    ["Mark of the Wild"] = "야생의 징표",
    ["Martyrdom"] = "헌신",
    ["Master Demonologist"] = "악령술의 대가",
    ["Master Summoner"] = "소환의 대가",
    ["Master of Deception"] = "속임수의 대가",
    ["Maul"] = "후려치기",
    ["Mechanostrider Piloting"] = "기계타조 조종",
    ["Meditation"] = "명상",
    ["Melee Specialization"] = "근접 무기 전문화",
    ["Mend Pet"] = "동물 치료",
    ["Mental Agility"] = "마음의 기민함",
    ["Mental Strength"] = "정신력",
    ["Mind Blast"] = "정신 분열",
    ["Mind Control"] = "정신 지배",
    ["Mind Flay"] = "정신의 채찍",
    ["Mind Soothe"] = "평정",
    ["Mind Vision"] = "마음의 눈",
    ["Mind-numbing Poison II"] = "정신 마비 독 II",
    ["Mind-numbing Poison III"] = "정신 마비 독 III",
    ["Mind-numbing Poison"] = "정신 마비 독",
    ["Mining"] = "채광",
    ["Mocking Blow"] = "도발의 일격",
    ["Mongoose Bite"] = "살쾡이의 이빨",
    ["Monster Slaying"] = "몬스터 사냥술",
    ["Moonfire"] = "달빛 섬광",
    ["Moonfury"] = "달의 분노",
    ["Moonglow"] = "달빛",
    ["Moonkin Aura"] = "달빛야수 오라",
    ["Moonkin Form"] = "달빛야수 변신",
    ["Mortal Shots"] = "죽음의 사격",
    ["Mortal Strike"] = "죽음의 일격",
    ["Multi-Shot"] = "일제 사격",
    ["Murder"] = "학살",
    ["Natural Armor"] = "무쇠 가죽",
    ["Natural Shapeshifter"] = "변신의 대가",
    ["Natural Weapons"] = "자연의 무기",
    ["Nature Resistance Totem"] = "자연 저항 토템",
    ["Nature Resistance"] = "자연 마법 저항",
    ["Nature's Focus"] = "자연의 정신 집중",
    ["Nature's Grace"] = "자연의 은혜",
    ["Nature's Grasp"] = "자연의 손아귀",
    ["Nature's Reach"] = "자연의 테두리",
    ["Nature's Swiftness"] = "자연의 신속함",
    ["Nightfall"] = "일몰",
    ["Omen of Clarity"] = "청명의 전조",
    ["One-Handed Axes"] = "한손 도끼",
    ["One-Handed Maces"] = "한손 철퇴",
    ["One-Handed Swords"] = "한손 검",
    ["One-Handed Weapon Specialization"] = "한손 무기류 전문화",
    ["Opening - No Text"] = "열기",
    ["Opening"] = "열기",
    ["Opportunity"] = "기회 포착",
    ["Overpower"] = "제압",
    ["Paranoia"] = "망상",
    ["Parry"] = "무기 막기",
    ["Pathfinding"] = "길 찾기",
    ["Perception"] = "직관력",
    ["Permafrost"] = "영구 결빙",
    ["Pet Aggression"] = "야수의 공격성",
    ["Pet Hardiness"] = "야수의 강인함",
    ["Pet Recovery"] = "야수의 회복력",
    ["Pet Resistance"] = "야수의 저항력",
    ["Phase Shift"] = "위상 변화",
    ["Pick Lock"] = "자물쇠 따기",
    ["Pick Pocket"] = "훔치기",
    ["Piercing Howl"] = "날카로운 포효",
    ["Piercing Ice"] = "사무치는 냉기",
    ["Plate Mail"] = "판금 갑옷",
    ["Poison Cleansing Totem"] = "독 정화 토템",
    ["Poisons"] = "독 조제",
    ["Polearm Specialization"] = "장창류 전문화",
    ["Polearms"] = "장창류",
    ["Polymorph"] = "변이",
    ["Portal: Darnassus"] = "차원의 문: 다르나서스",
    ["Portal: Ironforge"] = "차원의 문: 아이언포지",
    ["Portal: Orgrimmar"] = "차원의 문: 오그리마",
    ["Portal: Stormwind"] = "차원의 문: 스톰윈드",
    ["Portal: Thunder Bluff"] = "차원의 문: 썬더 블러프",
    ["Portal: Undercity"] = "차원의 문: 언더시티",
    ["Pounce Bleed"] = "암습 피해",
    ["Pounce"] = "암습",
    ["Power Infusion"] = "",    --확인 요망
    ["Power Word: Fortitude"] = "신의 권능: 인내",
    ["Power Word: Shield"] = "신의 권능: 보호막",
    ["Prayer of Fortitude"] = "인내의 기원",
    ["Prayer of Healing"] = "치유의 기원",
    ["Prayer of Shadow Protection"] = "",    --확인 요망
    ["Prayer of Spirit"] = "",    --확인 요망
    ["Precision"] = "정밀함",
    ["Predatory Strikes"] = "야생의 포식자",
    ["Premeditation"] = "사전계획",
    ["Preparation"] = "마음가짐",
    ["Presence of Mind"] = "냉정",
    ["Primal Fury"] = "야수의 분노",
    ["Prowl"] = "숨기",
    ["Psychic Scream"] = "영혼의 절규",
    ["Pummel"] = "자루 공격",
    ["Purge"] = "정화",
    ["Purification"] = "심신의 정화",
    ["Purify"] = "순화",
    ["Pursuit of Justice"] = "",    --확인 요망
    ["Pyroblast"] = "불덩이 작열",
    ["Pyroclasm"] = "화염 파열",
    ["Quickness"] = "민첩",
    ["Rain of Fire"] = "불의 비",
    ["Rake"] = "갈퀴 발톱",
    ["Ram Riding"] = "산양 타기",
    ["Ranged Weapon Specialization"] = "원거리 무기 전문화",
    ["Rapid Concealment"] = "은신술 연마",
    ["Rapid Fire"] = "속사",
    ["Raptor Riding"] = "랩터 타기",
    ["Raptor Strike"] = "랩터의 일격",
    ["Ravage"] = "약탈",
    ["Readiness"] = "만반의 준비",
    ["Rebirth"] = "환생",
    ["Reckless Charge"] = "무모한 돌진",
    ["Recklessness"] = "무모한 희생",
    ["Reckoning"] = "징벌",
    ["Redemption"] = "구원",
    ["Redoubt"] = "보루",
    ["Reflection"] = "반사",
    ["Regeneration"] = "재생력",
    ["Regrowth"] = "재생",
    ["Reincarnation"] = "윤회",
    ["Rejuvenation"] = "회복",
    ["Relentless Strikes"] = "가혹한 일격",
    ["Remorseless Attacks"] = "냉혹함",
    ["Remove Curse"] = "저주 해제",
    ["Remove Insignia"] = "계급장 제거",
    ["Remove Lesser Curse"] = "하급 저주 해제",
    ["Rend"] = "분쇄",
    ["Renew"] = "소생",
    ["Repentance"] = "참회",
    ["Resurrection"] = "부활",
    ["Retaliation"] = "보복",
    ["Retribution Aura"] = "응보의 오라",
    ["Revenge Stun"] = "복수 기절",
    ["Revenge"] = "복수",
    ["Reverberation"] = "산울림",
    ["Revive Pet"] = "야수 되살리기",
    ["Righteous Fury"] = "",    --확인 요망
    ["Rip"] = "도려내기",
    ["Riposte"] = "반격",
    ["Ritual of Doom Effect"] = "파멸의 의식",
    ["Ritual of Doom"] = "파멸의 의식",
    ["Ritual of Summoning"] = "소환 의식",
    ["Rockbiter Weapon"] = "대지의 무기",
    ["Rogue Passive"] = "",    --확인 요망
    ["Ruin"] = "붕괴",
    ["Rupture"] = "파열",
    ["Ruthlessness"] = "무정함",
    ["Sacrifice"] = "희생",
    ["Safe Fall"] = "낙법",
    ["Sanctity Aura"] = "고결의 오라",
    ["Sap"] = "기절시키기",
    ["Savage Fury"] = "맹렬한 격노",
    ["Savage Strikes"] = "야생의 일격",
    ["Scare Beast"] = "야수 겁주기",
    ["Scatter Shot"] = "산탄 사격",
    ["Scorch"] = "불태우기",
    ["Scorpid Poison"] = "전갈독",
    ["Scorpid Sting"] = "전갈 쐐기",
    ["Screech"] = "날카로운 울음소리",
    ["Seal Fate"] = "운명의 낙인",
    ["Seal of Command"] = "지휘의 문장",
    ["Seal of Justice"] = "심판의 문장",
    ["Seal of Light"] = "빛의 문장",
    ["Seal of Righteousness"] = "정의의 문장",
    ["Seal of Wisdom"] = "지혜의 문장",
    ["Seal of the Crusader"] = "성전사의 문장",
    ["Searing Light"] = "",    --확인 요망
    ["Searing Pain"] = "불타는 고통",
    ["Searing Totem"] = "불타는 토템",
    ["Seduction"] = "현혹",
    ["Sense Demons"] = "악마 감지",
    ["Sense Undead"] = "언데드 감지",
    ["Sentry Totem"] = "감시의 토템",
    ["Serpent Sting"] = "독사 쐐기",
    ["Setup"] = "사전 준비",
    ["Shackle Undead"] = "언데드 속박",
    ["Shadow Affinity"] = "암흑 마법 친화",
    ["Shadow Bolt"] = "어둠의 화살",
    ["Shadow Focus"] = "암흑 마법 집중",
    ["Shadow Mastery"] = "암흑 마법 전문화",
    ["Shadow Protection"] = "어둠의 보호",
    ["Shadow Reach"] = "어둠의 테두리",
    ["Shadow Resistance Aura"] = "암흑 저항의 오라",
    ["Shadow Resistance"] = "암흑 마법 저항",
    ["Shadow Ward"] = "암흑계 수호",
    ["Shadow Weaving"] = "어둠의 매듭",
    ["Shadow Word: Pain"] = "어둠의 권능: 고통",
    ["Shadowburn"] = "어둠의 연소",
    ["Shadowform"] = "어둠의 형상",
    ["Shadowguard"] = "어둠의 수호",
    ["Shadowmeld Passive"] = "그림자 숨기",
    ["Shadowmeld"] = "그림자 숨기",
    ["Sharpened Claws"] = "날카로운 발톱",
    ["Shatter"] = "산산조각",
    ["Sheep"] = "",    --확인 요망
    ["Shell Shield"] = "",    --확인 요망
    ["Shield Bash"] = "방패 가격",
    ["Shield Block"] = "방패 막기",
    ["Shield Slam"] = "방패 밀쳐내기",
    ["Shield Specialization"] = "방패 전문화",
    ["Shield Wall"] = "방패의 벽",
    ["Shield"] = "방패",
    ["Shoot Bow"] = "활 발사",
    ["Shoot Crossbow"] = "석궁 발사",
    ["Shoot Gun"] = "총 발사",
    ["Shoot"] = "마법봉 발사",
    ["Shred"] = "절단",
    ["Silence"] = "침묵",
    ["Silent Resolve"] = "무언의 결심",
    ["Sinister Strike"] = "사악한 일격",
    ["Siphon Life"] = "생명력 착취",
    ["Skinning"] = "무두질",
    ["Slam"] = "격돌",
    ["Sleep"] = "수면",
    ["Slice and Dice"] = "난도질",
    ["Slow Fall"] = "저속 낙하",
    ["Smelting"] = "제련술",
    ["Smite"] = "성스러운 일격",
    ["Soothe Animal"] = "동물 달래기",
    ["Soothing Kiss"] = "유혹의 입맞춤",
    ["Soul Fire"] = "영혼의 불꽃",
    ["Soul Link"] = "영혼의 고리",
    ["Soulstone Resurrection"] = "영혼석 부활",
    ["Spell Lock"] = "주문 잠금",
    ["Spell Warding"] = "",    --확인 요망
    ["Spirit Bond"] = "정신의 결속",
    ["Spirit Tap"] = "정신력 누출",
    ["Spirit of Redemption"] = "구원의 영혼",
    ["Spiritual Focus"] = "영적인 집중력",
    ["Spiritual Guidance"] = "",    --확인 요망
    ["Spiritual Healing"] = "영혼의 치유",
    ["Sprint"] = "전력 질주",
    ["Starfire"] = "별빛 화살",
    ["Starshards"] = "별조각",
    ["Staves"] = "지팡이",
    ["Stealth"] = "은신",
    ["Stoneclaw Totem"] = "돌발톱 토템",
    ["Stoneform"] = "석화",
    ["Stoneskin Totem"] = "돌가죽 토템",
    ["Stormstrike"] = "폭풍의 일격",
    ["Strength of Earth Totem"] = "대지력 토템",
    ["Stuck"] = "고립 상태 벗어나기",
    ["Subtlety"] = "영혼의 길잡이",
    ["Suffering"] = "고통",
    ["Summon Charger"] = "군마 소환",
    ["Summon Dreadsteed"] = "공포마 소환",
    ["Summon Felhunter"] = "지옥사냥개 소환",
    ["Summon Felsteed"] = "지옥마 소환",
    ["Summon Imp"] = "임프 소환",
    ["Summon Succubus"] = "서큐버스 소환",
    ["Summon Voidwalker"] = "보이드워커 소환",
    ["Summon Warhorse"] = "군마 소환",
    ["Sunder Armor"] = "방어구 가르기",
    ["Suppression"] = "억제",
    ["Surefooted"] = "침착함",
    ["Survivalist"] = "생존의 대가",
    ["Sweeping Strikes"] = "휩쓸기 일격",
    ["Swipe"] = "휘둘러치기",
    ["Sword Specialization"] = "도검류 전문화",
    ["Tactical Mastery"] = "전술 숙련",
    ["Tainted Blood"] = "얼룩진 피",
    ["Tailoring"] = "재봉술",
    ["Tame Beast"] = "야수 길들이기",
    ["Tamed Pet Passive"] = "",    --확인 요망
    ["Taunt"] = "도발",
    ["Teleport: Darnassus"] = "순간이동: 다르나서스",
    ["Teleport: Ironforge"] = "순간이동: 아이언포지",
    ["Teleport: Moonglade"] = "순간이동: 달의 숲",
    ["Teleport: Orgrimmar"] = "순간이동: 오그리마",
    ["Teleport: Stormwind"] = "순간이동: 스톰윈드",
    ["Teleport: Thunder Bluff"] = "순간이동: 썬더 블러프",
    ["Teleport: Undercity"] = "순간이동: 언더시티",
    ["The Human Spirit"] = "인간의 정신력",
    ["Thick Hide"] = "두꺼운 가죽",
    ["Thorns"] = "가시",
    ["Throw"] = "투척",
    ["Throwing Specialization"] = "투척술 전문화",
    ["Throwing Weapon Specialization"] = "투척 무기류 전문화",
    ["Thrown"] = "투척",
    ["Thunder Clap"] = "천둥벼락",
    ["Thundering Strikes"] = "우레의 일격",
    ["Thunderstomp"] = "",    --확인 요망
    ["Tidal Focus"] = "해일의 집중",
    ["Tidal Mastery"] = "해일의 깨달음",
    ["Tiger Riding"] = "호랑이 타기",
    ["Tiger's Fury"] = "맹공격",
    ["Torment"] = "고문",
    ["Totem"] = "",    --확인 요망
    ["Totemic Focus"] = "토템 집중",
    ["Touch of Weakness"] = "무력의 손길",
    ["Toughness"] = "강인함",
    ["Track Beasts"] = "야수 추적",
    ["Track Demons"] = "악마 추적",
    ["Track Dragonkin"] = "용족 추적",
    ["Track Elementals"] = "정령 추적",
    ["Track Giants"] = "거인 추적",
    ["Track Hidden"] = "은신 추적",
    ["Track Humanoids"] = "인간형 추적",
    ["Track Undead"] = "언데드 추적",
    ["Tranquil Air Totem"] = "",    --확인 요망
    ["Tranquil Spirit"] = "평온한 정신",
    ["Tranquility"] = "평온",
    ["Tranquilizing Shot"] = "평정의 사격",
    ["Trap Mastery"] = "덫 숙련",
    ["Travel Form"] = "치타 변신",
    ["Tremor Totem"] = "진동의 토템",
    ["Tribal Leatherworking"] = "전통 가죽세공",
    ["Trueshot Aura"] = "정조준 오라",
    ["Turn Undead"] = "언데드 퇴치",
    ["Two-Handed Axes and Maces"] = "양손 도끼류 및 둔기류",
    ["Two-Handed Axes"] = "양손 도끼",
    ["Two-Handed Maces"] = "양손 철퇴",
    ["Two-Handed Swords"] = "양손 검",
    ["Two-Handed Weapon Specialization"] = "양손 무기류 전문화",
    ["Unarmed"] = "맨손",
    ["Unbreakable Will"] = "굳은 의지",
    ["Unbridled Wrath Effect"] = "분노 해방",
    ["Unbridled Wrath"] = "분노 해방",
    ["Undead Horsemanship"] = "언데드 승마술",
    ["Underwater Breathing"] = "수중 호흡",
    ["Unending Breath"] = "영원의 숨결",
    ["Unholy Power"] = "부정의 힘",
    ["Unleashed Fury"] = "격노 폭발",
    ["Unyielding Faith"] = "",    --확인 요망
    ["Vampiric Embrace"] = "흡혈의 선물",
    ["Vanish"] = "소멸",
    ["Vanished"] = "소멸",
    ["Vengeance"] = "복수",
    ["Vigor"] = "강한 체력",
    ["Vile Poisons"] = "치명적인 독",
    ["Vindication"] = "",    --확인 요망
    ["Viper Sting"] = "살무사 쐐기",
    ["Volley"] = "연발 사격",
    ["Wand Specialization"] = "마법봉류 전문화",
    ["Wands"] = "마법봉",
    ["War Stomp"] = "전투 발구르기",
    ["Water Breathing"] = "수중 호흡",
    ["Water Walking"] = "수면 걷기",
    ["Weaponsmith"] = "무기제작",
    ["Whirlwind"] = "소용돌이",
    ["Will of the Forsaken"] = "포세이큰의 의지",
    ["Windfury Totem"] = "질풍의 토템",
    ["Windfury Weapon"] = "질풍의 무기",
    ["Windwall Totem"] = "바람막이 토템",
    ["Wing Clip"] = "날개 절단",
    ["Winter's Chill"] = "혹한의 추위",
    ["Wisp Spirit"] = "위습의 영혼",
    ["Wolf Riding"] = "늑대 타기",
    ["Wound Poison II"] = "상처 감염 독 II",
    ["Wound Poison III"] = "상처 감염 독 III",
    ["Wound Poison IV"] = "상처 감염 독 IV",
    ["Wound Poison"] = "상처 감염 독",
    ["Wrath"] = "천벌",
    ["Wyvern Sting"] = "비룡 쐐기"
	}
elseif locale == "deDE" then
    englishToLocal = {
        ["Abolish Disease"]="Krankheit aufheben",
        ["Abolish Poison Effect"]="Vergiftung aufheben - Effekt",
        ["Abolish Poison"]="Vergiftung aufheben",
        ["Activate MG Turret"]="MG-Turm aktivieren",
        ["Adrenaline Rush"]="Adrenalinrausch",
        ["Aftermath"]="Nachwirkung",
        ["Aggression"]="Aggression",
        ["Aimed Shot"]="Gezielter Schuss",
        ["Alchemy"]="Alchimie",
        ["Ambush"]="Hinterhalt",
        ["Amplify Curse"]="Fluch verst\195\164rken",
        ["Amplify Magic"]="Magie verst\195\164rken",
        ["Ancestral Healing"]="Heilung der Ahnen",
        ["Ancestral Knowledge"]="Wissen der Ahnen",
        ["Ancestral Spirit"]="Geist der Ahnen",
        ["Anger Management"]="Aggressionskontrolle",
        ["Anticipation"]="Vorahnung",
        ["Aquatic Form"]="Wassergestalt",
        ["Arcane Brilliance"]="Arkane Brillanz",
        ["Arcane Concentration"]="Arkane Konzentration",
        ["Arcane Explosion"]="Arkane Explosion",
        ["Arcane Focus"]="Arkaner Fokus",
        ["Arcane Instability"]="Arkane Instabilit\195\164t",
        ["Arcane Intellect"]="Arkane Intelligenz",
        ["Arcane Meditation"]="Arkane Meditation",
        ["Arcane Mind"]="Arkaner Geist",
        ["Arcane Missiles"]="Arkane Geschosse",
        ["Arcane Power"]="Arkane Macht",
        ["Arcane Resistance"]="Arkanwiderstand",
        ["Arcane Shot"]="Arkaner Schuss",
        ["Arcane Subtlety"]="Arkanes Feingef\195\188hl",
        ["Arctic Reach"]="Arktische Reichweite",
        ["Armorsmith"]="R\195\188stungsschmied",
        ["Aspect of the Beast"]="Aspekt des Wildtiers",
        ["Aspect of the Cheetah"]="Aspekt des Geparden",
        ["Aspect of the Hawk"]="Aspekt des Falken",
        ["Aspect of the Monkey"]="Aspekt des Affen",
        ["Aspect of the Pack"]="Aspekt des Rudels",
        ["Aspect of the Wild"]="Aspekt der Wildnis",
        ["Astral Recall"]="Astraler R\195\188ckruf",
        ["Attack"]="Angreifen",
        ["Attacking"]="Angreifen",
        ["Auto Shot"]="Autom. Schuss",
        ["Axe Specialization"]="Axt-Spezialisierung",
        ["Backstab"]="Meucheln",
        ["Bane"]="Dunkle Macht",
        ["Banish"]="Verbannen",
        ["Barkskin Effect"]="Baumrindeneffekt",
        ["Barkskin"]="Baumrinde",
        ["Barrage"]="Sperrfeuer",
        ["Bash"]="Hieb",
        ["Basic Campfire"]="Einfaches Lagerfeuer",
        ["Battle Shout"]="Schlachtruf",
        ["Battle Stance Passive"]="Kampfhaltung Passiv",
        ["Battle Stance"]="Kampfhaltung",
        ["Bear Form"]="B\195\164rengestalt",
        ["Beast Lore"]="Wildtierkunde",
        ["Beast Slaying"]="Wildtierschl\195\164chter",
        ["Beast Training"]="Wildtierausbildung",
        ["Benediction"]="Segnung",
        ["Berserker Rage"]="Berserkerwut",
        ["Berserker Stance Passive"]="Berserkerhaltung - Passiv",
        ["Berserker Stance"]="Berserkerhaltung",
        ["Berserking"]="Berserker",
        ["Bestial Discipline"]="Wildtierdisziplin",
        ["Bestial Swiftness"]="Erh\195\182hte Tiergeschwindigkeit",
        ["Bestial Wrath"]="Zorn des Wildtiers",
        ["Bite"]="Bei\195\159en",
        ["Black Arrow"]="Schwarzer Pfeil",
        ["Blackout"]="Blackout",
        ["Blacksmithing"]="Schmiedekunst",
        ["Blade Flurry"]="Klingenwirbel",
        ["Blast Wave"]="Druckwelle",
        ["Blessed Recovery"]="Gesegnete Erholung",
        ["Blessing of Freedom"]="Segen der Freiheit",
        ["Blessing of Kings"]="Segen der K\195\182nige",
        ["Blessing of Light"]="Segen des Lichts",
        ["Blessing of Might"]="Segen der Macht",
        ["Blessing of Protection"]="Segen des Schutzes",
        ["Blessing of Sacrifice"]="Segen der Opferung",
        ["Blessing of Salvation"]="Segen der Rettung",
        ["Blessing of Sanctuary"]="Segen des Refugiums",
        ["Blessing of Wisdom"]="Segen der Weisheit",
        ["Blind"]="Blenden",
        ["Blinding Powder"]="Blendungspulver",
        ["Blink"]="Blinzeln",
        ["Blizzard"]="Blizzard",
        ["Block"]="Blocken",
        ["Blood Craze"]="Blutwahnsinn",
        ["Blood Frenzy"]="Blutraserei",
        ["Blood Fury"]="Kochendes Blut",
        ["Blood Pact"]="Blutpakt",
        ["Bloodrage"]="Blutrausch",
        ["Bloodthirst"]="Blutdurst",
        ["Booming Voice"]="Donnernde Stimme",
        ["Bow Specialization"]="Bogenspezialisierung",
        ["Bows"]="Bogen",
        ["Bright Campfire"]="Helles Lagerfeuer",
        ["Brutal Impact"]="Brutaler Hieb",
        ["Burning Soul"]="Brennende Seele",
        ["Call Pet"]="Tier rufen",
        ["Call of Flame"]="Ruf der Flamme",
        ["Call of Thunder"]="Ruf des Donners",
        ["Camouflage"]="Tarnung",
        ["Cannibalize"]="Kannibalismus",
        ["Cat Form"]="Katzengestalt",
        ["Cataclysm"]="Katastrophe",
        ["Chain Heal"]="Kettenheilung",
        ["Chain Lightning"]="Kettenblitzschlag",
        ["Challenging Roar"]="Herausforderndes Gebr\195\188ll",
        ["Challenging Shout"]="Herausforderungsruf",
        ["Charge Rage Bonus Effect"]="Wut-Aufladung-Bonus-Effekt",
        ["Charge"]="Sturmangriff",
        ["Cheap Shot"]="Fieser Trick",
        ["Chilled"]="K\195\164lte",
        ["Claw"]="Klaue",
        ["Cleanse"]="Reinigung des Glaubens",
        ["Clearcasting"]="Freizaubern",
        ["Cleave"]="Spalten",
        ["Clever Traps"]="Falleneffizienz",
        ["Closing"]="Schlie\195\159en",
        ["Cloth"]="Stoff",
        ["Cobra Reflexes"]="Kobrareflexe",
        ["Cold Blood"]="Kaltbl\195\188tigkeit",
        ["Cold Snap"]="K\195\164lteeinbruch",
        ["Combat Endurance"]="Durchhalteverm\195\182gen des K\195\164mpfers",
        ["Combustion"]="Verbrennung",
        ["Command"]="Befehlsgewalt",
        ["Concentration Aura"]="Aura der Konzentration",
        ["Concussion Blow"]="Ersch\195\188tternder Schlag",
        ["Concussion"]="Ersch\195\188tterung",
        ["Concussive Shot"]="Ersch\195\188tternder Schuss",
        ["Cone of Cold"]="K\195\164ltekegel",
        ["Conflagrate"]="Feuersbrunst",
        ["Conjure Food"]="Essen herbeizaubern",
        ["Conjure Mana Agate"]="Mana-Achat herbeizaubern",
        ["Conjure Mana Citrine"]="Mana-Citrin herbeizaubern",
        ["Conjure Mana Jade"]="Mana-Jadestein herbeizaubern",
        ["Conjure Mana Ruby"]="Mana-Rubin herbeizaubern",
        ["Conjure Water"]="Wasser herbeizaubern",
        ["Consecration"]="Weihe",
        ["Consume Shadows"]="Schatten verzehren",
        ["Convection"]="Konvektion",
        ["Conviction"]="\195\156berzeugung",
        ["Cooking"]="Kochkunst",
        ["Corruption"]="Verderbnis",
        ["Counterattack"]="Gegenangriff",
        ["Counterspell"]="Gegenzauber",
        ["Cower"]="Ducken",
        ["Create Firestone"]="Feuerstein herstellen",
        ["Create Healthstone"]="Gesundheitsstein herstellen",
        ["Create Soulstone"]="Seelenstein herstellen",
        ["Create Spellstone"]="Zauberstein herstellen",
        ["Crippling Poison II"]="Verkr\195\188ppelndes Gift II",
        ["Crippling Poison"]="Verkr\195\188ppelndes Gift",
        ["Critical Mass"]="Kritische Masse",
        ["Crossbows"]="Armbr\195\188ste",
        ["Cruelty"]="Grausamkeit",
        ["Cultivation"]="Gr\195\188ner Daumen",
        ["Cure Disease"]="Krankheit heilen",
        ["Cure Poison"]="Vergiftung heilen",
        ["Curse of Agony"]="Fluch der Pein",
        ["Curse of Doom Effect"]="Fluch der Verdammnis'-Effekt",
        ["Curse of Doom"]="Fluch der Verdammnis",
        ["Curse of Exhaustion"]="Fluch der Ersch\195\182pfung",
        ["Curse of Idiocy"]="Fluch der Torheit",
        ["Curse of Recklessness"]="Fluch der Tollk\195\188hnheit",
        ["Curse of Shadow"]="Schattenfluch",
        ["Curse of Tongues"]="Fluch der Sprachen",
        ["Curse of Weakness"]="Fluch der Schw\195\164che",
        ["Curse of the Elements"]="Fluch der Elemente",
        ["Dagger Specialization"]="Dolch-Spezialisierung",
        ["Daggers"]="Dolche",
        ["Dampen Magic"]="Magie d\195\164mpfen",
        ["Dark Pact"]="Dunkler Pakt",
        ["Darkness"]="Dunkelheit",
        ["Dash"]="Spurt",
        ["Deadly Poison II"]="T\195\182dliches Gift II",
        ["Deadly Poison III"]="T\195\182dliches Gift III",
        ["Deadly Poison IV"]="T\195\182dliches Gift IV",
        ["Deadly Poison V"]="T\195\182dliches Gift V",
        ["Deadly Poison"]="T\195\182dliches Gift",
        ["Death Coil"]="Todesmantel",
        ["Death Wish"]="Todeswunsch",
        ["Deep Wounds"]="Tiefe Wunden",
        ["Defense"]="Verteidigung",
        ["Defensive Stance Passive"]="Verteidigungshaltung - Passiv",
        ["Defensive Stance"]="Verteidigungshaltung",
        ["Defensive State 2"]="Verteidigungsstatus 2",
        ["Defensive State"]="Verteidigungsstatus",
        ["Defiance"]="Trotz",
        ["Deflection"]="Abwehr",
        ["Demon Armor"]="D\195\164monenr\195\188stung",
        ["Demon Skin"]="D\195\164monenhaut",
        ["Demonic Embrace"]="D\195\164monische Umarmung",
        ["Demonic Sacrifice"]="D\195\164monische Opferung",
        ["Demoralizing Roar"]="Demoralisierendes Gebr\195\188ll",
        ["Demoralizing Shout"]="Demoralisierungsruf",
        ["Desperate Prayer"]="Verzweifeltes Gebet",
        ["Destructive Reach"]="Zerst\195\182rerische Reichweite",
        ["Detect Greater Invisibility"]="Gro\195\159e Unsichtbarkeit entdecken",
        ["Detect Invisibility"]="Unsichtbarkeit entdecken",
        ["Detect Lesser Invisibility"]="Geringe Unsichtbarkeit entdecken",
        ["Detect Magic"]="Magie entdecken",
        ["Detect Traps"]="Fallen entdecken",
        ["Detect"]="Entdecken",
        ["Deterrence"]="Abschreckung",
        ["Devastation"]="Verw\195\188stung",
        ["Devotion Aura"]="Aura der Hingabe",
        ["Devour Magic Effect"]="Magie verschlingen' - Effekt",
        ["Devour Magic"]="Magie verschlingen",
        ["Devouring Plague"]="Verschlingende Seuche",
        ["Diplomacy"]="Diplomatie",
        ["Dire Bear Form"]="Terrorb\195\164rengestalt",
        ["Disarm Trap"]="Falle entsch\195\164rfen",
        ["Disarm"]="Entwaffnen",
        ["Disease Cleansing Totem"]="Totem der Krankheitsreinigung",
        ["Disenchant"]="Entzaubern",
        ["Disengage"]="R\195\188ckzug",
        ["Dismiss Pet"]="Tier freigeben",
        ["Dispel Magic"]="Magiebannung",
        ["Distract"]="Ablenken",
        ["Distracting Shot"]="Ablenkender Schuss",
        ["Dive"]="Sturzflug",
        ["Divine Favor"]="G\195\182ttliche Gunst",
        ["Divine Fury"]="G\195\182ttlicher Furor",
        ["Divine Intellect"]="G\195\182ttliche Weisheit",
        ["Divine Intervention"]="G\195\182ttliches Eingreifen",
        ["Divine Protection"]="G\195\182ttlicher Schutz",
        ["Divine Shield"]="Gottesschild",
        ["Divine Spirit"]="G\195\182ttlicher Willen",
        ["Divine Strength"]="G\195\182ttliche St\195\164rke",
        ["Dodge"]="Ausweichen",
        ["Dragonscale Leatherworking"]="Drachenschuppenlederverarbeitung",
        ["Drain Life"]="Blutsauger",
        ["Drain Mana"]="Mana entziehen",
        ["Drain Soul"]="Seelendieb",
        ["Drink"]="Trinken",
        ["Dual Wield Specialization"]="Beidh\195\164ndigkeits-Spezialisierung",
        ["Dual Wield"]="Beidh\195\164ndigkeit",
        ["Duel"]="Duell",
        ["Eagle Eye"]="Adlerauge",
        ["Earth Shock"]="Erdschock",
        ["Earthbind Totem"]="Totem der Erdbindung",
        ["Efficiency"]="Effizienz",
        ["Elemental Focus"]="Elementarfokus",
        ["Elemental Fury"]="Elementarfuror",
        ["Elemental Leatherworking"]="Elementarlederverarbeitung",
        ["Elemental Mastery"]="Elementarbeherrschung",
        ["Elune's Grace"]="Elunes Anmut",
        ["Elusiveness"]="Fl\195\188chtigkeit",
        ["Emberstorm"]="Glutsturm",
        ["Enchanting"]="Verzauberkunst",
        ["Endurance Training"]="Belastbarkeit-Ausbildung",
        ["Endurance"]="Durchhalteverm\195\182gen",
        ["Engineering Specialization"]="Technologist",
        ["Engineering"]="Ingenieurskunst",
        ["Enrage"]="Wutanfall",
        ["Enriched Manna Biscuit"]="Angereicherter Manakeks",
        ["Enslave Demon"]="D\195\164monensklave",
        ["Entangling Roots"]="Wucherwurzeln",
        ["Entrapment"]="Einfangen",
        ["Escape Artist"]="Entfesselungsk\195\188nstler",
        ["Evasion"]="Entrinnen",
        ["Eventide"]="Abendzeit",
        ["Eviscerate"]="Ausweiden",
        ["Evocation"]="Hervorrufung",
        ["Execute"]="Hinrichten",
        ["Exorcism"]="Exorzismus",
        ["Expansive Mind"]="Wacher Geist",
        ["Explosive Trap Effect"]="Sprengfalle'-Effekt",
        ["Explosive Trap"]="Sprengfalle",
        ["Expose Armor"]="R\195\188stung schw\195\164chen",
        ["Eye for an Eye"]="Auge um Auge",
        ["Eye of Kilrogg"]="Auge von Kilrogg",
        ["Eyes of the Beast"]="Augen des Wildtiers",
        ["Fade"]="Verblassen",
        ["Faerie Fire"]="Feenfeuer",
        ["Far Sight"]="Fernsicht",
        ["Fear Ward"]="Furchtzauberschutz",
        ["Fear"]="Furcht",
        ["Feed Pet"]="Tier f\195\188ttern",
        ["Feedback"]="R\195\188ckkopplung",
        ["Feign Death"]="Totstellen",
        ["Feint"]="Finte",
        ["Fel Concentration"]="Teufelskonzentration",
        ["Fel Domination"]="Teufelsbeherrschung",
        ["Fel Intellect"]="Teufelsintelligenz",
        ["Fel Stamina"]="Teufelsausdauer",
        ["Felfire"]="Teufelsfeuer",
        ["Feline Grace"]="Katzenhafte Anmut",
        ["Feline Swiftness"]="Katzenhafte Schnelligkeit",
        ["Feral Aggression"]="Wilde Aggression",
        ["Feral Charge"]="Wilde Attacke",
        ["Feral Instinct"]="Instinkt der Wildnis",
        ["Ferocious Bite"]="Wilder Biss",
        ["Ferocity"]="Wildheit",
        ["Fetish"]="Fetisch",
        ["Find Herbs"]="Kr\195\164utersuche",
        ["Find Minerals"]="Mineraliensuche",
        ["Find Treasure"]="Schatzsucher",
        ["Fire Blast"]="Feuerschlag",
        ["Fire Nova Totem"]="Totem der Feuernova",
        ["Fire Power"]="Feuermacht",
        ["Fire Resistance Aura"]="Aura des Feuerwiderstands",
        ["Fire Resistance Totem"]="Totem des Feuerwiderstands",
        ["Fire Resistance"]="Feuerwiderstand",
        ["Fire Shield"]="Feuerschild",
        ["Fire Vulnerability"]="Feuerverwundbarkeit",
        ["Fire Ward"]="Feuerzauberschutz",
        ["Fireball"]="Feuerball",
        ["Firebolt"]="Feuerblitz",
        ["First Aid"]="Erste Hilfe",
        ["Fishing Poles"]="Angeln",
        ["Fishing"]="Angeln",
        ["Fist Weapon Specialization"]="Faustwaffen-Spezialisierung",
        ["Fist Weapons"]="Faustwaffen",
        ["Flame Shock"]="Flammenschock",
        ["Flame Throwing"]="Flammenwerfen",
        ["Flamestrike"]="Flammensto\195\159",
        ["Flamethrower"]="Flammenwerfer",
        ["Flametongue Totem"]="Totem der Flammenzunge",
        ["Flametongue Weapon"]="Waffe der Flammenzunge",
        ["Flare"]="Leuchtfeuer",
        ["Flash Heal"]="Blitzheilung",
        ["Flash of Light"]="Lichtblitz",
        ["Flurry"]="Schlaghagel",
        ["Focused Casting"]="Fokussiertes Zauberwirken",
        ["Food"]="Essen",
        ["Force of Will"]="Macht des Willens",
        ["Freezing Trap Effect"]="Eisk채ltefalle",
        ["Freezing Trap"]="Eisk\195\164ltefalle",
        ["Frenzied Regeneration"]="Rasende Regeneration",
        ["Frenzy"]="Raserei",
        ["Frost Armor"]="Frostr\195\188stung",
        ["Frost Channeling"]="Frost-Kanalisierung",
        ["Frost Nova"]="Frostnova",
        ["Frost Resistance Aura"]="Aura des Frostwiderstands",
        ["Frost Resistance Totem"]="Totem des Frostwiderstands",
        ["Frost Resistance"]="Frostwiderstand",
        ["Frost Shock"]="Frostschock",
        ["Frost Trap"]="Frostfalle",
        ["Frost Ward"]="Frostzauberschutz",
        ["Frostbite"]="Erfrierung",
        ["Frostbolt"]="Frostblitz",
        ["Frostbrand Weapon"]="Waffe des Frostbrands",
        ["Furious Howl"]="Wutgeheul",
        ["Furor"]="Furor",
        ["Garrote"]="Erdrosseln",
        ["Generic"]="Allgemein",
        ["Ghost Wolf"]="Geisterwolf",
        ["Ghostly Strike"]="Geisterhafter Sto\195\159",
        ["Gift of Nature"]="Geschenk der Natur",
        ["Gift of the Wild"]="Gabe der Wildnis",
        ["Gouge"]="Solarplexus",
        ["Grace of Air Totem"]="Totem der luftgleichen Anmut",
        ["Great Stamina"]="Gro\195\159e Ausdauer",
        ["Greater Blessing of Kings"]="Gro\195\159er Segen der K\195\182nige",
        ["Greater Blessing of Light"]="Gro\195\159er Segen des Lichts",
        ["Greater Blessing of Might"]="Gro\195\159er Segen der Macht",
        ["Greater Blessing of Salvation"]="Gro\195\159er Segen der Rettung",
        ["Greater Blessing of Sanctuary"]="Gro\195\159er Segen des Refugiums",
        ["Greater Blessing of Wisdom"]="Gro\195\159er Segen der Weisheit",
        ["Greater Heal"]="Gro\195\159e Heilung",
        ["Grim Reach"]="Grimmige Reichweite",
        ["Grounding Totem"]="Totem der Erdung",
        ["Grovel"]="Kriechen",
        ["Growl"]="Knurren",
        ["Guardian's Favor"]="Gunst des H\195\188ters",
        ["Gun Specialization"]="Schusswaffenspezialisierung",
        ["Guns"]="Schusswaffen",
        ["Hammer of Justice"]="Hammer der Gerechtigkeit",
        ["Hammer of Wrath"]="Hammer des Zorns",
        ["Hamstring"]="Kniesehne",
        ["Harass"]="Bel\195\164stigen",
        ["Hardiness"]="Z\195\164higkeit",
        ["Hawk Eye"]="Falkenauge",
        ["Heal"]="Heilen",
        ["Healing Focus"]="Heilfokus",
        ["Healing Light"]="Heilendes Licht",
        ["Healing Stream Totem"]="Totem des heilenden Flusses",
        ["Healing Touch"]="Heilende Ber\195\188hrung",
        ["Healing Wave"]="Welle der Heilung",
        ["Health Funnel"]="Lebenslinie",
        ["Heart of the Wild"]="Herz der Wildnis",
        ["Hellfire Effect"]="H\195\182llenfeuer - Effekt",
        ["Hellfire"]="H\195\182llenfeuer",
        ["Hemorrhage"]="Blutsturz",
        ["Herbalism"]="Kr\195\164utersammeln",
        ["Heroic Strike"]="Heldenhafter Sto\195\159",
        ["Hex of Weakness"]="Verhexung der Schw\195\164che",
        ["Hibernate"]="Winterschlaf",
        ["Holy Fire"]="Heiliges Feuer",
        ["Holy Light"]="Heiliges Licht",
        ["Holy Nova"]="Heilige Nova",
        ["Holy Power"]="Heilige Macht",
        ["Holy Reach"]="Heilige Reichweite",
        ["Holy Shield"]="Heiliger Schild",
        ["Holy Shock"]="Heiliger Schock",
        ["Holy Specialization"]="Macht des Glaubens",
        ["Holy Wrath"]="Heiliger Zorn",
        ["Honorless Target"]="Ehrenloses Ziel",
        ["Horse Riding"]="Pferdreiten",
        ["Howl of Terror"]="Schreckgeheul",
        ["Humanoid Slaying"]="Humanoident\195\182ten",
        ["Hunter's Mark"]="Mal des J\195\164gers",
        ["Hurricane"]="Hurrikan",
        ["Ice Armor"]="Eisr\195\188stung",
        ["Ice Barrier"]="Eis-Barriere",
        ["Ice Block"]="Eisblock",
        ["Ice Shards"]="Eissplitter",
        ["Ignite"]="Entz\195\188nden",
        ["Illumination"]="Illumination",
        ["Immolate"]="Feuerbrand",
        ["Immolation Trap Effect"]="Feuerbrandfalle",
        ["Immolation Trap"]="Feuerbrandfalle",
        ["Impact"]="Einschlag",
        ["Impale"]="Durchbohren",
        ["Improved Ambush"]="Verbesserter Hinterhalt",
        ["Improved Arcane Explosion"]="Verbesserte Arkane Explosion",
        ["Improved Arcane Missiles"]="Verbesserte arkane Geschosse",
        ["Improved Arcane Shot"]="Verbesserter Arkaner Schuss",
        ["Improved Aspect of the Hawk"]="Verbesserter Aspekt des Falken",
        ["Improved Aspect of the Monkey"]="Verbesserter Aspekt des Affen",
        ["Improved Backstab"]="Verbessertes Meucheln",
        ["Improved Battle Shout"]="Verbesserter Schlachtruf",
        ["Improved Berserker Rage"]="Verbesserte Berserkerwut",
        ["Improved Blessing of Might"]="Verbesserter Segen der Macht",
        ["Improved Blessing of Wisdom"]="Verbesserter Segen der Weisheit",
        ["Improved Blizzard"]="Verbesserter Blizzard",
        ["Improved Bloodrage"]="Verbesserter Blutrausch",
        ["Improved Chain Heal"]="Verbesserte Kettenheilung",
        ["Improved Chain Lightning"]="Verbesserter Kettenblitzschlag",
        ["Improved Challenging Shout"]="Verbesserter Herausforderungsruf",
        ["Improved Charge"]="Verbesserter Sturmangriff",
        ["Improved Cheap Shot"]="Verbesserter Fieser Trick",
        ["Improved Cleave"]="Verbessertes Spalten",
        ["Improved Concentration Aura"]="Verbesserte Aura der Konzentration",
        ["Improved Concussive Shot"]="Verbesserter Ersch\195\188tternder Schuss",
        ["Improved Cone of Cold"]="Verbesserter K\195\164ltekegel",
        ["Improved Corruption"]="Verbesserte Verderbnis",
        ["Improved Counterspell"]="Verbesserter Gegenzauber",
        ["Improved Curse of Agony"]="Verbesserter Fluch der Pein",
        ["Improved Curse of Exhaustion"]="Verbesserter Fluch der Ersch\195\182pfung",
        ["Improved Curse of Weakness"]="Verbesserter Fluch der Schw\195\164che",
        ["Improved Dampen Magic"]="Verbesserter Magied\195\164mpfer",
        ["Improved Deadly Poison"]="Verbessertes t\195\182dliches Gift",
        ["Improved Demoralizing Shout"]="Verbesserter Demoralisierender Ruf",
        ["Improved Devotion Aura"]="Verbesserte Aura der Hingabe",
        ["Improved Disarm"]="Verbessertes Entwaffnen",
        ["Improved Distract"]="Verbessertes Ablenken",
        ["Improved Drain Life"]="Verbesserter Blutsauger",
        ["Improved Drain Mana"]="Verbessertes Mana entziehen",
        ["Improved Drain Soul"]="Verbesserter Seelendieb",
        ["Improved Enrage"]="Verbesserter Wutanfall",
        ["Improved Enslave Demon"]="Verbesserter D\195\164monensklave",
        ["Improved Entangling Roots"]="Verbesserte Wucherwurzeln",
        ["Improved Evasion"]="Verbessertes Entrinnen",
        ["Improved Eviscerate"]="Verbessertes Ausweiden",
        ["Improved Execute"]="Verbessertes Hinrichten",
        ["Improved Expose Armor"]="Verbessertes R\195\188stung schw\195\164chen",
        ["Improved Eyes of the Beast"]="Verbesserte Augen des Wildtiers",
        ["Improved Fade"]="Verbessertes Verblassen",
        ["Improved Feign Death"]="Verbessertes Totstellen",
        ["Improved Fire Blast"]="Verbesserter Feuerschlag",
        ["Improved Fire Nova Totem"]="Verbessertes Totem der Feuernova",
        ["Improved Fire Ward"]="Verbesserter Feuerzauberschutz",
        ["Improved Fireball"]="Verbesserter Feuerball",
        ["Improved Firebolt"]="Verbesserter Feuerblitz",
        ["Improved Firestone"]="Verbesserter Feuerstein",
        ["Improved Flamestrike"]="Verbesserter Flammensto\195\159",
        ["Improved Flametongue Weapon"]="Verbesserte Waffe der Flammenzunge",
        ["Improved Flash of Light"]="Verbesserter Lichtblitz",
        ["Improved Frost Nova"]="Verbesserte Frostnova",
        ["Improved Frost Ward"]="Verbesserter Frostzauberschutz",
        ["Improved Frostbolt"]="Verbesserter Frostblitz",
        ["Improved Frostbrand Weapon"]="Verbesserte Waffe des Frostbrands",
        ["Improved Garrote"]="Verbessertes Erdrosseln",
        ["Improved Ghost Wolf"]="Verbesserter Geisterwolf",
        ["Improved Gouge"]="Verbesserter Solarplexus",
        ["Improved Grace of Air Totem"]="Verbessertes Totem der luftgleichen Anmut",
        ["Improved Grounding Totem"]="Verbessertes Totem der Erdung",
        ["Improved Hammer of Justice"]="Verbesserter Hammer der Gerechtigkeit",
        ["Improved Hamstring"]="Verbesserte Kniesehne",
        ["Improved Healing Stream Totem"]="Verbessertes Totem des heilenden Flusses",
        ["Improved Healing Touch"]="Verbesserte Heilende Ber\195\188hrung",
        ["Improved Healing Wave"]="Verbesserte Welle der Heilung",
        ["Improved Healing"]="Verbesserte Heilung",
        ["Improved Health Funnel"]="Verbesserte Lebenslinie",
        ["Improved Healthstone"]="Verbesserter Gesundheitsstein",
        ["Improved Heroic Strike"]="Verbesserter Heldenhafter Sto\195\159",
        ["Improved Hunter's Mark"]="Verbessertes Mal des J\195\164gers",
        ["Improved Immolate"]="Verbesserter Feuerbrand",
        ["Improved Imp"]="Verbesserter Wichtel",
        ["Improved Inner Fire"]="Verbessertes Inneres Feuer",
        ["Improved Instant Poison"]="Verbessertes sofort wirkendes Gift",
        ["Improved Intercept"]="Verbessertes Abfangen",
        ["Improved Intimidating Shout"]="Verbesserter Drohruf",
        ["Improved Judgement"]="Verbessertes Richturteil",
        ["Improved Kick"]="Verbesserter Tritt",
        ["Improved Kidney Shot"]="Verbesserter Nierenhieb",
        ["Improved Lash of Pain"]="Verbesserte Schmerzenspeitsche",
        ["Improved Lay on Hands"]="Verbesserte Handauflegung",
        ["Improved Lesser Healing Wave"]="Verbesserte Geringe Welle der Heilung",
        ["Improved Life Tap"]="Verbesserter Aderlass",
        ["Improved Lightning Bolt"]="Verbesserter Blitzschlag",
        ["Improved Lightning Shield"]="Verbesserter Blitzschlag-Schild",
        ["Improved Magma Totem"]="Verbessertes Totem der gl\195\188henden Magma",
        ["Improved Mana Burn"]="Verbesserter Manabrand",
        ["Improved Mana Shield"]="Verbesserter Manaschild",
        ["Improved Mana Spring Totem"]="Verbessertes Totem der Manaquelle",
        ["Improved Mark of the Wild"]="Verbessertes Mal der Wildnis",
        ["Improved Mend Pet"]="Verbessertes Tier heilen",
        ["Improved Mind Blast"]="Verbesserter Gedankenschlag",
        ["Improved Moonfire"]="Verbessertes Mondfeuer",
        ["Improved Nature's Grasp"]="Verbesserter Griff der Natur",
        ["Improved Overpower"]="Verbessertes \195\156berw\195\164ltigen",
        ["Improved Power Word: Fortitude"]="Verbessertes Machtwort: Seelenst\195\164rke",
        ["Improved Power Word: Shield"]="Verbessertes Machtwort: Schild",
        ["Improved Prayer of Healing"]="Verbessertes Gebet der Heilung",
        ["Improved Psychic Scream"]="Verbesserter Psychischer Schrei",
        ["Improved Pummel"]="Verbessertes Zuschlagen",
        ["Improved Regrowth"]="Verbessertes Nachwachsen",
        ["Improved Reincarnation"]="Verbesserte Reinkarnation",
        ["Improved Rejuvenation"]="Verbesserte Verj\195\188ngung",
        ["Improved Rend"]="Verbessertes Verwunden",
        ["Improved Renew"]="Verbesserte Erneuerung",
        ["Improved Retribution Aura"]="Verbesserte Aura der Vergeltung",
        ["Improved Revenge"]="Verbesserte Rache",
        ["Improved Revive Pet"]="Verbessertes Tier wiederbeleben",
        ["Improved Righteous Fury"]="Verbesserter Zorn der Gerechtigkeit",
        ["Improved Rockbiter Weapon"]="Verbesserte Felsbei\195\159erwaffe",
        ["Improved Rupture"]="Verbesserte Blutung",
        ["Improved Sap"]="Verbesserte Kopfnuss",
        ["Improved Scorch"]="Verbessertes Versengen",
        ["Improved Scorpid Sting"]="Verbesserter Skorpidstich",
        ["Improved Seal of Righteousness"]="Verbessertes Siegel der Rechtschaffenheit",
        ["Improved Seal of the Crusader"]="Verbessertes Siegel des Kreuzfahrers",
        ["Improved Searing Pain"]="Verbesserter Sengender Schmerz",
        ["Improved Searing Totem"]="Verbessertes Totem der Verbrennung",
        ["Improved Serpent Sting"]="Verbesserter Schlangenbiss",
        ["Improved Shadow Bolt"]="Verbesserter Schattenblitz",
        ["Improved Shadow Word: Pain"]="Verbessertes Schattenwort: Schmerz",
        ["Improved Shield Bash"]="Verbesserter Schildhieb",
        ["Improved Shield Block"]="Verbesserter Schildblock",
        ["Improved Shield Wall"]="Verbesserter Schildwall",
        ["Improved Shred"]="Verbessertes Schreddern",
        ["Improved Sinister Strike"]="Verbesserter Finsterer Sto\195\159",
        ["Improved Slam"]="Verbessertes Zerschmettern",
        ["Improved Slice and Dice"]="Verbessertes Zerh\195\164ckseln",
        ["Improved Spellstone"]="Verbesserter Zauberstein",
        ["Improved Sprint"]="Verbessertes Sprinten",
        ["Improved Starfire"]="Verbessertes Sternenfeuer",
        ["Improved Stoneclaw Totem"]="Verbessertes Totem der Steinklaue",
        ["Improved Stoneskin Totem"]="Verbessertes Totem der Steinhaut",
        ["Improved Strength of Earth Totem"]="Verbessertes Totem der Erdst\195\164rke",
        ["Improved Succubus"]="Verbesserter Sukkubus",
        ["Improved Sunder Armor"]="Verbessertes R\195\188stung zerrei\195\159en",
        ["Improved Taunt"]="Verbesserter Spott",
        ["Improved Thorns"]="Verbesserte Dornen",
        ["Improved Thunder Clap"]="Verbesserter Donnerknall",
        ["Improved Tranquility"]="Verbesserte Gelassenheit",
        ["Improved Vampiric Embrace"]="Verbesserte Vampirumarmung",
        ["Improved Vanish"]="Verbessertes Verschwinden",
        ["Improved Voidwalker"]="Verbesserter Leerwandler",
        ["Improved Windfury Weapon"]="Verbesserte Waffe des Windfurors",
        ["Improved Wing Clip"]="Verbessertes Zurechtstutzen",
        ["Improved Wrath"]="Verbesserter Zorn",
        ["Incinerate"]="Verbrennen",
        ["Inferno"]="Inferno",
        ["Initiative"]="Initiative",
        ["Inner Fire"]="Inneres Feuer",
        ["Inner Focus"]="Innerer Fokus",
        ["Innervate"]="Anregen",
        ["Insect Swarm"]="Insektenschwarm",
        ["Inspiration"]="Inspiration",
        ["Instant Poison II"]="Sofort wirkendes Gift II",
        ["Instant Poison III"]="Sofort wirkendes Gift III",
        ["Instant Poison IV"]="Sofort wirkendes Gift IV",
        ["Instant Poison V"]="Sofort wirkendes Gift V",
        ["Instant Poison VI"]="Sofort wirkendes Gift VI",
        ["Instant Poison"]="Sofort wirkendes Gift",
        ["Intensity"]="Intensit\195\164t",
        ["Intercept"]="Abfangen",
        ["Intimidating Shout"]="Drohruf",
        ["Intimidation"]="Einsch\195\188chterung",
        ["Iron Will"]="Eiserner Wille",
        ["Judgement of Command"]="Richturteil des Befehls",
        ["Judgement of Justice"]="Richturteil der Gerechtigkeit",
        ["Judgement of Light"]="Richturteil des Lichts",
        ["Judgement of Righteousness"]="Richturteil der Rechtschaffenheit",
        ["Judgement of Wisdom"]="Richturteil der Weisheit",
        ["Judgement of the Crusader"]="Richturteil des Kreuzfahrers",
        ["Judgement"]="Richturteil",
        ["Kick"]="Tritt",
        ["Kidney Shot"]="Nierenhieb",
        ["Killer Instinct"]="T\195\182tungstrieb",
        ["Kodo Riding"]="Kodoreiten",
        ["Lash of Pain"]="Schmerzenspeitsche",
        ["Last Stand"]="Letztes Gefecht",
        ["Lasting Judgement"]="Dauerhaftes Richturteil",
        ["Lay on Hands"]="Handauflegung",
        ["Leader of the Pack"]="Rudelf\195\188hrer",
        ["Leather"]="Leder",
        ["Leatherworking"]="Lederverarbeitung",
        ["Lesser Heal"]="Geringes Heilen",
        ["Lesser Healing Wave"]="Geringe Welle der Heilung",
        ["Lesser Invisibility"]="Geringe Unsichtbarkeit",
        ["Lethal Shots"]="T\195\182dliche Sch\195\188sse",
        ["Lethality"]="T\195\182dlichkeit",
        ["Levitate"]="Levitieren",
        ["Libram"]="Buchband",
        ["Life Tap"]="Aderlass",
        ["Lightning Bolt"]="Blitzschlag",
        ["Lightning Breath"]="Blitzschlagatem",
        ["Lightning Mastery"]="Blitzschlagbeherrschung",
        ["Lightning Reflexes"]="Blitzartige Reflexe",
        ["Lightning Shield"]="Blitzschlagschild",
        ["Lightwell Renew"]="Erneuerung des Lichtbrunnens",
        ["Lightwell"]="Brunnen des Lichts",
        ["Lockpicking"]="Schlossknacken",
        ["Long Daze"]="Lange Benommenheit",
        ["Mace Specialization"]="Streitkolben-Spezialisierung",
        ["Mace Stun Effect"]="Streitkolbenbet\195\164ubung-Effekt",
        ["Mage Armor"]="Magische R\195\188stung",
        ["Magma Totem"]="Totem der gl\195\188henden Magma",
        ["Mail"]="Panzer",
        ["Malice"]="T\195\188cke",
        ["Mana Burn"]="Manabrand",
        ["Mana Shield"]="Manaschild",
        ["Mana Spring Totem"]="Totem der Manaquelle",
        ["Mana Tide Totem"]="Totem der Manaflut",
        ["Mangle"]="Fleddern",
        ["Mark of the Wild"]="Mal der Wildnis",
        ["Martyrdom"]="M\195\164rtyrertum",
        ["Master Demonologist"]="Meister der D\195\164monologie",
        ["Master Summoner"]="Meister der Beschw\195\182rung",
        ["Master of Deception"]="Meister der T\195\164uschung",
        ["Maul"]="Zermalmen",
        ["Mechanostrider Piloting"]="Roboschreiter-Lenken",
        ["Meditation"]="Meditation",
        ["Melee Specialization"]="Nahkampf-Spezialisierung",
        ["Mend Pet"]="Tier heilen",
        ["Mental Agility"]="Mentale Beweglichkeit",
        ["Mental Strength"]="Mentale St\195\164rke",
        ["Mind Blast"]="Gedankenschlag",
        ["Mind Control"]="Gedankenkontrolle",
        ["Mind Flay"]="Gedankenschinden",
        ["Mind Soothe"]="Gedankenbes\195\164nftigung",
        ["Mind Vision"]="Gedankensicht",
        ["Mind-numbing Poison II"]="Gedankenbenebelndes Gift II",
        ["Mind-numbing Poison III"]="Gedankenbenebelndes Gift III",
        ["Mind-numbing Poison"]="Gedankenbenebelndes Gift",
        ["Mining"]="Bergbau",
        ["Mocking Blow"]="Sp\195\182ttischer Schlag",
        ["Mongoose Bite"]="Mungobiss",
        ["Monster Slaying"]="Monstert\195\182ten",
        ["Moonfire"]="Mondfeuer",
        ["Moonfury"]="Mondfuror",
        ["Moonglow"]="Mondschein",
        ["Moonkin Aura"]="Aura des Moonkin",
        ["Moonkin Form"]="Moonkingestalt",
        ["Mortal Shots"]="Todbringende Sch\195\188sse",
        ["Mortal Strike"]="T\195\182dlicher Sto\195\159",
        ["Multi-Shot"]="Mehrfachschuss",
        ["Murder"]="Mord",
        ["Natural Armor"]="Nat\195\188rliche R\195\188stung",
        ["Natural Shapeshifter"]="Schnellwandlung",
        ["Natural Weapons"]="Waffenbalance",
        ["Nature Resistance Totem"]="Totem des Naturwiderstands",
        ["Nature Resistance"]="Naturwiderstand",
        ["Nature's Focus"]="Naturfokus",
        ["Nature's Grace"]="Anmut der Natur",
        ["Nature's Grasp"]="Griff der Natur",
        ["Nature's Reach"]="Reichweite der Natur",
        ["Nature's Swiftness"]="Schnelligkeit der Natur",
        ["Nightfall"]="Einbruch der Nacht",
        ["Omen of Clarity"]="Omen der Klarsicht",
        ["One-Handed Axes"]="Einhand\195\164xte",
        ["One-Handed Maces"]="Einhandstreitkolben",
        ["One-Handed Swords"]="Einhandschwerter",
        ["One-Handed Weapon Specialization"]="Einhandwaffen-Spezialisierung",
        ["Opening - No Text"]="\195\150ffnen - Kein Text",
        ["Opening"]="\195\150ffnen",
        ["Opportunity"]="G\195\188nstige Gelegenheit",
        ["Overpower"]="\195\156berw\195\164ltigen",
        ["Paranoia"]="Paranoia",
        ["Parry"]="Parieren",
        ["Pathfinding"]="Orientierung",
        ["Perception"]="Wachsamkeit",
        ["Permafrost"]="Dauerfrost",
        ["Pet Aggression"]="Tieraggression",
        ["Pet Hardiness"]="Tier-Widerstandskraft",
        ["Pet Recovery"]="Tiererholung",
        ["Pet Resistance"]="Tier-Widerstand",
        ["Phase Shift"]="Phasenverschiebung",
        ["Pick Lock"]="Schloss knacken",
        ["Pick Pocket"]="Taschendiebstahl",
        ["Piercing Howl"]="Durchdringendes Heulen",
        ["Piercing Ice"]="Stechendes Eis",
        ["Plate Mail"]="Plattenpanzer",
        ["Poison Cleansing Totem"]="Totem der Giftreinigung",
        ["Poisons"]="Gifte",
        ["Polearm Specialization"]="Stangenwaffen-Spezialisierung",
        ["Polearms"]="Stangenwaffen",
        ["Polymorph"]="Verwandlung",
        ["Portal: Darnassus"]="Portal: Darnassus",
        ["Portal: Ironforge"]="Portal: Ironforge",
        ["Portal: Orgrimmar"]="Portal: Orgrimmar",
        ["Portal: Stormwind"]="Portal: Stormwind",
        ["Portal: Thunder Bluff"]="Portal: Thunder Bluff",
        ["Portal: Undercity"]="Portal: Undercity",
        ["Pounce Bleed"]="Anspringblutung",
        ["Pounce"]="Anspringen",
        ["Power Infusion"]="Seele der Macht",
        ["Power Word: Fortitude"]="Machtwort: Seelenst\195\164rke",
        ["Power Word: Shield"]="Machtwort: Schild",
        ["Prayer of Fortitude"]="Gebet der Seelenst\195\164rke",
        ["Prayer of Healing"]="Gebet der Heilung",
        ["Prayer of Shadow Protection"]="Gebet des Schattenschutzes",
        ["Prayer of Spirit"]="Gebet der Willenskraft",
        ["Precision"]="Pr\195\164zision",
        ["Predatory Strikes"]="Raubtierschl\195\164ge",
        ["Premeditation"]="Konzentration",
        ["Preparation"]="Vorbereitung",
        ["Presence of Mind"]="Geistesgegenwart",
        ["Primal Fury"]="Urfuror",
        ["Prowl"]="Schleichen",
        ["Psychic Scream"]="Psychischer Schrei",
        ["Pummel"]="Zuschlagen",
        ["Purge"]="Reinigen",
        ["Purification"]="L\195\164uterung",
        ["Purify"]="L\195\164utern",
        ["Pursuit of Justice"]="Streben nach Gerechtigkeit",
        ["Pyroblast"]="Pyroschlag",
        ["Pyroclasm"]="Feuerschwall",
        ["Quickness"]="Schnelligkeit",
        ["Rain of Fire"]="Feuerregen",
        ["Rake"]="Krallenhieb",
        ["Ram Riding"]="Widderreiten",
        ["Ranged Weapon Specialization"]="Distanzwaffen-Spezialisierung",
        ["Rapid Concealment"]="Schnelles Verstecken",
        ["Rapid Fire"]="Schnellfeuer",
        ["Raptor Riding"]="Raptorreiten",
        ["Raptor Strike"]="Raptorsto\195\159",
        ["Ravage"]="Verheeren",
        ["Readiness"]="Bereitschaft",
        ["Rebirth"]="Wiedergeburt",
        ["Reckless Charge"]="Tollk체hnes St체rmen",
        ["Recklessness"]="Tollk\195\188hnheit",
        ["Reckoning"]="Abrechnung",
        ["Redemption"]="Erl\195\182sung",
        ["Redoubt"]="Verschanzen",
        ["Reflection"]="Reflexion",
        ["Regeneration"]="Regeneration",
        ["Regrowth"]="Nachwachsen",
        ["Reincarnation"]="Reinkarnation",
        ["Rejuvenation"]="Verj\195\188ngung",
        ["Relentless Strikes"]="Unerbittliche St\195\182\195\159e",
        ["Remorseless Attacks"]="Gnadenlose Angriffe",
        ["Remove Curse"]="Fluch aufheben",
        ["Remove Insignia"]="Abzeichen entfernen",
        ["Remove Lesser Curse"]="Geringen Fluch aufheben",
        ["Rend"]="Verwunden",
        ["Renew"]="Erneuerung",
        ["Repentance"]="Bu\195\159e",
        ["Resurrection"]="Auferstehung",
        ["Retaliation"]="Gegenschlag",
        ["Retribution Aura"]="Aura der Vergeltung",
        ["Revenge Stun"]="Rachebet\195\164ubung",
        ["Revenge"]="Rache",
        ["Reverberation"]="Nachklingen",
        ["Revive Pet"]="Tier wiederbeleben",
        ["Righteous Fury"]="Zorn der Gerechtigkeit",
        ["Rip"]="Zerfetzen",
        ["Riposte"]="Riposte",
        ["Ritual of Doom Effect"]="Ritual der Verdammnis'-Effekt",
        ["Ritual of Doom"]="Ritual der Verdammnis",
        ["Ritual of Summoning"]="Ritual der Beschw\195\182rung",
        ["Rockbiter Weapon"]="Felsbei\195\159erwaffe",
        ["Rogue Passive"]="Schurke Passiv",
        ["Ruin"]="Verderben",
        ["Rupture"]="Blutung",
        ["Ruthlessness"]="Skrupellosigkeit",
        ["Sacrifice"]="Opferung",
        ["Safe Fall"]="Sicheres Fallen",
        ["Sanctity Aura"]="Aura der Heiligkeit",
        ["Sap"]="Kopfnuss",
        ["Savage Fury"]="Ungez\195\164hmte Wut",
        ["Savage Strikes"]="Wilde Schl\195\164ge",
        ["Scare Beast"]="Wildtier \195\164ngstigen",
        ["Scatter Shot"]="Streuschuss",
        ["Scorch"]="Versengen",
        ["Scorpid Poison"]="Skorpidgift",
        ["Scorpid Sting"]="Skorpidstich",
        ["Screech"]="Schrei",
        ["Seal Fate"]="Schicksal besiegeln",
        ["Seal of Command"]="Siegel des Befehls",
        ["Seal of Justice"]="Siegel der Gerechtigkeit",
        ["Seal of Light"]="Siegel des Lichts",
        ["Seal of Righteousness"]="Siegel der Rechtschaffenheit",
        ["Seal of Wisdom"]="Siegel der Weisheit",
        ["Seal of the Crusader"]="Siegel des Kreuzfahrers",
        ["Searing Light"]="Sengendes Licht",
        ["Searing Pain"]="Sengender Schmerz",
        ["Searing Totem"]="Totem der Verbrennung",
        ["Seduction"]="Verf\195\188hrung",
        ["Sense Demons"]="D\195\164monen sp\195\188ren",
        ["Sense Undead"]="Untote sp\195\188ren",
        ["Sentry Totem"]="Totem des Wachens",
        ["Serpent Sting"]="Schlangenbiss",
        ["Setup"]="Reinlegen",
        ["Shackle Undead"]="Untote fesseln",
        ["Shadow Affinity"]="Schattenaffinit\195\164t",
        ["Shadow Bolt"]="Schattenblitz",
        ["Shadow Focus"]="Schattenfokus",
        ["Shadow Mastery"]="Schattenbeherrschung",
        ["Shadow Protection"]="Schattenschutz",
        ["Shadow Reach"]="Schattenreichweite",
        ["Shadow Resistance Aura"]="Aura des Schattenwiderstands",
        ["Shadow Resistance"]="Schattenwiderstand",
        ["Shadow Ward"]="Schattenzauberschutz",
        ["Shadow Weaving"]="Schattenwirken",
        ["Shadow Word: Pain"]="Schattenwort: Schmerz",
        ["Shadowburn"]="Schattenbrand",
        ["Shadowform"]="Schattengestalt",
        ["Shadowguard"]="Schattenschild",
        ["Shadowmeld Passive"]="Schattenmimik Passiv",
        ["Shadowmeld"]="Schattenhaftigkeit",
        ["Sharpened Claws"]="Gesch\195\164rfte Klauen",
        ["Shatter"]="Zertr\195\188mmern",
        ["Shell Shield"]="Panzerschild",
        ["Shield Bash"]="Schildhieb",
        ["Shield Block"]="Schildblock",
        ["Shield Slam"]="Schildschlag",
        ["Shield Specialization"]="Schild-Spezialisierung",
        ["Shield Wall"]="Schildwall",
        ["Shield"]="Schild",
        ["Shoot Bow"]="Bogenschuss",
        ["Shoot Crossbow"]="Armbrust abschie\195\159en",
        ["Shoot Gun"]="Schusswaffe abfeuern",
        ["Shoot"]="Schie\195\159en",
        ["Shred"]="Schreddern",
        ["Silence"]="Stille",
        ["Silent Resolve"]="Schweigsame Entschlossenheit",
        ["Sinister Strike"]="Finsterer Sto\195\159",
        ["Siphon Life"]="Lebensentzug",
        ["Skinning"]="K\195\188rschnerei",
        ["Slam"]="Zerschmettern",
        ["Sleep"]="Schlaf",
        ["Slice and Dice"]="Zerh\195\164ckseln",
        ["Slow Fall"]="Langsamer Fall",
        ["Smelting"]="Verh\195\188ttung",
        ["Smite"]="G\195\182ttliche Pein",
        ["Soothe Animal"]="Tier bes\195\164nftigen",
        ["Soothing Kiss"]="Bes\195\164nftigender Kuss",
        ["Soul Fire"]="Seelenfeuer",
        ["Soul Link"]="Seelenverbindung",
        ["Soulstone Resurrection"]="Seelenstein-Auferstehung",
        ["Spell Lock"]="Zaubersperre",
        ["Spell Warding"]="Zauberschutz",
        ["Spirit Bond"]="Geistbande",
        ["Spirit Tap"]="Willensentzug",
        ["Spirit of Redemption"]="Geist der Erl\195\182sung",
        ["Spiritual Focus"]="Spiritueller Fokus",
        ["Spiritual Guidance"]="Geistige F\195\188hrung",
        ["Spiritual Healing"]="Spirituelle Heilung",
        ["Sprint"]="Sprinten",
        ["Starfire"]="Sternenfeuer",
        ["Starshards"]="Sternensplitter",
        ["Staves"]="St\195\164be",
        ["Stealth"]="Verstohlenheit",
        ["Stoneclaw Totem"]="Totem der Steinklaue",
        ["Stoneform"]="Steingestalt",
        ["Stoneskin Totem"]="Totem der Steinhaut",
        ["Stormstrike"]="Sturmschlag",
        ["Strength of Earth Totem"]="Totem der Erdst\195\164rke",
        ["Stuck"]="Feststecken",
        ["Subtlety"]="Feingef\195\188hl",
        ["Suffering"]="Leiden",
        ["Summon Charger"]="Streitross beschw\195\182ren",
        ["Summon Dreadsteed"]="Schreckensross herbeirufen",
        ["Summon Felhunter"]="Teufelsj\195\164ger beschw\195\182ren",
        ["Summon Felsteed"]="Teufelsross beschw\195\182ren",
        ["Summon Imp"]="Wichtel beschw\195\182ren",
        ["Summon Succubus"]="Sukkubus beschw\195\182ren",
        ["Summon Voidwalker"]="Leerwandler beschw\195\182ren",
        ["Summon Warhorse"]="Schlachtross beschw\195\182ren",
        ["Sunder Armor"]="R\195\188stung zerrei\195\159en",
        ["Suppression"]="Unterdr\195\188ckung",
        ["Surefooted"]="Sicherer Stand",
        ["Survivalist"]="\195\156berlebensk\195\188nstler",
        ["Sweeping Strikes"]="Weitreichende St\195\182\195\159e",
        ["Swipe"]="Prankenhieb",
        ["Sword Specialization"]="Schwert-Spezialisierung",
        ["Tactical Mastery"]="Taktiker",
        ["Tainted Blood"]="Besudeltes Blut",
        ["Tailoring"]="Schneiderei",
        ["Tame Beast"]="Wildtier z\195\164hmen",
        ["Tamed Pet Passive"]="Gez\195\164hmtes Tier - Passiv",
        ["Taunt"]="Spott",
        ["Teleport: Darnassus"]="Teleportieren: Darnassus",
        ["Teleport: Ironforge"]="Teleportieren: Ironforge",
        ["Teleport: Moonglade"]="Teleportieren: Moonglade",
        ["Teleport: Orgrimmar"]="Teleportieren: Orgrimmar",
        ["Teleport: Stormwind"]="Teleportieren: Stormwind",
        ["Teleport: Thunder Bluff"]="Teleportieren: Thunder Bluff",
        ["Teleport: Undercity"]="Teleportieren: Undercity",
        ["The Human Spirit"]="Unbeugsamkeit",
        ["Thick Hide"]="Dickes Fell",
        ["Thorns"]="Dornen",
        ["Throw"]="Werfen",
        ["Throwing Specialization"]="Wurfwaffen-Spezialisierung",
        ["Throwing Weapon Specialization"]="Wurfwaffen-Spezialisierung",
        ["Thrown"]="Wurfwaffe",
        ["Thunder Clap"]="Donnerknall",
        ["Thundering Strikes"]="Donnernde St\195\182\195\159e",
        ["Thunderstomp"]="Donnerstampfer",
        ["Tidal Focus"]="Gezeitenfokus",
        ["Tidal Mastery"]="Gezeitenbeherrschung",
        ["Tiger Riding"]="Tigerreiten",
        ["Tiger's Fury"]="Tigerfuror",
        ["Torment"]="Qual",
        ["Totem"]="Totem",
        ["Totemic Focus"]="Totemfokus",
        ["Touch of Weakness"]="Ber\195\188hrung der Schw\195\164che",
        ["Toughness"]="Z\195\164higkeit",
        ["Track Beasts"]="Wildtiere aufsp\195\188ren",
        ["Track Demons"]="D\195\164monen aufsp\195\188ren",
        ["Track Dragonkin"]="Drachkin aufsp\195\188ren",
        ["Track Elementals"]="Elementare aufsp\195\188ren",
        ["Track Giants"]="Riesen aufsp\195\188ren",
        ["Track Hidden"]="Verborgenes aufsp\195\188ren",
        ["Track Humanoids"]="Humanoide aufsp\195\188ren",
        ["Track Undead"]="Untote aufsp\195\188ren",
        ["Tranquil Air Totem"]="Totem der beruhigenden Winde",
        ["Tranquil Spirit"]="Gelassener Geist",
        ["Tranquility"]="Gelassenheit",
        ["Tranquilizing Shot"]="Einlullender Schuss",
        ["Trap Mastery"]="Fallenbeherrschung",
        ["Travel Form"]="Reisegestalt",
        ["Tremor Totem"]="Totem des Erdsto\195\159es",
        ["Tribal Leatherworking"]="Stammeslederverarbeitung",
        ["Trueshot Aura"]="Aura des Volltreffers",
        ["Turn Undead"]="Untote vertreiben",
        ["Two-Handed Axes and Maces"]="Zweihand\195\164xte und -Streitkolben",
        ["Two-Handed Axes"]="Zweihand\195\164xte",
        ["Two-Handed Maces"]="Zweihandstreitkolben",
        ["Two-Handed Swords"]="Zweihandschwerter",
        ["Two-Handed Weapon Specialization"]="Zweihandwaffen-Spezialisierung",
        ["Unarmed"]="Unbewaffnet",
        ["Unbreakable Will"]="Unbezwingbarer Wille",
        ["Unbridled Wrath Effect"]="Entfesselter Zorn'-Effekt",
        ["Unbridled Wrath"]="Entfesselter Zorn",
        ["Undead Horsemanship"]="Untotenreitkunst",
        ["Underwater Breathing"]="Unterwasseratmung",
        ["Unending Breath"]="Unendlicher Atem",
        ["Unholy Power"]="Unheilige Macht",
        ["Unleashed Fury"]="Entfesselter Zorn",
        ["Unyielding Faith"]="Unumst\195\182\195\159licher Glaube",
        ["Vampiric Embrace"]="Vampirumarmung",
        ["Vanish"]="Verschwinden",
        ["Vanished"]="Verschwunden",
        ["Vengeance"]="Rache",
        ["Vigor"]="Lebenskraft",
        ["Vile Poisons"]="\195\156ble Gifte",
        ["Vindication"]="Rechtschaffene Schw\195\164chung",
        ["Viper Sting"]="Vipernbiss",
        ["Volley"]="Salve",
        ["Wand Specialization"]="Zauberstab-Spezialisierung",
        ["Wands"]="Zauberst\195\164be",
        ["War Stomp"]="Kriegsdonner",
        ["Water Breathing"]="Wasseratmung",
        ["Water Walking"]="Wasserwandeln",
        ["Weaponsmith"]="Waffenschmied",
        ["Whirlwind"]="Wirbelwind",
        ["Will of the Forsaken"]="Wille der Verlassenen",
        ["Windfury Totem"]="Totem des Windzorns",
        ["Windfury Weapon"]="Waffe des Windfurors",
        ["Windwall Totem"]="Totem der Windmauer",
        ["Wing Clip"]="Zurechtstutzen",
        ["Winter's Chill"]="Winterk\195\164lte",
        ["Wisp Spirit"]="Irrwisch-Geist",
        ["Wolf Riding"]="Wolfreiten",
        ["Wound Poison II"]="Wundgift II",
        ["Wound Poison III"]="Wundgift III",
        ["Wound Poison IV"]="Wundgift IV",
        ["Wound Poison"]="Wundgift",
        ["Wrath"]="Zorn",
        ["Wyvern Sting"]="Stich des Fl\195\188geldrachen"
    }
elseif locale == "frFR" then
    englishToLocal = {
        ["Abolish Disease"]="Abolir maladie",
        ["Abolish Poison Effect"]="Effet Abolir le poison",
        ["Abolish Poison"]="Abolir le poison",
        ["Activate MG Turret"]="Activation de la tourelle de mitrailleuse",
        ["Adrenaline Rush"]="Pouss\195\169e d'adr\195\169naline",
        ["Aftermath"]="Cons\195\169quences",
        ["Aggression"]="Agressivit\195\169",
        ["Aimed Shot"]="Vis\195\169e",
        ["Alchemy"]="Alchimie",
        ["Ambush"]="Embuscade",
        ["Amplify Curse"]="Mal\195\169diction amplifi\195\169e",
        ["Amplify Magic"]="Amplification de la magie",
        ["Ancestral Healing"]="Gu\195\169rison des anciens",
        ["Ancestral Knowledge"]="Connaissance ancestrale",
        ["Ancestral Spirit"]="Esprit ancestral",
        ["Anger Management"]="Ma\195\174trise de la Rage",
        ["Anticipation"]="Anticipation",
        ["Aquatic Form"]="Forme aquatique",
        ["Arcane Brilliance"]="Illumination des arcanes",
        ["Arcane Concentration"]="Concentration des arcanes",
        ["Arcane Explosion"]="Explosion des arcanes",
        ["Arcane Focus"]="Focalisation des arcanes",
        ["Arcane Instability"]="Instabilit\195\169 des arcanes",
        ["Arcane Intellect"]="Intelligence des arcanes",
        ["Arcane Meditation"]="M\195\169ditation des arcanes",
        ["Arcane Mind"]="Esprit des arcanes",
        ["Arcane Missiles"]="Projectiles des arcanes",
        ["Arcane Power"]="Pouvoir des arcanes",
        ["Arcane Resistance"]="R\195\169sistance aux Arcanes",
        ["Arcane Shot"]="Tir des arcanes",
        ["Arcane Subtlety"]="Subtilit\195\169 des arcanes",
        ["Arctic Reach"]="Allonge arctique",
        ["Armorsmith"]="Fabricant d'armures",
        ["Aspect of the Beast"]="Aspect de la b\195\170te",
        ["Aspect of the Cheetah"]="Aspect du gu\195\169pard",
        ["Aspect of the Hawk"]="Aspect du faucon",
        ["Aspect of the Monkey"]="Aspect du singe",
        ["Aspect of the Pack"]="Aspect de la meute",
        ["Aspect of the Wild"]="Aspect de la nature",
        ["Astral Recall"]="Rappel astral",
        ["Attack"]="Attaque",
        ["Attacking"]="Attaque",
        ["Auto Shot"]="Tir automatique",
        ["Axe Specialization"]="Sp\195\169cialisation Hache",
        ["Backstab"]="Attaque sournoise",
        ["Bane"]="Fl\195\169au",
        ["Banish"]="Bannir",
        ["Barkskin Effect"]="Effet Ecorce",
        ["Barkskin"]="Ecorce",
        ["Barrage"]="Barrage",
        ["Bash"]="Sonner",
        ["Basic Campfire"]="Feu de camp basique",
        ["Battle Shout"]="Cri de guerre",
        ["Battle Stance Passive"]="Posture de combat",
        ["Battle Stance"]="Posture de combat",
        ["Bear Form"]="Forme d'ours",
        ["Beast Lore"]="Connaissance des b\195\170tes",
        ["Beast Slaying"]="Tueur de b\195\170tes",
        ["Beast Training"]="Apprivoisement",
        ["Benediction"]="B\195\169n\195\169diction",
        ["Berserker Rage"]="Rage berserker",
        ["Berserker Stance Passive"]="Posture berserker",
        ["Berserker Stance"]="Posture berserker",
        ["Berserking"]="Berserker",
        ["Bestial Discipline"]="Discipline bestiale",
        ["Bestial Swiftness"]="Rapidit\195\169 bestiale",
        ["Bestial Wrath"]="Courroux bestial",
        ["Bite"]="Morsure",
        ["Black Arrow"]="Fl\195\168che noire",
        ["Blackout"]="Aveuglement",
        ["Blacksmithing"]="Forge",
        ["Blade Flurry"]="D\195\169luge de lames",
        ["Blast Wave"]="Vague explosive",
        ["Blessed Recovery"]="R\195\169tablissement b\195\169ni",
        ["Blessing of Freedom"]="B\195\169n\195\169diction de libert\195\169",
        ["Blessing of Kings"]="B\195\169n\195\169diction des rois",
        ["Blessing of Light"]="B\195\169n\195\169diction de lumi\195\168re",
        ["Blessing of Might"]="B\195\169n\195\169diction de puissance",
        ["Blessing of Protection"]="B\195\169n\195\169diction de protection",
        ["Blessing of Sacrifice"]="B\195\169n\195\169diction de sacrifice",
        ["Blessing of Salvation"]="B\195\169n\195\169diction de salut",
        ["Blessing of Sanctuary"]="B\195\169n\195\169diction du sanctuaire",
        ["Blessing of Wisdom"]="B\195\169n\195\169diction de sagesse",
        ["Blind"]="C\195\169cit\195\169",
        ["Blinding Powder"]="Poudre aveuglante",
        ["Blink"]="Transfert",
        ["Blizzard"]="Blizzard",
        ["Block"]="Bloquer",
        ["Blood Craze"]="Folie sanguinaire",
        ["Blood Frenzy"]="Fr\195\169n\195\169sie sanglante",
        ["Blood Fury"]="Fureur sanguinaire",
        ["Blood Pact"]="Pacte de sang",
        ["Bloodrage"]="Rage sanguinaire",
        ["Bloodthirst"]="Sanguinaire",
        ["Booming Voice"]="Voix tonitruante",
        ["Bow Specialization"]="Sp\195\169cialisation Arc",
        ["Bows"]="Arcs",
        ["Bright Campfire"]="Feu de camp \195\169clatant",
        ["Brutal Impact"]="Impact brutal",
        ["Burning Soul"]="Ame ardente",
        ["Call Pet"]="Appel du familier",
        ["Call of Flame"]="Appel des flammes",
        ["Call of Thunder"]="Appel de la foudre",
        ["Camouflage"]="Dissimulation",
        ["Cannibalize"]="Cannibalisme",
        ["Cat Form"]="Forme de f\195\169lin",
        ["Cataclysm"]="Cataclysme",
        ["Chain Heal"]="Salve de gu\195\169rison",
        ["Chain Lightning"]="Cha\195\174ne d'\195\169clairs",
        ["Challenging Roar"]="Rugissement provocateur",
        ["Challenging Shout"]="Cri de d\195\169fi",
        ["Charge Rage Bonus Effect"]="Effet Bonus de Rage de la Charge",
        ["Charge"]="Charge",
        ["Cheap Shot"]="Coup bas",
        ["Chilled"]="Transi",
        ["Claw"]="Griffe",
        ["Cleanse"]="Epuration",
        ["Clearcasting"]="Id\195\169es claires",
        ["Cleave"]="Encha\195\174nement",
        ["Clever Traps"]="Pi\195\168ges astucieux",
        ["Closing"]="Fermeture",
        ["Cloth"]="Tissu",
        ["Cobra Reflexes"]="R\195\169flexes du cobra",
        ["Cold Blood"]="Sang froid",
        ["Cold Snap"]="Morsure de glace",
        ["Combat Endurance"]="Endurance de combat",
        ["Combustion"]="Combustion",
        ["Command"]="Commande",
        ["Concentration Aura"]="Aura de concentration",
        ["Concussion Blow"]="Bourrasque",
        ["Concussion"]="Commotion",
        ["Concussive Shot"]="Trait de choc",
        ["Cone of Cold"]="C\195\180ne de froid",
        ["Conflagrate"]="Conflagration",
        ["Conjure Food"]="Invocation de nourriture",
        ["Conjure Mana Agate"]="Invocation d'une agate de mana",
        ["Conjure Mana Citrine"]="Invocation d'une citrine de mana",
        ["Conjure Mana Jade"]="Invocation d'une jade de mana",
        ["Conjure Mana Ruby"]="Invocation d'un rubis de mana",
        ["Conjure Water"]="Invocation d'eau",
        ["Consecration"]="Cons\195\169cration",
        ["Consume Shadows"]="Consumer les ombres",
        ["Convection"]="Convection",
        ["Conviction"]="Conviction",
        ["Cooking"]="Cuisine",
        ["Corruption"]="Corruption",
        ["Counterattack"]="Contre-attaque",
        ["Counterspell"]="Contresort",
        ["Cower"]="D\195\169robade",
        ["Create Firestone"]="Cr\195\169ation de Pierre de feu",
        ["Create Healthstone"]="Cr\195\169ation de Pierre de soins",
        ["Create Soulstone"]="Cr\195\169ation de Pierre d'\195\162me",
        ["Create Spellstone"]="Cr\195\169ation de Pierre de sort",
        ["Crippling Poison II"]="Poison affaiblissant II",
        ["Crippling Poison"]="Poison affaiblissant",
        ["Critical Mass"]="Masse critique",
        ["Crossbows"]="Arbal\195\168tes",
        ["Cruelty"]="Cruaut\195\169",
        ["Cultivation"]="Culture",
        ["Cure Disease"]="Gu\195\169rison des maladies",
        ["Cure Poison"]="Gu\195\169rison du poison",
        ["Curse of Agony"]="Mal\195\169diction d'agonie",
        ["Curse of Doom Effect"]="Effet Mal\195\169diction funeste",
        ["Curse of Doom"]="Mal\195\169diction funeste",
        ["Curse of Exhaustion"]="Mal\195\169diction de fatigue",
        ["Curse of Idiocy"]="Mal\195\169diction d'idiotie",
        ["Curse of Recklessness"]="Mal\195\169diction de t\195\169m\195\169rit\195\169",
        ["Curse of Shadow"]="Mal\195\169diction de l'ombre",
        ["Curse of Tongues"]="Mal\195\169diction des langages",
        ["Curse of Weakness"]="Mal\195\169diction de faiblesse",
        ["Curse of the Elements"]="Mal\195\169diction des \195\169l\195\169ments",
        ["Dagger Specialization"]="Sp\195\169cialisation Dague",
        ["Daggers"]="Dagues",
        ["Dampen Magic"]="Att\195\169nuation de la magie",
        ["Dark Pact"]="Pacte noir",
        ["Darkness"]="T\195\169n\195\168bres",
        ["Dash"]="C\195\169l\195\169rit\195\169",
        ["Deadly Poison II"]="Poison mortel II",
        ["Deadly Poison III"]="Poison mortel III",
        ["Deadly Poison IV"]="Poison mortel IV",
        ["Deadly Poison V"]="Poison mortel V",
        ["Deadly Poison"]="Poison mortel",
        ["Death Coil"]="Voile mortel",
        ["Death Wish"]="Souhait mortel",
        ["Deep Wounds"]="Blessures profondes",
        ["Defense"]="D\195\169fense",
        ["Defensive Stance Passive"]="Posture d\195\169fensive",
        ["Defensive Stance"]="Posture d\195\169fensive",
        ["Defensive State 2"]="Posture d\195\169fensive 2",
        ["Defensive State"]="Posture d\195\169fensive",
        ["Defiance"]="D\195\169fi",
        ["Deflection"]="D\195\169viation",
        ["Demon Armor"]="Armure d\195\169moniaque",
        ["Demon Skin"]="Peau de d\195\169mon",
        ["Demonic Embrace"]="Baiser d\195\169moniaque",
        ["Demonic Sacrifice"]="Sacrifice d\195\169moniaque",
        ["Demoralizing Roar"]="Rugissement d\195\169moralisant",
        ["Demoralizing Shout"]="Cri d\195\169moralisant",
        ["Desperate Prayer"]="Pri\195\168re du d\195\169sespoir",
        ["Destructive Reach"]="Allonge de destruction",
        ["Detect Greater Invisibility"]="D\195\169tection de l'invisibilit\195\169 sup\195\169rieure",
        ["Detect Invisibility"]="D\195\169tection de l'invisibilit\195\169",
        ["Detect Lesser Invisibility"]="D\195\169tection de l'invisibilit\195\169 inf\195\169rieure",
        ["Detect Magic"]="D\195\169tection de la magie",
        ["Detect Traps"]="D\195\169tection des pi\195\168ges",
        ["Detect"]="D\195\169tection",
        ["Deterrence"]="Dissuasion",
        ["Devastation"]="D\195\169vastation",
        ["Devotion Aura"]="Aura de d\195\169votion",
        ["Devour Magic Effect"]="Effet festin magique",
        ["Devour Magic"]="Festin magique",
        ["Devouring Plague"]="Peste d\195\169vorante",
        ["Diplomacy"]="Diplomatie",
        ["Dire Bear Form"]="Forme d'ours redoutable",
        ["Disarm Trap"]="D\195\169sarmement de pi\195\168ge",
        ["Disarm"]="D\195\169sarmement",
        ["Disease Cleansing Totem"]="Totem de Purification des maladies",
        ["Disenchant"]="D\195\169senchanter",
        ["Disengage"]="D\195\169sengagement",
        ["Dismiss Pet"]="Renvoyer le familier",
        ["Dispel Magic"]="Dissipation de la magie",
        ["Distract"]="Distraction",
        ["Distracting Shot"]="Trait provocateur",
        ["Dive"]="Plongeon",
        ["Divine Favor"]="Faveur divine",
        ["Divine Fury"]="Fureur divine",
        ["Divine Intellect"]="Intelligence divine",
        ["Divine Intervention"]="Intervention divine",
        ["Divine Protection"]="Protection divine",
        ["Divine Shield"]="Bouclier divin",
        ["Divine Spirit"]="Esprit divin",
        ["Divine Strength"]="Force divine",
        ["Dodge"]="Esquiver",
        ["Dragonscale Leatherworking"]="Travail du cuir d'\195\169cailles de dragon",
        ["Drain Life"]="Drain de vie",
        ["Drain Mana"]="Drain de mana",
        ["Drain Soul"]="Siphon d'\195\162me",
        ["Drink"]="Boisson",
        ["Dual Wield Specialization"]="Sp\195\169cialisation Ambidextrie",
        ["Dual Wield"]="Ambidextrie",
        ["Duel"]="Duel",
        ["Eagle Eye"]="Oeil d'aigle",
        ["Earth Shock"]="Horion de terre",
        ["Earthbind Totem"]="Totem de lien terrestre",
        ["Efficiency"]="Efficacit\195\169",
        ["Elemental Focus"]="Focalisation \195\169l\195\169mentaire",
        ["Elemental Fury"]="Fureur \195\169l\195\169mentaire",
        ["Elemental Leatherworking"]="Travail du cuir \195\169l\195\169mentaire",
        ["Elemental Mastery"]="Ma\195\174trise \195\169l\195\169mentaire",
        ["Elune's Grace"]="Gr\195\162ce d'Elune",
        ["Elusiveness"]="Insaisissable",
        ["Emberstorm"]="Temp\195\170te ardente",
        ["Enchanting"]="Enchantement",
        ["Endurance Training"]="Entra\195\174nement \195\160 l'Endurance",
        ["Endurance"]="Endurance",
        ["Engineering Specialization"]="Sp\195\169cialisation",
        ["Engineering"]="Ing\195\169nieur",
        ["Enrage"]="Enrager",
        ["Enriched Manna Biscuit"]="Biscuit enrichi en manne",
        ["Enslave Demon"]="Asservir d\195\169mon",
        ["Entangling Roots"]="Sarments",
        ["Entrapment"]="Pi\195\168ge",
        ["Escape Artist"]="Ma\195\174tre de l'\195\169vasion",
        ["Evasion"]="Evasion",
        ["Eventide"]="Tomb\195\169e du jour",
        ["Eviscerate"]="Evisc\195\169ration",
        ["Evocation"]="Evocation",
        ["Execute"]="Ex\195\169cution",
        ["Exorcism"]="Exorcisme",
        ["Expansive Mind"]="Pens\195\169e expansive",
        ["Explosive Trap Effect"]="Effet Pi\195\168ge explosif",
        ["Explosive Trap"]="Pi\195\168ge explosif",
        ["Expose Armor"]="Exposer l'armure",
        ["Eye for an Eye"]="Oeil pour oeil",
        ["Eye of Kilrogg"]="Oeil de Kilrogg",
        ["Eyes of the Beast"]="Oeil de la b\195\170te",
        ["Fade"]="Oubli",
        ["Faerie Fire"]="Lucioles",
        ["Far Sight"]="Double vue",
        ["Fear Ward"]="Gardien de peur",
        ["Fear"]="Peur",
        ["Feed Pet"]="Nourrir le familier",
        ["Feedback"]="R\195\169action",
        ["Feign Death"]="Feindre la mort",
        ["Feint"]="Feinte",
        ["Fel Concentration"]="Concentration corrompue",
        ["Fel Domination"]="Domination corrompue",
        ["Fel Intellect"]="Intelligence corrompue",
        ["Fel Stamina"]="Endurance corrompue",
        ["Felfire"]="Gangrefeu",
        ["Feline Grace"]="Gr\195\162ce f\195\169line",
        ["Feline Swiftness"]="C\195\169l\195\169rit\195\169 f\195\169line",
        ["Feral Aggression"]="Agressivit\195\169 farouche",
        ["Feral Charge"]="Charge farouche",
        ["Feral Instinct"]="Instinct farouche",
        ["Ferocious Bite"]="Morsure f\195\169roce",
        ["Ferocity"]="Ferocit\195\169",
        ["Fetish"]="F\195\169tiche",
        ["Find Herbs"]="D\195\169couverte d'herbes",
        ["Find Minerals"]="D\195\169couverte de gisements",
        ["Find Treasure"]="D\195\169couverte de tr\195\169sors",
        ["Fire Blast"]="Trait de feu",
        ["Fire Nova Totem"]="Totem Nova de feu",
        ["Fire Power"]="Puissance du feu",
        ["Fire Resistance Aura"]="Aura de r\195\169sistance au Feu",
        ["Fire Resistance Totem"]="Totem de r\195\169sistance au feu",
        ["Fire Resistance"]="R\195\169sistance au Feu",
        ["Fire Shield"]="Bouclier de feu",
        ["Fire Vulnerability"]="Vuln\195\169rabilit\195\169 au Feu",
        ["Fire Ward"]="Gardien de feu",
        ["Fireball"]="Boule de feu",
        ["Firebolt"]="Eclair de feu",
        ["First Aid"]="Premiers soins",
        ["Fishing Poles"]="Cannes \195\160 p\195\170che",
        ["Fishing"]="P\195\170che",
        ["Fist Weapon Specialization"]="Sp\195\169cialisation Arme de pugilat",
        ["Fist Weapons"]="Armes de pugilat",
        ["Flame Shock"]="Horion de flammes",
        ["Flame Throwing"]="Jet de flammes",
        ["Flamestrike"]="Choc de flammes",
        ["Flamethrower"]="Lance-flammes",
        ["Flametongue Totem"]="Totem Langue de feu",
        ["Flametongue Weapon"]="Arme Langue de feu",
        ["Flare"]="Fus\195\169e \195\169clairante",
        ["Flash Heal"]="Soins rapides",
        ["Flash of Light"]="Eclair lumineux",
        ["Flurry"]="Rafale",
        ["Focused Casting"]="Incantation focalis\195\169e",
        ["Food"]="Nourriture",
        ["Force of Will"]="Force de volont\195\169",
        ["Freezing Trap Effect"]="Effet Pi챔ge givrant",
        ["Freezing Trap"]="Pi\195\168ge givrant",
        ["Frenzied Regeneration"]="R\195\169g\195\169n\195\169ration fr\195\169n\195\169tique",
        ["Frenzy"]="Fr\195\169n\195\169sie",
        ["Frost Armor"]="Armure de givre",
        ["Frost Channeling"]="Canalisation du givre",
        ["Frost Nova"]="Nova de givre",
        ["Frost Resistance Aura"]="Aura de r\195\169sistance au Givre",
        ["Frost Resistance Totem"]="Totem de r\195\169sistance au Givre",
        ["Frost Resistance"]="R\195\169sistance au Givre",
        ["Frost Shock"]="Horion de givre",
        ["Frost Trap"]="Pi\195\168ge de givre",
        ["Frost Ward"]="Gardien de givre",
        ["Frostbite"]="Morsure du givre",
        ["Frostbolt"]="Eclair de givre",
        ["Frostbrand Weapon"]="Arme de givre",
        ["Furious Howl"]="Hurlement furieux",
        ["Furor"]="Fureur",
        ["Garrote"]="Garrot",
        ["Generic"]="G\195\169n\195\169rique",
        ["Ghost Wolf"]="Loup fant\195\180me",
        ["Ghostly Strike"]="Frappe fantomatique",
        ["Gift of Nature"]="Don de la Nature",
        ["Gift of the Wild"]="Don du fauve",
        ["Gouge"]="Suriner",
        ["Grace of Air Totem"]="Totem de Gr\195\162ce a\195\169rienne",
        ["Great Stamina"]="Endurance sup\195\169rieure",
        ["Greater Blessing of Kings"]="B\195\169n\195\169diction des rois sup\195\169rieure",
        ["Greater Blessing of Light"]="B\195\169n\195\169diction de lumi\195\168re sup\195\169rieure",
        ["Greater Blessing of Might"]="B\195\169n\195\169diction de puissance sup\195\169rieure",
        ["Greater Blessing of Salvation"]="B\195\169n\195\169diction de salut sup\195\169rieure",
        ["Greater Blessing of Sanctuary"]="B\195\169n\195\169diction du sanctuaire sup\195\169rieure",
        ["Greater Blessing of Wisdom"]="B\195\169n\195\169diction de sagesse sup\195\169rieure",
        ["Greater Heal"]="Soins sup\195\169rieurs",
        ["Grim Reach"]="Allonge sinistre",
        ["Grounding Totem"]="Totem de Gl\195\168be",
        ["Grovel"]="Ramper",
        ["Growl"]="Grondement",
        ["Guardian's Favor"]="Faveur du Gardien",
        ["Gun Specialization"]="Sp\195\169cialisation Armes \195\160 feu",
        ["Guns"]="Armes \195\160 feu",
        ["Hammer of Justice"]="Marteau de la justice",
        ["Hammer of Wrath"]="Marteau de courroux",
        ["Hamstring"]="Brise-genou",
        ["Harass"]="Harc\195\168lement",
        ["Hardiness"]="Solidit\195\169",
        ["Hawk Eye"]="Oeil de faucon",
        ["Heal"]="Soins",
        ["Healing Focus"]="Focalisation des soins",
        ["Healing Light"]="Lumi\195\168re gu\195\169risseuse",
        ["Healing Stream Totem"]="Totem gu\195\169risseur",
        ["Healing Touch"]="Toucher gu\195\169risseur",
        ["Healing Wave"]="Vague de soins",
        ["Health Funnel"]="Captation de vie",
        ["Heart of the Wild"]="C\197\147ur de fauve",
        ["Hellfire Effect"]="Effet Flammes infernales",
        ["Hellfire"]="Flammes infernales",
        ["Hemorrhage"]="H\195\169morragie",
        ["Herb Gathering"]="Cueillette",
        ["Herbalism"]="Herboriste",
        ["Heroic Strike"]="Frappe h\195\169ro\195\175que",
        ["Hex of Weakness"]="Mal\195\169fice de faiblesse",
        ["Hibernate"]="Hibernation",
        ["Holy Fire"]="Flammes sacr\195\169es",
        ["Holy Light"]="Lumi\195\168re sacr\195\169e",
        ["Holy Nova"]="Nova sacr\195\169e",
        ["Holy Power"]="Puissance sacr\195\169e",
        ["Holy Reach"]="Allonge du Sacr\195\169",
        ["Holy Shield"]="Bouclier sacr\195\169",
        ["Holy Shock"]="Horion sacr\195\169",
        ["Holy Specialization"]="Sp\195\169cialisation",
        ["Holy Wrath"]="Col\195\168re divine",
        ["Honorless Target"]="Cible sans honneur",
        ["Horse Riding"]="Equitation",
        ["Howl of Terror"]="Hurlement de terreur",
        ["Humanoid Slaying"]="Tueur d'humano\195\175des",
        ["Hunter's Mark"]="Marque du chasseur",
        ["Hurricane"]="Ouragan",
        ["Ice Armor"]="Armure de glace",
        ["Ice Barrier"]="Barri\195\168re de glace",
        ["Ice Block"]="Parade de glace",
        ["Ice Shards"]="Eclats de glace",
        ["Ignite"]="Enflammer",
        ["Illumination"]="Illumination",
        ["Immolate"]="Immolation",
        ["Immolation Trap Effect"]="Effet Pi\195\168ge immolation",
        ["Immolation Trap"]="Pi\195\168ge d'Immolation",
        ["Impact"]="Impact",
        ["Impale"]="Empaler",
        ["Improved Ambush"]="Embuscade am\195\169lior\195\169e",
        ["Improved Arcane Explosion"]="Explosion des arcanes am\195\169lior\195\169e",
        ["Improved Arcane Missiles"]="Projectiles des arcanes am\195\169lior\195\169s",
        ["Improved Arcane Shot"]="Tir des arcanes am\195\169lior\195\169",
        ["Improved Aspect of the Hawk"]="Aspect du faucon am\195\169lior\195\169",
        ["Improved Aspect of the Monkey"]="Aspect du singe am\195\169lior\195\169",
        ["Improved Backstab"]="Attaque sournoise am\195\169lior\195\169e",
        ["Improved Battle Shout"]="Cri de guerre am\195\169lior\195\169",
        ["Improved Berserker Rage"]="Rage berserker am\195\169lior\195\169e",
        ["Improved Blessing of Might"]="B\195\169n\195\169diction de puissance am\195\169lior\195\169e",
        ["Improved Blessing of Wisdom"]="B\195\169n\195\169diction de sagesse am\195\169lior\195\169e",
        ["Improved Blizzard"]="Blizzard am\195\169lior\195\169",
        ["Improved Bloodrage"]="Rage sanguinaire am\195\169lior\195\169e",
        ["Improved Chain Heal"]="Salve de gu\195\169rison am\195\169lior\195\169e",
        ["Improved Chain Lightning"]="Cha\195\174ne d'\195\169clairs am\195\169lior\195\169e",
        ["Improved Challenging Shout"]="Cri de d\195\169fi am\195\169lior\195\169",
        ["Improved Charge"]="Charge am\195\169lior\195\169e",
        ["Improved Cheap Shot"]="Coup bas am\195\169lior\195\169",
        ["Improved Cleave"]="Encha\195\174nement am\195\169lior\195\169",
        ["Improved Concentration Aura"]="Aura de concentration am\195\169lior\195\169e",
        ["Improved Concussive Shot"]="Trait de choc am\195\169lior\195\169",
        ["Improved Cone of Cold"]="C\195\180ne de froid am\195\169lior\195\169",
        ["Improved Corruption"]="Corruption am\195\169lior\195\169e",
        ["Improved Counterspell"]="Contresort am\195\169lior\195\169",
        ["Improved Curse of Agony"]="Mal\195\169diction d'agonie am\195\169lior\195\169e",
        ["Improved Curse of Exhaustion"]="Mal\195\169diction de fatigue am\195\169lior\195\169e",
        ["Improved Curse of Weakness"]="Mal\195\169diction de faiblesse am\195\169lior\195\169e",
        ["Improved Dampen Magic"]="Att\195\169nuation de la magie am\195\169lior\195\169e",
        ["Improved Deadly Poison"]="Poison mortel am\195\169lior\195\169",
        ["Improved Demoralizing Shout"]="Cri d\195\169moralisant am\195\169lior\195\169",
        ["Improved Devotion Aura"]="Aura de d\195\169votion am\195\169lior\195\169e",
        ["Improved Disarm"]="D\195\169sarmement am\195\169lior\195\169",
        ["Improved Distract"]="Distraction am\195\169lior\195\169e",
        ["Improved Drain Life"]="Drain de vie am\195\169lior\195\169",
        ["Improved Drain Mana"]="Drain de mana am\195\169lior\195\169",
        ["Improved Drain Soul"]="Siphon d'\195\162me am\195\169lior\195\169",
        ["Improved Enrage"]="Enrager am\195\169lior\195\169",
        ["Improved Enslave Demon"]="Asservir d\195\169mon am\195\169lior\195\169",
        ["Improved Entangling Roots"]="Sarments am\195\169lior\195\169s",
        ["Improved Evasion"]="Evasion am\195\169lior\195\169e",
        ["Improved Eviscerate"]="Evisc\195\169ration am\195\169lior\195\169e",
        ["Improved Execute"]="Ex\195\169cution am\195\169lior\195\169e",
        ["Improved Expose Armor"]="Exposer l'armure am\195\169lior\195\169",
        ["Improved Eyes of the Beast"]="Oeil de la b\195\170te am\195\169lior\195\169",
        ["Improved Fade"]="Oubli am\195\169lior\195\169",
        ["Improved Feign Death"]="Feindre la mort am\195\169lior\195\169",
        ["Improved Fire Blast"]="Trait de feu am\195\169lior\195\169",
        ["Improved Fire Nova Totem"]="Totem Nova de feu am\195\169lior\195\169",
        ["Improved Fire Ward"]="Gardien de feu am\195\169lior\195\169",
        ["Improved Fireball"]="Boule de feu am\195\169lior\195\169e",
        ["Improved Firebolt"]="Eclair de feu am\195\169lior\195\169",
        ["Improved Firestone"]="Pierre de feu am\195\169lior\195\169e",
        ["Improved Flamestrike"]="Choc de flammes am\195\169lior\195\169",
        ["Improved Flametongue Weapon"]="Arme Langue de feu am\195\169lior\195\169e",
        ["Improved Flash of Light"]="Eclair lumineux am\195\169lior\195\169",
        ["Improved Frost Nova"]="Nova de givre am\195\169lior\195\169e",
        ["Improved Frost Ward"]="Gardien de givre am\195\169lior\195\169",
        ["Improved Frostbolt"]="Eclair de givre am\195\169lior\195\169",
        ["Improved Frostbrand Weapon"]="Arme de givre am\195\169lior\195\169e",
        ["Improved Garrote"]="Garrot am\195\169lior\195\169",
        ["Improved Ghost Wolf"]="Loup fant\195\180me am\195\169lior\195\169",
        ["Improved Gouge"]="Suriner am\195\169lior\195\169",
        ["Improved Grace of Air Totem"]="Totem de Gr\195\162ce a\195\169rienne am\195\169lior\195\169",
        ["Improved Grounding Totem"]="Totem de Gl\195\168be am\195\169lior\195\169",
        ["Improved Hammer of Justice"]="Marteau de la justice am\195\169lior\195\169",
        ["Improved Hamstring"]="Brise-genou am\195\169lior\195\169",
        ["Improved Healing Stream Totem"]="Totem gu\195\169risseur am\195\169lior\195\169",
        ["Improved Healing Touch"]="Toucher gu\195\169risseur am\195\169lior\195\169",
        ["Improved Healing Wave"]="Vague de soins am\195\169lior\195\169e",
        ["Improved Healing"]="Soin am\195\169lior\195\169",
        ["Improved Health Funnel"]="Captation de vie am\195\169lior\195\169e",
        ["Improved Healthstone"]="Pierre de soins am\195\169lior\195\169e",
        ["Improved Heroic Strike"]="Frappe h\195\169ro\195\175que am\195\169lior\195\169e",
        ["Improved Hunter's Mark"]="Marque du chasseur am\195\169lior\195\169e",
        ["Improved Immolate"]="Immolation am\195\169lior\195\169e",
        ["Improved Imp"]="Diablotin am\195\169lior\195\169",
        ["Improved Inner Fire"]="Feu int\195\169rieur am\195\169lior\195\169",
        ["Improved Instant Poison"]="Poison instantan\195\169 am\195\169lior\195\169",
        ["Improved Intercept"]="Interception am\195\169lior\195\169e",
        ["Improved Intimidating Shout"]="Cri d\226\128\153intimidation am\195\169lior\195\169",
        ["Improved Judgement"]="Jugement am\195\169lior\195\169",
        ["Improved Kick"]="Coup de pied am\195\169lior\195\169",
        ["Improved Kidney Shot"]="Aiguillon perfide am\195\169lior\195\169",
        ["Improved Lash of Pain"]="Fouet de la douleur am\195\169lior\195\169",
        ["Improved Lay on Hands"]="Imposition des mains am\195\169lior\195\169e",
        ["Improved Lesser Healing Wave"]="Vague de soins inf\195\169rieurs am\195\169lior\195\169e",
        ["Improved Life Tap"]="Connexion am\195\169lior\195\169e",
        ["Improved Lightning Bolt"]="Eclair am\195\169lior\195\169",
        ["Improved Lightning Shield"]="Bouclier de foudre am\195\169lior\195\169",
        ["Improved Magma Totem"]="Totem de Magma am\195\169lior\195\169",
        ["Improved Mana Burn"]="Br\195\187lure de mana am\195\169lior\195\169e",
        ["Improved Mana Shield"]="Bouclier de mana am\195\169lior\195\169",
        ["Improved Mana Spring Totem"]="Totem Fontaine de mana am\195\169lior\195\169",
        ["Improved Mark of the Wild"]="Marque du fauve am\195\169lior\195\169e",
        ["Improved Mend Pet"]="Gu\195\169rison du familier am\195\169lior\195\169e",
        ["Improved Mind Blast"]="Attaque mentale am\195\169lior\195\169e",
        ["Improved Moonfire"]="Eclat lunaire am\195\169lior\195\169",
        ["Improved Nature's Grasp"]="Emprise de la nature am\195\169lior\195\169e",
        ["Improved Overpower"]="Fulgurance am\195\169lior\195\169e",
        ["Improved Power Word: Fortitude"]="Mot de pouvoir : Robustesse am\195\169lior\195\169",
        ["Improved Power Word: Shield"]="Mot de pouvoir : Bouclier am\195\169lior\195\169",
        ["Improved Prayer of Healing"]="Pri\195\168re de soins am\195\169lior\195\169e",
        ["Improved Psychic Scream"]="Cri psychique am\195\169lior\195\169",
        ["Improved Pummel"]="Vol\195\169e de coups am\195\169lior\195\169e",
        ["Improved Regrowth"]="R\195\169tablissement am\195\169lior\195\169",
        ["Improved Reincarnation"]="R\195\169incarnation am\195\169lior\195\169e",
        ["Improved Rejuvenation"]="R\195\169cup\195\169ration am\195\169lior\195\169e",
        ["Improved Rend"]="Pourfendre am\195\169lior\195\169",
        ["Improved Renew"]="R\195\169novation am\195\169lior\195\169e",
        ["Improved Retribution Aura"]="Aura de vindicte am\195\169lior\195\169e",
        ["Improved Revenge"]="Vengeance am\195\169lior\195\169e",
        ["Improved Revive Pet"]="Ressusciter le familier am\195\169lior\195\169",
        ["Improved Righteous Fury"]="Fureur vertueuse am\195\169lior\195\169e",
        ["Improved Rockbiter Weapon"]="Arme Croque-roc am\195\169lior\195\169e",
        ["Improved Rupture"]="Rupture am\195\169lior\195\169e",
        ["Improved Sap"]="Assommer am\195\169lior\195\169",
        ["Improved Scorch"]="Br\195\187lure am\195\169lior\195\169e",
        ["Improved Scorpid Sting"]="Piq\195\187re de scorpide am\195\169lior\195\169e",
        ["Improved Seal of Righteousness"]="Sceau de pi\195\169t\195\169 am\195\169lior\195\169",
        ["Improved Seal of the Crusader"]="Sceau du Crois\195\169 am\195\169lior\195\169",
        ["Improved Searing Pain"]="Douleur br\195\187lante am\195\169lior\195\169e",
        ["Improved Searing Totem"]="Totem incendiaire am\195\169lior\195\169",
        ["Improved Serpent Sting"]="Morsure de serpent am\195\169lior\195\169e",
        ["Improved Shadow Bolt"]="Trait de l'ombre am\195\169lior\195\169",
        ["Improved Shadow Word: Pain"]="Mot de l'ombre : Douleur am\195\169lior\195\169",
        ["Improved Shield Bash"]="Coup de bouclier am\195\169lior\195\169",
        ["Improved Shield Block"]="Ma\195\174trise du blocage am\195\169lior\195\169e",
        ["Improved Shield Wall"]="Mur protecteur am\195\169lior\195\169",
        ["Improved Shred"]="Lambeau am\195\169lior\195\169",
        ["Improved Sinister Strike"]="Attaque pernicieuse am\195\169lior\195\169e",
        ["Improved Slam"]="Heurtoir am\195\169lior\195\169",
        ["Improved Slice and Dice"]="D\195\169biter am\195\169lior\195\169",
        ["Improved Spellstone"]="Pierre de sort am\195\169lior\195\169e",
        ["Improved Sprint"]="Sprint am\195\169lior\195\169",
        ["Improved Starfire"]="Feu stellaire am\195\169lior\195\169",
        ["Improved Stoneclaw Totem"]="Totem de Griffes de pierre am\195\169lior\195\169",
        ["Improved Stoneskin Totem"]="Totem de Peau de pierre am\195\169lior\195\169",
        ["Improved Strength of Earth Totem"]="Totem de Force de la Terre am\195\169lior\195\169",
        ["Improved Succubus"]="Succube am\195\169lior\195\169e",
        ["Improved Sunder Armor"]="Fracasser armure am\195\169lior\195\169",
        ["Improved Taunt"]="Provocation am\195\169lior\195\169e",
        ["Improved Thorns"]="Epines am\195\169lior\195\169es",
        ["Improved Thunder Clap"]="Coup de tonnerre am\195\169lior\195\169",
        ["Improved Tranquility"]="Tranquillit\195\169 am\195\169lior\195\169e",
        ["Improved Vampiric Embrace"]="Etreinte vampirique am\195\169lior\195\169e",
        ["Improved Vanish"]="Disparition am\195\169lior\195\169e",
        ["Improved Voidwalker"]="Marcheur du Vide am\195\169lior\195\169",
        ["Improved Windfury Weapon"]="Arme Furie-des-vents am\195\169lior\195\169e",
        ["Improved Wing Clip"]="Coupure d'ailes am\195\169lior\195\169e",
        ["Improved Wrath"]="Col\195\168re am\195\169lior\195\169e",
        ["Incinerate"]="Incin\195\169rer",
        ["Inferno"]="Inferno",
        ["Initiative"]="Initiative",
        ["Inner Fire"]="Feu int\195\169rieur",
        ["Inner Focus"]="Focalisation am\195\169lior\195\169e",
        ["Innervate"]="Innervation",
        ["Insect Swarm"]="Essaim d'insectes",
        ["Inspiration"]="Inspiration",
        ["Instant Poison II"]="Poison instantan\195\169 II",
        ["Instant Poison III"]="Poison instantan\195\169 III",
        ["Instant Poison IV"]="Poison instantan\195\169 IV",
        ["Instant Poison V"]="Poison instantan\195\169 V",
        ["Instant Poison VI"]="Poison instantan\195\169 VI",
        ["Instant Poison"]="Poison instantan\195\169",
        ["Intensity"]="Intensit\195\169",
        ["Intercept"]="Interception",
        ["Intimidating Shout"]="Cri d\226\128\153intimidation",
        ["Intimidation"]="Intimidation",
        ["Iron Will"]="Volont\195\169 de fer",
        ["Judgement of Command"]="Jugement d'autorit\195\169",
        ["Judgement of Justice"]="Jugement de justice",
        ["Judgement of Light"]="Jugement de lumi\195\168re",
        ["Judgement of Righteousness"]="Jugement de pi\195\169t\195\169",
        ["Judgement of Wisdom"]="Jugement de sagesse",
        ["Judgement of the Crusader"]="Jugement du Crois\195\169",
        ["Judgement"]="Jugement",
        ["Kick"]="Coup de pied",
        ["Kidney Shot"]="Aiguillon perfide",
        ["Killer Instinct"]="Instinct du tueur",
        ["Kodo Riding"]="Monte de kodo",
        ["Lash of Pain"]="Fouet de la douleur",
        ["Last Stand"]="Dernier rempart",
        ["Lasting Judgement"]="Jugement durable",
        ["Lay on Hands"]="Imposition des mains",
        ["Leader of the Pack"]="Chef de la meute",
        ["Leather"]="Cuir",
        ["Leatherworking"]="Travail du cuir",
        ["Lesser Heal"]="Soins inf\195\169rieurs",
        ["Lesser Healing Wave"]="Vague de soins inf\195\169rieurs",
        ["Lesser Invisibility"]="Invisibilit\195\169 inf\195\169rieure",
        ["Lethal Shots"]="Coups fatals",
        ["Lethality"]="Mortalit\195\169",
        ["Levitate"]="L\195\169vitation",
        ["Libram"]="Libram",
        ["Life Tap"]="Connexion",
        ["Lightning Bolt"]="Eclair",
        ["Lightning Breath"]="Souffle de foudre",
        ["Lightning Mastery"]="Ma\195\174trise de la foudre",
        ["Lightning Reflexes"]="R\195\169flexes \195\169clairs",
        ["Lightning Shield"]="Bouclier de foudre",
        ["Lightwell Renew"]="R\195\169novation du Puits de lumi\195\168re",
        ["Lightwell"]="Puits de lumi\195\168re",
        ["Lockpicking"]="Crochetage",
        ["Long Daze"]="H\195\169b\195\169tement prolong\195\169",
        ["Mace Specialization"]="Sp\195\169cialisation Masse",
        ["Mace Stun Effect"]="Effet \195\169tourdissant de la masse",
        ["Mage Armor"]="Armure du mage",
        ["Magma Totem"]="Totem de Magma",
        ["Mail"]="Mailles",
        ["Malice"]="Malice",
        ["Mana Burn"]="Br\195\187lure de mana",
        ["Mana Shield"]="Bouclier de mana",
        ["Mana Spring Totem"]="Totem Fontaine de mana",
        ["Mana Tide Totem"]="Totem de Vague de mana",
        ["Mangle"]="Mutilation",
        ["Mark of the Wild"]="Marque du fauve",
        ["Martyrdom"]="Martyre",
        ["Master Demonologist"]="Ma\195\174tre d\195\169monologue",
        ["Master Summoner"]="Ma\195\174tre invocateur",
        ["Master of Deception"]="Ma\195\174tre des illusions",
        ["Maul"]="Mutiler",
        ["Mechanostrider Piloting"]="Pilotage de m\195\169canotrotteur",
        ["Meditation"]="M\195\169ditation",
        ["Melee Specialization"]="Sp\195\169cialisation M\195\170l\195\169e",
        ["Mend Pet"]="Gu\195\169rison du familier",
        ["Mental Agility"]="Sagacit\195\169",
        ["Mental Strength"]="Force mentale",
        ["Mind Blast"]="Attaque mentale",
        ["Mind Control"]="Contr\195\180le mental",
        ["Mind Flay"]="Fouet mental",
        ["Mind Soothe"]="Apaisement",
        ["Mind Vision"]="Vision t\195\169l\195\169pathique",
        ["Mind-numbing Poison II"]="Poison de distraction mentale II",
        ["Mind-numbing Poison III"]="Poison de distraction mentale III",
        ["Mind-numbing Poison"]="Poison de distraction mentale",
        ["Mining"]="Minage",
        ["Mocking Blow"]="Coup railleur",
        ["Mongoose Bite"]="Morsure de la mangouste",
        ["Monster Slaying"]="Tueur de monstres",
        ["Moonfire"]="Eclat lunaire",
        ["Moonfury"]="Fureur lunaire",
        ["Moonglow"]="Lueur de la lune",
        ["Moonkin Aura"]="Aura de s\195\169l\195\169nien",
        ["Moonkin Form"]="Forme de s\195\169l\195\169nien",
        ["Mortal Shots"]="Coups mortels",
        ["Mortal Strike"]="Frappe mortelle",
        ["Multi-Shot"]="Fl\195\168ches multiples",
        ["Murder"]="Meurtre",
        ["Natural Armor"]="Armure naturelle",
        ["Natural Shapeshifter"]="Changeforme naturel",
        ["Natural Weapons"]="Armes naturelles",
        ["Nature Resistance Totem"]="Totem de r\195\169sistance \195\160 la Nature",
        ["Nature Resistance"]="R\195\169sistance \195\160 la Nature",
        ["Nature's Focus"]="Focalisation de la nature",
        ["Nature's Grace"]="Gr\195\162ce de la nature",
        ["Nature's Grasp"]="Emprise de la nature",
        ["Nature's Reach"]="Allonge de la Nature",
        ["Nature's Swiftness"]="Rapidit\195\169 de la nature",
        ["Nightfall"]="Cr\195\169puscule",
        ["Omen of Clarity"]="Augure de clart\195\169",
        ["One-Handed Axes"]="Haches \195\160 une main",
        ["One-Handed Maces"]="Masses \195\160 une main",
        ["One-Handed Swords"]="Ep\195\169es \195\160 une main",
        ["One-Handed Weapon Specialization"]="Sp\195\169cialisation Arme 1M",
        ["Opening - No Text"]="Ouverture - pas de texte",
        ["Opening"]="Ouverture",
        ["Opportunity"]="Opportunit\195\169",
        ["Overpower"]="Fulgurance",
        ["Paranoia"]="Parano\195\175a",
        ["Parry"]="Parade",
        ["Pathfinding"]="Science des chemins",
        ["Perception"]="Perception",
        ["Permafrost"]="Gel prolong\195\169",
        ["Pet Aggression"]="Agressivit\195\169 du familier",
        ["Pet Hardiness"]="Robustesse du familier",
        ["Pet Recovery"]="R\195\169tablissement du familier",
        ["Pet Resistance"]="R\195\169sistance du familier",
        ["Phase Shift"]="Changement de phase",
        ["Pick Lock"]="Crochetage",
        ["Pick Pocket"]="Vol \195\160 la tire",
        ["Piercing Howl"]="Hurlement per\195\167ant",
        ["Piercing Ice"]="Glace per\195\167ante",
        ["Plate Mail"]="Armure en plaques",
        ["Poison Cleansing Totem"]="Totem de Purification du poison",
        ["Poisons"]="Poisons",
        ["Polearm Specialization"]="Sp\195\169cialisation Arme d'hast",
        ["Polearms"]="Armes d'hast",
        ["Polymorph"]="M\195\169tamorphose",
        ["Portal: Darnassus"]="Portail : Darnassus",
        ["Portal: Ironforge"]="Portail : Ironforge",
        ["Portal: Orgrimmar"]="Portail : Orgrimmar",
        ["Portal: Stormwind"]="Portail\194\160: Stormwind",
        ["Portal: Thunder Bluff"]="Portail : Thunder Bluff",
        ["Portal: Undercity"]="Portail : Undercity",
        ["Pounce Bleed"]="Traquenard sanglant",
        ["Pounce"]="Traquenard",
        ["Power Infusion"]="Infusion de puissance",
        ["Power Word: Fortitude"]="Mot de pouvoir : Robustesse",
        ["Power Word: Shield"]="Mot de pouvoir : Bouclier",
        ["Prayer of Fortitude"]="Pri\195\168re de robustesse",
        ["Prayer of Healing"]="Pri\195\168re de soins",
        ["Prayer of Shadow Protection"]="Pri\195\168re de protection contre l'Ombre",
        ["Prayer of Spirit"]="Pri\195\168re d'Esprit",
        ["Precision"]="Pr\195\169cision",
        ["Predatory Strikes"]="Frappes de pr\195\169dateur",
        ["Premeditation"]="Pr\195\169m\195\169ditation",
        ["Preparation"]="Pr\195\169paration",
        ["Presence of Mind"]="Pr\195\169sence spirituelle",
        ["Primal Fury"]="Fureur primitive",
        ["Prowl"]="R\195\180der",
        ["Psychic Scream"]="Cri psychique",
        ["Pummel"]="Vol\195\169e de coups",
        ["Purge"]="Expiation",
        ["Purification"]="Purification",
        ["Purify"]="Purification",
        ["Pursuit of Justice"]="Poursuite de la justice",
        ["Pyroblast"]="Explosion pyrotechnique",
        ["Pyroclasm"]="Pyroclasme",
        ["Quickness"]="Rapidit\195\169",
        ["Rain of Fire"]="Pluie de feu",
        ["Rake"]="Griffure",
        ["Ram Riding"]="Monte de b\195\169lier",
        ["Ranged Weapon Specialization"]="Sp\195\169cialisation Armes \195\160 distance",
        ["Rapid Concealment"]="Dissimulation rapide",
        ["Rapid Fire"]="Tir rapide",
        ["Raptor Riding"]="Monte de raptor",
        ["Raptor Strike"]="Attaque du raptor",
        ["Ravage"]="Ravage",
        ["Readiness"]="Promptitude",
        ["Rebirth"]="Renaissance",
        ["Reckless Charge"]="Charge furieuse",
        ["Recklessness"]="T\195\169m\195\169rit\195\169",
        ["Reckoning"]="R\195\169tribution",
        ["Redemption"]="R\195\169demption",
        ["Redoubt"]="Redoute",
        ["Reflection"]="Renvoi",
        ["Regeneration"]="R\195\169g\195\169n\195\169ration",
        ["Regrowth"]="R\195\169tablissement",
        ["Reincarnation"]="R\195\169incarnation",
        ["Rejuvenation"]="R\195\169cup\195\169ration",
        ["Relentless Strikes"]="Frappes implacables",
        ["Remorseless Attacks"]="Attaques impitoyables",
        ["Remove Curse"]="D\195\169livrance de la mal\195\169diction",
        ["Remove Insignia"]="Enlever l'insigne",
        ["Remove Lesser Curse"]="D\195\169livrance de la mal\195\169diction mineure",
        ["Rend"]="Pourfendre",
        ["Renew"]="R\195\169novation",
        ["Repentance"]="Repentir",
        ["Resurrection"]="R\195\169surrection",
        ["Retaliation"]="Repr\195\169sailles",
        ["Retribution Aura"]="Aura de vindicte",
        ["Revenge Stun"]="Etourdissement vengeur",
        ["Revenge"]="Vengeance",
        ["Reverberation"]="R\195\169verb\195\169ration",
        ["Revive Pet"]="Ressusciter le familier",
        ["Righteous Fury"]="Fureur vertueuse",
        ["Rip"]="D\195\169chirure",
        ["Riposte"]="Riposte",
        ["Ritual of Doom Effect"]="Effet Rituel de mal\195\169diction",
        ["Ritual of Doom"]="Rituel de mal\195\169diction",
        ["Ritual of Summoning"]="Rituel d'invocation",
        ["Rockbiter Weapon"]="Arme Croque-roc",
        ["Rogue Passive"]="Voleur",
        ["Ruin"]="Ruine",
        ["Rupture"]="Rupture",
        ["Ruthlessness"]="N\195\169m\195\169sis",
        ["Sacrifice"]="Sacrifice",
        ["Safe Fall"]="Chute amortie",
        ["Sanctity Aura"]="Aura de saintet\195\169",
        ["Sap"]="Assommer",
        ["Savage Fury"]="Furie sauvage",
        ["Savage Strikes"]="Frappes sauvages",
        ["Scare Beast"]="Effrayer une b\195\170te",
        ["Scatter Shot"]="Fl\195\168che de dispersion",
        ["Scorch"]="Br\195\187lure",
        ["Scorpid Poison"]="Poison de scorpide",
        ["Scorpid Sting"]="Piq\195\187re de scorpide",
        ["Screech"]="Hurlement",
        ["Seal Fate"]="Scelle le destin",
        ["Seal of Command"]="Sceau d'autorit\195\169",
        ["Seal of Justice"]="Sceau de justice",
        ["Seal of Light"]="Sceau de lumi\195\168re",
        ["Seal of Righteousness"]="Sceau de pi\195\169t\195\169",
        ["Seal of Wisdom"]="Sceau de sagesse",
        ["Seal of the Crusader"]="Sceau du Crois\195\169",
        ["Searing Light"]="Lumi\195\168re incendiaire",
        ["Searing Pain"]="Douleur br\195\187lante",
        ["Searing Totem"]="Totem incendiaire",
        ["Seduction"]="S\195\169duction",
        ["Sense Demons"]="D\195\169tection des d\195\169mons",
        ["Sense Undead"]="D\195\169tection des morts-vivants",
        ["Sentry Totem"]="Totem Sentinelle",
        ["Serpent Sting"]="Morsure de serpent",
        ["Setup"]="Pr\195\169paratifs",
        ["Shackle Undead"]="Entraves des morts-vivants",
        ["Shadow Affinity"]="Affinit\195\169 avec l'ombre",
        ["Shadow Bolt"]="Trait de l'ombre",
        ["Shadow Focus"]="Focalisation de l'ombre",
        ["Shadow Mastery"]="Ma\195\174trise de l'ombre",
        ["Shadow Protection"]="Protection contre l'Ombre",
        ["Shadow Reach"]="Allonge de l'Ombre",
        ["Shadow Resistance Aura"]="Aura de r\195\169sistance \195\160 l'Ombre",
        ["Shadow Resistance"]="R\195\169sistance \195\160 l'Ombre",
        ["Shadow Ward"]="Gardien de l'ombre",
        ["Shadow Weaving"]="Tissage de l'ombre",
        ["Shadow Word: Pain"]="Mot de l'ombre\194\160: Douleur",
        ["Shadowburn"]="Br\195\187lure de l'ombre",
        ["Shadowform"]="Forme d'Ombre",
        ["Shadowguard"]="Garde de l'ombre",
        ["Shadowmeld Passive"]="Camouflage dans l'ombre",
        ["Shadowmeld"]="Camouflage dans l'ombre",
        ["Sharpened Claws"]="Griffes aiguis\195\169es",
        ["Shatter"]="Fracasser",
        ["Shell Shield"]="Carapace bouclier",
        ["Shield Bash"]="Coup de bouclier",
        ["Shield Block"]="Ma\195\174trise du blocage",
        ["Shield Slam"]="Heurt de bouclier",
        ["Shield Specialization"]="Sp\195\169cialisation Bouclier",
        ["Shield Wall"]="Mur protecteur",
        ["Shield"]="Bouclier",
        ["Shoot Bow"]="Tir \195\160 l'arc",
        ["Shoot Crossbow"]="Tir \195\160 l\226\128\153arbal\195\168te",
        ["Shoot Gun"]="Tir avec une arme \195\160 feu",
        ["Shoot"]="Tir",
        ["Shred"]="Lambeau",
        ["Silence"]="Silence",
        ["Silent Resolve"]="R\195\169solution silencieuse",
        ["Sinister Strike"]="Attaque pernicieuse",
        ["Siphon Life"]="Siphon de vie",
        ["Skinning"]="D\195\169pe\195\167age",
        ["Slam"]="Heurtoir",
        ["Sleep"]="Sommeil",
        ["Slice and Dice"]="D\195\169biter",
        ["Slow Fall"]="Chute lente",
        ["Smelting"]="Fondre",
        ["Smite"]="Ch\195\162timent",
        ["Soothe Animal"]="Apaiser les animaux",
        ["Soothing Kiss"]="Baiser apaisant",
        ["Soul Fire"]="Feu de l'\195\162me",
        ["Soul Link"]="Lien spirituel",
        ["Soulstone Resurrection"]="R\195\169surrection de pierre d'\195\162me",
        ["Spell Lock"]="Verrou magique",
        ["Spell Warding"]="Protection contre les sorts",
        ["Spirit Bond"]="Engagement spirituel",
        ["Spirit Tap"]="Connexion spirituelle",
        ["Spirit of Redemption"]="Esprit de r\195\169demption",
        ["Spiritual Focus"]="Focalisation spirituelle",
        ["Spiritual Guidance"]="Direction spirituelle",
        ["Spiritual Healing"]="Soins spirituels",
        ["Sprint"]="Sprint",
        ["Starfire"]="Feu stellaire",
        ["Starshards"]="Eclats stellaires",
        ["Staves"]="B\195\162tons",
        ["Stealth"]="Camouflage",
        ["Stoneclaw Totem"]="Totem de Griffes de pierre",
        ["Stoneform"]="Forme de pierre",
        ["Stoneskin Totem"]="Totem de Peau de pierre",
        ["Stormstrike"]="Courroux naturel",
        ["Strength of Earth Totem"]="Totem de Force de la Terre",
        ["Stuck"]="Bloqu\195\169",
        ["Subtlety"]="Discr\195\169tion",
        ["Suffering"]="Souffrance",
        ["Summon Charger"]="Invocation de destrier",
        ["Summon Dreadsteed"]="Invocation d'un Destrier de l'Effroi",
        ["Summon Felhunter"]="Invocation d'un chasseur corrompu",
        ["Summon Felsteed"]="Invocation d'un palefroi corrompu",
        ["Summon Imp"]="Invocation d'un diablotin",
        ["Summon Succubus"]="Invocation d'une succube",
        ["Summon Voidwalker"]="Invocation d'un marcheur du Vide",
        ["Summon Warhorse"]="Invocation d'un cheval de guerre",
        ["Sunder Armor"]="Fracasser armure",
        ["Suppression"]="Suppression",
        ["Surefooted"]="Pied s\195\187r",
        ["Survivalist"]="Survivant",
        ["Sweeping Strikes"]="Attaques circulaires",
        ["Swipe"]="Balayage",
        ["Sword Specialization"]="Sp\195\169cialisation Ep\195\169e",
        ["Tactical Mastery"]="Ma\195\174trise tactique",
        ["Tailoring"]="Couture",
        ["Tainted Blood"]="Corruption sanguine",
        ["Tame Beast"]="Dompte une b\195\170te",
        ["Tamed Pet Passive"]="Familier dompt\195\169",
        ["Taunt"]="Provocation",
        ["Teleport: Darnassus"]="T\195\169l\195\169portation\194\160: Darnassus",
        ["Teleport: Ironforge"]="T\195\169l\195\169portation\194\160: Ironforge",
        ["Teleport: Moonglade"]="T\195\169l\195\169portation\194\160: Reflet-de-Lune",
        ["Teleport: Orgrimmar"]="T\195\169l\195\169portation\194\160: Orgrimmar",
        ["Teleport: Stormwind"]="T\195\169l\195\169portation\194\160: Stormwind",
        ["Teleport: Thunder Bluff"]="T\195\169l\195\169portation\194\160: Thunder Bluff",
        ["Teleport: Undercity"]="T\195\169l\195\169portation\194\160: Undercity",
        ["The Human Spirit"]="L'esprit humain",
        ["Thick Hide"]="Peau \195\169paisse",
        ["Thorns"]="Epines",
        ["Throw"]="Lancer",
        ["Throwing Specialization"]="Sp\195\169cialisation Armes de jet",
        ["Throwing Weapon Specialization"]="Sp\195\169cialisation Armes de jet",
        ["Thrown"]="Armes de jet",
        ["Thunder Clap"]="Coup de tonnerre",
        ["Thundering Strikes"]="Frappe foudroyante",
        ["Thunderstomp"]="Grondeterre",
        ["Tidal Focus"]="Focalisation des flots",
        ["Tidal Mastery"]="Ma\195\174trise des flots",
        ["Tiger Riding"]="Monte de tigre",
        ["Tiger's Fury"]="Fureur du tigre",
        ["Torment"]="Tourment",
        ["Totem"]="Totem",
        ["Totemic Focus"]="Focalisation tot\195\169mique",
        ["Touch of Weakness"]="Toucher de faiblesse",
        ["Toughness"]="R\195\169sistance",
        ["Track Beasts"]="Pistage des b\195\170tes",
        ["Track Demons"]="Pistage des d\195\169mons",
        ["Track Dragonkin"]="Pistage des draconiens",
        ["Track Elementals"]="Pistage des \195\169l\195\169mentaires",
        ["Track Giants"]="Pistage des g\195\169ants",
        ["Track Hidden"]="Pistage des camoufl\195\169s",
        ["Track Humanoids"]="Pistage des humano\195\175des",
        ["Track Undead"]="Pistage des morts-vivants",
        ["Tranquil Air Totem"]="Totem de Tranquillit\195\169 de l'air",
        ["Tranquil Spirit"]="Tranquillit\195\169 de l'esprit",
        ["Tranquility"]="Tranquillit\195\169",
        ["Tranquilizing Shot"]="Tir tranquillisant",
        ["Trap Mastery"]="Ma\195\174trise des pi\195\168ges",
        ["Travel Form"]="Forme de voyage",
        ["Tremor Totem"]="Totem de S\195\169isme",
        ["Tribal Leatherworking"]="Travail du cuir tribal",
        ["Trueshot Aura"]="Aura de pr\195\169cision",
        ["Turn Undead"]="Renvoi des morts-vivants",
        ["Two-Handed Axes and Maces"]="Haches et masses \195\160 deux mains",
        ["Two-Handed Axes"]="Haches \195\160 deux mains",
        ["Two-Handed Maces"]="Masses \195\160 deux mains",
        ["Two-Handed Swords"]="Ep\195\169es \195\160 deux mains",
        ["Two-Handed Weapon Specialization"]="Sp\195\169cialisation Arme 2M",
        ["Unarmed"]="Mains nues",
        ["Unbreakable Will"]="Volont\195\169 inflexible",
        ["Unbridled Wrath Effect"]="Effet Col\195\168re d\195\169cha\195\174n\195\169e",
        ["Unbridled Wrath"]="Col\195\168re d\195\169cha\195\174n\195\169e",
        ["Undead Horsemanship"]="Monte de cheval squelette",
        ["Underwater Breathing"]="Respiration aquatique",
        ["Unending Breath"]="Respiration interminable",
        ["Unholy Power"]="Puissance impie",
        ["Unleashed Fury"]="Fureur lib\195\169r\195\169e",
        ["Unyielding Faith"]="Foi inflexible",
        ["Vampiric Embrace"]="Etreinte vampirique",
        ["Vanish"]="Disparition",
        ["Vanished"]="Invisible",
        ["Vengeance"]="Vengeance",
        ["Vigor"]="Vigueur",
        ["Vile Poisons"]="Poisons abominables",
        ["Vindication"]="Justification",
        ["Viper Sting"]="Morsure de vip\195\168re",
        ["Volley"]="Salve",
        ["Wand Specialization"]="Sp\195\169cialisation Baguette",
        ["Wands"]="Baguettes",
        ["War Stomp"]="Choc martial",
        ["Water Breathing"]="Respiration aquatique",
        ["Water Walking"]="Marcher sur l\226\128\153eau",
        ["Weaponsmith"]="Fabricant d'armes",
        ["Whirlwind"]="Tourbillon",
        ["Will of the Forsaken"]="Volont\195\169 des R\195\169prouv\195\169s",
        ["Windfury Totem"]="Totem Furie-des-vents",
        ["Windfury Weapon"]="Arme Furie-des-vents",
        ["Windwall Totem"]="Totem de Mur des vents",
        ["Wing Clip"]="Coupure d'ailes",
        ["Winter's Chill"]="Froid hivernal",
        ["Wisp Spirit"]="Esprit feu follet",
        ["Wolf Riding"]="Monte de loup",
        ["Wound Poison II"]="Poison douloureux II",
        ["Wound Poison III"]="Poison douloureux III",
        ["Wound Poison IV"]="Poison douloureux IV",
        ["Wound Poison"]="Poison douloureux",
        ["Wrath"]="Col\195\168re",
        ["Wyvern Sting"]="Piq\195\187re de wyverne"
    }
elseif locale == "zhCN" then
	englishToLocal = {
        ["Abolish Disease"]="\233\169\177\233\153\164\231\150\190\231\151\133",
        ["Abolish Poison Effect"]="\233\169\177\230\175\146\230\156\175\230\149\136\230\158\156",
        ["Abolish Poison"]="\233\169\177\230\175\146\230\156\175",
        ["Activate MG Turret"]="\229\191\145\229\176\132MGs",
        ["Adrenaline Rush"]="\229\134\178\229\138\168",
        ["Aftermath"]="\230\184\133\231\174\151",
        ["Aggression"]="\228\190\181\231\149\165",
        ["Aimed Shot"]="\231\158\132\229\135\134\229\176\132\229\135\187",
        ["Alchemy"]="\231\130\188\233\135\145\230\156\175",
        ["Ambush"]="\228\188\191\229\135\187",
        ["Amplify Curse"]="\232\175\133\229\146\146\229\162\158\229\185\133",
        ["Amplify Magic"]="\233\173\148\230\179\149\229\162\158\230\149\136",
        ["Ancestral Healing"]="\229\133\136\231\165\150\230\178\187\231\150\151",
        ["Ancestral Knowledge"]="\229\133\136\231\165\150\231\159\165\232\175\134",
        ["Ancestral Spirit"]="\229\133\136\231\165\150\228\185\139\233\173\130",
        ["Anger Management"]="\230\132\164\230\128\146\230\142\140\230\142\167",
        ["Anticipation"]="\233\162\132\231\159\165",
        ["Aquatic Form"]="\230\176\180\230\160\150\229\189\162\230\128\191\239\188\136\232\162\171\229\138\168\239\188\137",
        ["Arcane Brilliance"]="\229\165\165\230\156\175\229\133\137\232\190\137",
        ["Arcane Concentration"]="\229\165\165\230\156\175\228\184\147\230\179\168",
        ["Arcane Explosion"]="\233\173\148\231\136\134\230\156\175",
        ["Arcane Focus"]="\229\165\165\230\156\175\233\155\134\228\184\173",
        ["Arcane Instability"]="\229\165\165\230\156\175\229\162\158\230\149\136",
        ["Arcane Intellect"]="\229\165\165\230\156\175\230\153\186\230\133\167",
        ["Arcane Meditation"]="\229\165\165\230\156\175\229\134\165\230\131\179",
        ["Arcane Mind"]="\229\165\165\230\156\175\229\191\131\230\153\186",
        ["Arcane Missiles"]="\229\165\165\230\156\175\233\163\158\229\188\185",
        ["Arcane Power"]="\229\165\165\230\156\175\229\188\186\229\140\150",
        ["Arcane Resistance"]="\229\165\165\230\156\175\230\138\151\230\128\167",
        ["Arcane Shot"]="\229\165\165\230\156\175\229\176\132\229\135\187",
        ["Arcane Subtlety"]="\229\165\165\230\156\175\231\178\190\229\166\153",
        ["Arctic Reach"]="\230\158\191\229\175\146\229\187\182\228\188\184",
        ["Armorsmith"]="\230\138\164\231\148\178\233\148\187\233\128\160\229\184\136",
        ["Aspect of the Beast"]="\233\135\142\229\133\189\229\174\136\230\138\164",
        ["Aspect of the Cheetah"]="\231\140\142\232\177\185\229\174\136\230\138\164",
        ["Aspect of the Hawk"]="\233\155\132\233\185\176\229\174\136\230\138\164",
        ["Aspect of the Monkey"]="\231\191\181\231\140\180\229\174\136\230\138\164",
        ["Aspect of the Pack"]="\232\177\185\231\190\164\229\174\136\230\138\164",
        ["Aspect of the Wild"]="\233\135\142\230\128\167\229\174\136\230\138\164",
        ["Astral Recall"]="\230\152\159\231\149\140\228\188\160\233\128\191",
        ["Attack"]="\230\148\187\229\135\187",
        ["Attacking"]="\230\148\187\229\135\187",
        ["Auto Shot"]="\232\135\170\229\138\168\229\176\132\229\135\187",
        ["Axe Specialization"]="\230\150\167\228\184\147\231\178\190",
        ["Backstab"]="\232\131\140\229\136\186",
        ["Bane"]="\231\191\190\231\165\184",
        ["Banish"]="\230\148\190\233\128\191\230\156\175",
        ["Barkskin Effect"]="Barkskin Effect",
        ["Barkskin"]="\230\160\145\231\154\174\230\156\175",
        ["Barrage"]="\229\188\185\229\185\149",
        ["Bash"]="\233\135\191\229\135\187",
        ["Basic Campfire"]="\229\159\186\231\161\128\232\191\165\231\191\171",
        ["Battle Shout"]="\230\136\152\230\150\151\230\128\146\229\191\188",
        ["Battle Stance Passive"]="Battle Stance Passive",
        ["Battle Stance"]="\230\136\152\230\150\151\229\167\191\230\128\191",
        ["Bear Form"]="Bear Form",
        ["Beast Lore"]="\233\135\142\229\133\189\231\159\165\232\175\134",
        ["Beast Slaying"]="\233\135\142\229\133\189\230\191\128\230\137\139",
        ["Beast Training"]="\232\174\173\231\187\131\233\135\142\229\133\189",
        ["Benediction"]="\231\165\136\231\166\191",
        ["Berserker Rage"]="\231\139\130\230\154\180\228\185\139\230\128\146",
        ["Berserker Stance Passive"]="\231\139\130\230\154\180\229\167\191\230\128\191\239\188\136\232\162\171\229\138\168\239\188\137",
        ["Berserker Stance"]="\231\139\130\230\154\180\229\167\191\230\128\191",
        ["Berserking"]="\231\139\130\230\154\180",
        ["Bestial Discipline"]="\233\135\142\229\133\189\230\136\146\229\190\139",
        ["Bestial Swiftness"]="\233\135\142\229\133\189\232\191\133\230\191\183",
        ["Bestial Wrath"]="\231\139\130\233\135\142\230\128\146\231\191\171",
        ["Bite"]="\230\146\149\229\146\172",
        ["Black Arrow"]="\233\187\145\231\174\173",
        ["Blackout"]="\230\152\191\233\152\153",
        ["Blacksmithing"]="\233\148\187\233\128\160",
        ["Blade Flurry"]="\229\137\145\229\136\131\228\185\177\232\136\158",
        ["Blast Wave"]="\229\134\178\229\135\187\230\179\162",
        ["Blessing of Freedom"]="\232\135\170\231\148\177\231\165\191\231\166\191",
        ["Blessing of Kings"]="\231\142\139\232\128\133\231\165\191\231\166\191",
        ["Blessing of Light"]="\229\133\137\230\152\142\231\165\191\231\166\191",
        ["Blessing of Might"]="\229\138\155\233\135\191\231\165\191\231\166\191",
        ["Blessing of Protection"]="\228\191\191\230\138\164\231\165\191\231\166\191",
        ["Blessing of Sacrifice"]="\231\137\186\231\137\178\231\165\191\231\166\191",
        ["Blessing of Salvation"]="\230\139\175\230\149\145\231\165\191\231\166\191",
        ["Blessing of Sanctuary"]="\229\186\135\230\138\164\231\165\191\231\166\191",
        ["Blessing of Wisdom"]="\230\153\186\230\133\167\231\165\191\231\166\191",
        ["Blind"]="\232\135\180\231\155\178",
        ["Blinding Powder"]="\232\135\180\231\155\178\231\178\137",
        ["Blink"]="\233\151\170\231\142\176\230\156\175",
        ["Blizzard"]="\230\154\180\233\163\142\233\155\170",
        ["Block"]="\230\160\188\230\140\161",
        ["Blood Craze"]="\232\161\128\228\185\139\231\139\130\231\131\173",
        ["Blood Frenzy"]="\232\161\128\228\185\139\231\139\130\230\154\180",
        ["Blood Fury"]="\232\161\128\230\128\167\231\139\130\230\154\180",
        ["Blood Pact"]="\232\161\128\228\185\139\229\165\145\229\191\176",
        ["Bloodrage"]="\232\161\128\230\128\167\231\139\130\230\154\180",
        ["Bloodthirst"]="\229\151\156\232\161\128",
        ["Booming Voice"]="\233\156\135\232\128\179\229\151\147\233\159\179",
        ["Bows"]="\229\188\147",
        ["Bright Campfire"]="\230\152\142\228\186\174\231\175\191\231\191\171",
        ["Brutal Impact"]="\233\135\142\232\155\174\229\134\178\230\146\158",
        ["Burning Soul"]="\231\135\131\231\131\167\228\185\139\233\173\130",
        ["Call Pet"]="\229\191\172\229\148\164\229\174\160\231\137\169",
        ["Call of Flame"]="\231\131\136\231\132\176\229\191\172\229\148\164",
        ["Call of Thunder"]="\233\155\183\233\156\134\229\191\172\229\148\164",
        ["Camouflage"]="\228\188\170\232\163\133",
        ["Cannibalize"]="\233\163\159\229\176\184",
        ["Cat Form"]="Cat Form",
        ["Cataclysm"]="\231\191\190\229\191\152",
        ["Chain Heal"]="\230\178\187\231\150\151\233\147\190",
        ["Chain Lightning"]="\233\151\170\231\148\181\233\147\190",
        ["Challenging Roar"]="\230\140\145\230\136\152\229\146\134\229\147\174",
        ["Challenging Shout"]="\230\140\145\230\136\152\230\128\146\229\191\188",
        ["Charge Rage Bonus Effect"]="Charge Rage Bonus Effect",
        ["Charge"]="\229\134\178\233\148\139",
        ["Cheap Shot"]="\229\191\183\232\162\173",
        ["Chilled"]="\229\134\176\229\134\187",
        ["Claw"]="\231\136\170\229\135\187",
        ["Cleanse"]="\230\184\133\230\180\191\230\156\175",
        ["Clearcasting"]="\232\138\130\232\131\189\230\150\189\230\179\149",
        ["Cleave"]="\233\161\186\229\138\136\230\150\169",
        ["Clever Traps"]="\231\191\181\229\183\167\233\153\183\233\152\177",
        ["Closing"]="\229\133\179\233\151\173",
        ["Cloth"]="\229\184\131\231\148\178",
        ["Cold Blood"]="\229\134\183\232\161\128",
        ["Cold Snap"]="\230\128\165\233\128\159\229\134\183\229\191\180",
        ["Combat Endurance"]="\228\189\156\230\136\152\230\140\191\228\185\133",
        ["Combustion"]="\231\135\131\231\131\167",
        ["Command"]="\229\145\189\228\187\164",
        ["Concentration Aura"]="\228\184\147\230\179\168\229\133\137\231\142\175",
        ["Concussion Blow"]="\233\156\135\232\191\161\231\140\155\229\135\187",
        ["Concussion"]="\233\156\135\232\191\161",
        ["Concussive Shot"]="\233\156\135\232\191\161\229\176\132\229\135\187",
        ["Cone of Cold"]="\229\134\176\233\148\165\230\156\175",
        ["Conflagrate"]="\231\135\131\231\131\167",
        ["Conjure Food"]="\233\128\160\233\163\159\230\156\175",
        ["Conjure Mana Agate"]="\229\136\182\233\128\160\233\173\148\230\179\149\231\142\155\231\145\153",
        ["Conjure Mana Citrine"]="\229\136\182\233\128\160\233\173\148\230\179\149\233\187\132\230\176\180\230\153\182",
        ["Conjure Mana Jade"]="\229\136\182\233\128\160\233\173\148\230\179\149\231\191\161\231\191\160",
        ["Conjure Mana Ruby"]="\229\136\182\233\128\160\233\173\148\230\179\149\231\186\162\229\174\191\231\159\179",
        ["Conjure Water"]="\233\128\160\230\176\180\230\156\175",
        ["Consume Shadows"]="\229\191\158\229\153\172\230\154\151\229\189\177",
        ["Convection"]="\228\188\160\229\175\188",
        ["Conviction"]="\229\174\154\231\189\170",
        ["Corruption"]="\232\133\191\232\154\128\230\156\175",
        ["Counterattack"]="\229\191\191\229\135\187",
        ["Counterspell"]="\230\179\149\230\156\175\229\191\191\229\136\182",
        ["Cower"]="\231\149\191\231\188\169",
        ["Create Firestone"]="\229\136\182\233\128\160\231\191\171\231\132\176\231\159\179",
        ["Create Healthstone"]="\229\136\182\233\128\160\230\178\187\231\150\151\231\159\179",
        ["Create Soulstone"]="\229\136\182\233\128\160\230\158\191\230\149\136\231\191\181\233\173\130\231\159\179",
        ["Create Spellstone"]="\229\136\182\233\128\160\229\188\186\230\149\136\230\179\149\230\156\175\231\159\179",
        ["Crippling Poison II"]="\232\135\180\230\174\139\230\175\146\232\191\175 II",
        ["Crippling Poison"]="\232\135\180\230\174\139\230\175\146\232\191\175",
        ["Critical Mass"]="\231\191\171\231\132\176\233\135\191\229\135\187",
        ["Crossbows"]="\229\188\169",
        ["Cruelty"]="\230\174\139\229\191\191",
        ["Cultivation"]="\230\160\189\229\159\185",
        ["Cure Disease"]="\231\165\155\231\151\133\230\156\175",
        ["Cure Poison"]="\230\182\136\230\175\146\230\156\175",
        ["Curse of Agony"]="\231\151\155\232\139\166\232\175\133\229\146\146",
        ["Curse of Doom Effect"]="\229\142\132\232\191\191\232\175\133\229\146\146\230\149\136\230\158\156",
        ["Curse of Doom"]="\229\142\132\232\191\191\232\175\133\229\146\146",
        ["Curse of Exhaustion"]="\231\150\178\229\138\179\232\175\133\229\146\146",
        ["Curse of Idiocy"]="\231\151\180\229\145\134\232\175\133\229\146\146",
        ["Curse of Recklessness"]="\233\178\191\232\142\189\232\175\133\229\146\146",
        ["Curse of Shadow"]="\230\154\151\229\189\177\232\175\133\229\146\146",
        ["Curse of Tongues"]="\232\175\173\232\168\128\232\175\133\229\146\146",
        ["Curse of Weakness"]="\232\153\154\229\188\177\232\175\133\229\146\146",
        ["Curse of the Elements"]="\229\133\131\231\180\160\232\175\133\229\146\146",
        ["Dagger Specialization"]="\229\140\149\233\166\150\228\184\147\231\178\190",
        ["Daggers"]="\229\140\149\233\166\150",
        ["Dampen Magic"]="\233\173\148\230\179\149\230\138\145\229\136\182",
        ["Dark Pact"]="\233\187\145\230\154\151\229\165\145\231\186\166",
        ["Darkness"]="\233\187\145\230\154\151",
        ["Dash"]="\231\170\191\232\191\155",
        ["Deadly Poison II"]="\232\135\180\229\145\189\230\175\146\232\191\175 II",
        ["Deadly Poison III"]="\232\135\180\229\145\189\230\175\146\232\191\175 III",
        ["Deadly Poison IV"]="\232\135\180\229\145\189\230\175\146\232\191\175 IV",
        ["Deadly Poison"]="\232\135\180\229\145\189\230\175\146\232\191\175",
        ["Death Coil"]="\230\173\187\228\186\161\231\188\160\231\187\149",
        ["Death Wish"]="\230\173\187\228\186\161\228\185\139\230\132\191",
        ["Deep Wounds"]="\233\135\191\228\188\164",
        ["Defense"]="\233\152\178\229\190\161",
        ["Defensive Stance Passive"]="Defensive Stance Passive",
        ["Defensive Stance"]="\233\152\178\229\190\161\229\167\191\230\128\191",
        ["Defensive State 2"]="Defensive State 2",
        ["Defensive State"]="Defensive State",
        ["Defiance"]="\230\140\145\232\161\133",
        ["Deflection"]="\229\191\191\230\150\156",
        ["Demon Armor"]="\233\173\148\231\148\178\230\156\175",
        ["Demon Skin"]="\230\191\182\233\173\148\231\154\174\232\130\164",
        ["Demonic Embrace"]="\230\191\182\233\173\148\228\185\139\230\139\165",
        ["Demonic Sacrifice"]="\230\191\182\233\173\148\231\137\186\231\137\178",
        ["Demoralizing Roar"]="\230\140\171\229\191\151\229\146\134\229\147\174",
        ["Demoralizing Shout"]="\230\140\171\229\191\151\230\128\146\229\191\188",
        ["Desperate Prayer"]="\231\187\191\230\156\155\231\165\183\232\168\128",
        ["Destructive Reach"]="\230\175\191\231\191\173\229\187\182\228\188\184",
        ["Detect Greater Invisibility"]="\228\190\166\230\181\139\229\188\186\230\149\136\233\154\191\229\189\162",
        ["Detect Invisibility"]="\228\190\166\230\181\139\233\154\191\229\189\162",
        ["Detect Lesser Invisibility"]="\228\190\166\230\181\139\230\172\161\231\186\167\233\154\191\229\189\162",
        ["Detect Magic"]="\228\190\166\230\181\139\233\173\148\230\179\149",
        ["Detect Traps"]="\228\190\166\230\181\139\233\153\183\233\152\177",
        ["Detect"]="\228\190\166\230\181\139",
        ["Deterrence"]="\229\168\191\230\133\145",
        ["Devastation"]="\231\160\180\229\191\191",
        ["Devotion Aura"]="\232\153\148\232\175\154\229\133\137\231\142\175",
        ["Devour Magic Effect"]="\229\191\158\229\153\172\233\173\148\230\179\149\230\149\136\230\158\156",
        ["Devour Magic"]="\229\191\158\229\153\172\233\173\148\230\179\149",
        ["Devouring Plague"]="\229\153\172\231\191\181\231\152\159\231\150\171",
        ["Diplomacy"]="\229\164\150\228\186\164",
        ["Dire Bear Form"]="Dire Bear Form",
        ["Disarm Trap"]="\232\167\163\233\153\164\233\153\183\233\152\177",
        ["Disarm"]="\231\188\180\230\162\176",
        ["Disease Cleansing Totem"]="\231\165\155\231\151\133\229\155\190\232\133\190",
        ["Disenchant"]="\229\136\134\232\167\163",
        ["Disengage"]="\233\128\131\232\132\177",
        ["Dismiss Pet"]="\232\167\163\230\149\163\233\135\142\229\133\189",
        ["Dispel Magic"]="\233\169\177\230\149\163\233\173\148\230\179\149",
        ["Distract"]="\230\137\176\228\185\177",
        ["Distracting Shot"]="\230\137\176\228\185\177\229\176\132\229\135\187",
        ["Dive"]="\228\191\175\229\134\178",
        ["Divine Favor"]="\231\165\158\230\191\169\230\156\175",
        ["Divine Fury"]="\231\165\158\229\156\163\228\185\139\230\128\146",
        ["Divine Intellect"]="\231\165\158\229\156\163\230\153\186\230\133\167",
        ["Divine Intervention"]="\231\165\158\229\156\163\229\185\178\230\182\137",
        ["Divine Protection"]="\229\156\163\228\189\145\230\156\175",
        ["Divine Shield"]="\229\156\163\231\155\190\230\156\175",
        ["Divine Spirit"]="\231\165\158\229\156\163\228\185\139\231\191\181",
        ["Divine Strength"]="\231\165\158\229\156\163\228\185\139\229\138\155",
        ["Dodge"]="\232\186\178\233\151\170",
        ["Dragonscale Leatherworking"]="\233\190\153\233\179\158\229\136\182\231\154\174",
        ["Drain Life"]="\229\191\184\229\191\150\231\148\159\229\145\189",
        ["Drain Mana"]="\229\191\184\229\191\150\230\179\149\229\138\155",
        ["Drain Soul"]="\229\191\184\229\191\150\231\191\181\233\173\130",
        ["Dual Wield Specialization"]="\229\191\140\230\173\166\229\153\168\228\184\147\231\178\190",
        ["Dual Wield"]="\229\191\140\230\173\166\229\153\168",
        ["Duel"]="\229\134\179\230\150\151",
        ["Eagle Eye"]="\233\185\176\231\156\188\230\156\175",
        ["Earth Shock"]="\229\156\176\233\156\135\230\156\175",
        ["Earthbind Totem"]="\229\156\176\231\188\154\229\155\190\232\133\190",
        ["Efficiency"]="\230\149\136\231\142\135",
        ["Elemental Focus"]="\229\133\131\231\180\160\233\155\134\228\184\173",
        ["Elemental Fury"]="\229\133\131\231\180\160\228\185\139\230\128\146",
        ["Elemental Leatherworking"]="\229\133\131\231\180\160\229\136\182\231\154\174",
        ["Elemental Mastery"]="\229\133\131\231\180\160\230\142\140\230\191\161",
        ["Elune's Grace"]="\232\137\190\233\156\178\230\191\169\231\154\132\232\181\191\231\166\191",
        ["Elusiveness"]="\233\163\152\229\191\189\228\184\191\229\174\154",
        ["Emberstorm"]="\231\191\165\231\191\128\233\163\142\230\154\180",
        ["Enchanting"]="\233\153\132\233\173\148",
        ["Endurance Training"]="\232\128\191\228\185\133\232\174\173\231\187\131",
        ["Endurance"]="\232\128\191\228\185\133",
        ["Engineering Specialization"]="\229\183\165\231\168\139\229\173\166\228\184\147\231\178\190",
        ["Engineering"]="\229\183\165\231\168\139\229\173\166",
        ["Enrage"]="\231\139\130\230\128\146",
        ["Enslave Demon"]="\229\165\180\229\189\185\230\191\182\233\173\148",
        ["Entangling Roots"]="\231\186\160\231\188\160\230\160\185\233\161\187",
        ["Entrapment"]="\232\175\177\230\191\149",
        ["Escape Artist"]="\233\128\131\229\145\189\228\184\147\229\174\182",
        ["Evasion"]="\233\151\170\233\191\191",
        ["Eventide"]="\233\187\132\230\152\191",
        ["Eviscerate"]="\229\137\148\233\170\168",
        ["Evocation"]="\229\148\164\233\134\146",
        ["Execute"]="\230\150\169\230\191\128",
        ["Exorcism"]="\233\169\177\233\130\170\230\156\175",
        ["Expansive Mind"]="\229\188\128\233\152\148\230\128\191\231\187\180",
        ["Explosive Trap Effect"]="\231\136\134\231\130\184\233\153\183\233\152\177\230\149\136\230\158\156",
        ["Explosive Trap"]="\231\136\134\231\130\184\233\153\183\233\152\177",
        ["Expose Armor"]="\231\160\180\231\148\178",
        ["Eye for an Eye"]="zzOLDSpell - Reuse",
        ["Eye of Kilrogg"]="\229\159\186\229\176\148\231\189\151\230\160\188\228\185\139\231\156\188",
        ["Eyes of the Beast"]="\233\135\142\229\133\189\228\185\139\231\156\188",
        ["Fade"]="\230\184\191\233\154\191\230\156\175",
        ["Faerie Fire"]="\231\178\190\231\191\181\228\185\139\231\191\171",
        ["Far Sight"]="\232\167\134\231\149\140\230\156\175",
        ["Fear Ward"]="\233\152\178\230\138\164\230\191\191\230\131\167\231\187\147\231\149\140",
        ["Fear"]="\230\191\191\230\131\167\230\156\175",
        ["Feed Pet"]="\229\150\130\229\133\187\229\174\160\231\137\169",
        ["Feedback"]="\229\155\158\233\166\136",
        ["Feign Death"]="\229\191\135\230\173\187",
        ["Feint"]="\228\189\175\230\148\187",
        ["Fel Concentration"]="\230\191\182\233\173\148\228\184\147\230\179\168",
        ["Fel Domination"]="\230\191\182\233\173\148\230\148\175\233\133\191",
        ["Fel Intellect"]="\230\191\182\233\173\148\230\153\186\229\138\155",
        ["Fel Stamina"]="\230\191\182\233\173\148\232\128\191\229\138\155",
        ["Felfire"]="\233\173\148\231\191\171",
        ["Feline Grace"]="\232\177\185\228\185\139\228\188\152\233\155\133",
        ["Feline Swiftness"]="\232\177\185\228\185\139\232\191\133\230\191\183",
        ["Feral Aggression"]="\233\135\142\230\128\167\228\190\181\231\149\165",
        ["Feral Charge"]="\233\135\142\230\128\167\229\134\178\233\148\139",
        ["Feral Instinct"]="\233\135\142\230\128\167\230\156\172\232\131\189",
        ["Ferocious Bite"]="\229\135\182\231\140\155\230\146\149\229\146\172",
        ["Ferocity"]="\229\135\182\230\154\180",
        ["Find Herbs"]="\229\175\187\230\137\190\239\191\189?\239\191\189\239\191\189?\239\191\189",
        ["Find Minerals"]="\229\175\187\230\137\190\231\159\191\231\137\169",
        ["Find Treasure"]="\229\175\187\230\137\190\232\180\162\229\174\191",
        ["Fire Blast"]="\231\191\171\231\132\176\229\134\178\229\135\187",
        ["Fire Nova Totem"]="\231\191\171\231\132\176\230\150\176\230\152\159\229\155\190\232\133\190",
        ["Fire Power"]="\231\191\171\231\132\176\229\188\186\229\140\150",
        ["Fire Resistance Aura"]="\231\191\171\231\132\176\230\138\151\230\128\167\229\133\137\231\142\175",
        ["Fire Resistance Totem"]="\230\138\151\231\191\171\229\155\190\232\133\190",
        ["Fire Resistance"]="\231\191\171\231\132\176\230\138\151\230\128\167",
        ["Fire Shield"]="\231\191\171\231\132\176\228\185\139\231\155\190",
        ["Fire Vulnerability"]="\231\151\155\232\139\166\232\175\133\229\146\146",
        ["Fire Ward"]="\233\152\178\230\138\164\231\191\171\231\132\176\231\187\147\231\149\140",
        ["Fireball"]="\231\191\171\231\191\131\230\156\175",
        ["Firebolt"]="\231\191\171\231\132\176\231\174\173",
        ["First Aid"]="?ζ븨",
        ["Fishing Poles"]="\233\177\188\231\171\191",
        ["Fishing"]="\233\146\147\233\177\188",
        ["Fist Weapon Specialization"]="\230\139\179\229\165\151\228\184\147\231\178\190",
        ["Fist Weapons"]="\230\139\179\229\165\151",
        ["Flame Shock"]="\231\131\136\231\132\176\233\156\135\229\135\187",
        ["Flame Throwing"]="\231\131\136\231\132\176\230\138\149\230\142\183",
        ["Flamestrike"]="\231\131\136\231\132\176\233\163\142\230\154\180",
        ["Flamethrower"]="\229\191\145\229\176\132\231\191\171\231\132\176\229\150\183\229\176\132\229\153\168",
        ["Flametongue Totem"]="\231\191\171\232\136\140\229\155\190\232\133\190",
        ["Flametongue Weapon"]="\231\191\171\232\136\140\230\173\166\229\153\168",
        ["Flare"]="\231\133\167\230\152\142\229\188\185",
        ["Flash Heal"]="\229\191\171\233\128\159\230\178\187\231\150\151",
        ["Flash of Light"]="\229\156\163\229\133\137\233\151\170\231\142\176",
        ["Flurry"]="\228\185\177\232\136\158",
        ["Focused Casting"]="\228\184\147\230\179\168\230\150\189\230\179\149",
        ["Force of Will"]="\230\132\191\229\191\151\228\185\139\229\138\155",
        ["Freezing Trap Effect"]="?겼녃?룬삺?덃옖",
        ["Freezing Trap"]="\229\134\176\229\134\187\233\153\183\233\152\177",
        ["Frenzied Regeneration"]="\231\139\130\230\154\180\229\155\158\229\164\191",
        ["Frenzy"]="\231\139\130\228\185\177",
        ["Frost Armor"]="\233\156\156\231\148\178\230\156\175",
        ["Frost Channeling"]="\229\134\176\233\156\156\229\175\188\232\131\189",
        ["Frost Nova"]="\229\134\176\233\156\156\230\150\176\230\152\159",
        ["Frost Resistance Aura"]="\229\134\176\233\156\156\230\138\151\230\128\167\229\133\137\231\142\175",
        ["Frost Resistance Totem"]="\230\138\151\229\175\146\229\155\190\232\133\190",
        ["Frost Resistance"]="\229\134\176\233\156\156\230\138\151\230\128\167",
        ["Frost Shock"]="\229\134\176\233\156\156\233\156\135\229\135\187",
        ["Frost Trap"]="\229\134\176\233\156\156\233\153\183\233\152\177",
        ["Frost Ward"]="\233\152\178\230\138\164\229\134\176\233\156\156\231\187\147\231\149\140",
        ["Frostbite"]="\233\156\156\229\175\146\229\136\186\233\170\168",
        ["Frostbolt"]="\229\175\146\229\134\176\231\174\173",
        ["Frostbrand Weapon"]="\229\134\176\229\176\191\230\173\166\229\153\168",
        ["Furious Howl"]="\231\139\130\230\128\146\228\185\139\229\154\142",
        ["Furor"]="\230\191\128\230\128\146",
        ["Garrote"]="\231\187\158\229\150\137",
        ["Generic"]="Generic",
        ["Ghost Wolf"]="\229\185\189\233\173\130\228\185\139\231\139\188",
        ["Ghostly Strike"]="\233\172\188\233\173\133\230\148\187\229\135\187",
        ["Gift of Nature"]="\232\135\170\231\132\182\232\181\191\231\166\191",
        ["Gift of the Wild"]="\233\135\142\230\128\167\232\181\191\231\166\191",
        ["Gouge"]="\229\135\191\229\135\187",
        ["Grace of Air Totem"]="\233\163\142\228\185\139\228\188\152\233\155\133\229\155\190\232\133\190",
        ["Great Stamina"]="\230\140\191\228\185\133\232\128\191\229\138\155",
        ["Greater Heal"]="\229\188\186\230\149\136\230\178\187\231\150\151\230\156\175",
        ["Grim Reach"]="\230\151\160\230\131\133\229\187\182\228\188\184",
        ["Grounding Totem"]="\230\160\185\229\159\186\229\155\190\232\133\190",
        ["Grovel"]="\229\140\191\229\140\191",
        ["Growl"]="\228\189\142\229\191\188",
        ["Guardian's Favor"]="\229\188\186\229\140\150\228\191\191\230\138\164\231\165\191\231\166\191",
        ["Gun Specialization"]="\230\158\170\230\162\176\228\184\147\231\178\190",
        ["Guns"]="\230\158\170\230\162\176",
        ["Hammer of Justice"]="\229\136\182\232\163\191\228\185\139\233\148\164",
        ["Hammer of Wrath"]="\230\132\164\230\128\146\228\185\139\233\148\164",
        ["Hamstring"]="\230\150\173\231\173\139",
        ["Harass"]="\228\190\181\230\137\176",
        ["Hardiness"]="\229\191\154\233\159\167",
        ["Hawk Eye"]="\233\185\176\231\156\188",
        ["Heal"]="\230\178\187\231\150\151\230\156\175",
        ["Healing Focus"]="\229\188\186\229\140\150\229\191\171\233\128\159\230\178\187\231\150\151",
        ["Healing Light"]="\229\188\186\229\140\150\229\156\163\229\133\137\230\156\175",
        ["Healing Stream Totem"]="\230\178\187\231\150\151\228\185\139\230\179\137\229\155\190\232\133\190",
        ["Healing Touch"]="\230\178\187\231\150\151\228\185\139\232\167\166",
        ["Healing Wave"]="\230\178\187\231\150\151\230\179\162",
        ["Health Funnel"]="\231\148\159\229\145\189\233\128\154\233\191\147",
        ["Heart of the Wild"]="\233\135\142\230\128\167\228\185\139\229\191\131",
        ["Hellfire Effect"]="\229\156\176\231\139\177\231\131\136\231\132\176\230\149\136\230\158\156",
        ["Hellfire"]="\229\156\176\231\139\177\231\131\136\231\132\176",
        ["Hemorrhage"]="\229\135\186\232\161\128",
        ["Herb Gathering"]="\233\135\135\233\155\134\239\191\189?\239\191\189\239\191\189?\239\191\189",
        ["Heroic Strike"]="\232\139\177\229\139\135\230\137\147\229\135\187",
        ["Hex of Weakness"]="\232\153\154\229\188\177\229\166\150\230\156\175",
        ["Hibernate"]="\228\188\145\231\156\160",
        ["Holy Fire"]="\231\165\158\229\156\163\228\185\139\231\191\171",
        ["Holy Light"]="\229\156\163\229\133\137\230\156\175",
        ["Holy Nova"]="\231\165\158\229\156\163\230\150\176\230\152\159",
        ["Holy Power"]="\231\165\158\229\156\163\229\188\186\229\140\150",
        ["Holy Shield"]="\231\165\158\229\156\163\228\185\139\231\155\190",
        ["Holy Shock"]="\231\165\158\229\156\163\233\156\135\229\135\187",
        ["Holy Specialization"]="\231\165\158\229\156\163\228\184\147\231\178\190",
        ["Holy Wrath"]="\231\165\158\229\156\163\230\132\164\230\128\146",
        ["Honorless Target"]="\230\151\160\232\191\163\232\170\137\231\155\174\230\160\135",
        ["Horse Riding"]="\233\170\145\230\156\175\239\188\154\233\169\172",
        ["Howl of Terror"]="\230\191\191\230\131\167\229\154\142\229\191\171",
        ["Humanoid Slaying"]="\228\186\186\229\158\139\231\148\159\231\137\169\230\191\128\230\137\139",
        ["Hunter's Mark"]="\231\140\142\228\186\186\229\191\176\232\174\176",
        ["Hurricane"]="\233\163\147\233\163\142",
        ["Ice Armor"]="\229\134\176\231\148\178\230\156\175",
        ["Ice Barrier"]="\229\175\146\229\134\176\230\138\164\228\189\147",
        ["Ice Block"]="\229\175\146\229\134\176\229\177\191\233\154\156",
        ["Ice Shards"]="\229\175\146\229\134\176\231\162\142\231\137\135",
        ["Ignite"]="\231\130\185\231\135\131",
        ["Illumination"]="\229\191\175\229\191\145",
        ["Immolate"]="\231\140\174\231\165\173",
        ["Immolation Trap Effect"]="\231\140\174\231\165\173\233\153\183\233\152\177\230\149\136\230\158\156",
        ["Immolation Trap"]="\231\140\174\231\165\173\233\153\183\233\152\177",
        ["Impact"]="\229\134\178\229\135\187",
        ["Impale"]="\231\169\191\229\136\186",
        ["Improved Ambush"]="\229\188\186\229\140\150\228\188\191\229\135\187",
        ["Improved Arcane Explosion"]="\229\188\186\229\140\150\233\173\148\231\136\134\230\156\175",
        ["Improved Arcane Missiles"]="\229\188\186\229\140\150\229\165\165\230\156\175\233\163\158\229\188\185",
        ["Improved Arcane Shot"]="\229\188\186\229\140\150\229\165\165\230\156\175\229\176\132\229\135\187",
        ["Improved Aspect of the Hawk"]="\229\188\186\229\140\150\233\155\132\233\185\176\229\174\136\230\138\164",
        ["Improved Aspect of the Monkey"]="\229\188\186\229\140\150\231\191\181\231\140\180\229\174\136\230\138\164",
        ["Improved Backstab"]="\229\188\186\229\140\150\232\131\140\229\136\186",
        ["Improved Battle Shout"]="\229\188\186\229\140\150\230\136\152\230\150\151\230\128\146\229\191\188",
        ["Improved Berserker Rage"]="\229\188\186\229\140\150\231\139\130\230\154\180\228\185\139\230\128\146",
        ["Improved Blessing of Might"]="\229\188\186\229\140\150\229\138\155\233\135\191\231\165\191\231\166\191",
        ["Improved Blessing of Wisdom"]="\229\188\186\229\140\150\230\153\186\230\133\167\231\165\191\231\166\191",
        ["Improved Blizzard"]="\229\188\186\229\140\150\230\154\180\233\163\142\233\155\170",
        ["Improved Bloodrage"]="\229\188\186\229\140\150\232\161\128\230\128\167\231\139\130\230\154\180",
        ["Improved Chain Heal"]="\229\188\186\229\140\150\230\178\187\231\150\151\233\147\190",
        ["Improved Chain Lightning"]="\229\188\186\229\140\150\233\151\170\231\148\181\233\147\190",
        ["Improved Challenging Shout"]="\229\188\186\229\140\150\230\140\145\230\136\152\230\128\146\229\191\188",
        ["Improved Charge"]="\229\188\186\229\140\150\229\134\178\233\148\139",
        ["Improved Cheap Shot"]="\229\188\186\229\140\150\229\191\183\232\162\173",
        ["Improved Cleave"]="\229\188\186\229\140\150\233\161\186\229\138\136\230\150\169",
        ["Improved Concentration Aura"]="\229\188\186\229\140\150\228\184\147\230\179\168\229\133\137\231\142\175",
        ["Improved Concussive Shot"]="\229\188\186\229\140\150\233\156\135\232\191\161\229\176\132\229\135\187",
        ["Improved Cone of Cold"]="\229\188\186\229\140\150\229\134\176\233\148\165\230\156\175",
        ["Improved Corruption"]="\229\188\186\229\140\150\232\133\191\232\154\128\230\156\175",
        ["Improved Counterspell"]="\229\188\186\229\140\150\230\179\149\230\156\175\229\191\191\229\136\182",
        ["Improved Curse of Agony"]="\229\188\186\229\140\150\231\151\155\232\139\166\232\175\133\229\146\146",
        ["Improved Curse of Exhaustion"]="\229\188\186\229\140\150\231\150\178\229\138\179\232\175\133\229\146\146",
        ["Improved Curse of Weakness"]="\229\188\186\229\140\150\232\153\154\229\188\177\232\175\133\229\146\146",
        ["Improved Dampen Magic"]="\229\188\186\229\140\150\233\173\148\230\179\149\230\138\145\229\136\182",
        ["Improved Deadly Poison"]="\229\188\186\229\140\150\232\135\180\229\145\189\230\175\146\232\191\175",
        ["Improved Demoralizing Shout"]="\229\188\186\229\140\150\230\140\171\229\191\151\230\128\146\229\191\188",
        ["Improved Devotion Aura"]="\229\188\186\229\140\150\232\153\148\232\175\154\229\133\137\231\142\175",
        ["Improved Disarm"]="\229\188\186\229\140\150\231\188\180\230\162\176",
        ["Improved Distract"]="\229\188\186\229\140\150\230\137\176\228\185\177",
        ["Improved Drain Life"]="\229\188\186\229\140\150\229\191\184\229\191\150\231\148\159\229\145\189",
        ["Improved Drain Mana"]="\229\188\186\229\140\150\229\191\184\229\191\150\230\179\149\229\138\155",
        ["Improved Drain Soul"]="\229\188\186\229\140\150\229\191\184\229\191\150\231\191\181\233\173\130",
        ["Improved Enrage"]="\229\188\186\229\140\150\231\139\130\230\128\146",
        ["Improved Enslave Demon"]="\229\188\186\229\140\150\229\165\180\229\189\185\230\191\182\233\173\148",
        ["Improved Entangling Roots"]="\229\188\186\229\140\150\231\186\160\231\188\160\230\160\185\233\161\187",
        ["Improved Evasion"]="\229\188\186\229\140\150\233\151\170\233\191\191",
        ["Improved Eviscerate"]="\229\188\186\229\140\150\229\137\148\233\170\168",
        ["Improved Execute"]="\229\188\186\229\140\150\230\150\169\230\191\128",
        ["Improved Expose Armor"]="\229\188\186\229\140\150\231\160\180\231\148\178",
        ["Improved Eyes of the Beast"]="\229\188\186\229\140\150\233\135\142\229\133\189\228\185\139\231\156\188",
        ["Improved Fade"]="\229\188\186\229\140\150\230\184\191\233\154\191\230\156\175",
        ["Improved Feign Death"]="\229\188\186\229\140\150\229\191\135\230\173\187",
        ["Improved Fire Blast"]="\229\188\186\229\140\150\231\191\171\231\132\176\229\134\178\229\135\187",
        ["Improved Fire Nova Totem"]="\229\188\186\229\140\150\231\191\171\231\132\176\230\150\176\230\152\159\229\155\190\232\133\190",
        ["Improved Fire Ward"]="\229\188\186\229\140\150\233\152\178\230\138\164\231\191\171\231\132\176\231\187\147\231\149\140",
        ["Improved Fireball"]="\229\188\186\229\140\150\231\191\171\231\191\131\230\156\175",
        ["Improved Firebolt"]="\229\188\186\229\140\150\231\191\171\231\132\176\231\174\173",
        ["Improved Firestone"]="\229\188\186\229\140\150\231\191\171\231\132\176\231\159\179",
        ["Improved Flamestrike"]="\229\188\186\229\140\150\231\131\136\231\132\176\233\163\142\230\154\180",
        ["Improved Flametongue Weapon"]="\229\188\186\229\140\150\231\191\171\232\136\140\230\173\166\229\153\168",
        ["Improved Flash of Light"]="\229\188\186\229\140\150\229\156\163\229\133\137\233\151\170\231\142\176",
        ["Improved Frost Nova"]="\229\188\186\229\140\150\229\134\176\233\156\156\230\150\176\230\152\159",
        ["Improved Frost Ward"]="\229\188\186\229\140\150\233\152\178\230\138\164\229\134\176\233\156\156\231\187\147\231\149\140",
        ["Improved Frostbolt"]="\229\188\186\229\140\150\229\175\146\229\134\176\231\174\173",
        ["Improved Frostbrand Weapon"]="\229\188\186\229\140\150\229\134\176\229\176\191\230\173\166\229\153\168",
        ["Improved Garrote"]="\229\188\186\229\140\150\231\187\158\229\150\137",
        ["Improved Ghost Wolf"]="\229\188\186\229\140\150\229\185\189\233\173\130\228\185\139\231\139\188",
        ["Improved Gouge"]="\229\188\186\229\140\150\229\135\191\229\135\187",
        ["Improved Grace of Air Totem"]="\229\188\186\229\140\150\233\163\142\228\185\139\228\188\152\233\155\133\229\155\190\232\133\190",
        ["Improved Grounding Totem"]="\229\188\186\229\140\150\230\160\185\229\159\186\229\155\190\232\133\190",
        ["Improved Hammer of Justice"]="\229\188\186\229\140\150\229\133\172\230\173\163\229\156\163\229\191\176",
        ["Improved Hamstring"]="\229\188\186\229\140\150\230\150\173\231\173\139",
        ["Improved Healing Stream Totem"]="\229\188\186\229\140\150\230\178\187\231\150\151\228\185\139\230\179\137\229\155\190\232\133\190",
        ["Improved Healing Touch"]="\229\188\186\229\140\150\230\178\187\231\150\151\228\185\139\232\167\166",
        ["Improved Healing Wave"]="\229\188\186\229\140\150\230\178\187\231\150\151\230\179\162",
        ["Improved Healing"]="\229\188\186\229\140\150\230\178\187\231\150\151\230\156\175",
        ["Improved Health Funnel"]="\229\188\186\229\140\150\231\148\159\229\145\189\233\128\154\233\191\147",
        ["Improved Healthstone"]="\229\188\186\229\140\150\230\178\187\231\150\151\231\159\179",
        ["Improved Heroic Strike"]="\229\188\186\229\140\150\232\139\177\229\139\135\230\137\147\229\135\187",
        ["Improved Hunter's Mark"]="\229\188\186\229\140\150\231\140\142\228\186\186\229\191\176\232\174\176",
        ["Improved Immolate"]="\229\188\186\229\140\150\231\140\174\231\165\173",
        ["Improved Imp"]="\229\188\186\229\140\150\229\176\191\233\172\188",
        ["Improved Inner Fire"]="\229\188\186\229\140\150\229\191\131\231\191\181\228\185\139\231\191\171",
        ["Improved Instant Poison"]="\229\188\186\229\140\150\233\128\159\230\149\136\230\175\146\232\191\175",
        ["Improved Intercept"]="\229\188\186\229\140\150\230\139\166\230\136\170",
        ["Improved Intimidating Shout"]="\229\188\186\229\140\150\231\160\180\232\131\134\230\128\146\229\191\188",
        ["Improved Kick"]="\229\188\186\229\140\150\232\132\154\232\184\162",
        ["Improved Kidney Shot"]="\229\188\186\229\140\150\232\130\190\229\135\187",
        ["Improved Lash of Pain"]="\229\188\186\229\140\150\229\137\167\231\151\155\233\158\173\231\172\158",
        ["Improved Lay on Hands"]="\229\188\186\229\140\150\229\156\163\231\150\151\230\156\175",
        ["Improved Lesser Healing Wave"]="\229\188\186\229\140\150\230\172\161\231\186\167\230\178\187\231\150\151\230\179\162",
        ["Improved Life Tap"]="\229\188\186\229\140\150\231\148\159\229\145\189\229\136\134\230\181\191",
        ["Improved Lightning Bolt"]="\229\188\186\229\140\150\233\151\170\231\148\181\231\174\173",
        ["Improved Lightning Shield"]="\229\188\186\229\140\150\233\151\170\231\148\181\228\185\139\231\155\190",
        ["Improved Magma Totem"]="\229\188\186\229\140\150\231\134\148\229\178\169\229\155\190\232\133\190",
        ["Improved Mana Burn"]="\229\188\186\229\140\150\230\179\149\229\138\155\231\135\131\231\131\167",
        ["Improved Mana Shield"]="\229\188\186\229\140\150\230\179\149\229\138\155\230\138\164\231\155\190",
        ["Improved Mana Spring Totem"]="\229\188\186\229\140\150\230\179\149\229\138\155\228\185\139\230\179\137\229\155\190\232\133\190",
        ["Improved Mark of the Wild"]="\229\188\186\229\140\150\233\135\142\230\128\167\229\191\176\232\174\176",
        ["Improved Mend Pet"]="\229\188\186\229\140\150\230\178\187\231\150\151\229\174\160\231\137\169",
        ["Improved Mind Blast"]="\229\188\186\229\140\150\229\191\131\231\191\181\233\156\135\231\136\134",
        ["Improved Moonfire"]="\229\188\186\229\140\150\230\156\136\231\191\171\230\156\175",
        ["Improved Nature's Grasp"]="\229\188\186\229\140\150\232\135\170\231\132\182\228\185\139\230\191\161",
        ["Improved Overpower"]="\229\188\186\229\140\150\229\142\139\229\136\182",
        ["Improved Power Word: Fortitude"]="\229\188\186\229\140\150\231\156\159\232\168\128\230\156\175\239\188\154\233\159\167",
        ["Improved Power Word: Shield"]="\229\188\186\229\140\150\231\156\159\232\168\128\230\156\175\239\188\154\231\155\190",
        ["Improved Prayer of Healing"]="\229\188\186\229\140\150\230\178\187\231\150\151\231\165\183\232\168\128",
        ["Improved Psychic Scream"]="\229\188\186\229\140\150\229\191\131\231\191\181\229\176\150\229\149\184",
        ["Improved Pummel"]="\229\188\186\229\140\150\230\139\179\229\135\187",
        ["Improved Regrowth"]="\229\188\186\229\140\150\230\132\136\229\191\136",
        ["Improved Reincarnation"]="\229\188\186\229\140\150\229\164\191\231\148\159",
        ["Improved Rejuvenation"]="\229\188\186\229\140\150\229\155\158\230\152\165\230\156\175",
        ["Improved Rend"]="\229\188\186\229\140\150\230\146\149\232\163\130",
        ["Improved Renew"]="\229\188\186\229\140\150\230\191\162\229\164\191",
        ["Improved Retribution Aura"]="\229\188\186\229\140\150\230\131\169\231\189\154\229\133\137\231\142\175",
        ["Improved Revenge"]="\229\188\186\229\140\150\229\164\191\228\187\135",
        ["Improved Revive Pet"]="\229\188\186\229\140\150\229\164\191\230\180\187\229\174\160\231\137\169",
        ["Improved Righteous Fury"]="\229\188\186\229\140\150\230\132\164\230\128\146\229\156\163\229\191\176",
        ["Improved Rockbiter Weapon"]="\229\188\186\229\140\150\231\159\179\229\140\150\230\173\166\229\153\168",
        ["Improved Rupture"]="\229\188\186\229\140\150\229\137\178\232\163\130",
        ["Improved Sap"]="\229\188\186\229\140\150\233\151\183\230\163\191",
        ["Improved Scorch"]="\229\188\186\229\140\150\231\191\188\231\131\167",
        ["Improved Scorpid Sting"]="\229\188\186\229\140\150\230\175\146\232\191\142\233\146\137\229\136\186",
        ["Improved Seal of Righteousness"]="\229\188\186\229\140\150\230\173\163\228\185\137\229\156\163\229\191\176",
        ["Improved Seal of the Crusader"]="\229\188\186\229\140\150\229\191\191\229\173\151\229\134\155\229\156\163\229\191\176",
        ["Improved Searing Pain"]="\229\188\186\229\140\150\231\191\188\231\131\173\228\185\139\231\151\155",
        ["Improved Searing Totem"]="\229\188\186\229\140\150\231\191\188\231\131\173\229\155\190\232\133\190",
        ["Improved Serpent Sting"]="\229\188\186\229\140\150\230\175\146\232\155\135\233\146\137\229\136\186",
        ["Improved Shadow Bolt"]="\229\188\186\229\140\150\230\154\151\229\189\177\231\174\173",
        ["Improved Shadow Word: Pain"]="\229\188\186\229\140\150\230\154\151\232\168\128\230\156\175\239\188\154\231\151\155",
        ["Improved Shield Bash"]="\229\188\186\229\140\150\231\155\190\229\135\187",
        ["Improved Shield Block"]="\229\188\186\229\140\150\231\155\190\231\137\140\230\160\188\230\140\161",
        ["Improved Shield Wall"]="\229\188\186\229\140\150\231\155\190\229\162\153",
        ["Improved Shred"]="\229\188\186\229\140\150\230\146\149\231\162\142",
        ["Improved Sinister Strike"]="\229\188\186\229\140\150\233\130\170\230\191\182\230\148\187\229\135\187",
        ["Improved Slam"]="\229\188\186\229\140\150\231\140\155\229\135\187",
        ["Improved Slice and Dice"]="\229\188\186\229\140\150\229\136\135\229\137\178",
        ["Improved Spellstone"]="\229\188\186\229\140\150\230\179\149\230\156\175\231\159\179",
        ["Improved Sprint"]="\229\188\186\229\140\150\231\150\190\232\183\145",
        ["Improved Starfire"]="\229\188\186\229\140\150\230\152\159\231\191\171\230\156\175",
        ["Improved Stoneclaw Totem"]="\229\188\186\229\140\150\231\159\179\231\136\170\229\155\190\232\133\190",
        ["Improved Stoneskin Totem"]="\229\188\186\229\140\150\231\159\179\232\130\164\229\155\190\232\133\190",
        ["Improved Strength of Earth Totem"]="\229\188\186\229\140\150\229\164\167\229\156\176\228\185\139\229\138\155\229\155\190\232\133\190",
        ["Improved Succubus"]="\229\188\186\229\140\150\233\173\133\233\173\148",
        ["Improved Sunder Armor"]="\229\188\186\229\140\150\231\160\180\231\148\178\230\148\187\229\135\187",
        ["Improved Taunt"]="\229\188\186\229\140\150\229\152\178\232\174\189",
        ["Improved Thorns"]="\229\188\186\229\140\150\232\191\134\230\163\152\230\156\175",
        ["Improved Thunder Clap"]="\229\188\186\229\140\150\233\155\183\233\156\134\228\184\128\229\135\187",
        ["Improved Tranquility"]="\229\188\186\229\140\150\229\174\191\233\191\153",
        ["Improved Vanish"]="\229\188\186\229\140\150\230\182\136\229\164\177",
        ["Improved Voidwalker"]="\229\188\186\229\140\150\232\153\154\231\169\186\232\161\140\232\128\133",
        ["Improved Windfury Weapon"]="\229\188\186\229\140\150\233\163\142\230\128\146\230\173\166\229\153\168",
        ["Improved Wing Clip"]="\229\188\186\229\140\150\230\145\148\231\187\138",
        ["Improved Wrath"]="\229\188\186\229\140\150\230\132\164\230\128\146",
        ["Incinerate"]="\231\131\167\229\176\189",
        ["Inferno"]="\229\156\176\231\139\177\231\191\171",
        ["Initiative"]="\229\133\136\229\191\145\229\136\182\228\186\186",
        ["Inner Fire"]="\229\191\131\231\191\181\228\185\139\231\191\171",
        ["Inner Focus"]="\229\191\131\231\191\181\228\184\147\230\179\168",
        ["Innervate"]="\230\191\128\230\180\187",
        ["Insect Swarm"]="\232\153\171\231\190\164",
        ["Inspiration"]="\231\191\181\230\132\159",
        ["Instant Poison II"]="\233\128\159\230\149\136\230\175\146\232\191\175 II",
        ["Instant Poison III"]="\233\128\159\230\149\136\230\175\146\232\191\175 III",
        ["Instant Poison IV"]="\233\128\159\230\149\136\230\175\146\232\191\175 IV",
        ["Instant Poison V"]="\233\128\159\230\149\136\230\175\146\232\191\175 V",
        ["Instant Poison VI"]="\233\128\159\230\149\136\230\175\146\232\191\175 VI",
        ["Instant Poison"]="\233\128\159\230\149\136\230\175\146\232\191\175",
        ["Intensity"]="\229\188\186\231\131\136",
        ["Intercept"]="\230\139\166\230\136\170",
        ["Intimidating Shout"]="\231\160\180\232\131\134\230\128\146\229\191\188",
        ["Intimidation"]="\232\131\191\232\191\171",
        ["Iron Will"]="\233\146\162\233\147\191\230\132\191\229\191\151",
        ["Judgement of Command"]="\229\145\189\228\187\164\229\174\161\229\136\164",
        ["Judgement of Justice"]="\230\173\163\228\185\137\229\174\161\229\136\164",
        ["Judgement of Light"]="\229\156\163\229\133\137\229\174\161\229\136\164",
        ["Judgement of Righteousness"]="\230\173\163\228\185\137\229\156\163\229\191\176",
        ["Judgement of Wisdom"]="\230\153\186\230\133\167\229\174\161\229\136\164",
        ["Judgement of the Crusader"]="\229\191\191\229\173\151\229\134\155\229\174\161\229\136\164",
        ["Judgement"]="\229\174\161\229\136\164",
        ["Kick"]="\232\132\154\232\184\162",
        ["Kidney Shot"]="\232\130\190\229\135\187",
        ["Killer Instinct"]="\230\191\128\230\136\174\230\156\172\232\131\189",
        ["Kodo Riding"]="\233\170\145\230\156\175\239\188\154\231\167\145\229\164\154\229\133\189",
        ["Lash of Pain"]="\229\137\167\231\151\155\233\158\173\231\172\158",
        ["Last Stand"]="\231\160\180\233\135\156\230\178\137\232\136\159",
        ["Lasting Judgement"]="\229\188\186\229\140\150\229\133\137\230\152\142\229\156\163\229\191\176",
        ["Lay on Hands"]="\229\156\163\231\150\151\230\156\175",
        ["Leader of the Pack"]="\229\133\189\231\190\164\233\162\134\232\162\150",
        ["Leather"]="\231\154\174\233\191\169",
        ["Leatherworking"]="\229\136\182\231\154\174",
        ["Lesser Heal"]="\230\172\161\231\186\167\230\178\187\231\150\151\230\156\175",
        ["Lesser Healing Wave"]="\230\172\161\231\186\167\230\178\187\231\150\151\230\179\162",
        ["Lesser Invisibility"]="\230\172\161\231\186\167\233\154\191\229\189\162\230\156\175",
        ["Lethal Shots"]="\229\164\186\229\145\189\229\176\132\229\135\187",
        ["Lethality"]="\232\135\180\229\145\189\229\191\183\232\162\173",
        ["Levitate"]="\230\188\130\230\181\174\230\156\175",
        ["Life Tap"]="\231\148\159\229\145\189\229\136\134\230\181\191",
        ["Lightning Bolt"]="\233\151\170\231\148\181\231\174\173",
        ["Lightning Breath"]="\233\151\170\231\148\181\229\191\191\230\191\175",
        ["Lightning Mastery"]="\233\151\170\231\148\181\230\142\140\230\191\161",
        ["Lightning Reflexes"]="\233\151\170\231\148\181\229\191\191\229\176\132",
        ["Lightning Shield"]="\233\151\170\231\148\181\228\185\139\231\155\190",
        ["Lightwell Renew"]="zzOLDSpell - Reuse 7001",
        ["Lightwell"]="zzOLDSpell - Reuse 724",
        ["Long Daze"]="\233\149\191\230\151\182\233\151\180\231\156\169\230\153\149",
        ["Mace Specialization"]="\233\148\164\231\177\187\230\173\166\229\153\168\228\184\147\231\178\190",
        ["Mace Stun Effect"]="\233\148\164\229\135\187\230\152\191\232\191\183\230\149\136\230\158\156",
        ["Mage Armor"]="\233\173\148\231\148\178\230\156\175",
        ["Magma Totem"]="\231\134\148\229\178\169\229\155\190\232\133\190",
        ["Mail"]="\233\148\191\231\148\178",
        ["Malice"]="\230\191\182\230\132\191",
        ["Mana Burn"]="\230\179\149\229\138\155\231\135\131\231\131\167",
        ["Mana Shield"]="\230\179\149\229\138\155\230\138\164\231\155\190",
        ["Mana Spring Totem"]="\230\179\149\229\138\155\228\185\139\230\179\137\229\155\190\232\133\190",
        ["Mana Tide Totem"]="\230\179\149\229\138\155\228\185\139\230\189\174\229\155\190\232\133\190",
        ["Mangle"]="\229\137\178\231\162\142",
        ["Mark of the Wild"]="\233\135\142\230\128\167\229\191\176\232\174\176",
        ["Martyrdom"]="\230\174\137\233\154\190",
        ["Master Demonologist"]="\230\191\182\233\173\148\229\173\166\232\175\134\229\164\167\229\184\136",
        ["Master Summoner"]="\229\191\172\229\148\164\229\164\167\229\184\136",
        ["Master of Deception"]="\230\172\186\232\175\136\233\171\152\230\137\139",
        ["Maul"]="\230\167\140\229\135\187",
        ["Mechanostrider Piloting"]="\233\170\145\230\156\175\239\188\154\230\156\186\230\162\176\233\153\134\232\161\140\233\184\159",
        ["Meditation"]="\229\134\165\230\131\179",
        ["Melee Specialization"]="\232\191\145\230\136\152\228\184\147\231\178\190",
        ["Mend Pet"]="\230\178\187\231\150\151\229\174\160\231\137\169",
        ["Mental Agility"]="\231\178\190\231\165\158\230\149\191\233\148\191",
        ["Mental Strength"]="\229\191\131\231\191\181\228\185\139\229\138\155",
        ["Mind Blast"]="\229\191\131\231\191\181\233\156\135\231\136\134",
        ["Mind Control"]="\231\178\190\231\165\158\230\142\167\229\136\182",
        ["Mind Flay"]="\231\178\190\231\165\158\233\158\173\231\172\158",
        ["Mind Soothe"]="\229\174\137\230\138\154\229\191\131\231\191\181",
        ["Mind Vision"]="\229\191\131\231\191\181\232\167\134\231\149\140",
        ["Mind-numbing Poison II"]="\233\186\187\231\151\185\230\175\146\232\191\175 II",
        ["Mind-numbing Poison III"]="\233\186\187\231\151\185\230\175\146\232\191\175 III",
        ["Mind-numbing Poison"]="\233\186\187\231\151\185\230\175\146\232\191\175",
        ["Mining"]="\233\135\135\231\159\191",
        ["Mocking Blow"]="\230\131\169\230\136\146\231\151\155\229\135\187",
        ["Mongoose Bite"]="\231\140\171\233\188\172\230\146\149\229\146\172",
        ["Monster Slaying"]="\230\128\170\231\137\169\230\191\128\230\137\139",
        ["Moonfire"]="\230\156\136\231\191\171\230\156\175",
        ["Moonfury"]="\230\156\136\230\128\146",
        ["Moonglow"]="\230\156\136\229\133\137",
        ["Moonkin Aura"]="\230\158\173\229\133\189\229\133\137\231\142\175",
        ["Moonkin Form"]="\230\158\173\229\133\189\229\189\162\230\128\191\239\188\136\232\162\171\229\138\168\239\188\137",
        ["Mortal Shots"]="\232\135\180\230\173\187\229\176\132\229\135\187",
        ["Mortal Strike"]="\232\135\180\230\173\187\230\137\147\229\135\187",
        ["Multi-Shot"]="\229\164\154\233\135\191\229\176\132\229\135\187",
        ["Murder"]="\232\176\139\230\191\128",
        ["Natural Armor"]="\232\135\170\231\132\182\230\138\164\231\148\178",
        ["Natural Shapeshifter"]="\232\135\170\231\132\182\229\191\152\229\189\162",
        ["Natural Weapons"]="\230\173\166\229\153\168\229\185\179\232\161\161",
        ["Nature Resistance Totem"]="\232\135\170\231\132\182\230\138\151\230\128\167\229\155\190\232\133\190",
        ["Nature Resistance"]="\232\135\170\231\132\182\230\138\151\230\128\167",
        ["Nature's Focus"]="\232\135\170\231\132\182\233\155\134\228\184\173",
        ["Nature's Grace"]="\232\135\170\231\132\182\228\185\139\232\181\191",
        ["Nature's Grasp"]="\232\135\170\231\132\182\228\185\139\230\191\161",
        ["Nature's Reach"]="\232\135\170\231\132\182\229\187\182\228\188\184",
        ["Nature's Swiftness"]="\232\135\170\231\132\182\232\191\133\230\191\183",
        ["Nightfall"]="\229\164\156\229\185\149",
        ["Omen of Clarity"]="\230\184\133\230\153\176\233\162\132\229\133\134",
        ["One-Handed Axes"]="\229\191\149\230\137\139\230\150\167",
        ["One-Handed Maces"]="\229\191\149\230\137\139\233\148\164",
        ["One-Handed Swords"]="\229\191\149\230\137\139\229\137\145",
        ["One-Handed Weapon Specialization"]="\229\191\149\230\137\139\230\173\166\229\153\168\228\184\147\231\178\190",
        ["Opening - No Text"]="Opening - No Text",
        ["Opening"]="\230\137\147\229\188\128",
        ["Opportunity"]="\228\188\186\230\156\186\232\128\140\229\138\168",
        ["Overpower"]="\229\142\139\229\136\182",
        ["Paranoia"]="\229\164\154\231\150\145",
        ["Parry"]="\230\139\155\230\158\182",
        ["Pathfinding"]="\229\175\187\232\183\175",
        ["Perception"]="\230\132\159\231\159\165",
        ["Permafrost"]="\230\158\191\229\175\146\229\134\176\233\156\156",
        ["Pet Aggression"]="\229\174\160\231\137\169\229\165\189\230\150\151",
        ["Pet Hardiness"]="\229\174\160\231\137\169\232\128\191\228\185\133",
        ["Pet Recovery"]="\229\174\160\231\137\169\230\191\162\229\164\191",
        ["Pet Resistance"]="\229\174\160\231\137\169\230\138\151\233\173\148",
        ["Phase Shift"]="\231\155\184\228\189\191\229\191\152\230\191\162",
        ["Pick Lock"]="\229\188\128\233\148\191",
        ["Pick Pocket"]="\229\191\183\231\170\131",
        ["Piercing Howl"]="\229\136\186\232\128\179\230\128\146\229\191\188",
        ["Piercing Ice"]="\229\136\186\233\170\168\229\175\146\229\134\176",
        ["Plate Mail"]="\230\191\191\231\148\178",
        ["Poison Cleansing Totem"]="\230\184\133\230\175\146\229\155\190\232\133\190",
        ["Poisons"]="\230\175\146\232\191\175",
        ["Polearm Specialization"]="\233\149\191\230\159\132\230\173\166\229\153\168\228\184\147\231\178\190",
        ["Polearms"]="\233\149\191\230\159\132\230\173\166\229\153\168",
        ["Polymorph"]="\229\191\152\229\189\162\230\156\175",
        ["Portal: Darnassus"]="\228\188\160\233\128\191\233\151\168\239\188\154\232\190\190\231\186\179\232\139\191\230\150\175",
        ["Portal: Ironforge"]="\228\188\160\233\128\191\233\151\168\239\188\154\233\147\191\231\130\137\229\160\161",
        ["Portal: Orgrimmar"]="\228\188\160\233\128\191\233\151\168\239\188\154\229\165\165\230\160\188\231\145\158\231\142\155",
        ["Portal: Stormwind"]="\228\188\160\233\128\191\233\151\168\239\188\154\230\154\180\233\163\142\229\159\142",
        ["Portal: Thunder Bluff"]="\228\188\160\233\128\191\233\151\168\239\188\154\233\155\183\233\156\134\229\180\150",
        ["Portal: Undercity"]="\228\188\160\233\128\191\233\151\168\239\188\154\229\185\189\230\154\151\229\159\142",
        ["Pounce Bleed"]="\232\161\128\232\162\173",
        ["Pounce"]="\231\170\191\232\162\173",
        ["Power Infusion"]="zzOLDSpell - Reuse 10060",
        ["Power Word: Fortitude"]="\231\156\159\232\168\128\230\156\175\239\188\154\233\159\167",
        ["Power Word: Shield"]="\231\156\159\232\168\128\230\156\175\239\188\154\231\155\190",
        ["Prayer of Fortitude"]="\229\191\154\233\159\167\231\165\183\232\168\128",
        ["Prayer of Healing"]="\230\178\187\231\150\151\231\165\183\232\168\128",
        ["Precision"]="\231\178\190\231\161\174",
        ["Predatory Strikes"]="\231\140\155\229\133\189\230\148\187\229\135\187",
        ["Premeditation"]="\233\162\132\232\176\139",
        ["Preparation"]="\228\188\186\230\156\186\229\190\133\229\191\145",
        ["Presence of Mind"]="\230\176\148\229\174\154\231\165\158\233\151\178",
        ["Primal Fury"]="\229\142\159\229\167\139\231\139\130\230\128\146",
        ["Prowl"]="\230\189\156\228\188\191",
        ["Psychic Scream"]="\229\191\131\231\191\181\229\176\150\229\149\184",
        ["Pummel"]="\230\139\179\229\135\187",
        ["Purge"]="\229\135\128\229\140\150\230\156\175",
        ["Purification"]="\229\135\128\229\140\150",
        ["Purify"]="\231\186\175\229\135\128\230\156\175",
        ["Pyroblast"]="\231\130\142\231\136\134\230\156\175",
        ["Pyroclasm"]="\231\191\171\231\132\176\229\134\178\230\146\158",
        ["Quickness"]="\232\191\133\230\191\183",
        ["Rain of Fire"]="\231\191\171\231\132\176\228\185\139\233\155\168",
        ["Rake"]="\230\137\171\229\135\187",
        ["Ram Riding"]="\233\170\145\230\156\175\239\188\154\231\190\138",
        ["Ranged Weapon Specialization"]="\232\191\156\231\168\139\230\173\166\229\153\168\228\184\147\231\178\190",
        ["Rapid Concealment"]="\232\191\133\233\128\159\233\154\191\232\148\189",
        ["Rapid Fire"]="\230\128\165\233\128\159\229\176\132\229\135\187",
        ["Raptor Riding"]="\233\170\145\230\156\175\239\188\154\232\191\133\231\140\155\233\190\153",
        ["Raptor Strike"]="\231\140\155\231\166\189\228\184\128\229\135\187",
        ["Ravage"]="\230\175\191\231\191\173",
        ["Readiness"]="\229\135\134\229\164\135\229\176\177\231\187\170",
        ["Rebirth"]="\229\164\191\231\148\159",
        ["Recklessness"]="\233\178\191\232\142\189",
        ["Reckoning"]="\230\184\133\231\174\151",
        ["Redemption"]="\230\149\145\232\181\142",
        ["Redoubt"]="\231\155\190\231\137\140\229\163\191\229\158\146",
        ["Reflection"]="\229\191\191\229\176\132",
        ["Regeneration"]="\229\134\191\231\148\159",
        ["Regrowth"]="\230\132\136\229\191\136",
        ["Reincarnation"]="\229\164\191\231\148\159",
        ["Rejuvenation"]="\229\155\158\230\152\165\230\156\175",
        ["Relentless Strikes"]="\230\151\160\230\131\133\230\137\147\229\135\187",
        ["Remorseless Attacks"]="\229\134\183\233\133\183\230\148\187\229\135\187",
        ["Remove Curse"]="\232\167\163\233\153\164\232\175\133\229\146\146",
        ["Remove Insignia"]="\232\167\163\233\153\164\229\190\189\232\174\176",
        ["Remove Lesser Curse"]="\232\167\163\233\153\164\230\172\161\231\186\167\232\175\133\229\146\146",
        ["Rend"]="\230\146\149\232\163\130",
        ["Renew"]="\230\191\162\229\164\191",
        ["Repentance"]="\229\191\191\230\130\148",
        ["Resurrection"]="\229\164\191\230\180\187\230\156\175",
        ["Retaliation"]="\229\191\191\229\135\187\233\163\142\230\154\180",
        ["Retribution Aura"]="\230\131\169\231\189\154\229\133\137\231\142\175",
        ["Revenge Stun"]="\229\164\191\228\187\135\230\152\191\232\191\183",
        ["Revenge"]="\229\164\191\228\187\135",
        ["Reverberation"]="\229\155\158\229\147\191",
        ["Revive Pet"]="\229\164\191\230\180\187\229\174\160\231\137\169",
        ["Rip"]="\230\146\149\230\137\175",
        ["Riposte"]="\232\191\152\229\135\187",
        ["Ritual of Doom Effect"]="\230\156\171\230\151\165\228\187\170\229\188\191\230\149\136\230\158\156",
        ["Ritual of Doom"]="\230\156\171\230\151\165\228\187\170\229\188\191",
        ["Ritual of Summoning"]="\229\191\172\229\148\164\228\187\170\229\188\191",
        ["Rockbiter Weapon"]="\231\159\179\229\140\150\230\173\166\229\153\168",
        ["Rogue Passive"]="Rogue Passive",
        ["Ruin"]="\230\175\191\231\191\173",
        ["Rupture"]="\229\137\178\232\163\130",
        ["Ruthlessness"]="\230\151\160\230\131\133",
        ["Sacrifice"]="\231\137\186\231\137\178",
        ["Safe Fall"]="\229\174\137\229\133\168\233\153\191\232\191\189",
        ["Sanctity Aura"]="\229\156\163\230\180\191\229\133\137\231\142\175",
        ["Sap"]="\233\151\183\230\163\191",
        ["Savage Fury"]="\233\135\142\232\155\174\230\154\180\230\128\146",
        ["Savage Strikes"]="\233\135\142\232\155\174\230\137\147\229\135\187",
        ["Scare Beast"]="\230\191\191\229\191\147\233\135\142\229\133\189",
        ["Scatter Shot"]="\233\169\177\230\149\163\229\176\132\229\135\187",
        ["Scorch"]="\231\191\188\231\131\167",
        ["Scorpid Poison"]="\232\191\142\230\175\146",
        ["Scorpid Sting"]="\230\175\146\232\191\142\233\146\137\229\136\186",
        ["Screech"]="\229\176\150\229\149\184",
        ["Seal Fate"]="\229\176\191\229\191\176\229\145\189\232\191\191",
        ["Seal of Command"]="\229\145\189\228\187\164\229\156\163\229\191\176",
        ["Seal of Justice"]="\229\133\172\230\173\163\229\156\163\229\191\176",
        ["Seal of Light"]="\229\133\137\230\152\142\229\156\163\229\191\176",
        ["Seal of Righteousness"]="\230\173\163\228\185\137\229\156\163\229\191\176",
        ["Seal of Wisdom"]="\230\153\186\230\133\167\229\156\163\229\191\176",
        ["Seal of the Crusader"]="\229\191\191\229\173\151\229\134\155\229\156\163\229\191\176",
        ["Searing Light"]="\229\188\186\229\140\150\230\131\169\229\135\187",
        ["Searing Pain"]="\231\191\188\231\131\173\228\185\139\231\151\155",
        ["Searing Totem"]="\231\191\188\231\131\173\229\155\190\232\133\190",
        ["Seduction"]="\232\175\177\230\131\145",
        ["Sense Demons"]="\230\132\159\231\159\165\230\191\182\233\173\148",
        ["Sense Undead"]="\230\132\159\231\159\165\228\186\161\231\191\181",
        ["Sentry Totem"]="\229\178\151\229\147\168\229\155\190\232\133\190",
        ["Serpent Sting"]="\230\175\146\232\155\135\233\146\137\229\136\186",
        ["Setup"]="\232\176\131\230\149\180",
        ["Shackle Undead"]="\230\191\159\231\188\154\228\186\161\231\191\181",
        ["Shadow Affinity"]="\230\154\151\229\189\177\228\186\178\229\146\140",
        ["Shadow Bolt"]="\230\154\151\229\189\177\231\174\173",
        ["Shadow Focus"]="\230\154\151\229\189\177\233\155\134\228\184\173",
        ["Shadow Mastery"]="\230\154\151\229\189\177\230\142\140\230\191\161",
        ["Shadow Protection"]="\233\152\178\230\138\164\230\154\151\229\189\177",
        ["Shadow Reach"]="\230\154\151\229\189\177\229\187\182\228\188\184",
        ["Shadow Resistance Aura"]="\230\154\151\229\189\177\230\138\151\230\128\167\229\133\137\231\142\175",
        ["Shadow Resistance"]="\230\154\151\229\189\177\230\138\151\230\128\167",
        ["Shadow Ward"]="\233\152\178\230\138\164\230\154\151\229\189\177\231\187\147\231\149\140",
        ["Shadow Weaving"]="\230\154\151\229\189\177\228\185\139\230\179\162",
        ["Shadow Word: Pain"]="\230\154\151\232\168\128\230\156\175\239\188\154\231\151\155",
        ["Shadowburn"]="\230\154\151\229\189\177\231\191\188\231\131\167",
        ["Shadowform"]="\230\154\151\229\189\177\229\189\162\230\128\191",
        ["Shadowguard"]="\230\154\151\229\189\177\229\174\136\229\191\171",
        ["Shadowmeld Passive"]="\229\189\177\233\191\191",
        ["Shadowmeld"]="\229\189\177\233\191\191",
        ["Sharpened Claws"]="\233\148\139\229\136\169\229\133\189\231\136\170",
        ["Shatter"]="\231\162\142\229\134\176",
        ["Shield Bash"]="\231\155\190\229\135\187",
        ["Shield Block"]="\231\155\190\231\137\140\230\160\188\230\140\161",
        ["Shield Slam"]="\231\155\190\231\137\140\231\140\155\229\135\187",
        ["Shield Specialization"]="\231\155\190\231\137\140\228\184\147\231\178\190",
        ["Shield Wall"]="\231\155\190\229\162\153",
        ["Shield"]="\231\155\190\231\137\140",
        ["Shoot Bow"]="\229\188\147\229\176\132\229\135\187",
        ["Shoot Crossbow"]="\229\188\169\229\176\132\229\135\187",
        ["Shoot Gun"]="\230\158\170\230\162\176\229\176\132\229\135\187",
        ["Shoot"]="\229\176\132\229\135\187",
        ["Shred"]="\230\146\149\231\162\142",
        ["Silence"]="\230\178\137\233\187\152",
        ["Silent Resolve"]="\230\151\160\229\163\176\230\182\136\233\128\128",
        ["Sinister Strike"]="\233\130\170\230\191\182\230\148\187\229\135\187",
        ["Siphon Life"]="\231\148\159\229\145\189\232\153\185\229\191\184",
        ["Skinning"]="\229\137\165\231\154\174",
        ["Slam"]="\231\140\155\229\135\187",
        ["Slice and Dice"]="\229\136\135\229\137\178",
        ["Slow Fall"]="\231\188\147\232\191\189\230\156\175",
        ["Smelting"]="\231\134\148\231\130\188",
        ["Smite"]="\230\131\169\229\135\187",
        ["Soothe Animal"]="\229\174\137\230\138\154\229\138\168\231\137\169",
        ["Soothing Kiss"]="\229\174\137\230\138\154\228\185\139\229\191\187",
        ["Soul Fire"]="\231\191\181\233\173\130\228\185\139\231\191\171",
        ["Soul Link"]="\231\191\181\233\173\130\233\147\190\230\142\165",
        ["Spell Lock"]="\230\179\149\230\156\175\229\176\191\233\148\191",
        ["Spirit Bond"]="\231\191\181\233\173\130\232\191\148\231\187\147",
        ["Spirit Tap"]="\231\178\190\231\165\158\229\136\134\230\181\191",
        ["Spirit of Redemption"]="\230\149\145\232\181\142\228\185\139\233\173\130",
        ["Spiritual Focus"]="\231\178\190\231\165\158\233\155\134\228\184\173",
        ["Spiritual Guidance"]="\229\190\174\229\166\153",
        ["Spiritual Healing"]="\231\178\190\231\165\158\230\178\187\231\150\151",
        ["Sprint"]="\231\150\190\232\183\145",
        ["Starfire"]="\230\152\159\231\191\171\230\156\175",
        ["Starshards"]="\230\152\159\232\190\176\231\162\142\231\137\135",
        ["Staves"]="\230\179\149\230\191\150",
        ["Stealth"]="\230\189\156\232\161\140",
        ["Stoneclaw Totem"]="\231\159\179\231\136\170\229\155\190\232\133\190",
        ["Stoneform"]="\231\159\179\229\131\191\229\189\162\230\128\191",
        ["Stoneskin Totem"]="\231\159\179\232\130\164\229\155\190\232\133\190",
        ["Stormstrike"]="\233\163\142\230\154\180\230\137\147\229\135\187",
        ["Strength of Earth Totem"]="\229\164\167\229\156\176\228\185\139\229\138\155\229\155\190\232\133\190",
        ["Stuck"]="\229\191\161\230\173\187",
        ["Subtlety"]="\229\190\174\229\166\153",
        ["Suffering"]="\229\191\151\233\154\190",
        ["Summon Charger"]="\229\191\172\229\148\164\230\136\152\233\169\172",
        ["Summon Dreadsteed"]="\229\191\172\229\148\164\230\191\191\230\131\167\230\136\152\233\169\172",
        ["Summon Felhunter"]="\229\191\172\229\148\164\229\156\176\231\139\177\231\140\142\231\138\172",
        ["Summon Felsteed"]="\229\191\172\229\148\164\229\156\176\231\139\177\230\136\152\233\169\172",
        ["Summon Imp"]="\229\191\172\229\148\164\229\176\191\233\172\188",
        ["Summon Succubus"]="\229\191\172\229\148\164\233\173\133\233\173\148",
        ["Summon Voidwalker"]="\229\191\172\229\148\164\232\153\154\231\169\186\232\161\140\232\128\133",
        ["Summon Warhorse"]="\229\191\172\229\148\164\229\134\155\233\169\172",
        ["Sunder Armor"]="\231\160\180\231\148\178\230\148\187\229\135\187",
        ["Suppression"]="\233\149\135\229\142\139",
        ["Surefooted"]="\231\168\179\229\155\186",
        ["Survivalist"]="\231\148\159\229\173\152\228\184\147\229\174\182",
        ["Sweeping Strikes"]="\230\168\170\230\137\171\230\148\187\229\135\187",
        ["Swipe"]="\230\140\165\229\135\187",
        ["Sword Specialization"]="\229\137\145\231\177\187\230\173\166\229\153\168\228\184\147\231\178\190",
        ["Tactical Mastery"]="\230\136\152\230\156\175\230\142\140\230\191\161",
        ["Tainted Blood"]="\232\133\191\229\191\191\228\185\139\232\161\128",
        ["Tame Beast"]="\233\169\175\230\156\191\233\135\142\229\133\189",
        ["Tamed Pet Passive"]="Tamed Pet Passive",
        ["Taunt"]="\229\152\178\232\174\189",
        ["Teleport: Darnassus"]="\228\188\160\233\128\191\239\188\154\232\190\190\231\186\179\232\139\191\230\150\175",
        ["Teleport: Ironforge"]="\228\188\160\233\128\191\239\188\154\233\147\191\231\130\137\229\160\161",
        ["Teleport: Moonglade"]="\228\188\160\233\128\191\239\188\154\230\156\136\229\133\137\230\158\151\229\156\176",
        ["Teleport: Orgrimmar"]="\228\188\160\233\128\191\239\188\154\229\165\165\230\160\188\231\145\158\231\142\155",
        ["Teleport: Stormwind"]="\228\188\160\233\128\191\239\188\154\230\154\180\233\163\142\229\159\142",
        ["Teleport: Thunder Bluff"]="\228\188\160\233\128\191\239\188\154\233\155\183\233\156\134\229\180\150",
        ["Teleport: Undercity"]="\228\188\160\233\128\191\239\188\154\229\185\189\230\154\151\229\159\142",
        ["The Human Spirit"]="\228\186\186\231\177\187\231\178\190\233\173\130",
        ["Thick Hide"]="\229\142\154\231\154\174",
        ["Thorns"]="\232\191\134\230\163\152\230\156\175",
        ["Throw"]="\230\138\149\230\142\183",
        ["Throwing Specialization"]="\230\138\149\230\142\183\228\184\147\231\178\190",
        ["Throwing Weapon Specialization"]="\230\138\149\230\142\183\230\173\166\229\153\168\228\184\147\231\178\190",
        ["Thrown"]="\230\138\149\230\142\183",
        ["Thunder Clap"]="\233\155\183\233\156\134\228\184\128\229\135\187",
        ["Thundering Strikes"]="\233\155\183\233\184\163\231\140\155\229\135\187",
        ["Tidal Focus"]="\230\189\174\230\177\191\233\155\134\228\184\173",
        ["Tidal Mastery"]="\230\189\174\230\177\191\230\142\140\230\191\161",
        ["Tiger Riding"]="\233\170\145\230\156\175\239\188\154\232\177\185",
        ["Tiger's Fury"]="\231\140\155\232\153\142\228\185\139\230\128\146",
        ["Torment"]="\230\138\152\231\163\168",
        ["Totemic Focus"]="\229\155\190\232\133\190\233\155\134\228\184\173",
        ["Touch of Weakness"]="\232\153\154\229\188\177\228\185\139\232\167\166",
        ["Toughness"]="\229\191\154\233\159\167",
        ["Track Beasts"]="\232\191\189\232\184\170\233\135\142\229\133\189",
        ["Track Demons"]="\232\191\189\232\184\170\230\191\182\233\173\148",
        ["Track Dragonkin"]="\232\191\189\232\184\170\233\190\153\231\177\187",
        ["Track Elementals"]="\232\191\189\232\184\170\229\133\131\231\180\160\231\148\159\231\137\169",
        ["Track Giants"]="\232\191\189\232\184\170\229\183\168\228\186\186",
        ["Track Hidden"]="\232\191\189\232\184\170\233\154\191\232\151\191\231\148\159\231\137\169",
        ["Track Humanoids"]="\232\191\189\232\184\170\228\186\186\229\158\139\231\148\159\231\137\169",
        ["Track Undead"]="\232\191\189\232\184\170\228\186\161\231\191\181",
        ["Tranquil Spirit"]="\229\174\191\233\191\153\228\185\139\233\173\130",
        ["Tranquility"]="\229\174\191\233\191\153",
        ["Tranquilizing Shot"]="\229\174\191\231\165\158\229\176\132\229\135\187",
        ["Trap Mastery"]="\233\153\183\233\152\177\230\142\140\230\191\161",
        ["Travel Form"]="\230\151\133\232\161\140\229\189\162\230\128\191",
        ["Tremor Totem"]="\230\136\152\230\160\151\229\155\190\232\133\190",
        ["Tribal Leatherworking"]="\233\131\168\239\191\189?\229\136\182\231\154\174",
        ["Trueshot Aura"]="\229\188\186\229\135\187\229\133\137\231\142\175",
        ["Turn Undead"]="\232\182\133\229\186\166\228\186\161\231\191\181",
        ["Two-Handed Axes and Maces"]="\229\191\140\230\137\139\230\150\167\229\146\140\233\148\164",
        ["Two-Handed Axes"]="\229\191\140\230\137\139\230\150\167",
        ["Two-Handed Maces"]="\229\191\140\230\137\139\233\148\164",
        ["Two-Handed Swords"]="\229\191\140\230\137\139\229\137\145",
        ["Two-Handed Weapon Specialization"]="\229\191\140\230\137\139\230\173\166\229\153\168\228\184\147\231\178\190",
        ["Unarmed"]="\229\190\146\230\137\139",
        ["Unbreakable Will"]="\229\191\154\229\174\154\230\132\191\229\191\151",
        ["Unbridled Wrath Effect"]="\230\128\146\228\184\191\229\191\175\233\191\191\230\149\136\230\158\156",
        ["Unbridled Wrath"]="\230\128\146\228\184\191\229\191\175\233\191\191",
        ["Undead Horsemanship"]="\233\170\145\230\156\175\239\188\154\233\170\184\233\170\168\230\136\152\233\169\172",
        ["Underwater Breathing"]="\230\176\180\228\184\139\229\145\188\229\191\184",
        ["Unending Breath"]="\233\173\148\230\191\175\230\156\175",
        ["Unholy Power"]="\233\130\170\230\191\182\229\188\186\229\140\150",
        ["Unleashed Fury"]="\231\139\130\230\128\146\233\135\138\230\148\190",
        ["Unyielding Faith"]="zzOLDSpell - Reuse",
        ["Vampiric Embrace"]="\229\191\184\232\161\128\233\172\188\231\154\132\230\139\165\230\138\177",
        ["Vanish"]="\230\182\136\229\164\177",
        ["Vanished"]="\230\182\136\229\164\177",
        ["Vengeance"]="\229\164\191\228\187\135",
        ["Vigor"]="\231\178\190\229\138\155",
        ["Vile Poisons"]="\230\191\182\230\128\167\230\175\146\232\191\175",
        ["Vindication"]="Eagle Scout",
        ["Viper Sting"]="\232\191\176\232\155\135\233\146\137\229\136\186",
        ["Volley"]="\228\185\177\229\176\132",
        ["Wand Specialization"]="\233\173\148\230\191\150\228\184\147\231\178\190",
        ["Wands"]="\233\173\148\230\191\150",
        ["War Stomp"]="\230\136\152\228\186\137\232\183\181\232\184\191",
        ["Water Breathing"]="\230\176\180\228\184\139\229\145\188\229\191\184",
        ["Water Walking"]="\230\176\180\228\184\138\232\161\140\232\181\176",
        ["Weaponsmith"]="\230\173\166\229\153\168\233\148\187\233\128\160\229\184\136",
        ["Whirlwind"]="\230\151\139\233\163\142\230\150\169",
        ["Will of the Forsaken"]="\228\186\161\231\191\181\230\132\191\229\191\151",
        ["Windfury Totem"]="\233\163\142\230\128\146\229\155\190\232\133\190",
        ["Windfury Weapon"]="\233\163\142\230\128\146\230\173\166\229\153\168",
        ["Windwall Totem"]="\233\163\142\229\162\153\229\155\190\232\133\190",
        ["Wing Clip"]="\230\145\148\231\187\138",
        ["Winter's Chill"]="\230\183\177\229\134\172\228\185\139\229\175\146",
        ["Wisp Spirit"]="\231\178\190\231\191\181\228\185\139\233\173\130",
        ["Wolf Riding"]="\233\170\145\230\156\175\239\188\154\231\139\188",
        ["Wound Poison II"]="\232\135\180\228\188\164\230\175\146\232\191\175 II",
        ["Wound Poison III"]="\232\135\180\228\188\164\230\175\146\232\191\175 III",
        ["Wound Poison IV"]="\232\135\180\228\188\164\230\175\146\232\191\175 IV",
        ["Wound Poison"]="\232\135\180\228\188\164\230\175\146\232\191\175",
        ["Wrath"]="\230\132\164\230\128\146",
        ["Wyvern Sting"]="\231\191\188\233\190\153\233\146\137\229\136\186"
    }
elseif locale ~= "enUS" then
	-- no translation available
	englishToLocal = {
	}
end

if englishToLocal then
	for key in pairs(englishToLocal) do
		if not totalSpells[key] then
			error("Improper translation exists. %q is likely misspelled for locale %s.", key, locale)
			break
		end
	end
end

-------------IRIEL'S-STUB-CODE--------------
local stub = {};

-- Instance replacement method, replace contents of old with that of new
function stub:ReplaceInstance(old, new)
   for k,v in pairs(old) do old[k]=nil; end
   for k,v in pairs(new) do old[k]=v; end
end

-- Get a new copy of the stub
function stub:NewStub()
  local newStub = {};
  self:ReplaceInstance(newStub, self);
  newStub.lastVersion = '';
  newStub.versions = {};
  return newStub;
end

-- Get instance version
function stub:GetInstance(version)
   if (not version) then version = self.lastVersion; end
   local versionData = self.versions[version];
   if (not versionData) then
	  message("Cannot find library instance with version '" 
			  .. version .. "'");
	  return;
   end
   return versionData.instance;
end

-- Register new instance
function stub:Register(newInstance)
   local version,minor = newInstance:GetLibraryVersion();
   self.lastVersion = version;
   local versionData = self.versions[version];
   if (not versionData) then
	  -- This one is new!
	  versionData = { instance = newInstance,
		 minor = minor,
		 old = {} 
	  };
	  self.versions[version] = versionData;
	  newInstance:LibActivate(self);
	  return newInstance;
   end
   if (minor <= versionData.minor) then
	  -- This one is already obsolete
	  if (newInstance.LibDiscard) then
		 newInstance:LibDiscard();
	  end
	  return versionData.instance;
   end
   -- This is an update
   local oldInstance = versionData.instance;
   local oldList = versionData.old;
   versionData.instance = newInstance;
   versionData.minor = minor;
   local skipCopy = newInstance:LibActivate(self, oldInstance, oldList);
   table.insert(oldList, oldInstance);
   if (not skipCopy) then
	  for i, old in ipairs(oldList) do
		 self:ReplaceInstance(old, newInstance);
	  end
   end
   return newInstance;
end

-- Bind stub to global scope if it's not already there
if (not BabbleLib) then
   BabbleLib = stub:NewStub();
end

-- Nil stub for garbage collection
stub = nil;
-----------END-IRIEL'S-STUB-CODE------------

local function assert(condition, message)
	if not condition then
		local stack = debugstack()
		local first = string.gsub(stack, "\n.*", "")
		local file = string.gsub(first, "^(.*\\.*).lua:%d+: .*", "%1")
		file = string.gsub(file, "([%(%)%.%*%+%-%[%]%?%^%$%%])", "%%%1")
		if not message then
			local _,_,second = string.find(stack, "\n(.-)\n")
			message = "assertion failed! " .. second
		end
		message = "BabbleLib-Spell: " .. message
		local i = 1
		for s in string.gfind(stack, "\n([^\n]*)") do
			i = i + 1
			if not string.find(s, file .. "%.lua:%d+:") then
				error(message, i)
				return
			end
		end
		error(message, 2)
		return
	end
	return condition
end

local function argCheck(arg, num, kind, kind2, kind3, kind4)
	if tostring(type(arg)) ~= kind then
		if kind2 then
			if tostring(type(arg)) ~= kind2 then
				if kind3 then
					if tostring(type(arg)) ~= kind3 then
						if kind4 then
							if tostring(type(arg)) ~= kind4 then
								local _,_,func = string.find(debugstack(), "\n.-`(.-)'\n")
								assert(false, format("Bad argument #%d to `%s' (%s, %s, %s, or %s expected, got %s)", num, func, kind, kind2, kind3, kind4, type(arg)))
							end
						else
							local _,_,func = string.find(debugstack(), "\n.-`(.-)'\n")
							assert(false, format("Bad argument #%d to `%s' (%s, %s, or %s expected, got %s)", num, func, kind, kind2, kind3, type(arg)))
						end
					end
				else
					local _,_,func = string.find(debugstack(), "\n.-`(.-)'\n")
					assert(false, format("Bad argument #%d to `%s' (%s or %s expected, got %s)", num, func, kind, kind2, type(arg)))
				end
			end
		else
			local _,_,func = string.find(debugstack(), "\n.-`(.-)'\n")
			assert(false, format("Bad argument #%d to `%s' (%s expected, got %s)", num, func, kind, type(arg)))
		end
	end
end

local spellIcons = {
    ["Abolish Disease"]="Spell_Nature_NullifyDisease",
    ["Abolish Poison Effect"]="Spell_Nature_NullifyPoison_02",
    ["Abolish Poison"]="Spell_Nature_NullifyPoison_02",
    ["Activate MG Turret"]="INV_Weapon_Rifle_10",
    ["Adrenaline Rush"]="Spell_Shadow_ShadowWordDominate",
    ["Aftermath"]="Spell_Fire_Fire",
    ["Aggression"]="Ability_Racial_Avatar",
    ["Aimed Shot"]="INV_Spear_07",
    ["Alchemy"] = "Trade_Alchemy",
    ["Ambush"]="Ability_Rogue_Ambush",
    ["Amplify Curse"]="Spell_Shadow_Contagion",
    ["Amplify Magic"]="Spell_Holy_FlashHeal",
    ["Ancestral Healing"]="Spell_Nature_UndyingStrength",
    ["Ancestral Knowledge"]="Spell_Shadow_GrimWard",
    ["Ancestral Spirit"]="Spell_Nature_Regenerate",
    ["Anger Management"]="Spell_Holy_BlessingOfStamina",
    ["Anticipation"]="Spell_Nature_MirrorImage",
    ["Aquatic Form"]="Ability_Druid_AquaticForm",
    ["Arcane Brilliance"]="Spell_Holy_ArcaneIntellect",
    ["Arcane Concentration"]="Spell_Shadow_ManaBurn",
    ["Arcane Explosion"]="Spell_Nature_WispSplode",
    ["Arcane Focus"]="Spell_Holy_Devotion",
    ["Arcane Instability"]="Spell_Shadow_Teleport",
    ["Arcane Intellect"]="Spell_Holy_MagicalSentry",
    ["Arcane Meditation"]="Spell_Shadow_SiphonMana",
    ["Arcane Mind"]="Spell_Shadow_Charm",
    ["Arcane Missiles"]="Spell_Nature_StarFall",
    ["Arcane Power"]="Spell_Nature_Lightning",
    ["Arcane Resistance"]="Spell_Nature_StarFall",
    ["Arcane Shot"]="Ability_ImpalingBolt",
    ["Arcane Subtlety"]="Spell_Holy_DispelMagic",
    ["Arctic Reach"]="Spell_Shadow_DarkRitual",
    ["Aspect of the Beast"]="Ability_Mount_PinkTiger",
    ["Aspect of the Cheetah"]="Ability_Mount_JungleTiger",
    ["Aspect of the Hawk"]="Spell_Nature_RavenForm",
    ["Aspect of the Monkey"]="Ability_Hunter_AspectOfTheMonkey",
    ["Aspect of the Pack"]="Ability_Mount_WhiteTiger",
    ["Aspect of the Wild"]="Spell_Nature_ProtectionformNature",
    ["Astral Recall"]="Spell_Nature_AstralRecal",
    ["Attack"]="Temp",
    ["Attacking"]="Temp",
    ["Auto Shot"]="Ability_Whirlwind",
    ["Axe Specialization"]="INV_Axe_06",
    ["Backstab"]="Ability_BackStab",
    ["Bane"]="Spell_Shadow_DeathPact",
    ["Banish"]="Spell_Shadow_Cripple",
    ["Barkskin Effect"]="Spell_Nature_StoneClawTotem",
    ["Barkskin"]="Spell_Nature_StoneClawTotem",
    ["Barrage"]="Ability_UpgradeMoonGlaive",
    ["Bash"]="Ability_Druid_Bash",
    ["Basic Campfire"]="Spell_Fire_Fire",
    ["Battle Shout"]="Ability_Warrior_BattleShout",
    ["Battle Stance Passive"]="Ability_Warrior_OffensiveStance",
    ["Battle Stance"]="Ability_Warrior_OffensiveStance",
    ["Bear Form"]="Ability_Racial_BearForm",
    ["Beast Lore"]="Ability_Physical_Taunt",
    ["Beast Slaying"]="INV_Misc_Pelt_Bear_Ruin_02",
    ["Beast Training"]="Ability_Hunter_BeastCall02",
    ["Benediction"]="Spell_Frost_WindWalkOn",
    ["Berserker Rage"]="Spell_Nature_AncestralGuardian",
    ["Berserker Stance Passive"]="Ability_Racial_Avatar",
    ["Berserker Stance"]="Ability_Racial_Avatar",
    ["Berserking"]="Racial_Troll_Berserk",
    ["Bestial Discipline"]="Spell_Nature_AbolishMagic",
    ["Bestial Swiftness"]="Ability_Druid_Dash",
    ["Bestial Wrath"]="Ability_Druid_FerociousBite",
    ["Bite"]="Ability_Racial_Cannibalize",
    ["Black Arrow"]="Ability_TheBlackArrow",
    ["Blackout"]="Spell_Shadow_GatherShadows",
    ["Blacksmithing"] = "Trade_BlackSmithing",
    ["Blade Flurry"]="Ability_Warrior_PunishingBlow",
    ["Blast Wave"]="Spell_Holy_Excorcism_02",
    ["Blessed Recovery"]="Spell_Holy_BlessedRecovery",
    ["Blessing of Freedom"]="Spell_Holy_SealOfValor",
    ["Blessing of Kings"]="Spell_Magic_MageArmor",
    ["Blessing of Light"]="Spell_Holy_PrayerOfHealing02",
    ["Blessing of Might"]="Spell_Holy_FistOfJustice",
    ["Blessing of Protection"]="Spell_Holy_SealOfProtection",
    ["Blessing of Sacrifice"]="Spell_Holy_SealOfSacrifice",
    ["Blessing of Salvation"]="Spell_Holy_SealOfSalvation",
    ["Blessing of Sanctuary"]="Spell_Nature_LightningShield",
    ["Blessing of Wisdom"]="Spell_Holy_SealOfWisdom",
    ["Blind"]="Spell_Shadow_MindSteal",
    ["Blinding Powder"]="INV_Misc_Ammo_Gunpowder_02",
    ["Blink"]="Spell_Arcane_Blink",
    ["Blizzard"]="Spell_Frost_IceStorm",
    ["Block"]="Ability_Defend",
    ["Blood Craze"]="Spell_Shadow_SummonImp",
    ["Blood Frenzy"]="Ability_GhoulFrenzy",
    ["Blood Fury"]="Racial_Orc_BerserkerStrength",
    ["Blood Pact"]="Spell_Shadow_BloodBoil",
    ["Bloodrage"]="Ability_Racial_BloodRage",
    ["Bloodthirst"]="Spell_Nature_BloodLust",
    ["Booming Voice"]="Spell_Nature_Purge",
    ["Bow Specialization"]="INV_Weapon_Bow_12",
    ["Bows"]="INV_Weapon_Bow_05",
    ["Bright Campfire"]="Spell_Fire_Fire",
    ["Brutal Impact"]="Ability_Druid_Bash",
    ["Burning Soul"]="Spell_Fire_Fire",
    ["Call Pet"]="Ability_Hunter_BeastCall",
    ["Call of Flame"]="Spell_Fire_Immolation",
    ["Call of Thunder"]="Spell_Nature_CallStorm",
    ["Camouflage"]="Ability_Stealth",
    ["Cannibalize"]="Ability_Racial_Cannibalize",
    ["Cat Form"]="Ability_Druid_CatForm",
    ["Cataclysm"]="Spell_Fire_WindsofWoe",
    ["Chain Heal"]="Spell_Nature_HealingWaveGreater",
    ["Chain Lightning"]="Spell_Nature_ChainLightning",
    ["Challenging Roar"]="Ability_Druid_ChallangingRoar",
    ["Challenging Shout"]="Ability_BullRush",
    ["Charge Rage Bonus Effect"]="Ability_Warrior_Charge",
    ["Charge"]="Ability_Warrior_Charge",
    ["Cheap Shot"]="Ability_CheapShot",
    ["Chilled"]="Spell_Frost_IceStorm",
    ["Claw"]="Ability_Druid_Rake",
    ["Cleanse"]="Spell_Holy_Renew",
    ["Clearcasting"]="Spell_Shadow_ManaBurn",
    ["Cleave"]="Ability_Warrior_Cleave",
    ["Clever Traps"]="Spell_Nature_TimeStop",
    ["Closing"]="Temp",
    ["Cloth"]="INV_Chest_Cloth_21",
    ["Cobra Reflexes"]="Spell_Nature_GuardianWard",
    ["Cold Blood"]="Spell_Ice_Lament",
    ["Cold Snap"]="Spell_Frost_WizardMark",
    ["Combat Endurance"]="Spell_Nature_AncestralGuardian",
    ["Combustion"]="Spell_Fire_SealOfFire",
    ["Command"]="Ability_Warrior_WarCry",
    ["Concentration Aura"]="Spell_Holy_MindSooth",
    ["Concussion Blow"]="Ability_ThunderBolt",
    ["Concussion"]="Spell_Fire_Fireball",
    ["Concussive Shot"]="Spell_Frost_Stun",
    ["Cone of Cold"]="Spell_Frost_Glacier",
    ["Conflagrate"]="Spell_Fire_Fireball",
    ["Conjure Food"]="INV_Misc_Food_10",
    ["Conjure Mana Agate"]="INV_Misc_Gem_Emerald_01",
    ["Conjure Mana Citrine"]="INV_Misc_Gem_Opal_01",
    ["Conjure Mana Jade"]="INV_Misc_Gem_Emerald_02",
    ["Conjure Mana Ruby"]="INV_Misc_Gem_Ruby_01",
    ["Conjure Water"]="INV_Drink_06",
    ["Consecration"]="Spell_Holy_InnerFire",
    ["Consume Shadows"]="Spell_Shadow_AntiShadow",
    ["Convection"]="Spell_Nature_WispSplode",
    ["Conviction"]="Spell_Holy_RetributionAura",
    ["Cooking"] = "INV_Misc_Food_15",
    ["Corruption"]="Spell_Shadow_AbominationExplosion",
    ["Counterattack"]="Ability_Warrior_Challange",
    ["Counterspell"]="Spell_Frost_IceShock",
    ["Cower"]="Ability_Druid_Cower",
    ["Create Firestone"]="INV_Ammo_FireTar",
    ["Create Healthstone"]="INV_Stone_04",
    ["Create Soulstone"]="Spell_Shadow_SoulGem",
    ["Create Spellstone"]="INV_Misc_Gem_Sapphire_01",
    ["Crippling Poison II"]="Ability_PoisonSting",
    ["Crippling Poison"]="Ability_PoisonSting",
    ["Critical Mass"]="Spell_Nature_WispHeal",
    ["Crossbows"]="INV_Weapon_Crossbow_01",
    ["Cruelty"]="Ability_Rogue_Eviscerate",
    ["Cultivation"]="INV_Misc_Flower_01",
    ["Cure Disease"]="Spell_Holy_NullifyDisease",
    ["Cure Poison"]="Spell_Nature_NullifyPoison",
    ["Curse of Agony"]="Spell_Shadow_CurseOfSargeras",
    ["Curse of Doom Effect"]="Spell_Shadow_AuraOfDarkness",
    ["Curse of Doom"]="Spell_Shadow_AuraOfDarkness",
    ["Curse of Exhaustion"]="Spell_Shadow_GrimWard",
    ["Curse of Idiocy"]="Spell_Shadow_MindRot",
    ["Curse of Recklessness"]="Spell_Shadow_UnholyStrength",
    ["Curse of Shadow"]="Spell_Shadow_CurseOfAchimonde",
    ["Curse of Tongues"]="Spell_Shadow_CurseOfTounges",
    ["Curse of Weakness"]="Spell_Shadow_CurseOfMannoroth",
    ["Curse of the Elements"]="Spell_Shadow_ChillTouch",
    ["Dagger Specialization"]="INV_Weapon_ShortBlade_05",
    ["Daggers"]="Ability_SteelMelee",
    ["Dampen Magic"]="Spell_Nature_AbolishMagic",
    ["Dark Pact"]="Spell_Shadow_DarkRitual",
    ["Darkness"]="Spell_Shadow_Twilight",
    ["Dash"]="Ability_Druid_Dash",
    ["Deadly Poison II"]="Ability_Rogue_DualWeild",
    ["Deadly Poison III"]="Ability_Rogue_DualWeild",
    ["Deadly Poison IV"]="Ability_Rogue_DualWeild",
    ["Deadly Poison V"]="Ability_Rogue_DualWeild",
    ["Deadly Poison"]="Ability_Rogue_DualWeild",
    ["Death Coil"]="Spell_Shadow_DeathCoil",
    ["Death Wish"]="Spell_Shadow_DeathPact",
    ["Deep Wounds"]="Ability_BackStab",
    ["Defense"]="Ability_Racial_ShadowMeld",
    ["Defensive Stance Passive"]="Ability_Warrior_DefensiveStance",
    ["Defensive Stance"]="Ability_Warrior_DefensiveStance",
    ["Defensive State 2"]="Ability_Defend",
    ["Defensive State"]="Ability_Defend",
    ["Defiance"]="Ability_Warrior_InnerRage",
    ["Deflection"]="Ability_Parry",
    ["Demon Armor"]="Spell_Shadow_RagingScream",
    ["Demon Skin"]="Spell_Shadow_RagingScream",
    ["Demonic Embrace"]="Spell_Shadow_Metamorphosis",
    ["Demonic Sacrifice"]="Spell_Shadow_PsychicScream",
    ["Demoralizing Roar"]="Ability_Druid_DemoralizingRoar",
    ["Demoralizing Shout"]="Ability_Warrior_WarCry",
    ["Desperate Prayer"]="Spell_Holy_Restoration",
    ["Destructive Reach"]="Spell_Shadow_CorpseExplode",
    ["Detect Greater Invisibility"]="Spell_Shadow_DetectInvisibility",
    ["Detect Invisibility"]="Spell_Shadow_DetectInvisibility",
    ["Detect Lesser Invisibility"]="Spell_Shadow_DetectLesserInvisibility",
    ["Detect Magic"]="Spell_Holy_Dizzy",
    ["Detect Traps"]="Ability_Spy",
    ["Detect"]="Ability_Hibernation",
    ["Deterrence"]="Ability_Whirlwind",
    ["Devastation"]="Spell_Fire_FlameShock",
    ["Devotion Aura"]="Spell_Holy_DevotionAura",
    ["Devour Magic Effect"]="Spell_Nature_Purge",
    ["Devour Magic"]="Spell_Nature_Purge",
    ["Devouring Plague"]="Spell_Shadow_BlackPlague",
    ["Diplomacy"]="INV_Misc_Note_02",
    ["Dire Bear Form"]="Ability_Racial_BearForm",
    ["Disarm Trap"]="Spell_Shadow_GrimWard",
    ["Disarm"]="Ability_Warrior_Disarm",
    ["Disease Cleansing Totem"]="Spell_Nature_DiseaseCleansingTotem",
    ["Disenchant"] = "Spell_Holy_RemoveCurse",
    ["Disengage"]="Ability_Rogue_Feint",
    ["Dismiss Pet"]="Spell_Nature_SpiritWolf",
    ["Dispel Magic"]="Spell_Holy_DispelMagic",
    ["Distract"]="Ability_Rogue_Distract",
    ["Distracting Shot"]="Spell_Arcane_Blink",
    ["Dive"]="Spell_Shadow_BurningSpirit",
    ["Divine Favor"]="Spell_Holy_Heal",
    ["Divine Fury"]="Spell_Holy_SealOfWrath",
    ["Divine Intellect"]="Spell_Nature_Sleep",
    ["Divine Intervention"]="Spell_Nature_TimeStop",
    ["Divine Protection"]="Spell_Holy_Restoration",
    ["Divine Shield"]="Spell_Holy_DivineIntervention",
    ["Divine Spirit"]="Spell_Holy_DivineSpirit",
    ["Divine Strength"]="Ability_GolemThunderClap",
    ["Dodge"]="Spell_Nature_Invisibilty",
    ["Drain Life"]="Spell_Shadow_LifeDrain02",
    ["Drain Mana"]="Spell_Shadow_SiphonMana",
    ["Drain Soul"]="Spell_Shadow_Haunting",
    ["Dual Wield Specialization"]="Ability_DualWield",
    ["Dual Wield"]="Ability_DualWield",
    ["Duel"]="Temp",
    ["Eagle Eye"]="Ability_Hunter_EagleEye",
    ["Earth Shock"]="Spell_Nature_EarthShock",
    ["Earthbind Totem"]="Spell_Nature_StrengthOfEarthTotem02",
    ["Efficiency"]="Spell_Frost_WizardMark",
    ["Elemental Focus"]="Spell_Shadow_ManaBurn",
    ["Elemental Fury"]="Spell_Fire_Volcano",
    ["Elemental Mastery"]="Spell_Nature_WispHeal",
    ["Elune's Grace"]="Spell_Holy_ElunesGrace",
    ["Elusiveness"]="Spell_Magic_LesserInvisibilty",
    ["Emberstorm"]="Spell_Fire_SelfDestruct",
    ["Enchanting"] = "Trade_Engraving",
    ["Endurance Training"]="Spell_Nature_Reincarnation",
    ["Endurance"]="Spell_Nature_UnyeildingStamina",
    ["Engineering Specialization"]="INV_Misc_Gear_01",
    ["Engineering"] = "Trade_Engineering",
    ["Enrage"]="Ability_Druid_Enrage",
    ["Enslave Demon"]="Spell_Shadow_EnslaveDemon",
    ["Entangling Roots"]="Spell_Nature_StrangleVines",
    ["Entrapment"]="Spell_Nature_StrangleVines",
    ["Escape Artist"]="Ability_Rogue_Trip",
    ["Evasion"]="Spell_Shadow_ShadowWard",
    ["Eventide"]="Spell_Frost_Stun",
    ["Eviscerate"]="Ability_Rogue_Eviscerate",
    ["Evocation"]="Spell_Nature_Purge",
    ["Execute"]="INV_Sword_48",
    ["Exorcism"]="Spell_Holy_Excorcism_02",
    ["Expansive Mind"]="INV_Enchant_EssenceEternalLarge",
    ["Explosive Trap Effect"]="Spell_Fire_SelfDestruct",
    ["Explosive Trap"]="Spell_Fire_SelfDestruct",
    ["Expose Armor"]="Ability_Warrior_Riposte",
    ["Eye for an Eye"]="Spell_Holy_EyeforanEye",
    ["Eye of Kilrogg"]="Spell_Shadow_EvilEye",
    ["Eyes of the Beast"]="Ability_EyeOfTheOwl",
    ["Fade"]="Spell_Magic_LesserInvisibilty",
    ["Faerie Fire"]="Spell_Nature_FaerieFire",
    ["Far Sight"]="Spell_Nature_FarSight",
    ["Fear Ward"]="Spell_Holy_Excorcism",
    ["Fear"]="Spell_Shadow_Possession",
    ["Feed Pet"]="Ability_Hunter_BeastTraining",
    ["Feedback"]="Spell_Shadow_RitualOfSacrifice",
    ["Feign Death"]="Ability_Rogue_FeignDeath",
    ["Feint"]="Ability_Rogue_Feint",
    ["Fel Concentration"]="Spell_Shadow_FingerOfDeath",
    ["Fel Domination"]="Spell_Nature_RemoveCurse",
    ["Fel Intellect"]="Spell_Holy_MagicalSentry",
    ["Fel Stamina"]="Spell_Shadow_AntiShadow",
    ["Felfire"]="Spell_Fire_Fireball",
    ["Feline Grace"]="INV_Feather_01",
    ["Feline Swiftness"]="Spell_Nature_SpiritWolf",
    ["Feral Aggression"]="Ability_Druid_DemoralizingRoar",
    ["Feral Charge"]="Ability_Hunter_Pet_Bear",
    ["Feral Instinct"]="Ability_Ambush",
    ["Ferocious Bite"]="Ability_Druid_FerociousBite",
    ["Ferocity"]="INV_Misc_MonsterClaw_04",
    ["Fetish"]="INV_Misc_Horn_01",
    ["Find Treasure"]="Racial_Dwarf_FindTreasure",
    ["Fire Blast"]="Spell_Fire_Fireball",
    ["Fire Nova Totem"]="Spell_Fire_SealOfFire",
    ["Fire Power"]="Spell_Fire_Immolation",
    ["Fire Resistance Aura"]="Spell_Fire_SealOfFire",
    ["Fire Resistance Totem"]="Spell_FireResistanceTotem_01",
    ["Fire Resistance"]="Spell_Fire_FireArmor",
    ["Fire Shield"]="Spell_Fire_FireArmor",
    ["Fire Vulnerability"]="Spell_Fire_SoulBurn",
    ["Fire Ward"]="Spell_Fire_FireArmor",
    ["Fireball"]="Spell_Fire_FlameBolt",
    ["Firebolt"]="Spell_Fire_FireBolt",
    ["First Aid"] = "Spell_Holy_SealOfSacrifice",
    ["Fishing Poles"]="Trade_Fishing",
    ["Fishing"] = "Trade_Fishing",
    ["Fishing"]="Trade_Fishing",
    ["Fist Weapon Specialization"]="INV_Gauntlets_04",
    ["Fist Weapons"]="INV_Gauntlets_04",
    ["Flame Shock"]="Spell_Fire_FlameShock",
    ["Flame Throwing"]="Spell_Fire_Flare",
    ["Flamestrike"]="Spell_Fire_SelfDestruct",
    ["Flamethrower"]="Spell_Fire_Incinerate",
    ["Flametongue Totem"]="Spell_Nature_GuardianWard",
    ["Flametongue Weapon"]="Spell_Fire_FlameTounge",
    ["Flare"]="Spell_Fire_Flare",
    ["Flash Heal"]="Spell_Holy_FlashHeal",
    ["Flash of Light"]="Spell_Holy_FlashHeal",
    ["Flurry"]="Ability_GhoulFrenzy",
    ["Focused Casting"]="Spell_Arcane_Blink",
    ["Force of Will"]="Spell_Nature_SlowingTotem",
    ["Freezing Trap"]="Spell_Frost_ChainsOfIce",
    ["Frenzied Regeneration"]="Ability_BullRush",
    ["Frenzy"]="INV_Misc_MonsterClaw_03",
    ["Frost Armor"]="Spell_Frost_FrostArmor02",
    ["Frost Channeling"]="Spell_Frost_Stun",
    ["Frost Nova"]="Spell_Frost_FrostNova",
    ["Frost Resistance Aura"]="Spell_Frost_WizardMark",
    ["Frost Resistance Totem"]="Spell_FrostResistanceTotem_01",
    ["Frost Resistance"]="Spell_Frost_FrostWard",
    ["Frost Shock"]="Spell_Frost_FrostShock",
    ["Frost Trap"]="Spell_Frost_FreezingBreath",
    ["Frost Ward"]="Spell_Frost_FrostWard",
    ["Frostbite"]="Spell_Frost_FrostArmor",
    ["Frostbolt"]="Spell_Frost_FrostBolt02",
    ["Frostbrand Weapon"]="Spell_Frost_FrostBrand",
    ["Furious Howl"]="Ability_Hunter_Pet_Wolf",
    ["Furor"]="Spell_Holy_BlessingOfStamina",
    ["Garrote"]="Ability_Rogue_Garrote",
    ["Generic"]="INV_Shield_09",
    ["Ghost Wolf"]="Spell_Nature_SpiritWolf",
    ["Ghostly Strike"]="Spell_Shadow_Curse",
    ["Gift of Nature"]="Spell_Nature_ProtectionformNature",
    ["Gift of the Wild"]="Spell_Nature_Regeneration",
    ["Gouge"]="Ability_Gouge",
    ["Grace of Air Totem"]="Spell_Nature_InvisibilityTotem",
    ["Great Stamina"]="Spell_Nature_UnyeildingStamina",
    ["Greater Blessing of Kings"]="Spell_Magic_GreaterBlessingofKings",
    ["Greater Blessing of Light"]="Spell_Holy_GreaterBlessingofLight",
    ["Greater Blessing of Might"]="Spell_Holy_GreaterBlessingofKings",
    ["Greater Blessing of Salvation"]="Spell_Holy_GreaterBlessingofSalvation",
    ["Greater Blessing of Sanctuary"]="Spell_Holy_GreaterBlessingofSanctuary",
    ["Greater Blessing of Wisdom"]="Spell_Holy_GreaterBlessingofWisdom",
    ["Greater Heal"]="Spell_Holy_GreaterHeal",
    ["Grim Reach"]="Spell_Shadow_CallofBone",
    ["Grounding Totem"]="Spell_Nature_GroundingTotem",
    ["Grovel"]="Temp",
    ["Growl"]="Ability_Physical_Taunt",
    ["Guardian's Favor"]="Spell_Holy_SealOfProtection",
    ["Gun Specialization"]="INV_Musket_03",
    ["Guns"]="INV_Weapon_Rifle_01",
    ["Hammer of Justice"]="Spell_Holy_SealOfMight",
    ["Hammer of Wrath"]="Ability_ThunderClap",
    ["Hamstring"]="Ability_ShockWave",
    ["Harass"]="Ability_Hunter_Harass",
    ["Hardiness"]="INV_Helmet_23",
    ["Hawk Eye"]="Ability_TownWatch",
    ["Heal"]="Spell_Holy_Heal",
    ["Healing Focus"]="Spell_Holy_HealingFocus",
    ["Healing Light"]="Spell_Holy_HolyBolt",
    ["Healing Stream Totem"]="INV_Spear_04",
    ["Healing Touch"]="Spell_Nature_HealingTouch",
    ["Healing Wave"]="Spell_Nature_MagicImmunity",
    ["Health Funnel"]="Spell_Shadow_LifeDrain",
    ["Heart of the Wild"]="Spell_Holy_BlessingOfAgility",
    ["Hellfire Effect"]="Spell_Fire_Incinerate",
    ["Hellfire"]="Spell_Fire_Incinerate",
    ["Hemorrhage"]="Spell_Shadow_LifeDrain",
    ["Herbalism"] = "Spell_Nature_NatureTouchGrow",
    ["Heroic Strike"]="Ability_Rogue_Ambush",
    ["Hex of Weakness"]="Spell_Shadow_FingerOfDeath",
    ["Hibernate"]="Spell_Nature_Sleep",
    ["Holy Fire"]="Spell_Holy_SearingLight",
    ["Holy Light"]="Spell_Holy_HolyBolt",
    ["Holy Nova"]="Spell_Holy_HolyNova",
    ["Holy Power"]="Spell_Holy_Power",
    ["Holy Reach"]="Spell_Holy_Purify",
    ["Holy Shield"]="Spell_Holy_BlessingOfProtection",
    ["Holy Shock"]="Spell_Holy_SearingLight",
    ["Holy Specialization"]="Spell_Holy_SealOfSalvation",
    ["Holy Wrath"]="Spell_Holy_Excorcism",
    ["Honorless Target"]="Spell_Magic_LesserInvisibilty",
    ["Horse Riding"]="Spell_Nature_Swiftness",
    ["Howl of Terror"]="Spell_Shadow_DeathScream",
    ["Humanoid Slaying"]="Spell_Holy_PrayerOfHealing",
    ["Hunter's Mark"]="Ability_Hunter_SniperShot",
    ["Hurricane"]="Spell_Nature_Cyclone",
    ["Ice Armor"]="Spell_Frost_FrostArmor02",
    ["Ice Barrier"]="Spell_Ice_Lament",
    ["Ice Block"]="Spell_Frost_Frost",
    ["Ice Shards"]="Spell_Frost_IceShard",
    ["Ignite"]="Spell_Fire_Incinerate",
    ["Illumination"]="Spell_Holy_GreaterHeal",
    ["Immolate"]="Spell_Fire_Immolation",
    ["Immolation Trap Effect"]="Spell_Fire_FlameShock",
    ["Immolation Trap"]="Spell_Fire_FlameShock",
    ["Impact"]="Spell_Fire_MeteorStorm",
    ["Impale"]="Ability_SearingArrow",
    ["Improved Ambush"]="Ability_Rogue_Ambush",
    ["Improved Arcane Explosion"]="Spell_Nature_WispSplode",
    ["Improved Arcane Missiles"]="Spell_Nature_StarFall",
    ["Improved Arcane Shot"]="Ability_ImpalingBolt",
    ["Improved Aspect of the Hawk"]="Spell_Nature_RavenForm",
    ["Improved Aspect of the Monkey"]="Ability_Hunter_AspectOfTheMonkey",
    ["Improved Backstab"]="Ability_BackStab",
    ["Improved Battle Shout"]="Ability_Warrior_BattleShout",
    ["Improved Berserker Rage"]="Spell_Nature_AncestralGuardian",
    ["Improved Blessing of Might"]="Spell_Holy_FistOfJustice",
    ["Improved Blessing of Wisdom"]="Spell_Holy_SealOfWisdom",
    ["Improved Blizzard"]="Spell_Frost_IceStorm",
    ["Improved Bloodrage"]="Ability_Racial_BloodRage",
    ["Improved Chain Heal"]="Spell_Nature_HealingWaveGreater",
    ["Improved Chain Lightning"]="Spell_Nature_ChainLightning",
    ["Improved Challenging Shout"]="Ability_Warrior_Challange",
    ["Improved Charge"]="Ability_Warrior_Charge",
    ["Improved Cheap Shot"]="Ability_CheapShot",
    ["Improved Cleave"]="Ability_Warrior_Cleave",
    ["Improved Concentration Aura"]="Spell_Holy_MindSooth",
    ["Improved Concussive Shot"]="Spell_Frost_Stun",
    ["Improved Cone of Cold"]="Spell_Frost_Glacier",
    ["Improved Corruption"]="Spell_Shadow_AbominationExplosion",
    ["Improved Counterspell"]="Spell_Frost_IceShock",
    ["Improved Curse of Agony"]="Spell_Shadow_CurseOfSargeras",
    ["Improved Curse of Exhaustion"]="Spell_Shadow_GrimWard",
    ["Improved Curse of Weakness"]="Spell_Shadow_CurseOfMannoroth",
    ["Improved Dampen Magic"]="Spell_Nature_AbolishMagic",
    ["Improved Deadly Poison"]="Ability_Rogue_DualWeild",
    ["Improved Demoralizing Shout"]="Ability_Warrior_WarCry",
    ["Improved Devotion Aura"]="Spell_Holy_DevotionAura",
    ["Improved Disarm"]="Ability_Warrior_Disarm",
    ["Improved Distract"]="Ability_Rogue_Distract",
    ["Improved Drain Life"]="Spell_Shadow_LifeDrain02",
    ["Improved Drain Mana"]="Spell_Shadow_SiphonMana",
    ["Improved Drain Soul"]="Spell_Shadow_Haunting",
    ["Improved Enrage"]="Ability_Druid_Enrage",
    ["Improved Enslave Demon"]="Spell_Shadow_EnslaveDemon",
    ["Improved Entangling Roots"]="Spell_Nature_StrangleVines",
    ["Improved Evasion"]="Spell_Shadow_ShadowWard",
    ["Improved Eviscerate"]="Ability_Rogue_Eviscerate",
    ["Improved Execute"]="INV_Sword_48",
    ["Improved Expose Armor"]="Ability_Warrior_Riposte",
    ["Improved Eyes of the Beast"]="Ability_EyeOfTheOwl",
    ["Improved Fade"]="Spell_Magic_LesserInvisibilty",
    ["Improved Feign Death"]="Ability_Rogue_FeignDeath",
    ["Improved Fire Blast"]="Spell_Fire_Fireball",
    ["Improved Fire Nova Totem"]="Spell_Fire_SealOfFire",
    ["Improved Fire Ward"]="Spell_Fire_FireArmor",
    ["Improved Fireball"]="Spell_Fire_FlameBolt",
    ["Improved Firebolt"]="Spell_Fire_FireBolt",
    ["Improved Firestone"]="INV_Ammo_FireTar",
    ["Improved Flamestrike"]="Spell_Fire_SelfDestruct",
    ["Improved Flametongue Weapon"]="Spell_Fire_FlameTounge",
    ["Improved Flash of Light"]="Spell_Holy_FlashHeal",
    ["Improved Frost Nova"]="Spell_Frost_FreezingBreath",
    ["Improved Frost Ward"]="Spell_Frost_FrostWard",
    ["Improved Frostbolt"]="Spell_Frost_FrostBolt02",
    ["Improved Frostbrand Weapon"]="Spell_Frost_FrostBrand",
    ["Improved Garrote"]="Ability_Rogue_Garrote",
    ["Improved Ghost Wolf"]="Spell_Nature_SpiritWolf",
    ["Improved Gouge"]="Ability_Gouge",
    ["Improved Grace of Air Totem"]="Spell_Nature_InvisibilityTotem",
    ["Improved Grounding Totem"]="Spell_Nature_GroundingTotem",
    ["Improved Hammer of Justice"]="Spell_Holy_SealOfMight",
    ["Improved Hamstring"]="Ability_ShockWave",
    ["Improved Healing Stream Totem"]="INV_Spear_04",
    ["Improved Healing Touch"]="Spell_Nature_HealingTouch",
    ["Improved Healing Wave"]="Spell_Nature_MagicImmunity",
    ["Improved Healing"]="Spell_Holy_Heal02",
    ["Improved Health Funnel"]="Spell_Shadow_LifeDrain",
    ["Improved Healthstone"]="INV_Stone_04",
    ["Improved Heroic Strike"]="Ability_Rogue_Ambush",
    ["Improved Hunter's Mark"]="Ability_Hunter_SniperShot",
    ["Improved Immolate"]="Spell_Fire_Immolation",
    ["Improved Imp"]="Spell_Shadow_SummonImp",
    ["Improved Inner Fire"]="Spell_Holy_InnerFire",
    ["Improved Instant Poison"]="Ability_Poisons",
    ["Improved Intercept"]="Ability_Rogue_Sprint",
    ["Improved Intimidating Shout"]="Ability_GolemThunderClap",
    ["Improved Judgement"]="Spell_Holy_RighteousFury",
    ["Improved Kick"]="Ability_Kick",
    ["Improved Kidney Shot"]="Ability_Rogue_KidneyShot",
    ["Improved Lash of Pain"]="Spell_Shadow_Curse",
    ["Improved Lay on Hands"]="Spell_Holy_LayOnHands",
    ["Improved Lesser Healing Wave"]="Spell_Nature_HealingWaveLesser",
    ["Improved Life Tap"]="Spell_Shadow_BurningSpirit",
    ["Improved Lightning Bolt"]="Spell_Nature_Lightning",
    ["Improved Lightning Shield"]="Spell_Nature_LightningShield",
    ["Improved Magma Totem"]="Spell_Fire_SelfDestruct",
    ["Improved Mana Burn"]="Spell_Shadow_ManaBurn",
    ["Improved Mana Shield"]="Spell_Shadow_DetectLesserInvisibility",
    ["Improved Mana Spring Totem"]="Spell_Nature_ManaRegenTotem",
    ["Improved Mark of the Wild"]="Spell_Nature_Regeneration",
    ["Improved Mend Pet"]="Ability_Hunter_MendPet",
    ["Improved Mind Blast"]="Spell_Shadow_UnholyFrenzy",
    ["Improved Moonfire"]="Spell_Nature_StarFall",
    ["Improved Nature's Grasp"]="Spell_Nature_NaturesWrath",
    ["Improved Overpower"]="INV_Sword_05",
    ["Improved Power Word: Fortitude"]="Spell_Holy_WordFortitude",
    ["Improved Power Word: Shield"]="Spell_Holy_PowerWordShield",
    ["Improved Prayer of Healing"]="Spell_Holy_PrayerOfHealing02",
    ["Improved Psychic Scream"]="Spell_Shadow_PsychicScream",
    ["Improved Pummel"]="INV_Gauntlets_04",
    ["Improved Regrowth"]="Spell_Nature_ResistNature",
    ["Improved Reincarnation"]="Spell_Nature_Reincarnation",
    ["Improved Rejuvenation"]="Spell_Nature_Rejuvenation",
    ["Improved Rend"]="Ability_Gouge",
    ["Improved Renew"]="Spell_Holy_Renew",
    ["Improved Retribution Aura"]="Spell_Holy_AuraOfLight",
    ["Improved Revenge"]="Ability_Warrior_Revenge",
    ["Improved Revive Pet"]="Ability_Hunter_BeastSoothe",
    ["Improved Righteous Fury"]="Spell_Holy_SealOfFury",
    ["Improved Rockbiter Weapon"]="Spell_Nature_RockBiter",
    ["Improved Rupture"]="Ability_Rogue_Rupture",
    ["Improved Sap"]="Ability_Sap",
    ["Improved Scorch"]="Spell_Fire_SoulBurn",
    ["Improved Scorpid Sting"]="Ability_Hunter_CriticalShot",
    ["Improved Seal of Righteousness"]="Ability_ThunderBolt",
    ["Improved Seal of the Crusader"]="Spell_Holy_HolySmite",
    ["Improved Searing Pain"]="Spell_Fire_SoulBurn",
    ["Improved Searing Totem"]="Spell_Fire_SearingTotem",
    ["Improved Serpent Sting"]="Ability_Hunter_Quickshot",
    ["Improved Shadow Bolt"]="Spell_Shadow_ShadowBolt",
    ["Improved Shadow Word: Pain"]="Spell_Shadow_ShadowWordPain",
    ["Improved Shield Bash"]="Ability_Warrior_ShieldBash",
    ["Improved Shield Block"]="Ability_Defend",
    ["Improved Shield Wall"]="Ability_Warrior_ShieldWall",
    ["Improved Shred"]="Spell_Shadow_VampiricAura",
    ["Improved Sinister Strike"]="Spell_Shadow_RitualOfSacrifice",
    ["Improved Slam"]="Ability_Warrior_DecisiveStrike",
    ["Improved Slice and Dice"]="Ability_Rogue_SliceDice",
    ["Improved Spellstone"]="INV_Misc_Gem_Sapphire_01",
    ["Improved Sprint"]="Ability_Rogue_Sprint",
    ["Improved Starfire"]="Spell_Arcane_StarFire",
    ["Improved Stoneclaw Totem"]="Spell_Nature_StoneClawTotem",
    ["Improved Stoneskin Totem"]="Spell_Nature_StoneSkinTotem",
    ["Improved Strength of Earth Totem"]="Spell_Nature_EarthBindTotem",
    ["Improved Succubus"]="Spell_Shadow_SummonSuccubus",
    ["Improved Sunder Armor"]="Ability_Warrior_Sunder",
    ["Improved Taunt"]="Spell_Nature_Reincarnation",
    ["Improved Thorns"]="Spell_Nature_Thorns",
    ["Improved Thunder Clap"]="Ability_ThunderClap",
    ["Improved Tranquility"]="Spell_Nature_Tranquility",
    ["Improved Vampiric Embrace"]="Spell_Shadow_ImprovedVampiricEmbrace",
    ["Improved Vanish"]="Ability_Vanish",
    ["Improved Voidwalker"]="Spell_Shadow_SummonVoidWalker",
    ["Improved Windfury Weapon"]="Spell_Nature_Cyclone",
    ["Improved Wing Clip"]="Ability_Rogue_Trip",
    ["Improved Wrath"]="Spell_Nature_AbolishMagic",
    ["Incinerate"]="Spell_Fire_FlameShock",
    ["Inferno"]="Spell_Shadow_SummonInfernal",
    ["Initiative"]="Spell_Shadow_Fumble",
    ["Inner Fire"]="Spell_Holy_InnerFire",
    ["Inner Focus"]="Spell_Frost_WindWalkOn",
    ["Innervate"]="Spell_Nature_Lightning",
    ["Insect Swarm"]="Spell_Nature_InsectSwarm",
    ["Inspiration"]="Spell_Holy_LayOnHands",
    ["Instant Poison II"]="Ability_Poisons",
    ["Instant Poison III"]="Ability_Poisons",
    ["Instant Poison IV"]="Ability_Poisons",
    ["Instant Poison V"]="Ability_Poisons",
    ["Instant Poison VI"]="Ability_Poisons",
    ["Instant Poison"]="Ability_Poisons",
    ["Intensity"]="Spell_Fire_LavaSpawn",
    ["Intercept"]="Ability_Rogue_Sprint",
    ["Intimidating Shout"]="Ability_GolemThunderClap",
    ["Intimidation"]="Ability_Devour",
    ["Iron Will"]="Spell_Magic_MageArmor",
    ["Judgement of Command"]="Ability_Warrior_InnerRage",
    ["Judgement of Justice"]="Spell_Holy_SealOfWrath",
    ["Judgement of Light"]="Spell_Holy_HealingAura",
    ["Judgement of Righteousness"]="Ability_ThunderBolt",
    ["Judgement of Wisdom"]="Spell_Holy_RighteousnessAura",
    ["Judgement of the Crusader"]="Spell_Holy_HolySmite",
    ["Judgement"]="Spell_Holy_RighteousFury",
    ["Kick"]="Ability_Kick",
    ["Kidney Shot"]="Ability_Rogue_KidneyShot",
    ["Killer Instinct"]="Spell_Holy_BlessingOfStamina",
    ["Kodo Riding"]="Spell_Nature_Swiftness",
    ["Lash of Pain"]="Spell_Shadow_Curse",
    ["Last Stand"]="Spell_Holy_AshesToAshes",
    ["Lasting Judgement"]="Spell_Holy_HealingAura",
    ["Lay on Hands"]="Spell_Holy_LayOnHands",
    ["Leader of the Pack"]="Spell_Nature_UnyeildingStamina",
    ["Leather"]="INV_Chest_Leather_09",
    ["Leatherworking"] = "INV_Misc_ArmorKit_17",
    ["Lesser Heal"]="Spell_Holy_LesserHeal",
    ["Lesser Healing Wave"]="Spell_Nature_HealingWaveLesser",
    ["Lesser Invisibility"]="Spell_Magic_LesserInvisibilty",
    ["Lethal Shots"]="Ability_SearingArrow",
    ["Lethality"]="Ability_CriticalStrike",
    ["Levitate"]="Spell_Holy_LayOnHands",
    ["Libram"]="INV_Misc_Book_11",
    ["Life Tap"]="Spell_Shadow_BurningSpirit",
    ["Lightning Bolt"]="Spell_Nature_Lightning",
    ["Lightning Breath"]="Spell_Nature_Lightning",
    ["Lightning Mastery"]="Spell_Lightning_LightningBolt01",
    ["Lightning Reflexes"]="Spell_Nature_Invisibilty",
    ["Lightning Shield"]="Spell_Nature_LightningShield",
    ["Lightwell Renew"]="Spell_Holy_SummonLightwell",
    ["Lightwell"]="Spell_Holy_SummonLightwell",
    ["Long Daze"]="Spell_Frost_Stun",
    ["Mace Specialization"]="INV_Mace_01",
    ["Mace Stun Effect"]="Spell_Frost_Stun",
    ["Mage Armor"]="Spell_MageArmor",
    ["Magma Totem"]="Spell_Fire_SelfDestruct",
    ["Mail"]="INV_Chest_Chain_05",
    ["Malice"]="Ability_Racial_BloodRage",
    ["Mana Burn"]="Spell_Shadow_ManaBurn",
    ["Mana Shield"]="Spell_Shadow_DetectLesserInvisibility",
    ["Mana Spring Totem"]="Spell_Nature_ManaRegenTotem",
    ["Mana Tide Totem"]="Spell_Frost_SummonWaterElemental",
    ["Mangle"]="Ability_Druid_Mangle.tga",
    ["Mark of the Wild"]="Spell_Nature_Regeneration",
    ["Martyrdom"]="Spell_Nature_Tranquility",
    ["Master Demonologist"]="Spell_Shadow_ShadowPact",
    ["Master Summoner"]="Spell_Shadow_ImpPhaseShift",
    ["Master of Deception"]="Spell_Shadow_Charm",
    ["Maul"]="Ability_Druid_Maul",
    ["Mechanostrider Piloting"]="Spell_Nature_Swiftness",
    ["Meditation"]="Spell_Nature_Sleep",
    ["Melee Specialization"]="INV_Axe_02",
    ["Mend Pet"]="Ability_Hunter_MendPet",
    ["Mental Agility"]="Ability_Hibernation",
    ["Mental Strength"]="Spell_Nature_EnchantArmor",
    ["Mind Blast"]="Spell_Shadow_UnholyFrenzy",
    ["Mind Control"]="Spell_Shadow_ShadowWordDominate",
    ["Mind Flay"]="Spell_Shadow_SiphonMana",
    ["Mind Soothe"]="Spell_Holy_MindSooth",
    ["Mind Vision"]="Spell_Holy_MindVision",
    ["Mind-numbing Poison II"]="Spell_Nature_NullifyDisease",
    ["Mind-numbing Poison III"]="Spell_Nature_NullifyDisease",
    ["Mind-numbing Poison"]="Spell_Nature_NullifyDisease",
    ["Mining"]="Spell_Fire_FlameBlades",
    ["Mocking Blow"]="Ability_Warrior_PunishingBlow",
    ["Mongoose Bite"]="Ability_Hunter_SwiftStrike",
    ["Monster Slaying"]="INV_Misc_Head_Dragon_Black",
    ["Moonfire"]="Spell_Nature_StarFall",
    ["Moonfury"]="Spell_Nature_MoonGlow",
    ["Moonglow"]="Spell_Nature_Sentinal",
    ["Moonkin Aura"]="Spell_Nature_MoonGlow",
    ["Moonkin Form"]="Spell_Nature_ForceOfNature",
    ["Mortal Shots"]="Ability_PierceDamage",
    ["Mortal Strike"]="Ability_Warrior_SavageBlow",
    ["Multi-Shot"]="Ability_UpgradeMoonGlaive",
    ["Murder"]="Spell_Shadow_DeathScream",
    ["Natural Armor"]="Spell_Nature_SpiritArmor",
    ["Natural Shapeshifter"]="Spell_Nature_WispSplode",
    ["Natural Weapons"]="INV_Staff_01",
    ["Nature Resistance Totem"]="Spell_Nature_NatureResistanceTotem",
    ["Nature Resistance"]="Spell_Nature_ResistNature",
    ["Nature's Focus"]="Spell_Nature_HealingWaveGreater",
    ["Nature's Grace"]="Spell_Nature_NaturesBlessing",
    ["Nature's Grasp"]="Spell_Nature_NaturesWrath",
    ["Nature's Reach"]="Spell_Nature_NatureTouchGrow",
    ["Nature's Swiftness"]="Spell_Nature_RavenForm",
    ["Nightfall"]="Spell_Shadow_Twilight",
    ["Omen of Clarity"]="Spell_Nature_CrystalBall",
    ["One-Handed Axes"]="INV_Axe_01",
    ["One-Handed Maces"]="INV_Mace_01",
    ["One-Handed Swords"]="Ability_MeleeDamage",
    ["One-Handed Weapon Specialization"]="INV_Sword_20",
    ["Opening - No Text"]="Temp",
    ["Opening"]="Temp",
    ["Opportunity"]="Ability_Warrior_WarCry",
    ["Overpower"]="Ability_MeleeDamage",
    ["Paranoia"]="Spell_Shadow_AuraOfDarkness",
    ["Parry"]="Ability_Parry",
    ["Pathfinding"]="Ability_Mount_JungleTiger",
    ["Perception"]="Spell_Nature_Sleep",
    ["Permafrost"]="Spell_Frost_Wisp",
    ["Pet Aggression"]="Ability_Druid_Maul",
    ["Pet Hardiness"]="Ability_BullRush",
    ["Pet Recovery"]="Ability_Hibernation",
    ["Pet Resistance"]="Spell_Holy_BlessingOfAgility",
    ["Phase Shift"]="Spell_Shadow_ImpPhaseShift",
    ["Pick Lock"]="Spell_Nature_MoonKey",
    ["Pick Pocket"]="INV_Misc_Bag_11",
    ["Piercing Howl"]="Spell_Shadow_DeathScream",
    ["Piercing Ice"]="Spell_Frost_Frostbolt",
    ["Plate Mail"]="INV_Chest_Plate01",
    ["Poison Cleansing Totem"]="Spell_Nature_PoisonCleansingTotem",
    ["Poisons"]="Trade_BrewPoison",
    ["Polearm Specialization"]="INV_Weapon_Halbard_01",
    ["Polearms"]="INV_Spear_06",
    ["Polymorph"]="Spell_Nature_Polymorph",
    ["Portal: Darnassus"]="Spell_Arcane_PortalDarnassus",
    ["Portal: Ironforge"]="Spell_Arcane_PortalIronForge",
    ["Portal: Orgrimmar"]="Spell_Arcane_PortalOrgrimmar",
    ["Portal: Stormwind"]="Spell_Arcane_PortalStormWind",
    ["Portal: Thunder Bluff"]="Spell_Arcane_PortalThunderBluff",
    ["Portal: Undercity"]="Spell_Arcane_PortalUnderCity",
    ["Pounce Bleed"]="Ability_Druid_SupriseAttack",
    ["Pounce"]="Ability_Druid_SupriseAttack",
    ["Power Infusion"]="Spell_Holy_PowerInfusion",
    ["Power Word: Fortitude"]="Spell_Holy_WordFortitude",
    ["Power Word: Shield"]="Spell_Holy_PowerWordShield",
    ["Prayer of Fortitude"]="Spell_Holy_PrayerOfFortitude",
    ["Prayer of Healing"]="Spell_Holy_PrayerOfHealing02",
    ["Prayer of Shadow Protection"]="Spell_Holy_PrayerofShadowProtection",
    ["Prayer of Spirit"]="Spell_Holy_PrayerofSpirit",
    ["Precision"]="Ability_Marksmanship",
    ["Predatory Strikes"]="Ability_Hunter_Pet_Cat",
    ["Premeditation"]="Spell_Shadow_Possession",
    ["Preparation"]="Spell_Shadow_AntiShadow",
    ["Presence of Mind"]="Spell_Nature_EnchantArmor",
    ["Primal Fury"]="Ability_Racial_Cannibalize",
    ["Prowl"]="Ability_Druid_SupriseAttack",
    ["Psychic Scream"]="Spell_Shadow_PsychicScream",
    ["Pummel"]="INV_Gauntlets_04",
    ["Purge"]="Spell_Nature_Purge",
    ["Purification"]="Spell_Frost_WizardMark",
    ["Purify"]="Spell_Holy_Purify",
    ["Pursuit of Justice"]="Spell_Holy_PersuitofJustice",
    ["Pyroblast"]="Spell_Fire_Fireball02",
    ["Pyroclasm"]="Spell_Fire_Volcano",
    ["Quickness"]="Ability_Racial_ShadowMeld",
    ["Rain of Fire"]="Spell_Shadow_RainOfFire",
    ["Rake"]="Ability_Druid_Disembowel",
    ["Ram Riding"]="Spell_Nature_Swiftness",
    ["Ranged Weapon Specialization"]="INV_Weapon_Rifle_06",
    ["Rapid Concealment"]="Ability_Ambush",
    ["Rapid Fire"]="Ability_Hunter_RunningShot",
    ["Raptor Riding"]="Spell_Nature_Swiftness",
    ["Raptor Strike"]="Ability_MeleeDamage",
    ["Ravage"]="Ability_Druid_Ravage",
    ["Readiness"]="Spell_Nature_Sleep",
    ["Rebirth"]="Spell_Nature_Reincarnation",
    ["Recklessness"]="Ability_CriticalStrike",
    ["Reckoning"]="Spell_Holy_BlessingOfStrength",
    ["Redemption"]="Spell_Holy_Resurrection",
    ["Redoubt"]="Ability_Defend",
    ["Reflection"]="Spell_Frost_WindWalkOn",
    ["Regeneration"]="Spell_Nature_Regenerate",
    ["Regrowth"]="Spell_Nature_ResistNature",
    ["Reincarnation"]="Spell_Nature_Reincarnation",
    ["Rejuvenation"]="Spell_Nature_Rejuvenation",
    ["Relentless Strikes"]="Ability_Warrior_DecisiveStrike",
    ["Remorseless Attacks"]="Ability_FiegnDead",
    ["Remove Curse"]="Spell_Holy_RemoveCurse",
    ["Remove Insignia"]="Temp",
    ["Remove Lesser Curse"]="Spell_Nature_RemoveCurse",
    ["Rend"]="Ability_Gouge",
    ["Renew"]="Spell_Holy_Renew",
    ["Repentance"]="Spell_Holy_PrayerOfHealing",
    ["Resurrection"]="Spell_Holy_Resurrection",
    ["Retaliation"]="Ability_Warrior_Challange",
    ["Retribution Aura"]="Spell_Holy_AuraOfLight",
    ["Revenge Stun"]="Ability_Warrior_Revenge",
    ["Revenge"]="Ability_Warrior_Revenge",
    ["Reverberation"]="Spell_Frost_FrostWard",
    ["Revive Pet"]="Ability_Hunter_BeastSoothe",
    ["Righteous Fury"]="Spell_Holy_SealOfFury",
    ["Rip"]="Ability_GhoulFrenzy",
    ["Riposte"]="Ability_Warrior_Challange",
    ["Ritual of Doom Effect"]="Spell_Arcane_PortalDarnassus",
    ["Ritual of Doom"]="Spell_Shadow_AntiMagicShell",
    ["Ritual of Summoning"]="Spell_Shadow_Twilight",
    ["Rockbiter Weapon"]="Spell_Nature_RockBiter",
    ["Rogue Passive"]="Ability_Stealth",
    ["Ruin"]="Spell_Shadow_ShadowWordPain",
    ["Rupture"]="Ability_Rogue_Rupture",
    ["Ruthlessness"]="Ability_Druid_Disembowel",
    ["Sacrifice"]="Spell_Shadow_SacrificialShield",
    ["Safe Fall"]="INV_Feather_01",
    ["Sanctity Aura"]="Spell_Holy_MindVision",
    ["Sap"]="Ability_Sap",
    ["Savage Fury"]="Ability_Druid_Ravage",
    ["Savage Strikes"]="Ability_Racial_BloodRage",
    ["Scare Beast"]="Ability_Druid_Cower",
    ["Scatter Shot"]="Ability_GolemStormBolt",
    ["Scorch"]="Spell_Fire_SoulBurn",
    ["Scorpid Poison"]="Ability_PoisonSting",
    ["Scorpid Sting"]="Ability_Hunter_CriticalShot",
    ["Screech"]="Ability_Hunter_Pet_Bat",
    ["Seal Fate"]="Spell_Shadow_ChillTouch",
    ["Seal of Command"]="Ability_Warrior_InnerRage",
    ["Seal of Justice"]="Spell_Holy_SealOfWrath",
    ["Seal of Light"]="Spell_Holy_HealingAura",
    ["Seal of Righteousness"]="Ability_ThunderBolt",
    ["Seal of Wisdom"]="Spell_Holy_RighteousnessAura",
    ["Seal of the Crusader"]="Spell_Holy_HolySmite",
    ["Searing Light"]="Spell_Holy_SearingLightPriest",
    ["Searing Pain"]="Spell_Fire_SoulBurn",
    ["Searing Totem"]="Spell_Fire_SearingTotem",
    ["Seduction"]="Spell_Shadow_MindSteal",
    ["Sense Demons"]="Spell_Shadow_Metamorphosis",
    ["Sense Undead"]="Spell_Holy_SenseUndead",
    ["Sentry Totem"]="Spell_Nature_RemoveCurse",
    ["Serpent Sting"]="Ability_Hunter_Quickshot",
    ["Setup"]="Spell_Nature_MirrorImage",
    ["Shackle Undead"]="Spell_Nature_Slow",
    ["Shadow Affinity"]="Spell_Shadow_ShadowWard",
    ["Shadow Bolt"]="Spell_Shadow_ShadowBolt",
    ["Shadow Focus"]="Spell_Shadow_BurningSpirit",
    ["Shadow Mastery"]="Spell_Shadow_ShadeTrueSight",
    ["Shadow Protection"]="Spell_Shadow_AntiShadow",
    ["Shadow Reach"]="Spell_Shadow_ChillTouch",
    ["Shadow Resistance Aura"]="Spell_Shadow_SealOfKings",
    ["Shadow Resistance"]="Spell_Shadow_AntiShadow",
    ["Shadow Ward"]="Spell_Shadow_AntiShadow",
    ["Shadow Weaving"]="Spell_Shadow_BlackPlague",
    ["Shadow Word: Pain"]="Spell_Shadow_ShadowWordPain",
    ["Shadowburn"]="Spell_Shadow_ScourgeBuild",
    ["Shadowform"]="Spell_Shadow_Shadowform",
    ["Shadowguard"]="Spell_Nature_LightningShield",
    ["Shadowmeld Passive"]="Ability_Ambush",
    ["Shadowmeld"]="Ability_Ambush",
    ["Sharpened Claws"]="INV_Misc_MonsterClaw_04",
    ["Shatter"]="Spell_Frost_FrostShock",
    ["Shell Shield"]="Ability_Hunter_Pet_Turtle",
    ["Shield Bash"]="Ability_Warrior_ShieldBash",
    ["Shield Block"]="Ability_Defend",
    ["Shield Slam"]="INV_Shield_05",
    ["Shield Specialization"]="INV_Shield_06",
    ["Shield Wall"]="Ability_Warrior_ShieldWall",
    ["Shield"]="INV_Shield_04",
    ["Shoot Bow"]="Ability_Marksmanship",
    ["Shoot Crossbow"]="Ability_Marksmanship",
    ["Shoot Gun"]="Ability_Marksmanship",
    ["Shoot"]="Ability_ShootWand",
    ["Shred"]="Spell_Shadow_VampiricAura",
    ["Silence"]="Spell_Shadow_ImpPhaseShift",
    ["Silent Resolve"]="Spell_Nature_ManaRegenTotem",
    ["Sinister Strike"]="Spell_Shadow_RitualOfSacrifice",
    ["Siphon Life"]="Spell_Shadow_Requiem",
    ["Skinning"] = "INV_Misc_Pelt_Wolf_01",
    ["Slam"]="Ability_Warrior_DecisiveStrike",
    ["Slice and Dice"]="Ability_Rogue_SliceDice",
    ["Slow Fall"]="Spell_Magic_FeatherFall",
    ["Smelting"] = "Spell_Fire_FlameBlades",
    ["Smite"]="Spell_Holy_HolySmite",
    ["Soothe Animal"]="Ability_Hunter_BeastSoothe",
    ["Soothing Kiss"]="Spell_Shadow_SoothingKiss",
    ["Soul Fire"]="Spell_Fire_Fireball02",
    ["Soul Link"]="Spell_Shadow_GatherShadows",
    ["Soulstone Resurrection"]="INV_Misc_Orb_04",
    ["Spell Lock"]="Spell_Shadow_MindRot",
    ["Spell Warding"]="Spell_Holy_SpellWarding",
    ["Spirit Bond"]="Ability_Druid_DemoralizingRoar",
    ["Spirit Tap"]="Spell_Shadow_Requiem",
    ["Spirit of Redemption"]="INV_Enchant_EssenceEternalLarge",
    ["Spiritual Focus"]="Spell_Arcane_Blink",
    ["Spiritual Guidance"]="Spell_Holy_SpiritualGuidence",
    ["Spiritual Healing"]="Spell_Nature_MoonGlow",
    ["Sprint"]="Ability_Rogue_Sprint",
    ["Starfire"]="Spell_Arcane_StarFire",
    ["Starshards"]="Spell_Arcane_StarFire",
    ["Staves"]="INV_Staff_08",
    ["Stealth"]="Ability_Stealth",
    ["Stoneclaw Totem"]="Spell_Nature_StoneClawTotem",
    ["Stoneform"]="Spell_Shadow_UnholyStrength",
    ["Stoneskin Totem"]="Spell_Nature_StoneSkinTotem",
    ["Stormstrike"]="Spell_Holy_SealOfMight",
    ["Strength of Earth Totem"]="Spell_Nature_EarthBindTotem",
    ["Stuck"]="Spell_Shadow_Teleport",
    ["Subtlety"]="Ability_EyeOfTheOwl",
    ["Suffering"]="Spell_Shadow_BlackPlague",
    ["Summon Charger"]="Ability_Mount_Charger",
    ["Summon Dreadsteed"]="Ability_Mount_Dreadsteed",
    ["Summon Felhunter"]="Spell_Shadow_SummonFelHunter",
    ["Summon Felsteed"]="Spell_Nature_Swiftness",
    ["Summon Imp"]="Spell_Shadow_SummonImp",
    ["Summon Succubus"]="Spell_Shadow_SummonSuccubus",
    ["Summon Voidwalker"]="Spell_Shadow_SummonVoidWalker",
    ["Summon Warhorse"]="Spell_Nature_Swiftness",
    ["Sunder Armor"]="Ability_Warrior_Sunder",
    ["Suppression"]="Spell_Shadow_UnsummonBuilding",
    ["Surefooted"]="Ability_Kick",
    ["Survivalist"]="Spell_Shadow_Twilight",
    ["Sweeping Strikes"]="Ability_Rogue_SliceDice",
    ["Swipe"]="INV_Misc_MonsterClaw_03",
    ["Sword Specialization"]="INV_Sword_27",
    ["Tactical Mastery"]="Spell_Nature_EnchantArmor",
    ["Tailoring"] = "Trade_Tailoring",
    ["Tainted Blood"]="Spell_Shadow_LifeDrain",
    ["Tame Beast"]="Ability_Hunter_BeastTaming",
    ["Tamed Pet Passive"]="Ability_Mount_PinkTiger",
    ["Taunt"]="Spell_Nature_Reincarnation",
    ["Teleport: Darnassus"]="Spell_Arcane_TeleportDarnassus",
    ["Teleport: Ironforge"]="Spell_Arcane_TeleportIronForge",
    ["Teleport: Moonglade"]="Spell_Arcane_TeleportMoonglade",
    ["Teleport: Orgrimmar"]="Spell_Arcane_TeleportOrgrimmar",
    ["Teleport: Stormwind"]="Spell_Arcane_TeleportStormWind",
    ["Teleport: Thunder Bluff"]="Spell_Arcane_TeleportThunderBluff",
    ["Teleport: Undercity"]="Spell_Arcane_TeleportUnderCity",
    ["The Human Spirit"]="INV_Enchant_ShardBrilliantSmall",
    ["Thick Hide"]="INV_Misc_Pelt_Bear_03",
    ["Thorns"]="Spell_Nature_Thorns",
    ["Throw"]="Ability_Throw",
    ["Throwing Specialization"]="INV_ThrowingAxe_03",
    ["Throwing Weapon Specialization"]="INV_ThrowingKnife_01",
    ["Thrown"]="INV_ThrowingKnife_02",
    ["Thunder Clap"]="Spell_Nature_ThunderClap",
    ["Thundering Strikes"]="Ability_ThunderBolt",
    ["Thunderstomp"]="Ability_Hunter_Pet_Gorilla",
    ["Tidal Focus"]="Spell_Frost_ManaRecharge",
    ["Tidal Mastery"]="Spell_Nature_Tranquility",
    ["Tiger Riding"]="Spell_Nature_Swiftness",
    ["Tiger's Fury"]="Ability_Mount_JungleTiger",
    ["Torment"]="Spell_Shadow_GatherShadows",
    ["Totem"]="Spell_Nature_StoneClawTotem",
    ["Totemic Focus"]="Spell_Nature_MoonGlow",
    ["Touch of Weakness"]="Spell_Shadow_DeadofNight",
    ["Toughness"]="Spell_Holy_Devotion",
    ["Track Beasts"]="Ability_Tracking",
    ["Track Demons"]="Spell_Shadow_SummonFelHunter",
    ["Track Dragonkin"]="INV_Misc_Head_Dragon_01",
    ["Track Elementals"]="Spell_Frost_SummonWaterElemental",
    ["Track Giants"]="Ability_Racial_Avatar",
    ["Track Hidden"]="Ability_Stealth",
    ["Track Humanoids"]="Ability_Tracking",
    ["Track Undead"]="Spell_Shadow_DarkSummoning",
    ["Tranquil Air Totem"]="Spell_Nature_Brilliance",
    ["Tranquil Spirit"]="Spell_Holy_ElunesGrace",
    ["Tranquility"]="Spell_Nature_Tranquility",
    ["Tranquilizing Shot"]="Spell_Nature_Drowsy",
    ["Trap Mastery"]="Ability_Ensnare",
    ["Travel Form"]="Ability_Druid_TravelForm",
    ["Tremor Totem"]="Spell_Nature_TremorTotem",
    ["Trueshot Aura"]="Ability_TrueShot",
    ["Turn Undead"]="Spell_Holy_TurnUndead",
    ["Two-Handed Axes and Maces"]="INV_Axe_10",
    ["Two-Handed Axes"]="INV_Axe_04",
    ["Two-Handed Maces"]="INV_Mace_04",
    ["Two-Handed Swords"]="Ability_MeleeDamage",
    ["Two-Handed Weapon Specialization"]="INV_Axe_09",
    ["Unarmed"]="Ability_GolemThunderClap",
    ["Unbreakable Will"]="Spell_Magic_MageArmor",
    ["Unbridled Wrath Effect"]="Spell_Nature_StoneClawTotem",
    ["Unbridled Wrath"]="Spell_Nature_StoneClawTotem",
    ["Undead Horsemanship"]="Spell_Nature_Swiftness",
    ["Underwater Breathing"]="Spell_Shadow_DemonBreath",
    ["Unending Breath"]="Spell_Shadow_DemonBreath",
    ["Unholy Power"]="Spell_Shadow_ShadowWordDominate",
    ["Unleashed Fury"]="Ability_BullRush",
    ["Unyielding Faith"]="Spell_Holy_UnyieldingFaith",
    ["Vampiric Embrace"]="Spell_Shadow_UnsummonBuilding",
    ["Vanish"]="Ability_Vanish",
    ["Vanished"]="Ability_Vanish",
    ["Vengeance"]="Spell_Nature_Purge",
    ["Vigor"]="Spell_Nature_EarthBindTotem",
    ["Vile Poisons"]="Ability_Rogue_FeignDeath",
    ["Vindication"]="Spell_Holy_Vindication",
    ["Viper Sting"]="Ability_Hunter_AimedShot",
    ["Volley"]="Ability_Marksmanship",
    ["Wand Specialization"]="INV_Wand_01",
    ["Wands"]="Ability_ShootWand",
    ["War Stomp"]="Ability_WarStomp",
    ["Water Breathing"]="Spell_Shadow_DemonBreath",
    ["Water Walking"]="Spell_Frost_WindWalkOn",
    ["Weakened Soul"]="Spell_Holy_AshesToAshes",
    ["Whirlwind"]="Ability_Whirlwind",
    ["Will of the Forsaken"]="Spell_Shadow_RaiseDead",
    ["Windfury Totem"]="Spell_Nature_Windfury",
    ["Windfury Weapon"]="Spell_Nature_Cyclone",
    ["Windwall Totem"]="Spell_Nature_EarthBind",
    ["Wing Clip"]="Ability_Rogue_Trip",
    ["Winter's Chill"]="Spell_Frost_ChillingBlast",
    ["Wisp Spirit"]="Spell_Nature_WispSplode",
    ["Wolf Riding"]="Spell_Nature_Swiftness",
    ["Wound Poison II"]="INV_Misc_Herb_16",
    ["Wound Poison III"]="INV_Misc_Herb_16",
    ["Wound Poison IV"]="INV_Misc_Herb_16",
    ["Wound Poison"]="INV_Misc_Herb_16",
    ["Wrath"]="Spell_Nature_AbolishMagic",
    ["Wyvern Sting"]="INV_Spear_02"
}

local lib = {}
local localToEnglish

if locale == "enUS" then
	function lib:GetEnglish(spell)
		argCheck(spell, 2, "string")
		assert(totalSpells[spell], format("Spell %q does not exist", spell))
		return spell
	end
	
	function lib:GetLocalized(spell)
		argCheck(spell, 2, "string")
		assert(totalSpells[spell], format("Spell %q does not exist", spell))
		return spell
	end
	
	function lib:GetIterator()
		return pairs(totalSpells)
	end
	
	lib.GetReverseIterator = lib.GetIterator
	
	function lib:HasSpell(spell)
		argCheck(spell, 2, "string")
		return totalSpells[spell] and true or false
	end
	
	function lib:GetSpellIcon(spell)
		argCheck(spell, 2, "string")
		local icon = spellIcons[spell]
		if not icon then
			return nil
		end
		return "Interface\\Icons\\" .. icon
	end
	
	function lib:GetShortSpellIcon(spell)
		argCheck(spell, 2, "string")
		return spellIcons[spell]
	end
else
	function lib:GetEnglish(spell)
		argCheck(spell, 2, "string")
		local t = localToEnglish[spell]
		assert(t, format("Spell %q does not exist or is not translated into %s", spell, locale))
		return t
	end
	
	function lib:GetLocalized(spell)
		argCheck(spell, 2, "string")
		assert(totalSpells[spell], format("Spell %q does not exist", spell))
		local t = englishToLocal[spell]
		assert(t, format("Spell %q is not translated into %s", spell, locale))
		return t
	end
	
	local improperTranslation = nil
	for spell in pairs(totalSpells) do
		if not englishToLocal[spell] then
			improperTranslation = spell
			break
		end
	end
	
	if improperTranslation then
		function lib:GetIterator()
			assert(false, "Spell %q not translated into %s", improperTranslation, locale)
		end
		
		lib.GetReverseIterator = lib.GetIterator
	else
		function lib:GetIterator()
			return pairs(englishToLocal)
		end
		
		function lib:GetReverseIterator()
			return pairs(localToEnglish)
		end
	end
	
	function lib:HasSpell(spell)
		argCheck(spell, 2, "string")
		return (totalSpells[spell] or localToEnglish[spell]) and true or false
	end
	
	function lib:GetSpellIcon(spell)
		argCheck(spell, 2, "string")
		local icon = spellIcons[localToEnglish[spell] or spell]
		if not icon then
			return nil
		end
		return "Interface\\Icons\\" .. icon
	end
	
	function lib:GetShortSpellIcon(spell)
		argCheck(spell, 2, "string")
		return spellIcons[localToEnglish[spell] or spell]
	end
end

function lib:GetLibraryVersion()
	return MAJOR_VERSION, MINOR_VERSION
end

function lib:LibActivate(stub, oldLib, oldList)
	if locale ~= "enUS" then
		localToEnglish = {}
		for english, localized in pairs(englishToLocal) do
			localToEnglish[localized] = english
		end
	end
	
	local mt = getmetatable(self) or {}
	mt.__call = self.GetLocalized
	setmetatable(self, mt)
end

function lib:LibDeactivate()
	totalSpells, localToEnglish, englishToLocal, spellIcons = nil
end

BabbleLib:Register(lib)
lib = nil
